\ Umbilical Forth kernel code                        sfp 13/09/89

((
Copyright (C) 1988-1991

MicroProcessor Engineering
133 Hill Lane
Southampton SO1 5AF
England

tel: (+44) 703 631441
fax: (+44 703 339691
))

\ System equates
hex

020 EQU ABL
00D EQU ACR
02E EQU ADOT
007 EQU ABELL
008 EQU BSIN
008 EQU BSOUT
00A EQU ALF
00C EQU FFEED

000 EQU FALSE
 -1 EQU TRUE

\ user variables                                   Jon 20/06/89

hex
002 user s0			\ reset value of data stack
004 user r0			\ reset value of return stack
006 user base                   \ number conversion base
007 user out                    \ output counter

((
\
\ The USER variables below may be needed if input from the user
\ is required when the application runs.
\

008 user span                   \ if i/p buffer used
014 user pad                    \ start of scratch string buff.
))


\ constants

0 CONSTANT 0


\ (.")                                          sfpJon 20/06/89

: (.")          \ -- ; displays in-line data
  r> count 2dup + >r  type  ;


\ u.            *** NOT BASE SENSITIVE ***         Jon 20/06/89

decimal

: u.            \ u -- ; simple print utility ; relies on EMIT
  0                                     \ -- u 0 ; start counter
  begin  1+                             \ increment counter
         swap 0 10 um/mod               \ -- n rem quot
         rot over 0=                    \ -- rem quot n flag
  until                                 \ until next digit 0
  swap                                  \ -- dign..dig1 n 0
  do  ascii 0 + emit  loop              \ display character
  ."  "  ;                              \ display space

((
\ u.            *** BASE SENSITIVE ***             Jon 20/06/89

: u.            \ u -- ; simple print utility ; relies on EMIT
  0                                     \ -- u 0 ; start counter
  begin  1+                             \ increment counter
         swap 0 base c@ um/mod          \ -- n rem quot
         rot over 0=                    \ -- rem quot n flag
  until                                 \ until next digit 0
  swap                                  \ -- dign..dig1 n 0
  do  dup 9 > if  7 +  endif            \ allows for A..F
      ascii 0 + emit                    \ display character
  loop                                  \
  ."  "  ;                              \ display space
))
\ .                                                sfp 13/09/89

\
\ Choose one of the two versions of the print routine. The second version
\ relies on the Umbilical Forth system, and thus is not suitable for use
\ in an application.
\
: .             \ n -- ; display character ; needs U. (see above)
  dup 0<                                \ if negative
  if  ." -" abs  endif                  \  add leading '-'
  u.  ;                                 \ then print it

((
: .             \ n -- ; relies on Umbilical Forth
  .-cmnd>h send-message  ;
))


: (init)	\ -- ;
  sp@ s0 !  rp@ r0 !			\ save initial values
  10 base c!				\ set base
;

l: STRT	 0 ,  				\ this label gets patched 
		 			\ by MAKE-TURNKEY

: Startup	\ -- ; run startup code
  (init)				\ initialise Forth
  STRT @ Execute			\ run application
;

