\ 64180 Umbilical Forth startup code

((
released for use without royalty when used with the
MPE Z80/64180 Forth Cross Compiler.

Copyright (c) 1987-1991

MicroProcessor Engineering
133/133a Hill Lane
Shirley
Southampton SO1 5AF

tel: (+44) 703 63 14 41 (international)
     0703 631441        (domestic)

May 1991	Converted to text file

))
\ Start up table - entry points ...................sfp 28/03/90

hex
\
\ We assume that HERE points to an area that contains the CPU reset vector
\ and that space is available for a mode 2 interrupt table. By default this
\ table is 256 bytes long. The 256 byte boundary aligned base of this table
\ is a label called INT-PAGE. When interrupts are defined later the vectors
\ can be set by referring to an offset from INT-PAGE, e.g.
\
\	ENTRY-POINT INT-PAGE VECTOR# 2* + !
\
here 0FF00 and  equ int-page

\
\ in a ROMmed system it is convenient to keep the interrupt page at 0, and
\ to use the first 4 bytes for the reset vectors. Note that other locations
\ will be required for the RST nn entry points. This code should be added
\ by the user.
\
assembler
  di  ecld jp				\ disable interrupts, skip tables
forth
\
\ Add here all the other RST vectors using:
\	n ORG
\

\
\ Reserve space for restart jumps & interrupt vectors. We assume that
\ the full 256 bytes for mode 2 is required
\
int-page 0100 + org

\
\ The locations CLD1 holds the word that will be executed at cold start
\ Whatever word is inserted between the ] and [ will be executed by the
\ startup code below.
\
L: CLD1         ] startup [        \ cold start word

\
\ Cold and warm starts
\
\ This code starts the Forth virtual machine running.
\
hex
assembler
l: ecld
 	hl, # init-u0 ld   up hl ld     \ set user pointer
        iy, # init-r0 ld                \ set return stack
        sp, # init-s0 ld                \ set data stack
        bc, # cld1 ld                   \ set IP (see above)
        ix, # next ld   next,           \ pointer to next
					\ needed if space-saving NEXT, used
forth
\ all done

decimal

;p
