((

	SAVE-SYM.FTH

	J Lee :- 25/7/90

	MicroProcessor Engineering Ltd
	133/133a Hill Lane
	Southampton
	SO1 5AF

	tele:	(0703) 631441
	inter:	+44 703 631441


	Save symbol table to disk: SUSPEND & RESUME

))




only forth also c-c definitions
decimal




\ Segment# Segment#++ !Segment# .Segment-Title .. J Lee -- 25/07/90
\

decimal

variable Segment#		\ Segment number in symbol table traversal

256 constant Max-#Segs	\ maximum number of segments


create Segment-Table
  Max-#Segs dcell* allot


: Segment#++	( -- ; increment segment# by 1 )
	Segment# incr  ;


: Clean-Segment-Table	( -- ; clean out segment table )
	Segment-Table Max-#Segs dcell* erase  ;


: !Orig-Seg#	( segment -- )
	Segment# @ dcell* Segment-Table + !  ;


: !New-Seg#	( segment -- )
	Segment# @ dcell* cell+ Segment-Table + !  ;



\ This word will abort if segment can't be found
\
: @New-Segment	( old-seg -- new-seg ; translate segment only )
	Segment-Table
	Begin
		dup @
		dup 0=  If  cr ." Can't find segment: " 2drop .hex  abort  Endif
		>r over r> <>
	While
		dcell+				
	Repeat
	nip cell+ @  ;


: Translate-Seg	( seg off -- seg' off )
	swap @new-segment swap  ;


: ?Reset-Pointer  ( seg off -- ; translate if non-zero )
    2dup 2@l 2dup or
    If
         translate-seg
         2swap 2!l
    Else
         2drop  2drop
    Endif  ;




\ Create-File Open-File Close-File .. J Lee -- 27/07/90
\


: Create-File	( pcb -- ; create a file )
	dup create-path-pcb
	If  ." Can't create: " .pcb  abort  Endif
	drop  ;


: Open-File	( pcb -- ; open a file )
	dup open-path-pcb
	If  ." Can't open: " .pcb  abort  Endif
	drop  ;


: Close-File	( -- ; close a file )
	dup close-path-pcb
	If  ." Can't close: " .pcb  abort  Endif
	drop  ;




\ Symbols.Pcb Create-Symbols Open- Close- .. J Lee -- 25/07/90
\


pcb Symbols.Pcb		Symbols.Pcb pathname SYMBOLS.OUT


: Create-Symbols	( -- ; create symbols file )
	Symbols.Pcb create-file  ;


: Open-Symbols	( -- ; close symbols file )
	Symbols.Pcb open-file  ;


: Close-Symbols	( -- ; close symbols file )
	Symbols.Pcb close-file  ;


: Save-Chunk	( segment -- ; write chunk to file )
	0 /Chunk Symbols.Pcb handle (write-path)
	If  ." Can't write a chunk to: " Symbols.Pcb	.pcb  abort  Endif
	drop  ;




\ Requireds.Pcb Create-Requireds Open- Close- .. J Lee -- 15/1/91
\


pcb Requireds.Pcb		Requireds.Pcb pathname REQUIREDS.OUT


: Create-Requireds	( -- ; create requireds file )
	Requireds.Pcb create-file  ;


: Open-requireds	( -- ; close requireds file )
	requireds.Pcb open-file  ;


: Close-requireds	( -- ; close requireds file )
	requireds.Pcb close-file  ;



defer REQ-ACTION		\ action depends on whether saving or loading



: >Req-Symbol	( seg nfa -- )
	name>l >body cell+ 	\ symbol address
	req-action  ;


: >Req-Thread	( thread-addr -- )
	Begin
\		main-mod
2 mod-seg
 swap @l ?dup			\ get NFA
	While
\		main-mod
2 mod-seg
 over >req-symbol	\ relink symbol
		n>link				\ move to LFA for next symbol
	Repeat  ;


: >Requireds	( -- ; relink all required words )
	required.voc-addr
	dup cell+   main-mod rot @l 0
	?Do
		dup >req-thread
		cell+
	Loop
	drop  ;



variable Required-Buffer  cell allot	\ buffer for saving and loading

: Write-Req	( d -- ; write 'd' to file )
	required-buffer 2!
	required-buffer dcell requireds.pcb handle write-path
	If  ." Can't write a chunk to: " Requireds.Pcb .pcb  abort  Endif
	drop  ;



: Save-Req-Action	( seg addr -- ; save symbol pointer at address to file )
	2@l write-req  ;



: Save-Requireds	( -- ; save required symbol segments )
	create-requireds
	assign save-req-action to-do req-action
	>requireds
	-1 -1 write-req
	close-requireds  ;



: Read-Req-Action	( seg addr -- ; read required symbol segment )
	required-buffer dcell requireds.pcb handle read-path
	If  ." Can't read: " requireds.pcb .pcb  abort  Endif
	drop
	2dup -1 -rot cell- !l		\ flag symbol as defined
	required-buffer 2@ and -1 = abort" Required Symbols mismatch when reloading"
	required-buffer 2@ 
        2dup or 0<>
        If
                translate-seg 2swap 2!l
        Else
                2drop 2drop
        Endif  ;


: Read-Requireds	( -- ; read required symbol segemnts back & translate )
	open-requireds
	assign read-req-action to-do req-action
	>requireds
	close-requireds  ;




\ Ram.Pcb Create-Ram Open- Close- .. J Lee -- 25/07/90
\


pcb Ram.Pcb		Ram.Pcb pathname RAM.OUT


: Create-Ram	( -- ; create Ram file )
  Ram.Pcb create-file  ;


: Open-Ram	( -- ; close Ram file )
  Ram.Pcb open-file  ;


: Close-Ram	( -- ; close Ram file )
  Ram.Pcb close-file  ;


: Calc-Ram-Pars	( -- seg off size )
  Ram-Area @(g)         \ segment
  0                     \ start of seg (off)
  Ram-Size @(g)  ;      \ size of table


: Write-Ram	( seg off len -- )
  Ram.Pcb handle (write-path)
  abort" Can't write to Ram file"
  drop  ;


: Save-Ram	( -- )
  create-ram
  calc-ram-pars
  write-ram
  close-ram  ;


: Calc-Read-Ram	( -- ; allocate new RAM table space and set pointer )
  Ram-Size @(g)         \ size of table
  #bytes>#paras alloc-mem       \ allocate RAM table
  abort" Can't grab RAM table memory"
  Ram-Area !(g)  ;      \ set pointer to new table


: Read-Ram	( addr len -- )
  calc-ram-pars
  Ram.Pcb handle (read-path)
  abort" Can't read Ram File"
  drop  ;


: Load-Ram	( -- )
  open-ram
  calc-read-ram
  read-ram
  close-ram  ;




\ Save-Chunks Save-Labels Save-Equates Save-Symbols .. J Lee 27/7/90
\


: Save-Chunks	(( seg >voc-link(s) -- ; enumerate a single vocabulary ))
	>voc-link(s)-  
	voc-chunk+ @(p)l				\ get vocs first chunk
	Begin
		dup save-chunk				\ save a chunk
		dup !orig-seg# segment#++		\ next segment index
		>chunk-link				\ get >chunk-link addr
		@(p)l					\ get next chunk
		dup 0=					\ continue until end of chunk chain
	Until
	drop  ;


: Save-Labels	(( seg >voc-link(s) -- ; save labels vocabulary ))
	'Labels(s) 2@(g) >voc-link(s)+ save-chunks  ;


: Save-Equates	(( seg >voc-link(s) -- ; save equates vocabulary ))
	'Equates(s) 2@(g) >voc-link(s)+ save-chunks  ;


: Save-Symbols	( page# -- ; save all chunks of all vocs in page 0 )
	>r					\ preserve page#
	create-symbols
	clean-segment-table
	segment# off
	r@ page-chunk@			\ get page chunk
	>voc-link(s) 2@(p)l		\ get first voc
	Begin
		2dup save-chunks	\ enumerate single voc
		2@(p)l			\ get next voc
		2dup or 0=		\ continue if current voc not last in chain
	Until
	2drop
	r> 0=				 \ save labels and equates for page 0
	If
		save-labels
		save-equates
	Endif
	close-symbols  ;




\ Create- Close- Save-Segs .. J Lee -- 27/07/90
\


pcb Segments.Pcb		Segments.Pcb pathname SEGMENTS.OUT


: Create-Segs	( -- ; create segments file )
	Segments.Pcb create-file  ;


: Close-Segs	( -- ; close segments file )
	Segments.Pcb close-file  ;


: Open-Segs	( -- ; create segments file )
	Segments.Pcb open-file  ;


: Save-Segs	( -- ; save segment table to disk )
	create-segs
	segment-table Max-#Segs dcell* segments.pcb handle write-path
	If  ." Can't write: " segments.pcb .pcb  abort  Endif
	drop
	close-segs  ;


: Read-Segs	( -- ; save segment table to disk )
	open-segs
	segment-table Max-#Segs dcell* segments.pcb handle read-path
	If  ." Can't read: " segments.pcb .pcb  abort  Endif
	drop
	close-segs  ;




\ Save-Globals Reload-Globals Reset-Globals .. J Lee -- 03/08/90
\


pcb Globals.Pcb		Globals.Pcb pathname GLOBALS.OUT


: Create-Globals	( -- ; create global variables file )
	Globals.Pcb create-file  ;


: Open-Globals	( -- open global variables file )
	Globals.Pcb open-file  ;


: Close-Globals	( -- close global variables file )
	Globals.Pcb close-file  ;


: Add-Globals	( -- ; add extra data into global buffer for saving )
	voc-seg@ Global-Voc-Seg !(g)  ;


: Save-Globals	( -- ; save global variables to file )
	create-globals
	add-globals		\ add extra variables into global area for saving
	main-mod {Global-Management  }Global-Management over -
	Globals.Pcb handle (write-path)
	If  cr ." Can't write: " Globals.Pcb .pcb  abort  Endif
	drop  
	close-globals  ;


: Read-Globals	( -- ; reload global variables from file )
	open-globals
	main-mod {Global-Management  }Global-Management over -
	Globals.Pcb handle (read-path)
	If  cr ." Can't read: " Globals.Pcb .pcb  abort  Endif
	drop  
	close-globals  ;


: Reset-Global-Seg	( addr -- ; reset global variable of 'addr' only )
	dup @(g) @new-segment  swap !(g)  ;


: ?Reset-Global-Seg	( addr -- ; reset global-seg if non-zero )
	dup @(g)
	If
		reset-global-seg
	Else
		drop
	Endif  ;


: Reset-Global	( addr -- ; reset global dvariable of 'addr )
	dup 2@(g) translate-seg  rot 2!(g)  ;	


: ?Reset-Global	( addr -- ; reset global if non-zero )
	dup 2@(g) or
	If
		reset-global
	Else
		2drop
	Endif  ;


: Reset-Globals	( -- ; reset all global variables that need to be )
	Ref1-Seg ?reset-global-seg
	Ref2-Seg ?reset-global-seg
	Ref-Seg ?reset-global-seg
	'Equates(s) reset-global
	'Labels(s) reset-global
	'Forth(s) reset-global
	'Root(s) reset-global
	Cont(s) ?reset-global
	Curr(s) ?reset-global
	Global-Voc-Seg @(g) @new-segment voc-seg!  ;





\ Save-Image Save-Page .. J Lee -- 08/08/90
\


: Save-Image	( -- ; finish off image file )
	flg.upd @(g)
	If  i.write  flg.upd off(g)  Endif
	i.close  ;


\ : Save-Page	( -- ; save page to file )
\	save-image
\	save-symbols
\	save-segs
\	save-globals
\	save-requireds
\	?Rom @(g) If  save-ram  Endif  ;	\ save init. RAM for ROM targets


\ : Suspend	( -- ; suspend kernel )
\	save-page
\	free-symbol-space					\ free symbol memory
\	bye  ;


: Set-Pcbs	( seg $addr -- )
 	2dup Globals.Pcb set-pathname-l "" .GLB" Globals.Pcb set-ext
	2dup Requireds.Pcb set-pathname-l "" .REQ" Requireds.Pcb set-ext
	Ram.Pcb set-pathname-l "" .RAM" Ram.Pcb set-ext  ;


: Set-Page-Pcbs	( page# -- )
	main-mod swap >page-table page.name
	2dup Symbols.Pcb set-pathname-l "" .SYM" Symbols.Pcb set-ext
	Segments.Pcb set-pathname-l "" .SEG" Segments.Pcb set-ext  ;


: Save-Page	( page# -- ; )
	dup set-page-pcbs
	save-image
	save-symbols
	save-segs  ;


: Suspend-kernel	( seg $addr -- )
	0 save-page
	set-pcbs
	save-globals
	save-requireds
	?Rom @(g)  If  save-ram  Endif  ;





\ Page-Base #Chunks Reload-Page .. J Lee -- 27/07/90
\


variable Page-Base		\ address of base chunk for re-loaded page


: #Chunks	( pcb -- #chunks ; returns number ofchunks in file )
	?file-size /Chunk um/mod nip  ;


: Reload-Page	( -- )
	symbols.pcb
	open-symbols
	segment# off
	dup #chunks 0
	?Do
		i swap >r
		claim-chunk
		swap 0= If  dup page-base !  Endif

		dup 0 /chunk r@ handle (read-path)
 		abort" error reading chunk"  drop
\		cr ." loading at segment: " dup .hex
		!new-seg#  segment#++
		r>
	Loop
	drop
	close-symbols  ;




\ Relink->Chunk-Link -<Chunk-Link -Chunk-Links .. J Lee -- 27/07/90
\


: Relink->Chunk-Link	( voc-seg -- ; relink forward chunk links for a voc. )
	Begin
		chunk-link cell(s)+
		2dup @l
		dup 0<>
		If
			@new-segment  dup >r  -rot
			!l  r>
		Else
			-rot 2drop
		Endif
		dup 0=
	Until
	drop  ;


: Relink-<Chunk-Link	( voc-seg -- ; relink backward chunk link for a voc. )
	dup latest-chunk @l  @new-segment	\ get latest-chunk
	dup  rot latest-chunk !l 			\ set new latest-chunk
	Begin
		chunk-link
		2dup @l
		dup 0<>
		If
			@new-segment  dup >r  -rot
			!l  r>
		Else
			-rot 2drop
		Endif
		dup 0=
	Until
	drop  ;


: Relink-Chunk-Links	( voc-seg -- ; relink forward and backward chunk links )
	dup relink->chunk-link
	relink-<chunk-link  ;




\ Relink-Ref-Links Relink-Symbol-Refs Relink-Forwards .. J Lee -- 08/08/90
\


: Relink-Ref-Links	( ref-addr[d] -- ; relink for. ref links )
	Begin
		2dup 2@l			\ get next for. ref packet
		2dup or 0<>		\ give up if end of chain
	While
		translate-seg		\ translate for. ref packet
		2dup 2rot 2!l		\ and write it back
	Repeat
	2drop 2drop  ;


: Relink-Symbol-Refs	( sym-addr[d] -- ; all for. refs for a symbol )
	2dup cell(s)+ relink-ref-links		\ relink forward refs
	2dup def-word?						\ an unres. defining word?
	If
		cell(s)+ dcell(s)+ cell(s)+		\ y:  relink run-time
		relink-ref-links
	Else
		2drop
	Endif  ;


: Relink-Forwards	( voc-seg -- ; relink all forward refs in a voc )
	Begin
		Chunk-Threads  #Threads(s) cell(s)* bounds
		Do
			dup i						\ for each thread
			Begin
				@(s)l ?dup					\ -- nfa [nfa]
			While
				2dup name>(s) cell(s)+			\ -- nfa nfa addr(s)
				2dup resolved?					\ symbol defined ?
				If
					2drop					\ yes, chuck data
				Else
					relink-symbol-refs			\ relink for. refs
				Endif
				over swap n>link(s)				\ switch to link
			Repeat
			cell(s)
		+Loop
		>Chunk-Link @(s)l  dup 0=
	Until
	drop  ;


: Relink-^c/v	( sym-addr[d] -- ; relink c/v pointer )
	cell(s)+					\ c/v data pointer
	2dup 2@l translate-seg		\ translate pointer
	2swap 2!l  ;				\ update


: Relink-C/Vs	( voc-seg -- ; relink all constants & variables in a voc )
	Begin
		Chunk-Threads  #Threads(s) cell(s)* bounds
		Do
			dup i						\ for each thread
			Begin
				@(s)l ?dup		  		\ -- nfa [nfa]
			While
				2dup name>(s) cell(s)+		\ -- nfa nfa addr(s)
				2dup c/v?			  		\ symbol defined ?
				If
					relink-^c/v			\ relink for. refs
				Else
					2drop				\ yes, chuck data
				Endif
				over swap n>link(s)			\ switch to link
			Repeat
			cell(s)
		+Loop
		>Chunk-Link @(s)l  dup 0=
	Until
	drop  ;




\ Relink->Voc-Link -<Voc-Link -Voc-Links .. J Lee -- 30/07/90
\


: Relink->Voc-Link	( page-seg -- ; relink voc links for a page )
	>voc-link(s)	\ get old >voc-link
	Begin
		2dup 2@l
		over 0<>
		If
			\ not pointing to zero segment
			\ so rewrite pointer with new segment
			translate-seg
			2dup 2rot 2!l
			\ translate voc-chunk and update voc chunk links
			2dup >voc-link(s)- voc-chunk+ 2dup @l @new-segment
			dup 2swap !l			\ translate voc-chunk
			dup relink-chunk-links	\ relink chunk links
			dup relink-forwards		\ relink forward reference
			relink-c/vs			\ relink constants & variables
			0
		Else
			\ don't do anything with pointer
			2drop 2drop
			-1
		Endif
	Until  ;


: Relink-<Voc-Link	( page-seg -- ; relink voc links for a page )
\	Curr->voc-link(s) 2@l			\ get old >voc-link
\	translate-seg >voc-link(s)- <voc-link(s)+	\ translate to new
	<voc-link(s)
	Begin
		2dup 2@l
		over 0<>
		If
			\ not pointing to zero segment
			\ so rewrite pointer with new segment
			translate-seg
			2dup 2rot 2!l
			0
		Else
			\ don't do anything with pointer
			2drop 2drop
			-1
		Endif
	Until  ;


: Relink-Voc-Links	( page-seg -- ; relink all voc-links in page )
	dup relink->voc-link
	dup relink-<voc-link
	curr->voc-link(s)		\ translate curr->voc-link
        ?reset-pointer  ;


: Relink-Labels	( -- ; relink labels vocabulary )
	'Labels(s) 2@(g) voc-chunk+
	2dup @l  @new-segment
	dup >r  -rot !l  r> 
	dup relink-chunk-links
        relink-forwards  ;


: Relink-Equates	( -- ; relink equates vocabulary )
	'Equates(s) 2@(g) voc-chunk+
	2dup @l  @new-segment  dup >r  -rot !l  r> 
	relink-chunk-links  ;




\ Reset-Context Reset-Current .. J Lee -- 01/08/90
\


: Reset-Context	(( page-seg -- ; reset context(s) for page ))
	vsize(s) 0
	?Do				\ for each thread
		dup context(s) i +
                ?reset-pointer
	dcell(s) 
	+Loop
	drop  ;


: Reset-Current	(( page-seg -- ; reset current(s) for page ))
	current(s) ?reset-pointer  ;




\ Reset-vars .. J Lee -- 22/1/91
\


: Reset-Page-Voc(s)  ( page-seg -- ; reset page vocabulary )
	Page-Voc(s)
        ?reset-pointer  ;



\ Reset-'Latest(s) Reset-'Latest: Reset-Latests .. J Lee -- 01/08/90
\


: Reset-'Latest(s)	( page-seg -- )
	'latest(s) ?reset-pointer  ;


: Reset-'Latest:	( page-seg -- )
	'latest: ?reset-pointer  ;


: Reset-Latests	( page-seg -- )
	dup reset-'latest(s)
       	reset-'latest:  ;



\ Relink-Page Relink-Kernel-Page .. J Lee -- 22/1/91
\

\ file name for page should be in symbols.pcb
: (Relink-Page)	( -- page-seg ; reload and relink a page )
	reload-page
        page-base @
	dup relink-voc-links
	dup reset-context
        dup reset-current
 	dup reset-latests  ;


: Relink-Page  ( -- )
        (relink-page) reset-page-voc(s)  ;


: Relink-Kernel-Page  ( -- )
        (relink-page)  drop  ;


: Relink-Others	 ( -- ; relink labels & equates )
  "" SEGMENTS.TMP" dup Segments.Pcb set-pathname  \ read segment table saved
  read-segs                                       \ by 'load-kernel'
  relink-labels  relink-equates                   \ relink labels & equates
  $>pad pad $>asciiz delete-path              \ delete temporary file
  If                                              \ issue warning if not
    cr ." Warning: Can't delete SEGMENTS.TMP" cr  \  deleted
  Endif  ;




\ Free-UnLinked-Pages .. J Lee -- 18/3/91
\

: Free-UnLinked-Pages  ( -- ; free pages if not linked )
  segment-table
  Begin
    dup cell + @  dup -1 <>
  While
    release-chunk
    dcell +
  Repeat
  drop  ;




\ Load-Page Load-Kernel Resume-Project .. J Lee -- 08/08/90
\


: Load-Page	( page# -- )
  dup set-page-pcbs
  read-segs
  relink-page
  page-base @ swap page-chunk!  ;


: Load-Kernel	( seg $addr -- )
  set-pcbs		\ set project file names
  read-globals			\ to get the page-table
  0 set-page-pcbs		\ set page file names
  read-segs
  relink-kernel-page
  reset-globals
  ?Rom @(g)				\ rom/ram system?
  If					\ y:  load initialised RAM table
  	load-ram
  Endif
  read-requireds
  "" SEGMENTS.TMP" Segments.Pcb set-pathname    \ save translated segment
  save-segs                                     \ table for 'relink-others'
  page-base @ 0 page-chunk!  ;


: Resume	( -- )
  0 >page-table page.name img.pcb set-pathname  "" .IMG" img.pcb set-ext
  img.pcb i.open abort" can't open file"
  state(t) off(g)
  cc-quit  ;


: (Suspend)	( seg $addr -- )
  >api-window             \ re-direct i/o to api window
  2dup suspend-kernel	\ save kernel page always
  #Pages 1		\ for all possible pages
  ?Do
  	i page-chunk@ 0<>  i data-page? not         \ page present
               AND                                     \ AND not a data page
  	If					\ y:  save page
  		i save-page
  	Endif
  Loop
  cr cr ."  PROJECT SUSPENDED ... " count-l type-l cr cr
  ;  PUBLIC


: (Restart)  ( seg $addr -- )
  title
  cr cr ."  RESUMING PROJECT ... " 2dup count-l type-l cr cr
  assign free-unlinked-pages to-do free-all-pages
  load-kernel
  #Pages 1
  ?Do
  	i page-chunk@ 0<>  i data-page? not   AND
        If
  	  i load-page
  	Endif
  Loop
  relink-others
  assign (free-all-pages) to-do free-all-pages  ;  PUBLIC


only forth definitions

