((
\ Umbilical Forth host side                        sfp 06/03/88

Jonathan Lee, February 1988

Copyright (c) 1988
MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF
tel: 0703 631441        (inside UK)
     (+44) 703 631441   (international)

))


only forth also c-c also Umbilical definitions

\ ?Token Symbol-Of [ primitives ] ............. J LJon 20/03/89
                                      \

: ?Token                              \ addr -- targ-addr
  @(s)l ?dup ?undef ;                 \
                                      \
: Symbol-Of                           \ -- addr ; <wordname>
  [compile] target  ;                 \
immediate                             \

\ Split *** DEPENDENT *** ...................... J sfp 03/04/89
                                      \
hex                                   \
: Split                               \ n -- bl bh
  0 0100 um/mod                       \
;                                     \
decimal                               \

\  Split has to produce the bytes in the order that the
\  TARGET expects them to be stacked to form a 16b word.

\ Wait-byte ?synch-byte ........................ J  \  13/10/91

: Wait-byte                           \ -- b
  byte-to-host                        \ From serial port via
\  cr ." Receiving: " dup .
;                                     \ MF-COMM
                                      \
: ?synch-byte                         \ b -- ( expected )
  ACK! <> abort" message error"       \ ACK! code byte expected
;                                     \ else error

\ Send-byte Send-word *** DEPENDENT *** ........ J  \  13/10/91
                                      \
: Send-byte                           \ b --
\ 1000 0 do loop				\ delay to help target keep up
\  cr ." Sending:" dup .
  byte-to-target                      \ To serial port via
;                                     \ MF-COMM
                                      \
: Send-word                           \ n --
  split                               \ -- bl bh
  send-byte                           \ -- bl
  wait-byte ?synch-byte               \ -- bl
  send-byte                           \ --
  wait-byte ?synch-byte               \ --
;                                     \
                                      \ Send each byte and wait
                                      \ for ACK! to be returned.
\ Receive-byte Receive-word *** DEPENDENT *** .. J L   06/03/88
                                      \
hex                                   \
: Receive-word                        \ -- n
  wait-byte                           \ -- bh
  ACK! send-byte                      \ -- bh
  wait-byte                           \ -- bh bl
  ACK! send-byte                      \ -- bh bl
  swap 100 * +                        \ Convert to a word -- n
;                                     \
decimal                               \

\ send-stack receive-stack                         sfp 28/06/90

: send-stack    \ sys -- ; send stack to target
  depth dup send-word  ?dup             \ say what's to come
  if  0 swap 1-                         \ send bottom first
      do  i roll send-word  -1 +loop
  endif  ;

: receive-stack \ -- sys ; receive stack from target
  receive-word 0                        \ how many words ?
  ?do  receive-word  loop  ;            \ receive them

\ .-host-mess(r) ............................... J sfp 28/06/90

: .-host-mess(r)        \ -- ; From serial
  ACK! send-byte  receive-word .  ;

: s>t-host-mess(r)      \ sys -- ; send host stack to target
  ACK! send-byte  send-stack  ;

: s>h-host-mess(r)      \ -- sys ; receive stack from target
  ACK! send-byte  receive-stack  ;

\ Push-host-mess(r) Key?-host-mess(r) .......... J sfp 28/06/90

: Push-host-mess(r)     \ -- n ; From serial
  ACK! send-byte  receive-word  ;     \ Leave n on HOST stack

: Key?-host-mess(r)     \ -- ; ( To serial )
  ACK! send-byte  key? send-word  ;   \ Send flag to serial

\ Key-host-mess(r) emit-host-mess(r) .. ........ J L  19/02/88

: Key-host-mess(r)                    \ -- ( To serial )
  ACK! send-byte                      \
  key send-word                       \ Send char to serial
;                                     \
                                      \
: Emit-host-mess(r)                   \ -- ( From serial )
  ACK! send-byte                      \
  receive-word                        \
  emit                                \ Emit char to serial
;                                     \

\ Host-message(r) .............................. J sfp 28/06/90
                                                \
: Host-message(r)                               \ mess# --
  CASE                                          \
    key-cmnd>h  OF  key-host-mess(r)  ENDOF     \
    emit-cmnd>h OF  emit-host-mess(r) ENDOF     \
    push-cmnd>h OF  push-host-mess(r) ENDOF     \
    key?-cmnd>h OF  key?-host-mess(r) ENDOF     \
    .-cmnd>h    OF  .-host-mess(r)    ENDOF     \
    s>t-cmnd>h  OF  s>t-host-mess(r)  ENDOF     \
    s>h-cmnd>h  OF  s>h-host-mess(r)  ENDOF     \
    abort" Illegal message from target"         \
  ENDCASE                                       \
;                                               \

\ check-target-errors                              sfp 28/06/90

: check-target-errors   \ n -- n'
  dup SUFL! = 1 ?error  ;

\ Receive-message .............................. J sfp 28/06/90
: Receive-message	\ --
  BEGIN                               \
    wait-byte                         \ Wait for TARGET MESSAGE

\ debug
	dup ACK! =
	If  cr ." FAULT" cr  drop wait-byte  Endif

    dup OK! <>                        \
  WHILE                               \
    host-message(r)                   \ Execute MESSAGE
  REPEAT                              \
  Drop                                \
;                                     \

((                                      \
: Receive-message                     \ --
  BEGIN                               \
    wait-byte                         \ Wait for TARGET MESSAGE
    check-target-errors               \ check target errors
    dup OK! <>                        \
  WHILE                               \
    host-message(r)                   \ Execute MESSAGE
  REPEAT                              \
  Drop                                \
;                                     \
))
\ Pop-host-message(s) .......................... J sfp 06/07/90

: Pop-host-mess(s)      \ -- n
  wait-byte ?synch-byte
  receive-word  ;

\ exec-host-mess(s) push-host-mess(s) .......... J sfp 28/06/90
                                      \
: Exec-host-mess(s)                   \ n --
  wait-byte                           \ Wait for ACK! code
  ?synch-byte                         \ Error if not
  send-stack                          \ Send stack over
  receive-message		      
  receive-stack			      \
;                                     \

: Push-host-mess(s)                   \ n --
  wait-byte                           \ Wait for ACK! code
  ?synch-byte                         \ Error if not
  send-word                           \
;                                     \

\ s>t-host-mess(s) s>h-host-mess(s)                sfp 06/07/90

: s>t-host-mess(s)      \ sys -- ; send host stack to target
  wait-byte ?synch-byte                 \ wait for acknowledge
  send-stack  ;

: s>h-host-mess(s)      \ -- sys ; receive target stack
  wait-byte ?synch-byte                 \ wait for acknowledge
  receive-stack  ;

\ @-host-mess(s) !-host-mess(s)                    sfp 06/07/90

: @-host-mess(s)        \ addr -- n
  wait-byte ?synch-byte                 \ wait for acknowledge
  send-word  receive-word  ;

: !-host-mess(s)        \ n addr --
  wait-byte ?synch-byte                 \ wait for acknowledge
  swap send-word send-word  ;

\ Host-message                                     sfp 06/07/90

: Host-message(s)       \ mess# --
  CASE
    execute-cmnd>t OF  exec-host-mess(s)  ENDOF \
    push-cmnd>t    OF  push-host-mess(s)  ENDOF \
    pop-cmnd>t     OF  pop-host-mess(s)   ENDOF \
    s>t-cmnd>t     OF  s>t-host-mess(s)   ENDOF \ stack > target
    s>h-cmnd>t     OF  s>h-host-mess(s)   ENDOF \ stack > target
    @-cmnd>t       OF  @-host-mess(s)     ENDOF \ @(T)
    !-cmnd>t       OF  !-host-mess(s)     ENDOF \ !(T)
    C@-cmnd>t      OF  @-host-mess(s)     ENDOF \ C@(T)
    C!-cmnd>t      OF  !-host-mess(s)     ENDOF \ C!(T)
    1 abort"  Illegal Message to target"
  ENDCASE
  ACK! send-byte  ;

\ Send-message >Target ......................... J Jon 20/03/89
                                      \
: Send-message                        \ mess# --
  dup send-byte                       \ Send MESSAGE byte
  host-message(s)                     \ Execute host part
;                                     \
                                      \
: >Target                             \ pars... mess# --
  send-message                        \
  receive-message                     \
;                                     \

\ >Target target-exec targ-prompt............... J sfp 03/04/89
                                      \
: target-exec                         \ n --
  ?token                              \ Is token defined ?
  execute-cmnd>t >target              \
;                                     \
