((

	MPE 180/z80 Cross Assembler

	180 assembler - september 1985
	converted to Forth-83 - november 87
	converted to version 5 compiler - August 1990

	Copyright (c) 1985, 1987
	MicroProcessor Engineering
	133 Hill Lane
	Shirley
	Southampton SO1 5AF
	England

	tel:		(+44) 703 631441

))


\ cross assembler load screen  .............       sfp 10/02/90

only forth also c-c definitions

\ for a cross-assembler, load these screens
DECIMAL 10 17 from-file xasm180.fth           \ cross assembler prefix
DECIMAL 80 86 from-file xasm180.fth           \ local labels
DECIMAL 20 65 from-file xasm180.fth           \ assembler body
DECIMAL 70 77 from-file xasm180.fth           \ cross assembler end

only forth also c-c definitions
;p
\ conventional assembler load screen               sfp 10/02/90

only forth definitions
vocabulary assembler  also assembler definitions

DECIMAL 5  LOAD         \ load prefix

\ if testing assembler, load screen 4
\ DECIMAL 4 LOAD

DECIMAL 80 LOAD         \ local labels
DECIMAL 10 LOAD         \ assembler body
DECIMAL 78 LOAD         \ end of conventional assembler



\ load this screen if testing the assembler        sfp 29/01/90
((
: .BYTE         BASE @ SWAP  HEX
                0 <# # # #> TYPE SPACE
                BASE !  ;
: .WORD         BASE @ SWAP  HEX
                0 <# # # # # #> TYPE SPACE
                BASE !  ;

: C,(T)         DUP .BYTE C,(T)  ;
: w,(T)         DUP .WORD W,(T)  ;


))
\ target reference words                           sfp 29/01/90
((
: HERE(T)       HERE  ;
: W,(T)         W,  ;           : C,(T)         C,  ;
: W@(T)         @  ;            : C@(T)         C@  ;
: W!(T)         !  ;            : C!(T)         C!  ;
))
\

\ general assembler variables                      sfp 29/01/90

variable <prefix>               \ prefix/postfix mode
         <prefix> off           \ default to postfix
create aprior  0 , 0 ,          \ see ?prefix
create last-pos 0 , 0 ,         \ holds BLK & >IN

\

\ save-pos restore-pos                             sfp 29/01/90

: save-pos      \ -- ; preserves opcode position in text
  blk @  >in @  last-pos 2!  ;

: restore-pos   \ -- ; restore text position
  last-pos 2@  >in !  blk !  ;

\

\ a-error ?a-error                                 sfp 29/01/90

: prefix?       \ -- t/f ; true if in prefix mode
  <prefix> @  ;

: a-error       \ n -- ; error exit
  prefix?
  if  restore-pos  endif
  error  ;

: ?a-error      \ t/f n -- ; error n if t/f true
  swap
  if  a-error  else  drop  endif  ;
\

\ short? ?short                                    sfp 10/02/90

\ MPE Z80 Cross assembler                          sfp 29/01/90
hex
CR CR   ." Loading Z80/64180 Cross Assembler ..." CR  HEX

also assembler definitions

: ?Uncons	( -- )
	Ref1 @(g) ?dup
	If
		cr cell+ @ 6u.r  02e error  Ref1 off(g)
	Endif
	Ref2 @(g) ?dup
	If
		cr  cell+ @ 6u.r  02e error  Ref2 off(g)
	Endif  ;


\ general assembler variables                      sfp 29/01/90

variable <prefix>               \ prefix/postfix mode
         <prefix> off           \ default to postfix
create aprior  0 , 0 ,          \ see ?prefix
create last-pos 0 , 0 ,         \ holds BLK & >IN



\ save-pos restore-pos                             sfp 29/01/90

: save-pos      \ -- ; preserves opcode position in text
  blk @  >in @  last-pos 2!  ;

: restore-pos   \ -- ; restore text position
  last-pos 2@  >in !  blk !  ;



\ a-error ?a-error                                 sfp 29/01/90

: prefix?       \ -- t/f ; true if in prefix mode
  <prefix> @  ;

: a-error       \ n -- ; error exit
  prefix?
  if  restore-pos  endif
  error  ;

: ?a-error      \ t/f n -- ; error n if t/f true
  swap
  if  a-error  else  drop  endif  ;

\ short? ?short                                    sfp 10/02/90

hex

: short?
  -080 07F within? ;

: ?short        \ n -- ; error if not in range -128..+127
  short? 0= 024 ?a-error  ;

\ 26/09/91

\ forward-set absolute                             sfp 29/01/90

: forward-set	( addr mode -- addr )
	>r							\ preserve mode
	sc/c(s)						\ preserve order
	here(t) over dcell(s)+ ref-seg @(g) swap !(s)l	\ put addr in packet
	r> over 3 cells(s)+ ref-seg @(g) swap !(s)l		\ put mode in packet
	rc/c(s)  ;					\ restore order

: Absolute	( addr -- )
	dup
	If
		dup Ref1 @(g) =
		If
			Ref1-Seg @(g) ref-seg !(g)
			Ref1 off(g)  1 forward-set
		Endif
		dup Ref2 @(g) =
		If
			Ref2-Seg @(g) ref-seg !(g)
			Ref2 off(g)  1 forward-set
 		Endif
	Endif
	w,(t) ;



\ rel8                                             sfp 29/01/90

: Rel8	( addr/n -- )
	dup
	If
		dup Ref1 @(g) = 
		If
			Ref1-Seg @(g) Ref-Seg !(g)
			Ref1 off(g)  3 forward-set
			drop  0 c,(t)  exit
		Endif
		dup Ref2 @(g) =
		If
			Ref2-Seg @(g) Ref-Seg !(g)
			Ref2 off(g)  3 forward-set
			drop  0 c,(t)  exit
		Endif
	Endif
	here(t) 1+ - dup ?short
	c,(t)  ;

\                                                 sfp 29/01/90



\ ?prefix                                          sfp 29/01/90
\
\ The basis of this code was presented by Bob Smith at the
\ November 1987 FORML Conference - thanks
\
: ?prefix       \ structure -- str' ; executes previous opcode
  prefix?
  if  r>
      aprior 2@  2swap  aprior 2!
      >r
  endif  ;

\

\ prefix postfix                                   sfp 29/01/90

also interpreter definitions

: prefix        cc/i  <prefix> on  ;

: postfix       cc/i  <prefix> off  ;

previous definitions

\

\ Define operand addressing modes for two operands sfp 15/04/87
HEX

1 CONSTANT 8BR                  ( 8 bit register, or [hl] )
2 CONSTANT IND-MODE             ( indirect - [ix], [iy] )
3 CONSTANT 16BR                 ( 16 bit register )
4 CONSTANT IMM-MODE             ( immediate operand )
5 CONSTANT SPEC-REG             ( special cases of reg usage )
6 CONSTANT SP-IND               ( index through special regs )

\

\ Define registers                                 sfp 15/04/87
HEX
( 8 bit registers )
0 CONSTANT B-REG                1 CONSTANT C-REG
2 CONSTANT D-REG                3 CONSTANT E-REG
4 CONSTANT H-REG                5 CONSTANT L-REG
6 CONSTANT (HL)-REG             7 CONSTANT A-REG

( 16 bit registers )
0 CONSTANT BC-REG               1 CONSTANT DE-REG
2 CONSTANT HL-REG               3 CONSTANT SP-REG
0DD CONSTANT IX-REG             0FD CONSTANT IY-REG

\

\ define special registers                         sfp 29/01/90

-1 CONSTANT I-REG               -2 CONSTANT R-REG
-3 CONSTANT AF-REG              -4 CONSTANT AF'-REG
-5 CONSTANT (BC)-REG            -6 CONSTANT (DE)-REG
-7 CONSTANT (SP)-REG

\

\ variables                                        sfp 29/01/90

\ -- addr
  VARIABLE M1   ( addressing mode of first operand )
  VARIABLE R1   ( register used by first operand )
  VARIABLE M2   ( addressing mode of second/only operand )
  VARIABLE R2   ( register used by second/only operand )
  VARIABLE CC-SET       ( condition set flag )
  VARIABLE C-CODE       ( condition used )
  VARIABLE (C)-MODE     ( [c] for in & out instructions )

\

\ reset words                                      sfp 29/01/90

: reset         \ -- ; used to reset assembler variables
  M1 off  R1 off  M2 off  R2 off
  CC-SET off  C-CODE off  (C)-MODE off  ;

also asm-access definitions
: reset         \ -- ; made available for user
  reset  ;
previous definitions

also c-c definitions
: A-RESET       \ -- ; needed by cross compiler core
  [ also asm-access ]  RESET  [ previous ]  ;
previous definitions
\
\ null-op kickoff set-null                         sfp 29/01/90

: null-op       \ -- ; force execution of previous opcode
  0 ?prefix drop  a-reset  ;

: kickoff       \ n -- ; dummy operator
  drop  a-reset ;

: set-null      \ -- ; initialise APRIOR
  0 ['] kickoff >body aprior 2!  ;

\

\ asm_start asm_end                                sfp 29/01/90

also c-c definitions

: ASM_START     \ -- ; initialise assembler
  set-null  save-pos  a-reset  
;

: ASM_END       \ -- reset assembler
  null-op  
;
previous definitions
\

\ Define addressing modes                          sfp 18/05/87

( mode register -- ; -- )
: OP1           create  , ,  DOES> DUP  @ R1 !  cell+ @ M1 !  ;
: OP2           create  , ,  DOES> DUP  @ R2 !  cell+ @ M2 !  ;
also asm-access definitions
( Eight bit registers )
8BR B-REG OP1 B,                8BR B-REG OP2 B
( 8BR C-REG OP1 C,                8BR C-REG OP2 C  )
8BR D-REG OP1 D,                8BR D-REG OP2 D
8BR E-REG OP1 E,                8BR E-REG OP2 E
8BR H-REG OP1 H,                8BR H-REG OP2 H
8BR L-REG OP1 L,                8BR L-REG OP2 L
8BR (HL)-REG OP1 (HL),          8BR (HL)-REG OP2 (HL)
8BR A-REG OP1 A,                8BR A-REG OP2 A
8BR (HL)-REG OP1 S,             \
\ 16 bit register addressing / indexed addressing
HEX

16BR BC-REG OP1 BC,             16BR BC-REG OP2 BC
16BR DE-REG OP1 DE,             16BR DE-REG OP2 DE
16BR HL-REG OP1 HL,             16BR HL-REG OP2 HL
16BR SP-REG OP1 SP,             16BR SP-REG OP2 SP
16BR IX-REG OP1 IX,             16BR IX-REG OP2 IX
16BR IY-REG OP1 IY,             16BR IY-REG OP2 IY
16BR AF-REG OP1 AF,             16BR AF'-REG OP2 AF'
                                16BR AF-REG OP2 AF
( indexed addressing )

IND-MODE IX-REG OP1 (IX),       IND-MODE IX-REG OP2 (IX)
IND-MODE IY-REG OP1 (IY),       IND-MODE IY-REG OP2 (IY)
\
\ Special cases                                    sfp 15/04/87

SP-IND (BC)-REG OP1 (BC),       SP-IND (BC)-REG OP2 (BC)
SP-IND (DE)-REG OP1 (DE),       SP-IND (DE)-REG OP2 (DE)
SP-IND (SP)-REG OP1 (SP),       SP-IND (SP)-REG OP2 (SP)

previous definitions


((
( move this group to be compiled last in assembler )
( as their names conflict with standard words )
SPEC-REG I-REG OP1 I,           SPEC-REG I-REG OP2 I
SPEC-REG R-REG OP1 R,           SPEC-REG R-REG OP2 R
0 0 OP1 ,               ( direct addr, compatible with LMI )
IMM-MODE 0 OP2 #        ( immediate operand )
))
\ mode detection
HEX
( -- ; error checking, error if not so )
: MUST-BE       0= 021 ?ERROR  ;
: MUST-BE-DEST  0= 02D ?ERROR  ;
: MUST-BE-SOURCE  0= 02C ?ERROR  ;
( -- t/f )
: 8R1?          M1 @ 8BR =  ;
: 8R2?          M2 @ 8BR =  ;
: 16R1?         M1 @ 16BR =  ;
: 16R2?         M2 @ 16BR =  ;
: ACC1?         8R1?  R1 @ A-REG =  AND  ;
: ACC2?         8R2?  R2 @ A-REG =  AND  ;
: DIR1?         M1 @  R1 @  OR 0=  ;
: DIR2?         M2 @  R2 @  OR 0=  ;
: #?            M2 @ IMM-MODE =  ;      \
\ index mode detection
( -- t/f )
: IND1?         M1 @ IND-MODE =  ;
: IND2?         M2 @ IND-MODE =  ;
: XY?           @ DUP  IX-REG =  SWAP IY-REG =  OR  ;
: XY1?          16R1?  R1 XY?  AND  ;
: XY2?          16R2?  R2 XY?  AND  ;
: NOT-XY        XY? 022 ?ERROR  ;
: (HL)?         @ (HL)-REG =  ;
: (HL)2?        8R2?  R2 (HL)?  AND  ;
: HL?           @ HL-REG =  ;
( Detect HL,rp modes as these are - sort of - special cases )
: HL,RP?        16R1?  R1 HL?  AND  16R2? AND  ;
( n -- ; check index range and embed it )
: INDEX,        DUP -080 07F WITHIN? 0= 024 ?ERROR  C,(T)  ;
\
\ ?ixy, ?[ixy], ?index, ..............          sfpsfp 13/10/87

: ?IXY, ( addr -- )
        DUP  XY?                        ( addr t/f -- )
        IF  DUP @ C,(T)  HL-REG SWAP !  ( lay prefix, subst. HL)
        ELSE  DROP  ENDIF  ;            ( do nothing )

: ?(IXY),       ( addr -- )
        DUP  XY?
        IF  DUP @ C,(T)  (HL)-REG SWAP !
        ELSE  DROP  ENDIF  ;

: ?INDEX,       ( [ disp ] addr -- )
        @ IND-MODE = IF  INDEX,  ENDIF  ;
\

\ <<3  <<4  op+rp,  op+r8,  prefix, ?warn ....  sfp sept 85
( n -- n<< )
: <<3           DUP +  DUP +  DUP +  ;
: <<4           <<3  DUP +  ;

( opcode addr-of-R1/R2 -- ; adds register pair and embeds it )
: OP+RP,        @ <<4 + C,(T)  ;
: OP+R8,        @ <<3 + C,(T)  ;

( -- )
: PREFIX,       0ED C,(T)  ;
: EXTEND,       0CB C,(T)  ;

( t/f n -- )
: ?WARN         SWAP IF  CR HERE(T) U.  MESSAGE CR
                     ELSE  DROP  ENDIF  ;       \
\ 3modes tri-mode ..........................       sfp 15/04/87
( ... opcode -- t/f ; true returned if one of three modes )
: 3MODES        ACC1?                   ( A, check )
                IF  #?                  ( A, # check )
                    IF  046 + C,(T)  C,(T)  1
                    ELSE  8R2? IND2? OR ( A, R or [ixy] check )
                          IF  R2 ?(IXY),  R2 @ + C,(T)
                              M2 ?INDEX,  1
                          ELSE DROP 0
                          ENDIF
                    ENDIF
                ELSE  DROP 0  ENDIF  ;

( n -- ; ... -- ; used for AND CP OR SUB XOR  )
: TRI-MODE      create  ,  DOES> @ 3MODES MUST-BE  RESET  ;
\
\ adc ......................................... sfpsfp 15/04/87

also asm-access definitions

( ... -- ; ADC ADD SBC are special cases )
: ADC           088 3MODES 0=
                IF  HL,RP? MUST-BE  R2 NOT-XY
                    PREFIX,  04A R2 OP+RP,
                ENDIF
                RESET  ;
\

\ add - sufficiently special case
HEX
: ADD           080 3MODES 0=    ( 0 if not 1 of 3 main modes )
                IF  HL,RP?                     ( HL, rp check )
                    IF  R2 NOT-XY       ( xy not allowed here )
                        09 R2 OP+RP,
                    ELSE  XY1? MUST-BE-SOURCE
                          16R2? MUST-BE-DEST    ( XY, rp only )
                          R2 HL? 0= MUST-BE-DEST ( HL invalid )
                          R2 XY?           ( both index regs? )
                          IF  R1 @ R2 @ = MUST-BE
                              HL-REG R2 !
                          ENDIF
                          R1 @ C,(T)  09 R2 OP+RP,
                     ENDIF
                ENDIF  RESET  ; \
\ sbc .....................................
HEX

: SBC           098 3MODES 0=
                IF  HL,RP? MUST-BE  R2 NOT-XY
                    PREFIX,  042 R2 OP+RP,
                ENDIF
                RESET  ;

previous definitions
\

\ bit-ins ...................................      sfp 15/04/87

: BIT-INS       ( e.g. b 5 [ixy] bit )
        create  ,  DOES> @ >R  8R2? IND2? OR MUST-BE
        R2 ?(IXY),                               ( lay prefix )
        EXTEND,                            ( extension opcode )
        M2 ?INDEX,                               ( ix,iy disp )
        DUP 0 7 WITHIN? 0= 023 ?ERROR         ( bit in range? )
        <<3                                ( align bit number )
        R2 @ + R> + C,(T)  RESET  ;    ( combine reg + opcode )

\

\ Conditionals - indicators                        sfp 15/04/87

: CONDITION
                create  ,  DOES> @ C-CODE !  1 CC-SET !  ;
( -- )
: C-TOGGLE      CC-SET @ IF  C-CODE @ 1 XOR C-CODE !  ENDIF  ;

also asm-access definitions
0 CONDITION NZ,         1 CONDITION Z,
2 CONDITION NC,         2 CONDITION NCY,
3 CONDITION CY,
4 CONDITION PO,         5 CONDITION PE,
6 CONDITION P,          7 CONDITION M,
previous definitions
\

\ +cond call ret ...........................
HEX

: +COND,        ( opcode -- )
        CC-SET @
        IF  C-CODE @ <<3  ELSE  9  ENDIF
        + C,(T)  ;

also asm-access definitions
: CALL
        0C4 +COND, ABSOLUTE RESET  ;

: RET
        0C0 +COND, RESET  ;
previous definitions
\
\ 0op1 0op2 ................................       sfp 15/04/87

( n -- ; -- )
: 0OP1  create  ,  DOES> @ C,(T) RESET  ;

: 0OP2  create  ,  DOES>  PREFIX,  @ C,(T)  RESET  ;

\

\ inc/dec ....................................     sfp 18/05/87

( -- ; -- )
: INC/DEC
        create  , ,  DOES>
        8R2? IND2? OR                  ( indexed or 8bit reg? )
        IF  R2 ?(IXY),  cell+ @ R2 OP+R8,  M2 ?INDEX,
        ELSE  16R2? MUST-BE
              R2 ?IXY,  @ R2 OP+RP,
        ENDIF
        RESET  ;

\

\ djnz im ..................................

also asm-access definitions
: DJNZ  010 C,(T) REL8 RESET  ;

: IM    PREFIX,
        CASE
          0     OF  046 C,(T)   ENDOF
          1     OF  056 C,(T)   ENDOF
          2     OF  05E C,(T)   ENDOF
                026 ERROR
        ENDCASE
        RESET  ;
previous definitions
\

\ ex ......................................        sfp 12/08/87
also asm-access definitions
: EX    16R1? 16R2? AND         ( check both ops 16-bit reg )
        IF  R1 @ AF-REG =  R2 @ AF'-REG = AND
            IF  08 C,(T)
            ELSE  R1 @ DE-REG =  R2 HL?  AND
                  r1 hl?  r2 @ de-reg =  and  or
                  0= 025 ?ERROR   0EB C,(T)
            ENDIF
        ELSE  M1 @ SP-IND =  R1 @ (SP)-REG =  AND  MUST-BE-DEST
              16R2? MUST-BE-SOURCE
              R2 ?IXY,  R2 HL? MUST-BE-SOURCE  0E3 C,(T)
        ENDIF
        RESET  ;
previous definitions
\
\ in out .....................................     sfp 18/04/87
: PORT, DUP  0 0FF WITHIN? 0= 027 ?ERROR  C,(T)  ;
also asm-access definitions
: (C)   1 (C)-MODE !  ;
: (C),  (C)  ;
: IN    ACC1? DIR2? AND  (C)-MODE @ 0= AND
        IF  0DB C,(T) PORT,                          ( a, port )
        ELSE  8R1? (C)-MODE @  AND  MUST-BE         ( reg, [c] )
              PREFIX,  040 R1 OP+R8,
        ENDIF  RESET  ;
: OUT   DIR1? ACC2? AND  (C)-MODE @ 0= AND
        IF  0D3 C,(T) PORT,     ( port , a )
        ELSE  8R2? (C)-MODE @  AND  MUST-BE   (HL)2? 02A ?WARN
              PREFIX,  041 R2 OP+R8,
        ENDIF  RESET  ;
previous definitions    \
\ jp jr ......................................
also asm-access definitions
: JP    DIR2?
        IF  CC-SET @
            IF  0C2 C-CODE @ <<3 +  ELSE  0C3  ENDIF
            C,(T)  ABSOLUTE
        ELSE  (HL)2? IND2? OR MUST-BE
              R2 ?(IXY), 0E9 C,(T)
        ENDIF
        RESET  ;

: JR    CC-SET @
        IF  C-CODE @ DUP  3 > 028 ?ERROR  <<3 020 +
        ELSE  018 ENDIF
        C,(T) REL8  RESET  ;
\
\ ld - screen 1 ...........................

: LD    CASE
        #?      ?OF  CASE  M1 @
                     8BR   OF  06 R1 OP+R8, C,(T)  ENDOF
                     16BR  OF  R1 ?IXY,
                               01 R1 OP+RP,  ABSOLUTE  ENDOF
                     IND-MODE
                           OF  R1 ?(IXY),  036 C,(T)
                               SWAP  INDEX,  C,(T)  ENDOF
                           0 MUST-BE-DEST
                     ENDCASE
                ENDOF

\

\ ld - screen 2 ...........................        sfp 15/04/87
        DIR2?   ?OF  ACC1?
                     IF  03A C,(T) ABSOLUTE     ( a, nnnn )
                     ELSE  16R1? MUST-BE-DEST   ( rp, nnn )
                           R1 ?IXY,  R1 HL?
                           IF  02A C,(T)
                           ELSE  PREFIX,  04B R1 OP+RP,  ENDIF
                           ABSOLUTE
                     ENDIF      ENDOF

        8R1?  8R2? IND2? OR  AND        ( r, r or r, d [xy] )
                ?OF  R1 (HL)?  IND2? AND  02A ?WARN
                     R2 ?(IXY), 040 R2 @ + R1 OP+R8,  M2 ?INDEX,
                ENDOF
\

\ ld - screen 3 ...............................

        DIR1?   ?OF  ACC2?
                     IF  032 C,(T) ABSOLUTE     ( nnnn , a )
                     ELSE  16R2? MUST-BE-SOURCE
                           R2 ?IXY,  R2 HL?
                           IF  022 C,(T)
                           ELSE  PREFIX,  043 R2 OP+RP,  ENDIF
                           ABSOLUTE
                     ENDIF      ENDOF

        IND1? 8R2? AND                  ( d [ixy], r )
                ?OF  (HL)2? 02A ?WARN
                     R1 ?(IXY),  070 R2 @ + C,(T)  INDEX,  ENDOF

\
\ ld - screen 4 ...........................

        16R1? 16R2? AND                 ( sp, hl or sp, ixy )
                ?OF  R1 @ SP-REG = MUST-BE-DEST
                     R2 ?IXY,  R2 HL? MUST-BE-SOURCE
                     0F9 C,(T)          ENDOF

        ACC1?   ?OF  CASE  M2 @
                       SPEC-REG  OF  PREFIX,  R2 @ I-REG =
                                     IF  057  ELSE  05F  ENDIF
                                     C,(T)      ENDOF
                       SP-IND    OF  R2 @ (BC)-REG =
                                     IF  0A  ELSE  01A  ENDIF
                                     C,(T)      ENDOF
                                 0 MUST-BE-SOURCE
                      ENDCASE           ENDOF           \
\ ld - screen 5 ...........................

        ACC2?   ?OF  CASE  M1 @
                     SPEC-REG   OF  PREFIX,  R1 @ I-REG =
                                    IF  047  ELSE  04F  ENDIF
                                    C,(T)       ENDOF
                     SP-IND     OF  R1 @ (BC)-REG =
                                    IF  02  ELSE  012  ENDIF
                                    C,(T)       ENDOF
                                0 MUST-BE-DEST
                     ENDCASE            ENDOF
                0 MUST-BE  1
        ENDCASE
        RESET  ;
previous definitions
\
\ mlt in0 out0                                     sfp 14/10/87
also asm-access definitions  hex

: mlt           \ -- ; rp mlt ; needs 16-bit regiser operand
  16r2? must-be   r2 not-xy             \ 16-bit reg, not IX,Y
  prefix,  04C r2 op+rp,  reset  ;      \ lay opcode

: in0           \ n -- ; g, port# in0
  8r1? must-be-dest  dir2? must-be-source       \ check modes
  prefix,  0 r1 op+r8,  port,  reset  ;         \ lay data

: out0          \ n -- ; port# g out0
  dir1? must-be-dest  8r2? must-be-source       \ check modes
  prefix,  1 r2 op+r8,  port,  reset  ;         \ lay data

previous definitions    \
\ pop/push ...................................     sfp 15/04/87

: POP/PUSH
        create  ,  DOES> @
        16R2? MUST-BE                       ( 16-bit regs only)
        R2 @  DUP SP-REG = 0= MUST-BE       ( not stack point!)
        AF-REG = IF SP-REG R2 ! ENDIF       ( take AF instead )
        R2 ?IXY,  R2 OP+RP,  RESET  ;       ( check xy, add op)

\

\ shift rst ..................................     sfp 15/04/87

: SHIFT         create  ,  DOES> @ >R
                8R2? IND2? OR MUST-BE
                R2 ?(IXY),  EXTEND,  M2 ?INDEX,
                R> R2 @ + C,(T)
                RESET  ;

also asm-access definitions
: RST           DIR2? MUST-BE
                DUP 8 < IF  <<3  ENDIF
                0C7 + C,(T)  RESET  ;
previous definitions
\

\ tstio                                            sfp 14/10/87

also asm-access definitions  hex

: tstio         \ port# -- ; (c), m tstio
  (c)-mode @ must-be-dest               \ check first operand
  dir2? must-be-source                  \ check second operand
  prefix,  074 c,(t)  port,  reset  ;   \ lay opcodes

previous definitions

\

\ tst                                              sfp 14/10/87

also asm-access definitions  hex

: tst           \ ; tst a, g ; tst a, # m ; tst a, (hl)
  acc1? must-be-dest  #?                \ dest always acc.
  if  prefix,  064 c,(t)  c,(t)         \ lay immediate opcodes
  else  8r2? must-be-source             \ check source operand
        prefix,  04 r2 op+r8,           \ lay register opcodes
  endif                                 \
  reset  ;                              \ reset assembler

previous definitions

\

\ tri-mode bit-ins                                 sfp 15/04/87

also asm-access definitions

0A0 TRI-MODE AND        0B8 TRI-MODE CP
0B0 TRI-MODE OR         090 TRI-MODE SUB
0A8 TRI-MODE XOR

040 BIT-INS BIT         080 BIT-INS RES
0C0 BIT-INS SET

\

\ zero operand instructions                        sfp 06/04/90

03F 0OP1 CCF    0A9 0OP2 CPD    0B9 0OP2 CPDR   0A1 0OP2 CPI
0B1 0OP2 CPIR   02F 0OP1 CPL    027 0OP1 DAA    0F3 0OP1 DI
0FB 0OP1 EI     0D9 0OP1 EXX    076 0OP1 HALT   0AA 0OP2 IND
0BA 0OP2 INDR   0A2 0OP2 INI    0B2 0OP2 INIR   0A8 0OP2 LDD
0B8 0OP2 LDDR   0A0 0OP2 LDI    0B0 0OP2 LDIR   044 0OP2 NEG
000 0OP1 NOP
0AB 0OP2 OUTD   0BB 0OP2 OTDR   0A3 0OP2 OUTI   0B3 0OP2 OTIR
04D 0OP2 RETI   045 0OP2 RETN   017 0OP1 RLA    007 0OP1 RLCA
06F 0OP2 RLD    01F 0OP1 RRA    00F 0OP1 RRCA   067 0OP2 RRD
037 0OP1 SCF

076 0op2 SLP    08B 0op2 OTDM   09B 0op2 OTDMR  083 0op2 OTIM
093 0op2 OTIMR
\
\ inc/dec pop/push shift

05 0B INC/DEC DEC       04 03 INC/DEC INC

0C1 POP/PUSH POP        0C5 POP/PUSH PUSH

010 SHIFT RL    000 SHIFT RLC   020 SHIFT SLA   018 SHIFT RR
008 SHIFT RRC   028 SHIFT SRA   038 SHIFT SRL

\

\ special addressing modes, or conflict with Forth sfp 15/04/87

8BR C-REG OP1 C,                8BR C-REG OP2 C

SPEC-REG I-REG OP1 I,           SPEC-REG I-REG OP2 I
SPEC-REG R-REG OP1 R,           SPEC-REG R-REG OP2 R

IMM-MODE 0 OP2 #        ( immediate operand )

\

\ conditional structures 1                         sfp 15/04/87

( -- ; error if condition code set )
: ?UNC          CC-SET @ 029 ?ERROR  0 C-CODE !  ;
( -- ; error if condition code not set )
: ?CON          CC-SET @ 0= 029 ?ERROR  ;

( -- addr )
: BEGIN,        HERE(T)  ;

( addr -- )
: AGAIN,        ?UNC  JR  ;
: UNTIL,        ?CON  C-TOGGLE  C-CODE @ 3 >
                IF JP ELSE JR ENDIF  ;
\

\ conditional structures 2                         sfp 11/05/88

( -- addr 1/0 )
: IF,           ?CON  C-TOGGLE  HERE(T) 1+ DUP  C-CODE @ 3 >
                IF  JP 1  ELSE  1+ JR 0  ENDIF  ;
( addr n -- )
: THEN,         IF  HERE(T) SWAP W!(T)
                ELSE  HERE(T) OVER 1+ - dup ?short SWAP C!(T)
                ENDIF  ;
: ENDIF,        THEN,  ;
( -- addr )
: SKIP,         ?UNC  HERE(T) 1+ DUP 1+ JR  ;
( addr1 1/0 -- addr2 0 )
: ELSE,         >R >R  ?UNC HERE(T) 1+ DUP 1+ JR
                R> R> THEN,  0  ;
\
\ conditional structures 3                         sfp 15/04/87

( -- addr 1/0 )
: WHILE,        IF,  ;
( addr/begin addr/while 1/0 -- )
: REPEAT,       ?UNC  ROT JR  THEN,  ;

( n -- addr )
: DO,           B, # LD  BEGIN,  ;
( addr -- )
: LOOP,         DJNZ  ;
previous definitions







\ Cross Assembler clean up                         sfp 30/03/90
hex
also asm-access definitions
: C-C   [COMPILE] C-C  ;        IMMEDIATE
: CC/A  [COMPILE] CC/A  ;       IMMEDIATE

: End-Code	( -- )
  asm_end  ?uncons
	sp@ cell+ <> 02f ?error
\	'latest: 2@(v) smudge(s)
	State(t) off(g)  ;

: Forth	( -- )
	end-code  ;
previous definitions
\
\ target branch words                              sfp 15/04/87

only forth also c-c definitions hex

        CR CR   ." Loading target branches ....."  CR

: MRK>          HERE(T)  0 W,(T)  ;
: MRK<          HERE(T)  ;

( absolute branches )
: >RES          HERE(T) SWAP W!(T)  ;
: <RES          W,(T)  ;
((
( relative branches )
: >RES          HERE(T) OVER - SWAP W!(T)  ;
: <RES          HERE(T) - W,(T)  ;
))
\ (Resolve) .............................          sfp 29/01/90
  cr cr .( loading resolve ...) cr cr
: (Resolve)	(( n fwd-ref(d) symbol(d) -- ))
\  cr ." RESOLVING: " 2dup >name(s) .name(s) cr 
	status+ mark-resolved	\ mark symbol as resolved
	3dup !(s)l			\ set target addr in symbol
	cell(s)+ 2dup 2@(s)l	\ fetch next forward reference packet
	0 0 2rot 2!(s)l		\ set ^forward reference as resolved
	rot >r				\ stach symbol value
	Begin
		2dup or 0<>
	While
		2dup dcell(s)+  2dup @(s)l
		r@ swap 2swap cell(s)+ @(s)l
		Case                		\ label-addr reference-location mode
			assembl?  state_flag @(g) 2 =   or
			If				\ fix for labels page
				save-env-page @(g) curr-page!
			Endif
      			0 Of !(t) Endof                       \ CFA
		      	1 Of !(t) Endof                       \ absolute address
			2 Of swap over 2+ - swap !(t) Endof   \ 16 bit offset
			3 Of swap over 1+ - [+assembler] dup ?short [previous]
                          swap c!(t) Endof  \ 8 bit offset
		          abort" illegal addressing mode "
		Endcase
\		assembl?  state_flag @(g) 2 =   or
\		If				\ fix for labels page
\			0 curr-page!
\		Endif
		2@(s)l
	Repeat
	2drop r> drop ;

\ Resolve Resolve-Def-Word (Host-Create)           Jon 17/11/88
                                      \
: Resolve                             \ n addr -- n addr val-fld
  2dup (resolve)                      \ go resolve symbol
;                                     \
                                      \
: Resolve-Def-Word	(( n addr(d) -- ))
	2dup status+ mark-run-time           \ mark run time defined
	2dup 3 cells(s)+ 2swap               \ target addr field
	(resolve)  ;                         \ go resolve symbol

\ dodoes, docreate,                                Jon 16/08/88
hex
: asm-run-ref	( )
	state(t) @(g) >r  2 state(t) !(g)  run-time-ref
	r> state(t) !(g)  ;


: compile-call
  asm-run-ref
  [ also assembler ] 0CD c,(t) absolute [previous]  ;

: compile-jmp
  asm-run-ref
  [ also assembler ] 0C3 c,(t) absolute [previous]  ;

: compile-run	( )
  3 cells(s)+ compile-jmp  ;


\ ?align-pfa                                       sfp 29/01/90

: ?align-pfa    \ -- ; insert NOP to put PFA on even boundary
  here(t) 1 and 0=
  if  090 c,(t)  endif  ;

\

\ Dodoes, Docreate,                                Jon 16/08/88

: asm-ref	( )
	state(t) @(g) >r  2 state(t) !(g)  ref  r> state(t) !(g)  ;

: DODOES,
  the-label DODOES
  asm-ref  [ also asm-access ] call [previous]  ;

: DOCREATE,
  the-label DOCREATE
  asm-ref  [ also asm-access ] jp [previous]  ;

\ end of cross assembler                           Jon 16/08/88

        CR CR ." Cross Assembler loaded. "  CR


\ end of conventional assembler                    sfp 29/01/90

only forth  also assembler  also forth definitions
: L:            ?EXEC  create  smudge  !CSP
                also asm-access  RESET INITFWD  ;
: CODE          ?EXEC  !CSP CREATE  -3 allot
                also asm-access  RESET INITFWD  ;  IMMEDIATE
: ;CODE         ?COMP ?CSP  COMPILE (;CODE)
                also asm-access  !CSP  [COMPILE] [
                RESET INITFWD  ;  IMMEDIATE
only forth definitions

: END-CODE      ?EXEC ?CSP SMUDGE  previous  ;  IMMEDIATE



\ 64180 Assembler extensions                       sfp 10/02/90
decimal

: 4*    2* 2* ;

32 CONSTANT MAXREF      ( no. of forward references )
create FWDREFS      MAXREF 4* ALLOT

10 CONSTANT MAXLAB      ( no. of local labels )
create LABTAB       MAXLAB 2* ALLOT

: FWD                           ( n -- )
    4* FWDREFS + ;
: LABEL                         ( n -- )
    2*  LABTAB + ;
\
\ 64180 Assembler extensions                       sfp 10/02/90
Hex

: ?UNRES-LOCS   \ -- ; look for unresolved forward references
  MAXREF 0
  DO  I FWD @ 02E ?ERROR  LOOP ;        \ should all be resolved

also c-c definitions
: INITFWD       \ -- ; initialize tables
  FWDREFS MAXREF 4* ERASE               \ erase both tables
  LABTAB MAXLAB 2*  ERASE  ;  INITFWD
previous definitions

: RELATIVE      \ addr -- offset
  HERE(T) SWAP - ;
\
\ Z80 Assembler  extensions                        sfp 30/03/90
HEX
: resolve-label         \ n -- n ; resolve forward references
  MAXREF  0
  DO  I FWD DUP @                       \ -- n addr ref
      2 PICK =                          \ -- n addr t/f
      IF  DUP 2+ @ DUP C@(T)            \ -- n tabadd addr op
          DUP 0C7 AND 0=  SWAP  038 AND 8 > AND
          IF  DUP 2+ RELATIVE  DUP short? 0= 024 ?ERROR
              SWAP 1+ C!(T)           ( 8 bit relative )
          ELSE  HERE(T) SWAP 1+ !(T)  ( 16 bit absolute )
          ENDIF
          0 SWAP ! ( remove from table )
      ELSE  DROP
      ENDIF
  LOOP  ;                  \
\ Z80 Assembler extensions                         sfp 30/03/90

: ADDFWD         ( add forward reference to table )
                ( n  ---  n )
        MAXREF 1+ 0
        DO
                MAXREF I = 1C ?ERROR
                I FWD DUP @ 0=
                IF      2DUP ! HERE(T) SWAP 2+ ! LEAVE
                ELSE    DROP
                ENDIF
        LOOP ;

DECIMAL
\

\ Z80 Assembler  extensions                        sfp 30/03/90
ASSEMBLER

: !LABTAB       ( set up addr of local label )
                ( n  --- )
                resolve-label HERE(T) SWAP LABEL ! ;

: @LABTAB       ( get local label addr, or if undefined )
                ( add current dict.position to forward refs )
                ( n  ---  addr )
                DUP LABEL @ SWAP OVER 0=
                IF  ADDFWD 2DROP HERE(T)
                ELSE  DROP
                ENDIF  ;
\

\ Z80 Assembler                                    sfp 30/03/90
HEX
also asm-access definitions
( local label definition )
: L$:   DUP 0 MAXLAB WITHIN? 0= 02D ?ERROR
        !LABTAB ;

( local label reference )
: L$    DUP 0 MAXLAB WITHIN? 0= 02D ?ERROR
        @LABTAB ;

: LOC-DEF     create  ,  DOES>  @  L$: ;
: LOC-REF     create  ,  DOES>  @  L$  ;
previous definitions
\

\ Preset local labels                              sfp 29/01/90

also asm-access definitions
1 LOC-DEF L$1:          1 LOC-REF L$1
2 LOC-DEF L$2:          2 LOC-REF L$2
3 LOC-DEF L$3:          3 LOC-REF L$3
4 LOC-DEF L$4:          4 LOC-REF L$4
5 LOC-DEF L$5:          5 LOC-REF L$5
6 LOC-DEF L$6:          6 LOC-REF L$6
7 LOC-DEF L$7:          7 LOC-REF L$7
8 LOC-DEF L$8:          8 LOC-REF L$8
9 LOC-DEF L$9:          9 LOC-REF L$9
10 LOC-DEF L$10:        10 LOC-REF L$10
previous definitions
DECIMAL
\
\                                                 sfp 29/01/90


