((

	XC-EMU.FTH

	MPE Forth Cross Compiler v5.00

	J Lee - 10/7/90


	Copyright (C) 1983-1990

	MicroProcessor Engineering
	133 Hill Lane
	Southampton
	SO1 5AF
	England

	tel: (+44) 703 631441   (international)
	tel: 0703-631441        (domestic)

))




only forth also c-c definitions
decimal


((
Byte ordering selection:
Check that the relevant big/little endian code is loaded.
))



\ Emulator output control .. Jon -- 15/02/89
\

: Emulator  ( -- )
  Emulator-Out on(g)  ;

: -Emulator  ( -- )
  Emulator-Out off(g)  ;

: Emulator?  ( -- t/f )
  Emulator-Out @(g)  ;

-Emulator                             \ default to disk output



\ u2/ du< du> d< d> .. Jon 11/01/89
\

: u2/  ( n -- n>>1 )
  0 2 um/mod nip  ;


: DU<  ( ud1 ud2 -- t/f )
  rot swap 2dup u<
  If
    2drop 2drop true
  Else
    <> If
         2drop false
       Else
         u<
       Endif
  Endif  ;


: DU>  ( ud1 ud2 -- t/f )
  2swap du<   ;


: D<  ( d1 d2 -- t/f )
  2 pick over =  If   du<   Else  nip rot drop <  Endif  ;


: D>  ( d1 d2 -- t/f )
  2swap d<  ;



\ 2Variable .............................          Jon 23/11/88
\

: 2Variable                           \ -- ; -- addr [child]
  create  0 , 0 ,
  does>  ;



\ VARIABLE I/O ADDRESSES ................       R. Jon 22/11/88
\

hex                                       \

variable epbase  0300 epbase !            \ default
                                          \
epbase @     variable addr-lo  addr-lo !  \ addr lo-byte addr U8
epbase @ 1+  variable addr-hi  addr-hi !  \ addr hi-byte
epbase @ 2+  variable cport0   cport0  !  \
epbase @ 3 + variable cword0   cword0  !  \
epbase @ 4 + variable data0    data0   !  \ data odd bytes PA U7
epbase @ 5 + variable data1    data1   !  \ data even bytes PB
epbase @ 6 + variable cport1   cport1  !  \ PC
epbase @ 7 + variable cword1   cword1  !  \ CW



\ variables .............................       R. Jon 22/11/88
\

 variable e-type
 variable e-last
2variable e-offset
 variable e-pars-mask
 variable e-bus-width



\ data0! data1!                                R. Jon 23/11/88
\

hex

code data0!     \ b addr -- ; store byte into PROM
  dx, addr-lo mov               \ point to low address port
  ax, bx mov                    \ get address
  ax, e-last and                \ mask to RAM address
  ax, e-pars-mask or            \ mask in EPROM pins 1,27,26
  dx, ax out                    \ output address
  dx, data0 mov                 \ point to data port 0 (PA)
  ax pop   dx, al out           \ send it
  dx, cword1 mov                \ point to port C
  al, # 009 mov   dx, al out    \ pulse chip select line high
  al, # 008 mov   dx, al out    \  and then low again   PC4
  bx pop                        \ restore TOS register
  next,
end-code


code data1!     \ b addr -- ; store byte into PROM
  dx, addr-lo mov               \ point to low address port
  ax, bx mov                    \ get address
  ax, e-last and                \ mask to RAM address
  ax, e-pars-mask or            \ mask in EPROM pins 1,27,26
  dx, ax out                    \ output address
  dx, data1 mov                 \ point to data port 1 (PB)
  ax pop   dx, al out           \ send it
  dx, cword1 mov                \ point to port C
  al, # 00b mov   dx, al out    \ pulse chip select line high
  al, # 00a mov   dx, al out    \  and then low again  PC5
  bx pop                        \ restore TOS register
  next,
end-code



\ data1@ data0@                             R. Jon 23/11/88
\

hex

code data1@     \ addr -- b ; fetch byte from PROM
  dx, addr-lo mov               \ point to low address port
  ax, bx mov                    \ get address
  ax, e-last and                \ mask to RAM address
  ax, e-pars-mask or            \ mask in EPROM pins 1 & 27
  dx, ax out                    \ output address
  dx, cword1 mov                \ point to port C
  al, # 00b mov   dx, al out    \ chip select line high  PC5
  dx, data1 mov                 \ point to data port 1
  al, dx in   cl, al mov        \ read low byte
  dx, cword1 mov                \ point to port C
  al, # 00a mov   dx, al out    \ chip select line low
  ch, # 0 mov   bx, cx mov      \ return byte
  next,
end-code


code data0@     \ addr -- b ; fetch byte from PROM
  dx, addr-lo mov               \ point to low address port
  ax, bx mov                    \ get address
  ax, e-last and                \ mask to RAM address
  ax, e-pars-mask or            \ mask in EPROM pins 1 & 27
  dx, ax out                    \ output address
  dx, cword1 mov                \ point to port C
  al, # 009 mov   dx, al out    \ chip select line high  PC4
  dx, data0 mov                 \ point to data port 1
  al, dx in   cl, al mov        \ read low byte
  dx, cword1 mov                \ point to port C
  al, # 008 mov   dx, al out    \ chip select line low
  ch, # 0 mov   bx, cx mov      \ return byte
  next,
end-code



\ cs0-hi cs1-hi .. R. Jon 14/12/88
\

hex

: cs0-hi  ( --  ;  pc4 to hi )
  009 cword1 @ pc!  ;

: cs1-hi  ( --  ;  pc5 to hi )
  00b cword1 @ pc!  ;



\ set-pc reset-pc set-data-in set-data-out         Jon 22/11/88
\

hex                                   \
                                      \
: set-pc                              \ --
  00e cword1 @ pc!  ;                 \ pc7 hi    USER/PC
                                      \
: reset-pc                            \ --
  00f cword1 @ pc!  ;                 \ pc7 lo
                                      \
: set-data-in                         \ --
  092 cword1 @ pc!  ;                 \ data ppi-
                                      \ read data from epem
: set-data-out                        \ --
  080 cword1 @ pc!  ;                 \ data ppi-
                                      \ write data to epem


\ set-write reset-write .................       R. Jon 25/11/88s
\

hex                                   \
                                      \
: set-write                           \ --
  set-data-out  00c cword1 @ pc!  ;   \ pc6 lo    R/W
                                      \
: reset-write                         \ --
  set-data-in  00d cword1 @ pc!  ;    \ pc6 hi



\ init-ppis .............................       R. Jon 25/11/88
\

hex

: init-ppis                           \ --
  080 cword0 @ pc!                    \ addr to op
  080 cword1 @ pc!  ;                 \ data to op


\ reset-addrs ...........................       R. sfp 19/09/89
\

decimal

: reset-addrs   \ addr --
  dup        epbase  !
  dup        addr-lo !                \ addr lo-byte addr U8
  dup    1+  addr-hi !                \ addr hi-byte
  dup    2+  cport0  !                \
  dup    3 + cword0  !                \
  dup    4 + data0   !                \ data odd bytes PA U7
  dup    5 + data1   !                \ data even bytes PB
  dup    6 + cport1  !                \ PC
         7 + cword1  ! ;              \ CW



\ e-pars                                        R. Jon 25/11/88
\

hex

\ return numbers needed to deal with EPROM used
: e-pars        \ -- ; set eprom data varaiables
  case  e-type @
    0  of  01FFF 0E000  endof           \ 2764
    1  of  03FFF 0C000  endof           \ 27128 - ok
    2  of  07FFF 08000  endof           \ 27256 - ok
    3  of  0FFFF 00000  endof           \ 27512 - ok
  endcase
  e-pars-mask !  e-last !  ;

decimal




\ data!                                         R. Jon 22/11/88
\

: data!                 \ b d-addr -- ; general 8/16 bit !
  e-bus-width @
  case
    0 of 2dup e-last @  0 d> if    drop data0!  \ first prom
                             else  drop data1!  \ second prom
                             endif
      endof
    1 of 2 mu/mod rot                           \ 16 bit
         case 0 of drop data1! endof
              1 of drop data0! endof
         endcase
      endof
  endcase  ;



\ data@                                         R. Jon 22/11/88
\

: data@                 \ d-addr -- b ; general 8/16 bit @
  e-bus-width @
  case
    0 of 2dup e-last @  0 d> if    drop data0@  \ first prom
                             else  drop data1@  \ second prom
                             endif
      endof
    1 of 2 mu/mod rot                           \ 16 bit
         case 0 of drop data1@ endof
              1 of drop data0@ endof
         endcase
      endof
  endcase  ;


\ open-eprom  close-eprom                       R. Jon 07/02/89
\

decimal

: (open-emulator)               \ Eprom-Type Bus-Width --
  e-bus-width !                 \ 8bit bus, 27256 eprom at 0000
  e-type !                      \ For testing using:
  init-ppis                     \ set up both 8255s for op
  e-pars
  reset-write reset-pc          \ release emulator
  cs0-hi  cs1-hi                \ select both devices
  set-pc set-write  ;

: (close-emulator)              \ --
  reset-write  reset-pc         \
  cs0-hi  cs1-hi  ;             \




\ >Emu-Addr .. J Lee -- 17/4/91
\

: >Emu-Addr  ( addr -- d-addr' ; return real emulator address )
  o-i @(p) - 0          \ subtract origin in image, leave double
  e-offset 2@ d+  ;     \ add offset into eprom



\ emu-c! emu-c@ .........................          Jon 23/11/88
\

: emu-c!                              \ b addr --
  >emu-addr data!  ;                  \
                                      \
: emu-c@                              \ addr -- b
  reset-write  reset-pc               \
  cs0-hi  cs1-hi                      \
  reset-write  set-pc                 \
  >emu-addr data@                     \
  reset-write  reset-pc               \
  cs0-hi  cs1-hi                      \
  set-pc  set-write  ;                \



\ emu-split-buff                                   sfp 24/04/89
\

also forth

create emu-split-buff  4 allot          \ used for byte ordering

previous





((
        Choose LITTLE or BIG endian
))




\ LITTLE-ENDIAN
\ emu-@ emu-! (low/high - little-endian)           sfp 30/01/90

: emu-@         \ addr -- n
  dup emu-c@ emu-split-buff c!        \
  1+ emu-c@ emu-split-buff 1+ c!      \
  emu-split-buff @  ;


: emu-!         \ n addr --
  swap emu-split-buff !               \
  emu-split-buff c@ over emu-c!       \
  emu-split-buff 1+ c@ swap 1+ emu-c!  ;



((
\ BIG-ENDIAN
\ emu-@ emu-! (high/low - big-endian)              sfp 30/01/90

: emu-@         \ addr -- n
  dup emu-c@  emu-split-buff 1+ c!    \
  1+ emu-c@  emu-split-buff c!        \
  emu-split-buff @  ;                    

                                      \
: emu-!         \ n addr --
  swap emu-split-buff !               \
  emu-split-buff 1+ c@  over emu-c!   \
  emu-split-buff c@  swap 1+ emu-c!  ;
))


\ emu-c@(u) emu-c!(u)                              sfp 24/04/89
\

((
        Required by the emulator for Umbilical Forth, when operating
        interactively. These versions leave the emulator connected to
        the target rather than the PC.
))

: emu-c@(u)                           \ addr -- b
  reset-write reset-pc                \
  cs0-hi cs1-hi                       \
  reset-write set-pc                  \
  >emu-addr data@                           \
  reset-write reset-pc                \
  cs0-hi cs1-hi  ;                    \


: emu-c!(u)                           \ b addr --
  reset-write reset-pc                \
  cs0-hi cs1-hi                       \
  set-pc set-write                    \
  emu-c!                              \
  reset-write reset-pc                \
  cs0-hi cs1-hi  ;                    \




((
        Choose LITTLE or BIG endian
))



\ LITTLE-ENDIAN
\ emu-@(u) emu-!(u) (low/high - little-endian)     sfp 30/01/90
\ Required by the emulator for Umbilical Forth, when operating
\ interactively. These versions leave the emulator connected to
\ the target rather than the PC )


: emu-@(u)      \ addr -- n
  dup emu-c@(u)  emu-split-buff c!      \ first byte is low
  1+ emu-c@(u)  emu-split-buff 1+ c!    \ second byte is high
  emu-split-buff @  ;                   \

: emu-!(u)      \ n addr --
  swap emu-split-buff !                 \
  emu-split-buff c@  over emu-c!(u)     \ first byte is low
  emu-split-buff 1+ c@  swap 1+ emu-c!(u)  ;  \ second is high



((
\ BIG-ENDIAN
\ emu-@(u) emu-!(u) (high/low - big-endian)        sfp 30/01/90
\ Choose this screen or previous according to byte order
\ Required by the emulator for Umbilical Forth, when operating
\ interactively. These versions leave the emulator connected to
\ the target rather than the PC )

: emu-@(u)      \ addr -- n
  dup emu-c@(u) emu-split-buff 1+ c!    \ first byte is high
  1+ emu-c@(u) emu-split-buff c!        \ second byte is low
  emu-split-buff @  ;                   \ collect result

: emu-!(u)      \ n addr --
  swap emu-split-buff !                 \ store n
  emu-split-buff 1+ c@  over emu-c!(u)  \ first byte is high
  emu-split-buff c@ swap 1+ emu-c!(u) ; \ second byte is low
))



\ Emulator parameters ...................          Jon 15/02/89
\

only Forth also c-c also Forth definitions
                                      \
0 constant e2764                      \ eprom type
1 constant e27128                     \
2 constant e27256                     \
3 constant e27512                     \
                                      \
0 constant 8bit                       \ bus width
1 constant 16bit                      \
2 constant 32bit                      \



\ Open and Close emulator .. J Lee 17/4/91
\


: >Disk  ( -- ; assign output to disk )
  assign c!(d) to-do c!(o)            \ assign disk io words
  assign c@(d) to-do c@(o)            \ to-do target memory
  assign w!(d) to-do w!(o)            \ access
  assign w@(d) to-do w@(o)  ;


: >Emulator  ( -- ; assign output to emulator )
  curr-code-page @(g) >page-table page.epem 2@(g)       \ get emulator offset
  e-offset 2!                         \ write as driver offset
  assign emu-c! to-do c!(o)           \ assign eprom io words
  assign emu-c@ to-do c@(o)           \ to-do target memory
  assign emu-!  to-do w!(o)           \
  assign emu-@  to-do w@(o)  ;        \


: Close-Emulator                      \ --
  (close-emulator)  ;                 \ access, finish emulator


: Output-Emulator                     \ Eprom-Type Bus-Width --
  emulator                            \ flag emulator in use
  (open-emulator)  ;                  \ init emulator


: Emu-Base                            \ addr --
  Reset-Addrs  ;                      \ set card's i/o addr

