\ Serial i/o drivers for 64180 ASCI

((
Copyright (c) 1991

MicroProcessor Engineering
133 Hill Lane
Southampton SO1 5AF
England

tel: (+44) 703 631441
fax: (+44) 703 339691

First Release:	May 1991

Changes:	See RELEASE.DOC for full details
))
\ 64180 ASCI driver load screen                    sfp 10/05/91

only forth definitions

hex
	  
\ note that CTS0 and DCD0 must be held low for the UART to work

assembler
l: init-serial  \ -- ; initialise 64180 ASCI
		\ baud rate numbers  1=19200, 2=9600, 3=4800, 4=2400
  a, # 0 ld   RCR a out0   DCNTL a out0 \ no refresh, no waits
  a, # 064 ld   CNTLA0 a out0           \ Enable Trans. & Rec.
  a, # 2 ld   CNTLB0 a out0             \ Div:=16 SS:=2=/4
  ret
forth

code init-ser   \ --
  init-serial call   next,
end-code

code (emit)     \ char --
l: CONOUT                               \ L := Char code
  a, STAT0 in0   a, # 2 and             \ extract TX status bit
  z, CONOUT jr                          \ spin until set
  hl pop   a, l ld   TDR0 a out0        \ transmit character
  next,
end-code

: emit          \ char --
  (emit)  1 out +!  ;

: type          \ addr len
  bounds
  ?do  i c@ emit  loop  ;

: cr            \ --
  0D emit  0A emit  out off  ;

\ ASCI - (key?)                                    sfp 31/01/90

hex

code (key?)     \ -- t/f
  a, STAT0 in0   a, # 080 and		\ read status bit
  nz, if,  a, # 0FF ld  endif,          \ return 0 or -1
  l, a ld   h, a ld    hl push          \ return it
  next,
end-code

: key?          \ -- t/f
  (key?)  ;

code (key)      \ -- char ; needs extra help for multi-tasking
l: CONIN
   a, STAT0 in0   a, # 080 and          \ Extract read status
   z, CONIN jr                          \ spin until found
   h, # 0 ld   l, TSR0 in0    hl push 
   next,
end-code

defer key       \ -- char ; reads character from channel
  assign (key) to-do key                \ default to serial


\ all done

;p
