\ Serial i/o drivers for Z84C15

((
Copyright (c) 1991

MicroProcessor Engineering
133 Hill Lane
Southampton SO1 5AF
England

tel: (+44) 703 631441
fax: (+44) 703 339691

First Release:	May 1991

Changes:	See RELEASE.DOC for full details
))
\ Z84C15 SIO - i/o addressing & bit masks                 gie 20/05/91

only forth definitions

hex
\
\ Define the required i/o addresses
\
018		equ sio			\ Z84C15 SIO base address
sio		equ a-data		\ only using channel B
sio 1+		equ a-cmd		\ 
sio 2+ 		equ b-data
sio 3 +		equ b-cmd

010             equ ctc                 \ CTC base address
ctc             equ ctc0
ctc 1+          equ ctc1                \ CH 1 for RS232
ctc 2+          equ ctc2
ctc 3 +         equ ctc3

\
\ Define the bit masks for testing the status registers
\
001		equ rda			\ read data available
004		equ tbe			\ transmit buffer empty


\ set up CTC & SIO                      gie 21/05/91

l: sio-tab
  ctc1 c,   003 c,		\ reset CTC 1
  ctc1 c,   015 c,		\ set timer 1 prescale 16 auto
  ctc1 c,   004 c,		\ time const reg -> 4
  ctc1 c,   020 c,		\ 9600 baud for 19.6608 crystal
				\ 020h - 9600
  b-cmd c,  004 c,		\ 16x clock 1 stop 0 parity
  b-cmd c,  044 c,
  b-cmd c,  003 c,		\ 8 b/char Rx enable
  b-cmd c,  0C1 c, 
  b-cmd c,  005 c,		\ 8 b/char RTS hi Tx enable
  b-cmd c,  068 c,
  b-cmd c,  001 c,		\ Disable interrupts
  b-cmd c,  004 c, 

hex

: init-ser	\ -- ; initialise CTC and SIO
  018 0
  do  i sio-tab + 1+ c@			\ get value to store
      i sio-tab +    c@			\ get port to store to
      p!				\ and store it
  2 +loop  ;
\ sio - (emit) emit cr ................            gie 21/05/91

hex

code (emit)	\ char --
l: char-op
  a, # 0 ld   b-cmd a out   nop		\ select reg
  a, b-cmd in   a, # tbe and		\ spin until ready
  z, char-op jr 
  hl pop   a, l ld   b-data a out       \ transmit character
  next,
end-code

: emit		\ char -- ; transmit character
  (emit)  1 out +!  ;			\ also increment output counter

: type		\ addr len -- ; transmit string
  bounds ?do  i c@ emit  loop  ;

: cr		\ -- ; transmit <cr> <lf>
  0A emit  0D emit  out off  ;

code (key)      \ -- char ; reads character from serial line
l: char-ip 
  a, # 0 ld   b-cmd a out   nop         \ select register
  a, b-cmd in   a, # rda and            \ read and test
  z, char-ip jr                         \ spin until ready
  a, b-data in   l, a ld   h, # 0 ld    \ read character
  hl push   next,                       \ return it
end-code

defer key       \ -- char ; reads character from channel
  assign (key) to-do key                \ default to serial

code (key?)	\ -- t/f
  a, # 0 ld   b-cmd a out   nop         \ select reg
  l, # 0 ld   a, b-cmd in   a, # rda and  \ test reg
  nz, if,  l dec   endif,               \ return 0 or -1
  h, l ld   hl push                     \ return complete flag
  next,   end-code                      \

: key?          \ -- t/f ; true if character available
  (key?)  ;
\ all done

decimal

;p
