\ paged target example definition file
pto

Copyright (c) 1994

MicroProcessor Engineering Ltd
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: (+44) 703 631441
fax: (+44) 703 339691
net: mpe@cix.compulink.co.uk

\ start here

only forth definitions decimal

  all from-file nextfast	\ macro for fast NEXT
\ all from-file nextjp		\ macro for short NEXT

\  Hex 0320 Emu-Base		\ set emulator i/o address
\  e27256 8bit output-emulator	\ output to emulator

Floats				\ switch floating point on

CROSS-COMPILE			\ switch compiler on

\ no-log			\ turn off display

Only Forth Definitions		\ target search order

\ Define target configuration here. These flags define whether certain
\ files are loaded, and whether certain initialisation words are included
\ in COLD. Note that selection of the multitasker is defined by the value
\ set for #TASKS on the next page.
\
0 equ romforth?				\ true to load romforth extensions
1 equ paged?				\ true if target is paged
1 equ softfp?				\ true if target needs floating point

\ memory definitions                               sfp 10/05/91
hex
      $0000 $3FFF     KERNEL     rom180		\ Kernel ROM: 0h->3FFFh
      $4000 $7FFF $00 CODE-PAGE  page1		\ first page: 4000h->7FFFh
      $4000 $7FFF $04 CODE-PAGE  page2		\ 2nd page: 4000h->7FFFh
      $4000 $7FFF $08 CODE-PAGE  page3		\ 3rd page: 4000h->7FFFh
      $8000 $BFFF $00 KERNEL-RAM rom180-DATA	\ Kernel RAM: 8000h->BFFFh
      $C000           MEM-END			\ RAM ends at BFFFh

\      $0000 IN-EMULATOR UE180			\ Output to emulator

      0C000 equ appl-rom			\ Define application area
      0FFFF equ appl-rom-end			\ both start and finish

paged-vocabulary PAGE1				\ declare page vocabularies
paged-vocabulary PAGE2
paged-vocabulary PAGE3

use-code ROM180					\ Select code page
use-data ROM180-DATA				\ Select data page

\ define memory allocations

$0008 equ #tasks			\ number of tasks - at least 1

$0080 equ User-size			\ size of tasks user area
$0040 equ SP-size 			\ size of tasks data stack
$0040 equ RP-size			\ size of tasks return stack
$0100 equ intram			\ space used by interrupt page

$0080 EQU Tib-len			\ terminal i/p buffer length

\ calculate memory map

User-size SP-size + equ Task-s0		\ initial offset of data stack					  
Task-s0   RP-size + equ Task-r0		\ initial offset of return stack					  

Task-r0 equ per-task			\ system area size for each task

EM      \ length            name
  intram - 		dup equ INT-INIT-U0 	\ base of interrupt area
  #tasks per-task * -	dup equ INIT-U0		\ base of task user area
  tib-len - 		dup equ INIT-TIB	\ base of TIB
drop

\ Place the stacks inside the first task area
init-u0 Task-r0 + equ INIT-R0
init-u0 Task-s0 + equ INIT-S0

\ Kernel Files -> Fixed Kernel

  decimal all from-file sfr180			\ 64180 registers
  decimal all from-file start180		\ vectors and startup
  decimal all from-file code180			\ 64180 code definitions
  decimal all from-file drivers\asci180		\ 64180 ASCI driver
  decimal all from-file kernel			\ main part of Forth
  decimal all from-file romtools		\ nucleus extensions
  decimal all from-file interupt		\ interrupt handler

  decimal all from-file paging\paging		\ Page switch words
  decimal all from-file examples\dallas.z80	\ Dallas smart watch driver

\ Kernel Extensions

\ Multi tasking code required if more than 1 task needed
#tasks 1 > 
if(
  decimal all from-file multi180		\ multi-tasker
)endif
		     
\ compile romforth if required
romforth?
if(
  decimal all from-file romforth\link		\ linker
  decimal all from-file romforth\iodef		\ io definitions
  decimal all from-file romforth\filetran	\ source load
  decimal all from-file romforth\bin-down	\ binary > host
  decimal all from-file romforth\hex-down	\ hex > host
  decimal all from-file romforth\textfile	\ text files
  decimal all from-file romforth\blocks		\ blocks
)endif

\ compile floating point if required in page 1
softfp?
if(					      
  use-code PAGE1

  decimal all from-file softfp\fpromhi.fth	\ Floating point primitives
  decimal all from-file softfp\softfp.fth	\ High level floting point

  finis-code-page
)endif

\ processor type and Forth-83 marker
	  
use-code ROM180

: .cpu 		\ -- ; display CPU type
  ." MPE 64180 ROM PowerForth "		\ sign-on
;	

: Forth-83  ; is-fence

\ add application files in pages 2 & 3
decimal		
		 
use-code PAGE2

( app code here! )

finis-code-page

use-code PAGE3

( app code here! )

finis-code-page

FINIS

;p
