\ 64180 ROM tools for MPE Z80/64180 Forth Cross Compiler
((
Released for use with the MPE Z80/64180 Forth Cross Compiler by:

MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: (+44) 703 631441   (international)
     0703 631441        (domestic)
))
\ >link link>                                      Jon 19/08/88

((
\
\ it is unlikely that these words will be needed
\
: >link		\ cfa -- lfa ; convert code field addr. to link field addr.
  >name n>link  ;

: link>		\ lfa -- cfa ; convert link field addr. to code field addr.
  link>n name>  ;
))
\ .byte .word .ascii dump

hex

: .byte		\ b -- ; display byte as 2 hex digits
   base @ swap  hex
   0 <# # # #> type
   base !  ;

: .word		\ n -- ; display word as 4 hex digits
  base @ swap  hex
  0 <# # # # # #> type
  base !  ;

: .ascii	\ char -- ; display character as ASCII
  07F and  dup 020 07E within? 0=	\ out of range 020..07Eh ?
  if  drop  ascii .  endif		\ y: show as '.'
  emit  ;

: dump		\ addr len -- ; display range of memory
  bounds				\ get limits
  do  cr  i .word  i 010 bounds         \ print address
      do  space  i c@ .byte  loop       \ print byte
      2 spaces  i 010 bounds            \ gap
      do  i c@ .ascii  loop             \ ascii o/p
      halt? ?leave			\ quit or halt
  010 +loop                             \ until done
  cr  ;
\ .s ?

: .s		\ ... -- ... ; non-destructive stack display
  cr
  depth ?dup
  if  ."  top"  0
      do  i pick cr 6 u.r  loop
  else  ." empty stack"
  endif
  cr  ;

: ?		\ addr -- ; display word contents of addr
  @ .  ;
\ assign to-do

\
\ The phrase:
\   ASSIGN <action>  TO-DO <deferred-word>
\ can be used in a colon definition or when interpreting to set the action
\ of a deferred word. Thus:
\   DEFER JIM  ASSIGN WORDS TO-DO JIM
\   JIM
\ will execute WORDS.
\
: assign	\ -- cfa ; state smart version of '
  state @				\ if compiling
  if  [compile] [']			\ use [']
  else  '				\ else use '
  endif  ;  immediate

internal
: (to-do)	\ cfa -- ; stores cfa in body of word compiled after (TO-DO)
  r> dup 2+ >r  @ >body @ !  ;
external

: to-do		\ cfa -- ; compiling -- 
  state @				\ if compiling
  if  compile (to-do)			\ action at run time
  else  ' >body @ !			\ otherwise do it now
  endif ;  immediate

\ trim (forget) $forget forget

\
\ The words combine to produce FORGET
\
decimal

internal
: trim		\ nfa-to-forget voc-cfa --
  dup >threads swap >#threads @ 2*
  bounds				\ bound the threads
  do  i @				\ fetch top link
      begin  2dup u> 0=			\ while nfa < link
        while  n>link @			\  try next one
      repeat
      i !				\ update thread entry
  2 +loop				\ step to next thread
  drop  ;				\ release nfa
external

: (forget)	\ nfa -- ; forgets back to given nfa
  >r  r@ fence @ u<  21 ?error		\ check FORGET is legitimate
  voc-link @				\ start at top of voc. chain
  begin  r@ over u<			\ unhook all vocs above cut off
    while  >voc-link @
	   only forth definitions
  repeat
  dup voc-link !			\ voc-link -- ; pointer to top voc
  begin  r@ over                        \ -- v-l nfa v-l
         trim                           \ -- v-l ; cut links
         >voc-link @ ?dup 0=            \ check end of chain
  until
  r> n>link dp !  ;                     \ reset dp

: $forget       \ $addr -- ; forgets word name in given string
  current @  v-find 0= 0 ?error		\ error if name not found
  >name (forget)  ;

: forget	\ -- ; name to forget follows in input stream
  bl word  dup count upper  $forget  ;
\ vocs order

also root definitions

: vocs		\ -- ; display defined vocabularies
  voc-link				\ follow voc-link chain
  begin  @ ?dup				\ while another link
   while  dup >name .name space		\ show voc. name
          >voc-link			\ step on
  repeat  ;

: .voc		\ addr -- ; if link exists display voc name
  @ ?dup				\ fetch link, non-zero?
  if  >name .name space  endif  ;	\ y: show name

: order		\ show search order in CONTEXT array and then CURRENT voc.
  cr ." context: "			\ CONTEXT array
  context vsize bounds			\ for each valid voc (non-zero_
  do  i .voc  2 +loop			\ show vocabulary
  cr ." current: " current .voc cr  ;

previous definitions
\ all done

decimal

;p
