\ MPE ROM PowerForth Forth extension tool set

((
released for use without royalty when used with the
MPE Z80/64180 Forth Cross Compiler.

Copyright (c) 1987-1991

MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: (+44) 703 631441	(international)
     0703 631441	(domestic)
fax: (+44) 703 339691

May 1991	Converted to text file

))
\ -trailing

\
\ This word strips the trailing spaces from a string. It is most useful when
\ displaying lines from a screen to strip the trailing spaces from the
\ 64 byte fixed length lines. This word is also provided as part of
\ BLOCKS.FTH in the ROMFORTH directory.
\
: -trailing	\ addr len -- addr len' ; strip trailing spaces
   dup 0
   ?do  2dup + 1- c@ bl <> ?leave 1-  loop  ;


\ (#in) #in

\
\ (#IN) and #IN are provided to collect numbers from the keyboard in
\ decimal. (#IN) is useful because it returns the number of digits converted
\ so that 0 digits indicates that the user just pressed <Enter>, rather than
\ entering a valid number of value 0.
\
decimal

: (#in)		\ -- n #chars ; read a decimal number from the keyboard
		\ returning the number, and the number of digits converted
  0 0					\ n=0, #chars=0
  begin   key dup 13 <>			\ while key is not CR
    while  dup  10 digit		\ digit?
           if  swap emit		\ y:, echo it
               rot 10 * +		\     accumulate it
	       swap 1+			\     count it
           else  8 =			\ n:, backspace character?
                 if  dup		\     y:, remove last character
                     if  swap 10 /	\         divide total by 10
			 swap 1-	\         reduce count
			 bs		\         wipe out character
		     endif
                 endif
           endif
  repeat
  drop  ;				\ discard CR

: #in		\ -- n ; collect decimal number from keyboard
  0					\ initial value
  begin  drop (#in)  until  ;		\ keep trying until valid

;p
