\ API for XS3 v3.3 upwards allows the PowerForth/386 API calls

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  variables

hex

variable (di)			\ save di

create old-d7  4 allot		\ old vector

variable xs3-psp                \ xs3's psp stashed
variable xcomp-psp              \ xcomp's psp stashed

variable (ss1)			\ temps for stack switching for 386 i/f
variable (ss2)
variable (sp1)
variable (sp2)
variable (bp1)
variable (bp2)

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  save-di

hex

code save-regs		\ -- ; preserve di and ss
  (di) di mov				\ preserve both di
  (ss1) ss mov				\ and ss
  next,
end-code

: save-di		\ -- ; save regs for 386 stack switch
  save-regs				\ need di anyway
  sp@ 010 - (sp1) !			\ new data stack pointer
  rp@ 010 - (bp1) !			\ new r stack pointer
;

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  fn#-table

decimal

create fn#-table   64 allot	\ table of fn actions
				\ space for 32 functions

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  int-d7 - entry

variable (ax)			\ spares to hold params in
variable (bx)
variable (cx)
variable (dx)

hex

code int-d7		\ -- ; api interrupt entry point
  l$1 jmp			\ go to the real code
  ", XShellv2/3.3"		\ lay down identifier
l$1:			\ code starts here
  bx, # 10 cmp   l$4 jae	\ test function range

  ds push  es push		\ preserve segment regs on return stack
  si push  di push		\ preserve pointers on return stack
  ax, cs mov    ds, ax mov	\ cs into ds
  es, ax mov			\ cs into es also
  bp, sp xchg			\ swap stacks back to normal
  from-api # -1 mov		\ set from-api on
  ah, # 051 mov			\ fn# 51  (get-psp)
  021 int			\ make int seg in bx
  xcomp-psp bx mov		\ store seg in xcomp-psp
  bx, xs3-psp  mov		\ get new psp
  ah, # 050 mov			\ fn# 50 (set-psp)
  021 int			\ call int

l$2:	    		\ x86 model isr
  bx pop			\ get function# from data stack
  bx, # 1 shl			\ convert to word index
  ax, fn#-table [bx] mov	\ get CFA into AX
\  si, # return-cfa mov		\ fake a code return 
  si, # here 0A + mov		\ fake code return  4 bytes
  di, (di) mov			\ set user pointer  4 bytes
  bx pop			\ get TOS into BX   1 byte
  ax jmp			\ execute CFA       1 byte
\ lbl: return-cfa
  here 2+ ,			\ dummy for code definition

l$3:		   	\ done for invalid x86 fn# and exit
  bx push			\ preserve TOS on data stack
  bx, xcomp-psp  mov		\ restore old psp
  ah, # 050 mov			\ fn# 50 (set-psp)
  021 int			\ call int
  bp, sp xchg			\ swap stacks
  from-api # 0 mov		\ set from-api off
  di pop  si pop		\ restore pointers from return stack
  es pop  ds pop		\ restore segment regs from return stack
  iret				\ and return from int

l$4:		\ 386 model isr
  ds push  es push		\ preserve segment regs
  si push  di push		\ preserve pointers
  cs: (ax) ax mov		\ preserve regs from PF/386
  cs: (bx) bx mov
  cs: (cx) cx mov
  cs: (dx) dx mov
  ax, cs mov			\ set ds to the xs3 one
  ds, ax mov
  (ss2) ss mov			\ preserve stack segment
  (sp2) sp mov			\ and pointer
  (bp2) bp mov			\ and rpointer
  ss, (ss1) mov			\ set to Forth stack segment
  sp, (sp1) mov			\ and pointer
  bp, (bp1) mov			\ and rpointer
  from-api # -1 mov		\ set from-api on
  ah, # 051 mov			\ fn# 51  (get-psp)
  021 int			\ make int seg in bx
  xcomp-psp bx mov		\ store seg in xcomp-psp
  bx, xs3-psp  mov		\ get new psp
  ah, # 050 mov			\ fn# 50 (set-psp)
  021 int			\ call int
  bx, (bx) mov			\ get the fn# back
  bx, # 20 cmp   l$5 jae	\ test function range
  bx, # 1 shl			\ convert to word index
  ax, fn#-table [bx] mov	\ get CFA into AX
\  si, # return-cfa mov		\ fake a code return 
  si, # here 09 + mov		\ fake code return  4 bytes
  di, (di) mov			\ set user pointer  4 bytes
  ax jmp			\ execute CFA       1 byte
\ lbl: return-cfa
  here 2+ ,			\ dummy for code definition
  (bx) bx mov			\ preserve return value

l$5:			\ done for invalid 386 fn# and exit
  from-api # 0 mov		\ set from-api off
  bx, xcomp-psp  mov		\ restore old psp
  ah, # 050 mov			\ fn# 50 (set-psp)
  021 int			\ call int
  bp, (bp2) mov			\ restore rpointer
  ss, (ss2) mov			\ restore stack segment
  sp, (sp2) mov			\ and stack pointer
  bx, (bx) mov			\ restore return value
  di pop  si pop		\ restore pointers from return stack
  es pop  ds pop		\ restore segment regs from return stack
  iret				\ and return from int

end-code

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  get-psp

hex

code  get-psp		\ -- seg ; get the segment of the psp
  bx push			\ manage stack
  ah, # 051 mov			\ fn# 51
  021 int			\ make int
  next,				\ carry on with forth
end-code

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  init-api-int

hex

: init-api-int		\ -- ; install the api interrupt
  get-psp xs3-psp !		\ save off xs2's psp for later
  0d7 get-vector		\ get old vector for d7
  old-d7 2!			\ save old vector
  cs> ['] int-d7 0d7 set-vector	\ set the required one
  save-di			\ preserve the user area
;

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  dis-api-int

hex

: dis-api-int		\ -- ; restore the old d7 interrupt
  old-d7 2@			\ get old vector
  0d7 set-vector		\ restore it
;

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  api-key

hex

: api-key		\ key -- ; execute alt key action
  dup 64 <			\ mask flag and bounds
  if
    2* alt-table + @ execute	\ get action & execute
  else
    drop no-act			\ beep if not in range
  endif
;

: api-key/386		\ -- ; execute alt key action
  (ax) @ api-key
;

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  .no func

decimal

: stop-key 		\ -- t/f ; wait for user to read box
  0		 				\ dummy quit flag
  (key?)	 				\ if a key press
  if (key)	 				\ get first key
     case
       00 of (key)				\ if 00, get the second
             case   68 of drop -1 endof		\ set quit flag
                    59 of more-help endof	\ do help
                          wrong-tone		\ wrong key
             endcase
          endof
       27 of drop -1 endof
             wrong-tone			  	\ wrong key
     endcase
  endif
;

: .F10			\ -- ; say F10 is to quit
  ."  <F10> to exit"  
;

: (.no-func)		\ -- ; say no function available
  save-win			\ save details of old window
  create-error-window		\ make new window
  curr-handle to-window		\ move into new window
  cr
  ."  This function not available in this mode"                 
  cr red .F10                                                        
  error-tone		  	\ rasp to tell user
  begin  stop-key until	  	\ wait for user
  spare-keys                               
  curr-handle from-window 	\ get out of new window
  delete-curr-window	  	\ remove new one from list
  rest-win		  	\ back to old window
;                                                               

assign (.no-func) to-do .no-func

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  top-bar-target

: top-bar-umb		\ -- ; draw top bar in umbilcal/compiler mode
  0 0 gotoxy				\ top of screen
  attrib>112				\ inverse attribs
  .XSHELL				\ what program
  21 spaces				\ white space
  shell-mode @
  case
    2 of  ." CROSS COMPILER" endof  	\ cross compiler running
    3 of  ." UMBILICAL MODE" endof  	\ umbilical mode
  endcase
  21 spaces	     	  		\ space till end of line
  .F1		       			\ the help key
  dark		       			\ normal attribs
;

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  .umb

: .umb			\ -- ; show this is umbilcal mode
  save-win		       		\ preserve current window
  screen-handle @ op-handle !		\ use whole screen
  top-bar-umb		       		\ show umbilical mode
  bottom-bar-target	       		\ normal bottom line
  rest-win		       		\ back to old window
  api-handle @  op-handle !   		\ go into api window
  attrib>7
  cls			       		\ clear
;

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  umb-type

: emit/386		\ -- ; emit char from (ax) from pf386
  (ax) @ emit
;

: umb-type		\ seg addr len -- ; print text in umbilical mode
  >r				\ len on R
  cs> here			\ this seg
  r@				\ len
  cmovel			\ move to this seg
  here r> type			\ and type it
;

: umb-type/386
  (ax) @ (cx) @ (dx) @ umb-type
;

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  umb-mode

decimal

: umb-mode		\ -- ; wait for user, then go to umbilical mode
  3 shell-mode !		\ set flag to new value
  cr red .Press dark		\ wait for user
  (key) drop spare-keys 	\ to press a key
  .umb				\ new screen
;

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  new-bar

: new-bar		\ -- ; change bottom banner
  save-win   			\ preserve current window
  screen-handle @ op-handle !	\ use whole screen
  bottom-bar-target	     	\ normal bottom line
  rest-win			\ back to old window
;

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  umb-using

: umb-using		\ seg off len -- ; using this file
  screen-pcb reset-pcb			\ clear out pcb
  cs> screen-pcb p-name  rot		\ seg:off seg:off len
  cmovel				\ long move to pcb
  new-bar				\ redraw bar
;

: umb-using/386
  (ax) @ (cx) @ (dx) @ umb-using
;

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  umb-use

: umb-use		\ seg off len -- ; use this file
  >r 1- curr-text$ r> 1+		\ seg off seg off len
  cmovel				\ long move to buffer
  new-bar				\ redraw bar
;

: umb-use/386
  (ax) @ (cx) @ (dx) @ umb-use
;

\ -----End of Page-----
\ -- R.G.G -- 15/9/92 --  386 serial services

: umb-ser-emit		\ -- ; get a char and emit with serial comms as ALT-P
  (ax) @ ser-emit			\ go send it
;

: umb-ser-type		\ -- ; print a string
  (ax) @ (cx) @			\ get seg off
  cs> here			\ this seg
  (dx) @			\ len
  cmovel			\ move to this seg
  here (dx) @ bounds		\ make start and end
  ?do
    i c@ ser-emit		\ ser emit each char
  loop
;

: umb-ser-key?		\ -- t/f ; is there a char avail
  ser-key?
;

: umb-ser-key		\ -- char ; get char avail
  ser-key
;

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  fill fn#-table

decimal

' api-key   fn#-table      !		\ key  = fn#0
' .umb      fn#-table 2+   !		\ cls  = fn#1
' emit      fn#-table 4  + !		\ emit = fn#2
' umb-type  fn#-table 6  + !		\ type = fn#3
' umb-mode  fn#-table 8  + !		\ mode = fn#4
' umb-using fn#-table 10 + !		\ scr  = fn#5
' umb-use   fn#-table 12 + !		\ fth  = fn#6
' noop      fn#-table 14 + !		\ noop = fn#7
' noop      fn#-table 16 + !		\ noop = fn#8
' noop      fn#-table 18 + !		\ noop = fn#9
' noop      fn#-table 20 + !		\ noop = fn#A
' noop      fn#-table 22 + !		\ noop = fn#B
' noop      fn#-table 24 + !		\ noop = fn#C
' noop      fn#-table 26 + !		\ noop = fn#D
' noop      fn#-table 28 + !		\ noop = fn#E
' noop      fn#-table 30 + !		\ noop = fn#F

' api-key/386   fn#-table 32 + !	\ key  = fn#10 
' .umb      fn#-table 34 + !		\ cls  = fn#11 
' emit/386      fn#-table 36 + !	\ emit = fn#12 
' umb-type/386  fn#-table 38 + !	\ type = fn#13 
' umb-mode  fn#-table 40 + !		\ mode = fn#14 
' umb-using/386 fn#-table 42 + !	\ scr  = fn#15 
' umb-use/386   fn#-table 44 + !	\ fth  = fn#16 
' umb-ser-emit	fn#-table 46 + !	\ ser-emit = fn#17
' umb-ser-type	fn#-table 48 + !	\ ser-type = fn#18
' umb-ser-key?  fn#-table 50 + !	\ ser-key? = fn#19
' umb-ser-key   fn#-table 52 + !	\ ser-key? = fn#1A
' noop      fn#-table 54 + !		\ noop = fn#1B
' noop      fn#-table 56 + !		\ noop = fn#1C
' noop      fn#-table 58 + !		\ noop = fn#1D
' noop      fn#-table 60 + !		\ noop = fn#1E
' noop      fn#-table 62 + !		\ noop = fn#1F
