\ ascii table window for xshell3

                                                                

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  variables

headerless
                                                                
variable 1st            \ -- addr ; first value in window       
variable 10th           \ -- addr ; last value in window        
                                                                
32 1st !                \ initial char to start table           


\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  3.r 1st@ 10th@ 
                                                                
: 3.r		\ n -- ; print right alligned in 3 chars
  3 .r 
;
                                                                
: 1st@		\ -- n ; get 1st value
  1st @ 
;
                                                                
: 10th@		\ -- n ; get 10th value
  10th @ 
;

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 -- .mnem
                                                                
: .mnem                 \ n -- ;                                
  case                                                          
    00 of ." NUL"  endof   01 of ." SOH"  endof                 
    02 of ." STX"  endof   03 of ." ETX"  endof                 
    04 of ." EOT"  endof   05 of ." ENQ"  endof                 
    06 of ." ACK"  endof   07 of ." BEL"  endof                 
    08 of ." BS "  endof   09 of ." HT "  endof                 
    10 of ." LF "  endof   11 of ." VT "  endof                 
    12 of ." FF "  endof   13 of ." CR "  endof                 
    14 of ." SO "  endof   15 of ." SI "  endof                 
    16 of ." DLE"  endof   17 of ." DC1"  endof                 
    18 of ." DC2"  endof   19 of ." DC3"  endof                 
    20 of ." DC4"  endof   21 of ." NAK"  endof                 
    22 of ." SYN"  endof   23 of ." ETB"  endof                 
    24 of ." CAN"  endof   25 of ." EM"   endof                 
    26 of ." SUB"  endof   27 of ." ESC"  endof                 
    28 of ." FS "  endof   29 of ." GS "  endof                 
    30 of ." RS "  endof   31 of ." US "  endof                 
  endcase                                                       
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  -emit
                                                                
: >32			\ n1 -- n2 ; convert to space
  drop bl 
;
                                                                
: -emit			\ n1 -- ; maybe print this character
  dup                                                           
  case                                                          
    07 of >32  endof		\ swap BEL for space                
    08 of >32  endof		\ swap BS for space                 
    09 of >32  endof		\ swap HT for space                 
    10 of >32  endof		\ swap LF for space                 
    13 of >32  endof		\ swap CR for space                 
  endcase                                                       
  emit				\ emit whatever                 
;                                                               

\ eliminates spurious <CR>s, etc in ascii table                 

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  .char(00-20) .top-line(00-20)
                                                                
: .char(00-20)          \ n -- ; show a control character
  space                                                         
  dup decimal  3.r 3 spaces    \ show decimal                   
  dup hex      3.r 4 spaces    \ show hex                       
  dup -emit        3 spaces    \ show char                      
  dup                                                           
  ." ^" ascii @ + emit 2 spaces \ show control char             
  .mnem                         \ show mnemonic                 
;                                                               
                                                                
: .top-line(00-20)      \ -- ; column markers for control characters
  red ."   D     H     Ch  Cn  Mnm " dark  \ tops of columns    
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  .char(21-ff) .top-line(21-ff)
                                                                
: .char(21-ff)          \ n -- ; show normal character
  dup  space                                                    
  decimal  3.r 3 spaces        \ show decimal                   
  dup                                                           
  hex      3.r 4 spaces        \ show hex                       
  emit                                                          
;                                                               
                                                                
: .top-line(21-ff)      \ -- ; column markers for normal characters
  red ."   D     H     Ch          "     \ tops of columns      
  dark                                                          
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  set-attribs
                                                                
: set-attribs           \ n -- ; dark/yellow for altrenate characters
  dup                                                           
  01 and                        \ odd or even ?                 
  if                                                            
     dark                       \ normal if odd                 
  else                                                          
     yellow                     \ bright of even                
  endif                                                         
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  .char
                                                                
: .char                 \ n -- ; print this char
  dup                                                           
  set-attribs                   \ set odd/even attribs          
  0 31 within?                  \ 00 - 31 (decimal)             
  if                                                            
    .char(00-20)		\ print as control char
  else                                                          
    .char(21-FF)		\ print as normal char
  endif                                                         
  dark                                                          
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  .ascii-table
                                                                
: .ascii-table          \ -- ; print visible part of table
  0 1 gotoxy   			\ first entry in table
  base @       			\ preserve base                 
  10th@ 1st@   			\ first and last-1 entries        
  do                                                            
    decimal                                              
    i .char    			\ show character info.          
    cr	       			\ next line                     
  loop                                                          
  10th@ decimal                                                 
  .char	       			\ show last char                
  base !       			\ reset base                    
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  .top-line
                                                                
: .top-line		\ -- ; print the appropriate top line
  0 0 gotoxy
  1st@ 32 <			\ if 1st is 00-20                 
  10th@ 32 < or                 \ if 10th is 00-20               
  if                                                            
    .top-line(00-20)            \ show wide one                 
  else                                                          
    .top-line(21-FF)            \ show normal one               
  endif                                                         
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  go-end
                                                                
: redraw-ascii		\ -- ; redraw the table
  cls
  .top-line                     \ show correct top line         
  .ascii-table			\ show ascii table              
;
                                                                
: go-end                \ -- ; go to end of table
  245 1st !                     \ first = 245                   
  255 10th !                    \ last = 255                    
  redraw-ascii
;                                                         
                                                                
\ hm                                            R. G.  01/09/89 

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  hm
                                                               
: hm                    \ -- ; go to top of table
  00 1st !                      \ first = 0                     
  10 10th !                     \ last = 10                     
  redraw-ascii                                                  
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  pg-dn
                                                                
: pg-dn                 \ -- ; down one screen worth
  11 10th +!                    \ increment last by 10          
  255 10th @ min 10th !         \ set 10th to 255 if necessary  
  10th@ 10 - 1st !              \ set first to suit             
  redraw-ascii                                                  
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  pg-up
                                                                
: pg-up                 \ -- ; up one screen worth
  -11 1st +!                    \ decrement first by 10         
  0 1st@ max 1st !              \ set 1st to 0 if necessary     
  1st @ 10 + 10th !             \ set first to suit             
  redraw-ascii                                                  
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  up
                                                                
: up                    \ -- ; up one line
  1st@ 0>					\ if there are more to go..  
  if                                                            
     -1 1st +!  -1 10th +!			\ decrement limits           
     0 0 gotoxy
     25 spaces			     		\ clean top line
     -1 curr-handle @ scroll-window drop	\ scroll
     0 1 gotoxy					\ goto top line              
     1st@ .char					\ show new first character   
     .top-line					\ show correct top line         
  else
    end-of-list-tone				\ end of option
  endif                                                         
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  dn
                                                                
: dn                    \ -- ; down one line
  10th@ 255 <				\ if there are more to go..  
  if                                                            
     0 1 gotoxy 25 spaces		\ blank top line first
     1 1st +!  1 10th +! 		\ increment limits           
     1 curr-handle @ scroll-window drop	\ scroll
     0 11 gotoxy	 		\ goto bottom line           
     10th@ .char	 		\ show new last character    
     .top-line	               		\ show correct top line         
  else
    end-of-list-tone		 	\ end of option
  endif                                                         
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  table>down

: table>down            \ -- ; move table down one
  a/t-tly @ 13 + #rows @ <      \ one in from the edge ?        
  if                                                            
     1 a/t-tly +!               \ increment y location of table 
     0 1 curr-handle @ moveby-window drop
  else
    end-of-list-tone	       	\ end of option
  endif ;                                                       

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  table>up
                                                                
: table>up              \ -- ; move table up one
  a/t-tly @ 0 >  	               \ one in from the edge ?        
  if                                                            
     -1 a/t-tly +!      	        \ increment x location of table 
     0 -1 curr-handle @ moveby-window drop
  else
   end-of-list-tone    			\ end of option
  endif ;                                                       

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  table>left
                                                                
: table>left            \ -- ; move table left one
  a/t-tlx @ 0 >				\ one in from the edge ?        
  if                                                            
     -1 a/t-tlx +!			\ increment x location of table 
     -1 0 curr-handle @ moveby-window drop
  else
   end-of-list-tone			\ end of option
  endif ;                                                       

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  table>right
                                                                
: table>right           \ -- ; move table right one
  a/t-tlx @ 28 + 79 <			\ one in from the edge ?        
  if                                                            
     1 a/t-tlx +!			\ increment x location of table 
     1 0 curr-handle @ moveby-window drop
  else
    end-of-list-tone			\ end of option
  endif ;                                                       

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  browse
                                                                
: browse                \ -- ; browse around table
  begin (key)                                                   
    case                                                        
           00 of     
                 (key)                                                         
                 case                                                          
                    59 of more-help endof	\ help on F1
                    68 of exit     endof	\ quit on F10
                    80 of dn       endof 	\ down arrow                       
                    72 of up       endof    	\ up arrow                         
                    81 of pg-dn    endof    	\ page down                        
                    73 of pg-up    endof    	\ page up                          
                    71 of hm       endof    	\ home                             
                    79 of go-end   endof    	\ end                              
                          wrong-tone		\ wrong key
                 endcase
              endof
      ascii 6 of table>right  endof     	\ move table to right   
      ascii 4 of table>left   endof     	\ move table to right   
      ascii 2 of table>down   endof     	\ move table down       
      ascii 8 of table>up     endof     	\ move table up         
           27 of exit         endof     	\ quit
                 wrong-tone			\ wrong key
    endcase                                                     
  again                                                         
;

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  (ascii-table)

decimal                                                         
                                                                
: (ascii-table)         \ -- ; do the whole thing
  base @ >r decimal		\ go into decimal               
  1st@ 10 + 10th !		\ set first and last             
  redraw-ascii			\ draw first page
  browse			\ browse it                     
  r> base !			\ restore system base
;

\ -----End of Page-----
\ -- R.G.G -- 25/05/90 --  ascii-table -- top level

headers

: ascii-table           \ -- ; do it
  save-win
  a/t-tly @ 13 + #rows @ >       	\ if below edge of screen
  if 10 a/t-tly ! endif			\ protect from 43/25 problems
  create-ascii-windows
  curr-handle to-window
  cursor-off			 	\ turn off cursor               
  10 #help
  (ascii-table)				\ ascii table primitive         
  cursor-on				\ back to old screen            
  curr-handle from-window
  rest-win
  delete-curr-window
;                                                               
 
behead
