\ compiler module code for xshell v3 compiler.module


\ -----End of Page-----
\ -- R.G.G -- 26/06/90 --  externs and vars

extern api-handle			\ in order to use the window
extern in-compiler			\ says we are running
extern attrib>7
extern compiler-path			\ where to find the compiler

extern red		 		\ for messages
extern dark		 		\ for text
extern .top-bar		 		\ for use by UMBILICAL-MODE
extern shell-mode	 		\  ditto

extern (dir)		 		\ for  dir function
extern $dir-spec	 		\ default spec

extern (alt-key)			\ need the master's one
extern (alt-key?)			\ need the master's one

extern entry-r0				\ where r0 was at start up
extern entry-s0				\ where s0 was at start up

extern $comp-comm			\ the compiler command string

extern umb-i/p>log			\ perhaps log it
extern umb-o/p>log			\ perhaps log it

extern redraw-bottom-bar		\ how to do a new bottom bar

variable compiler-error	public		\ was there a compiler error

\ -----End of Page-----
\ -- R.G.G -- 24/10/90 --  close-compiler

defer close-compiler			\ will have free-symbol-space assigned
  public

assign noop to-do close-compiler	\ for now and for compcore

\ -----End of Page-----
\ -- R.G.G -- 26/06/90 --  .s -- redefinition

: .binary		\ n -- ; print in binary (straight from forth.scr)
  base @ >r
  binary
  0 
  <# # # # # ascii _ hold # # # # ascii _ hold
  # # # # ascii _ hold # # # # #>
  type ." -b "
  r> base !
;

: .word			\ n -- ; print as 16b hex (straight from forth.scr)
  base @ >r
  hex
  0 <# # # # # #> type
  r> base !
;

: .byte			\ n -- ; print as 8b hex (straight from forth.scr)
  base @ >r
  hex
  0 <# # # #> type				\ n --
  r> base !
;

hex

: .ascii		\ b -- ; maybe emit (straight from forth.scr)
  07f and  dup 020 07e within? 0=
  if
    drop 02e
  endif
  emit  
;

decimal

: .s			\ -- ; print stack in this module only
  cr  depth ?dup
  if 
    ."    top"  dup 0< 1 ?error  0
    do 
       i pick dup  cr 6 .r space
       base @
       dup 10 <> if  over decimal  6 u.r ." -d  "  endif
       dup 16 <> if  over   	 .word ." -h  "  endif
       dup 2 <> if  over .binary  endif
       base !
       drop
       halt? ?leave
    loop
  else
    ." empty stack"
  endif 
  cr  
;

\ -----End of Page-----
\ -- R.G.G -- 10/1/92 --  set-error

: set-error		\ -- ; set compiler error flag in master
  compiler-error on		\ set flag on
;

\ -----End of Page-----
\ -- R.G.G -- 28/06/90 --  >api-window

: >api-window		\ -- ; use the api screen window
  0 mod-seg >es api-handle e@		\ get window number
  op-handle !		      		\ reset to host handle
;

\ -----End of Page-----
\ -- R.G.G -- 26/06/90 --  new-stacks

: new-stacks		\ -- ; set up new stack bases
  0 mod-seg >es
  in-compiler e@		\ if we are not yet in the compiler
  0=		   		\ get flag,
  if
    rp@ entry-r0 e!		\ set entry version
    sp@ entry-s0 e!
  endif
  rp@ r0 !	   		\ new ret stack base
  sp@ s0 !	   		\ new stack base
;

\ -----End of Page-----
\ -- R.G.G -- 27/06/90 --  set-flags

: set-flags  		\ -- ; say we are running the compiler now
  -1 0 mod-seg >es in-compiler e!		\ set flag on
;

\ -----End of Page-----
\ -- R.G.G -- 26/06/90 --  io-assignments

: (key)'		\ -- char ;
  (key)
;

: (key)			\ -- char ; get a key via the master module
  (alt-key)			\ do the one in the master module
;

: (key?)'		\ -- t/f ;
  (key?)
;

: (key?)     		\ -- t/f ; is a key pending via the master module
  (alt-key?)			\ do the one in the master module
;

: (umb-key)		\ -- char ; maybe log the key press
  (key)				\ get key stroke
  umb-i/p>log			\ perhaps log it
;

: (umb-emit)		\ char -- ; maybe log the character
  umb-o/p>log			\ perhaps log it
  (emit)			\ always emit it
;

: (umb-type)		\ addr len -- ; type a string from umbilcal mode
  bounds
  ?do
     i c@ (umb-emit)
  loop
;

: new-io		\ -- ; direct via master module
  0 mod-seg >es api-handle e@		\ get window number
  op-handle !		      		\ and direct into it			
  assign (key) to-do key		\ the right one
  assign (key?) to-do key?		\ the right one
;

: umbilical-io		\ -- ; maybe also log
  assign (umb-key) to-do key 		\ new loggable key
  assign (umb-emit) to-do emit		\ new loggable emit
  assign (umb-type) to-do type		\ new loggable type
;

\ -----End of Page-----
\ -- R.G.G -- 26/06/90 --  bye

: bye			\ -- ; bye back into master module
  0 mod-seg >es
  entry-s0 e@ sp! entry-r0 e@ rp!	 \ back as we were, quit is automatic
;

\ -----End of Page-----
\ -- R.G.G -- 28/06/90 --  using

: using			\ <filename> -- ; get a screen file name
  using					\ do old version
  redraw-bottom-bar			\ but do this as well
;

: re-using		\ -- ; just as
  re-using				\ do old version
  redraw-bottom-bar			\ and do bottom bar to suit
;

: load-using		\ <filename> -- ; just as
  cs> bl word $using 8 ?error		\ do a using
  redraw-bottom-bar			\ do bottom bar
  load re-using  			\ and do this
;

: thru-using		\ <filename> -- ; just as
  cs> bl word $using 8 ?error
  redraw-bottom-bar
  thru re-using  
;

\ -----End of Page-----
\ -- R.G.G -- 28/06/90 --  use

: use			\ <filename> -- ; just as
  use					\ do old version
\  curr-text$ 2dup c@l 			\ -- seg off len ;
\  pass-use-file			\ pass it (call to extern)
  redraw-bottom-bar			\ and do pretty screen
;

\ -----End of Page-----
\ -- R.G.G -- 28/06/90 --  dir

create *.fth ", *.FTH"  

: copy>master		\ $addr1 -- $addr2 ; copy spec to master
  dup >r			\ R:$addr
  cs> swap			\ seg1 off1
  0 mod-seg $dir-spec		\ seg1 off1 seg2 off2
  r> c@ 1+			\ seg1 off1 seg2 off2 len
  cmovel			\ move to master
  $dir-spec
;

: dir			\ <spec> -- ; do this via master module/browser
  bl word			\ get i/p
  dup c@ 0=			\ if no i/p
  if
    drop *.fth
  endif 			\ replace with default
  copy>master			\ send string to master
  (dir)				\ do function in master
;

\ -----End of Page-----
\ -- R.G.G -- 28/06/90 --  cd

: cd			\ <spec> -- ; do this and do bottom bar
  cd   				\ do original
  redraw-bottom-bar		\ and tidy up
;

\ -----End of Page-----
\ -- R.G.G -- 28/06/90 --  umbilical-comms

variable delay-count  1 delay-count !

: serial-key		\ -- char ; get a serial char
  begin
    key?				\ has a key been pressed?
    if
      key 02 = if abort endif		\ if so, abort if ^B
    endif
    ser-key?				\ carry on until serial char
  until
  ser-key				\ get serial char
;

: byte-to-host		\ -- char ; get a char for umbilical
  serial-key
;

: byte-to-target	\ char -- ; send char from, umbilical
  ser-emit
  delay-count @ 0 do loop
;

\ -----End of Page-----
\ -- R.G.G -- 28/06/90 --  umbilical-mode

: umbilical-mode	\ -- ; switch to this mode
  [ d-ptr1 @ , ]	     			\ check dongle
  es>
  0 mod-seg >es	     				\ use right module
  3 shell-mode e!	     			\ set umbilical mode
  >es
  cr red ."  Press any key to continue" dark	\ tell user
  (key)' drop		     			\ wait for user
  begin (key?)' while (key)' drop repeat		\ tidy up keyboard
  .top-bar			       		\ show user
  attrib>7					\ back to normal attribs
  umbilical-io			       		\ log the io
;

\ -----End of Page-----
\ -- R.G.G -- 26/06/90 --  new interpret loop

: (quit)		\ -- ; just like the original
  blk off state off 		 		\ thats  right
  BEGIN
    cr query interpret state @ 0= 		\ just like quit
    IF								
      prompt			  		\ print prompt
    ENDIF
 again
;

\ -----End of Page-----
\ -- R.G.G -- 29/06/90 --  ?command-line

: copy-command		\ -- ; get the command from the master module
  es> $comp-comm 1+		\ source
  cs> tib			\ destination
  $comp-comm ec@		\ length
  cmovel			\ move string
  >in off			\ turn off pointer  
  $comp-comm ec@ #tib !		\ set length of tib
;

: ?command-line		\ -- ; is there a command line to get
  0 mod-seg >es	       		\ use that module
  $comp-comm 1+ ec@    		\ get first char in command
  ascii - <>	       		\ if not `null' ...
  if
    copy-command       		\ copy command to tib
    interpret	       		\ interpret from it
  endif
;

\ -----End of Page-----
\ -- R.G.G -- 26/06/90 --  compiler

defer loader		\ so that compiler looks like a v4 compcore

: .kernel		\ -- ; default sign-on
  cr ." MPE Forth Cross-Compiler Kernel, v5.00"		\ what it is
  cr .rel-date	   			\ in file release.fth	
  cr .free				\ just like cold	
;

assign (quit) to-do quit

assign .kernel to-do loader		\ default sign on to be done

: compiler		\ -- ; word called by master
  [ d-ptr1 @ , ]			  \ check dongle
  0 mod-seg >es				  \ use this other module
  in-compiler e@			  \ if not yet running compilre
  0=					  \ get flag,
  if
    rp@ entry-r0 e! 			  \ set entry version
    sp@ entry-s0 e!
  endif
  compiler-error off			  \ turn off error indication
  rp@ r0 !				  \ new ret stack base
  sp@ s0 !				  \ new stack base
  blk off
  >in off
  #tib off
  set-flags				  \ say we are in compiler
  assign >api-window to-do normal-drivers \ fix handler for errors
  new-io				  \ redirect into window system
  loader				  \ to do whatever
  ?command-line				  \ interpret any comm-line passed
  cr ."   ok"
  quit
; public

: cold ;			\ dummy so that people can type it
