\ configuration code for xs3

only forth also xs3 definitions

\ -----End of Page-----
\ -- R.G.G -- 06/06/90 --  variables

variable date-flag  public	  	\ used to configure fred

date-flag on			  	\ pre-programmed default

variable time-flag  public		\ used to configure fred

variable window# public			\ the window to work in

create tab-text   128 allot   public	\ the text for the fred tabs

"" "
	1+ tab-text 64 cmove
"" "
	1+ tab-text 64 + 64 cmove

create stamp-text 64  allot	 public	\ the text of the fred stamp

""  \ " stamp-text $move		\ default stamp text

extern get-setup			\ get the setup from fred module
extern set-setup			\ set the setup in fred module
extern tab-stops			\ the ones in the editor
extern stmp-date			\ the variable to get info from
extern stmp-time			\ the variable to get info from
extern stmp				\ the buffer to get text from

headerless

pcb cfg-file	      			\ the file to open

"" XS3.CFG" cfg-file set-pathname	\ and its name

\ -----End of Page-----
\ -- R.G.G -- 11/06/90 --  written-tone

: written-tone		\ -- ; say we have written config file
  100 12 beep				\ it works !!!
  200 12 beep
  300 12 beep
;

\ -----End of Page-----
\ -- R.G.G -- 06/06/90 --  open-cfg

hex

code rename-path 	\ addrz1 addrz2 -- status ; rename addrz1 to addrz2
  dx pop			\ set up dx
  di push  es push		\ presere used registers
  di, bx mov			\ set up di
  ax, cs mov			\ get the segment for both
  ds, ax mov			\ set up ds
  es, ax mov			\ set up es
  al, # 0 mov			\ set up al
  ah, # 056 mov			\ set up ah
  021 int			\ do the deed
  es pop  di pop		\ restore registers used
  nc, if,
    bx, # 00 mov		\ return success
  else,
    bx, # -1 mov		\ return failure
  endif,
  next,
end-code

decimal

create temp-buff 10 allot		\ temp for renaming file

: open-cfg-op		\ -- t/f ; open the file
  "" XS3.CF!" $>asciiz delete-path drop		\ delete existing backup file
  "" XS3.CFG" $>asciiz temp-buff 10 cmove	\ move first to temp-buff
  temp-buff "" XS3.CF!" $>asciiz rename-path drop	\ rename old to backup
  cfg-file create-path-pcb			\ create the file regardless
  dup	
  if
    ." Can't create configuration file " cfg-file .pcb
    key drop
  endif
  0=					\ == true: opened
;

\ -----End of Page-----
\ -- R.G.G -- 06/06/90 --  ?cfg

: ?cfg	    		\ -- t/f ; does cfg file exist
  cfg-file open-path-pcb	       	\ open existing file
  0=				       	\ true for exists
  cfg-file handle close-path	       	\ close it again
  0=				       	\ true for exists
  and				       	\ must both be so
;
  
\ -----End of Page-----
\ -- R.G.G -- 06/06/90 --  close-cfg

: close-cfg    		\ -- ; close the cfg file
  cfg-file handle close-path	drop		\ try to close file
;

\ -----End of Page-----
\ -- R.G.G -- 06/06/90 --   >cfg-file  cfg-file>

: >cfg-file		\ -- handle ; direct into cfg file
  op-handle @	window# !			\ preserve window
  cfg-file handle op-handle !			\ direct op to file
;

: cfg-file>	   	\ handle -- ; direct back to screen
  window# @ op-handle !				\ restore window
;

\ -----End of Page-----
\ -- R.G.G -- 06/06/90 --  (write-cfg) stuff

: .bl	  		\ -- ; print a space
  bl emit   		    	\ send a space to file	
;

: .'	  		\ -- ; print a "
  ascii " emit 			\ send a " to file
  .bl	       			\ and a space
;

: .""	    		\ -- ; print a ""
  ascii " emit
  ascii " emit			\ send a "" to file
  .bl	      			\ and a space
;
	
: .cr/lf  		\ -- ; print a cr/lf
  13 emit
  10 emit			\ send a cr to file
;

: >file	  		\ $addr -- ; print a string and a cr/;f
  count type .cr/lf	      	\ type string and new-line
;

\ -----End of Page-----
\ -- R.G.G -- 08/06/90 --  more write function

: write-fn-keys		\ -- ; save function key setup
  13 0					\ for each key
  do
    letter-table i + c@ dup 0=		\ get assignment
    if drop ascii _ endif		\ replace nul with _ ?
    emit				\ and send to file
  loop
;

: write-tabs		\ -- ; write fred tabs data
  .""					\ start of string
  tab-text 64 type			\ send to file
  .'					\ end of string
  "" is-tabs-top" >file			\ write first line
  .""					\ start of string
  tab-text 64 + 64 type			\ send to file
  .'					\ end of string
  "" is-tabs-bottom" >file		\ write first line
;

: write-stamp		\ -- ; write the fred stamp
  stamp-text count type		    	\ send to-file
;

: .on			\ -- ; print `on'
  ." on"
;

: .off			\ print `off'
  ." off"
;

: write-time/date	\ -- ; write fred time and date status
  ." date "			\ date setting
  date-flag @			\ get value
  if    .on			\ say on
  else  .off			\ say off
  endif
  .cr/lf			\ new line
  ." time "			\ time setting
  time-flag @			\ get value
  if    .on			\ say on
  else  .off			\ say off
  endif
  .cr/lf			\ new line
;  

: .edit-file-status	\ -- ; whether to pass file name to editor
  ." file "	    		\ write name of variable
  edit-file @
  if   .on
  else .off
  endif
  .cr/lf
;

\ -----End of Page-----
\ -- R.G.G -- 08/06/90 --  (write-cfg)

: (write-cfg)			\ -- ;
  ." \ XShell v3 Configuration file: " .date ."  at " .time .cr/lf
  curr-edit$ cs> here curr-edit$ c@l 1+ cmovel
  ."" here count type .'   	"" is-editor"		>file
  .edit-file-status
  ."" write-fn-keys .'	   	"" is-fn-keys"		>file
  ."" $blow-prom count type .'	"" is-blow"		>file
  ."" $emu-prom count type .'	"" is-emu"		>file
  ."" $u1-prompt count type .'	"" is-prompt#1"		>file
  ."" $u1-comm count type .'	"" is-command#1"	>file
  ."" $u2-prompt count type .'	"" is-prompt#2"		>file
  ."" $u2-comm count type .'	"" is-command#2"	>file
  ."" $compiler count type .'	"" is-compiler"		>file
  ."" $comp-comm count type .'	"" is-comp-command"	>file
  ."" $dump-comm count type .'	"" is-dump"		>file
  int/ext @
  if "" external" >file
  endif
  0  ser-drop u.		"" baud"		>file
  6  ser-drop .			"" parity"		>file
  4  ser-drop .			"" data"		>file
  8  ser-drop .			"" stop"		>file
  2  ser-drop .			"" shake"		>file
  10 ser-drop .			"" port"		>file
  dumb/files @ .		"" server"		>file
  fred-loaded @			\ only if fred is currently loaded
  if
    es> >r
    set-setup			\ get the status from it
    r> >es
  endif
  write-tabs	
  ."" write-stamp .'	   	"" is-stamp" 	>file
  write-time/date
  modes @ .		 	"" modes"	>file
  loud @ .			"" loud"	>file
  title-attrib		@ .
  help-prompt-attrib	@ .
  body-attrib	  	@ .
  header-attrib	  	@ .
  border-attrib	  	@ .
  window-attrib	  	@ .
  help-border-attrib 	@ .
  help-body-attrib	@ .	"" colours"	>file
;

\ -----End of Page-----
\ -- R.G.G -- 06/06/90 --  write-cfg

headers

: write-cfg		\ -- ; write the cfg file
  open-cfg-op  			\ try to open file
  if
    >cfg-file  			\ direct op to file
    base @    			\ preserve base
    decimal			\ into decimal
    (write-cfg)			\ write cfg file
    base !			\ back to default base
    close-cfg			\ close cfg file
    cfg-file>			\ back to window
    written-tone		\ say so
  endif
; public

\ -----End of Page-----
\ -- R.G.G -- 11/06/90 --  read-cfg code

defer letter>action-table

decimal 

: start-fn#s		\ -- ; set the function key data
  13 2				\ fn2 -- fn12                   
  do                                                            
    i curr-fn# !		\ set fn#                       
    letter-table i + c@		\ get letter                    
    letter>action-table		\ set up action                 
  loop                                                          
;                                                               

only forth definitions

headers

vocabulary config

only forth also xs3 also config definitions

: ""			\ <string> -- ; just like ""
  [compile] ""				\ synonym of ""
; immediate

: is-editor		\ $addr -- ; get editor name
  cs> swap curr-edit$ 64 cmovel  	\ move to right place
;

: is-fn-keys		\ $addr -- ; get function keys
  1+ dup 1- c@ 0			\ for all chars in string (0-12)
  ?do
    dup i + c@				\ get letter or underscore
    dup ascii _ =			\ if char is underscore
    if drop 0 endif			\ then replace with zero		
    i letter-table + c!			\ store in letter-table
  loop
  drop
  start-fn#s				\ do key set-up
;

: is-blow		\ $addr -- ; get programmer name
  $blow-prom $move			\ move
;

: is-emu		\ $addr -- ; get emulator name
 $emu-prom $move			\ move
;

: is-prompt#1		\ $addr -- ; get user1 prompt
  $u1-prompt $move			\ move
;

: is-command#1		\ $addr -- ; get user1 command
  $u1-comm $move			\ move
;

: is-prompt#2		\ $addr -- ; get user2 prompt
  $u2-prompt $move			\ move
;

: is-command#2		\ $addr -- ; get user2 command
  $u2-comm $move			\ move
;

: is-compiler		\ $addr -- ; get compiler name
  $compiler $move			\ move
;

: is-comp-command	\ $addr -- ; get compiler command
  $comp-comm $move			\ move
;

: is-dump		\ $addr -- ; get dump command
  $dump-comm $move			\ move
;

: baud			\ n -- ; get baud rate
  1 ser-2drop				\ set baud rate
;

: parity		\ n -- ; get parity type
  7 ser-2drop				\ set parity type 0,1,2
;

: data			\ n -- ; get #data bits
  5 ser-2drop				\ set data bits 7,8
;

: stop			\ n -- ; get #stop bits
  9 ser-2drop				\ set stop bits 1,2
;

: shake			\ n -- ; get h/s type
  3 ser-2drop				\ set h/s type 1,2,3,4
;

: port			\ n -- ; get port#
  11 ser-2drop				\ set port# 1,2,3,4
;

: server		\ n -- ; make or not file server
  dumb/files !
;

: external		\ -- ; set using extenal comms
  int/ext on
;

: colours		\ a1 a2 a3 a4 a5 a6 -- ; set system attribs
  help-body-attrib	!
  help-border-attrib	!
  window-attrib	    	!
  border-attrib		!
  header-attrib		!
  body-attrib		!
  help-prompt-attrib	!
  title-attrib		!
;

: modes			\ n -- ; set modes
  modes !			\ set default screen modes
;

: loud			\ n -- ; set noise
  loud !      			\ set default screen modes
;

: is-tabs-top		\ $addr -- ; set top tab stops in fred
  1+ tab-text 64 cmove		\ move to first part of tab text
;

: is-tabs-bottom	\ $addr -- ; set bottom tabs in fred
  1+ tab-text 64 + 64 cmove	\ move to second part
;

: is-stamp		\ $addr -- ; get fred stamp
  stamp-text $move		\ move to mod0  buffer
;

variable date		\ to hold fred config info
variable time
variable file

: on			\ addr -- ; turn something on
  on				\ synonym of forth word
;

: off			\ addr --  ; turn someting off
  off				\ synonym of forth  word
;

: \			\ -- ; do a comment
  [compile] \			\ synonym of forth word
;  immediate

: set-fred		\ -- ; set fred config from this file
  fred-loaded @	   		\ if editor module loaded..
  if
    es>
    date @ date-flag !		\ set date flag
    time @ time-flag !		\ set time flag
    get-setup	      		\ call setup  word in fred module
    >es
  endif
;

headerless

: set-edit-file		\ -- ; set this flag
  file @ edit-file !		\ set whether to pass file name to ed.
;

: (read-cfg)		\ -- ; read the cfg file, and interpret it
  ip-handle @					\ preserve i/o handles
  op-handle @
  "" nul" $>asciiz open-path drop op-handle !	\ redirect to nul
  decimal				    	\ base for number input
  only config definitions			\ use this vocabulary
  1 1 cs> "" XS3.CFG" $from			\ read this file
  op-handle @ close-path drop			\ close nul channel
  only forth definitions	   	 	\ back to normnal
  set-fred					\ set up editor
  set-edit-file					\ set up ascii editor
  make-compiler-path				\ work out where the compiler is
  ser-close  ser-open				\ reset comms parameters
  op-handle !					\ restore i/o handles
  ip-handle !
;

\ -----End of Page-----
\ -- R.G.G -- 06/06/90 --  read-cfg

only forth also config also xs3 definitions

headers

: read-cfg		\ -- ; maybe read the cfg file
  ?cfg				\ does file exist
  if
    (read-cfg)			\ read configuration
  endif
;

only forth also xs3 definitions

behead
