\ function calls for xs3 - the bulk of the code


\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  text messages

: .no-comm              \ -- ; just say this
  ."  This command not initialised"  
;
                                                                
: .warn                 \ -- ; just say this
  ." Warning:"
;
                                                                
: .enter                \ -- ; just say this
  ." Enter command:   "  
;

: .enter-menu           \ -- ; just say this
  ." Enter menu text: "
;                                                               
  
\ -----End of Page-----
\ -- R.G.G -- 05/06/90 --  video-mode stuff

hex

headerless

code >43		\ -- ; select 43 line ega mode
  bp push bx push		\ preserve bp & bx
  ax, # 02 mov			\ ah=0, al=2: mode set
  010 int			\ call int 10
  ax, # 01112 mov		\ ah=11, al=12
  bl, # 00 mov			\ block#: 8*8 character set
  010 int			\ call int 10
  ax, # 01200 mov		\ ah=12, al=00
  bl, # 020 mov			\ select alternate printscreen routine
  010 int			\ call int 10
  03 int			\ finish off
  bx pop  bp pop		\ restore bx & bp
  next,
end-code	 

code >50		\ -- ; select 50 line vga mode
  bp push bx push		\ preserve bp & bx
  ax, # 01202 mov		\ fn12 and 400 scan lines
  bx, # 00030 mov		\ subfunction number
  010 int			\ call int
  ax, # 02 mov			\ ah=0, al=2: mode set          
  010 int			\ call int 10                   
  ax, # 01112 mov		\ ah=11, al=12                  
  bl, # 00 mov			\ block#: 8*8 character set     
  010 int			\ call int 10                   
  ax, # 01200 mov		\ ah=12, al=00                  
  bl, # 020 mov			\ select alternate printscreen routine  
  010 int			\ call int 10                   
  bx pop  bp pop		\ restore bx & bp               
  next,				\ next word
end-code

decimal

: test-mode		\ -- t/f ; see how many rows at the moment
  max-rows off				\ reset to nothing
  50 screen-drop
  case
    4 of 43 max-rows ! endof
    5 of 43 max-rows ! endof	     	\ these are EGA
    7 of 50 max-rows ! endof
    8 of 50 max-rows ! endof	     	\ these are VGA
  endcase
  max-rows @ 0<>		     	\ true for EGA/VGA
;

decimal                                                         

: 50-line		\ -- ; go to 50 lines
  >50				\ hardware reset
  49 #rows !
  51 screen-2drop		\ re-init direct drivers
;

: 43-line		\ -- ; go to 43 lines
  >43		    		\ hardware reset                
  42 #rows !	    		\ reset number of rows          
  51 screen-2drop		\ re-init direct drivers
;                                                               

headers

: 25-line		\ -- ; go to 25 lines
  max-rows off				\ reset length of screen
  old-mode @ 49 screen-2drop		\ hardware reset                
  24 #rows !				\ reset number of rows          
  51 screen-2drop			\ re-init direct drivers
;

headerless

: .no-ega		\ -- ; say there is no ega or vga
  save-win
  create-mode-window
  curr-handle to-window
  error-tone					     \ this was a bad move	
  cr                                                          
  red ."  Error" dark ."   An EGA or VGA card must be installed "      
  cr  ."         to use 43/50 line mode."                           
  cursor-off
  spare-keys                                         
  (key) drop						\ wait for user                 
  spare-keys                                                    
  cursor-on						\ back to old screen            
  curr-handle from-window
  delete-curr-window
  rest-win
;   

: redraw-screens		\ -- ;
  mode-changed on
  screen-handle @ op-handle !		\ back to full screen
  delete-target-window
  create-target-window
  target-handle @ 
  dup close-window drop
  dup >r body-attrib @ dup dup r> attribs-window drop
      reopen-window drop
  target-handle init-window
  delete-host-window
  create-host-window
  host-handle @
  dup close-window drop
  dup >r body-attrib @ dup dup r> attribs-window drop
      reopen-window drop
  host-handle @ open-window drop
  shell-mode @
  case
    1 of
        top-bar-target	  			\ same top line
        bottom-bar-target			\ and bottom line
        target-handle to-window
      endof
    0 of
        top-bar-host	  	 		\ same top line
        bottom-bar-host				\ and bottom line
        host-handle @ op-handle !  
      endof
       delete-api-window
       create-api-window
       top-bar-umb	       			\ otherwise reset umbilical window
       bottom-bar-target
       api-handle to-window
  endcase
  0 comp-xy ! 0 comp-xy 2+ !			\ zero compiler location
  0 targ-xy ! 0 targ-xy 2+ !			\ zero host location
  0 0 gotoxy	     				\ zero target location
;

headers

: 25/43-mode		\ -- ; try to switch mode
  from-api @			\ don't allow call by external app.
  if
     25 #help
    .no-func
  else
    test-mode 0=		\ is ega card installed?  
    if
      .no-ega			\ if not, then say so     
    else
      #rows @	dup		\ which screen mode ?     
      42 = swap 49 = or                                                   
      if			\ if 43 line              
        25-line			\ switch to 25            
        redraw-screens 
      else	      		\ if 25 line, then        
        max-rows @
        43 =
        if
          43-line     		\ switch to 43            
        else
          50-line
        endif
        redraw-screens		\ 
      endif                                                   
    endif                                                         
  endif
;


\ -----End of Page-----
\ -- R.G.G -- 04/06/90 --  to-dos  from-dos

: to-dos		\ -- handle #rows ; go to dos window
  shell-mode @ 1 <=
  if
    from-api @ 0= 			\ if not running umbilical
    if
      ser-close		  		\ close comms for next prog
    endif
  endif
  0 cooked 1 cooked			\ normal DOS cooked functions
  op-handle @		  		\ preserve handle
  create-dos-window	  		\ create now, may be new dimensions
  dos-handle to-window
  modes @
  02 and
  if
    #rows @		  		\ preserve size of current screen
    dup 24 <> 				\ maybe go back to 25 lines
    if 25-line endif
  endif
;

: from-dos		\ #rows handle -- ; return from dos window
  modes @
  02 and
  if
    case
      42 of 43-line endof		\ return to last screen size
      49 of 50-line endof
    endcase
  endif
  dos-handle from-window
  delete-dos-window		   	\ delete ready for next time
  op-handle !			   	\ restore to old screen
  ip-handle @ raw 		   	\ need raw i/p
  shell-mode @ 1 <=
  if
    from-api @ 0=			\ if not running umbilical
    if
      ser-open    		   	\ re-open comms for target
    endif
  endif
;
behead

hex

: to-compiler		\ -- handle ; prepare to run compiler
\  ser-close				\ close comms for next prog
  op-handle @				\ preserve handle
  create-dos-comp-window		\ create now, may be new dimensions
  dos-comp-handle to-window
  save-di
;

: from-compiler		\ handle -- ; return from compiler
  dos-comp-handle from-window
  delete-dos-comp-window		\ delete ready for next time
  op-handle !				\ restore to old screen
\  ser-open				\ re-open comms for target
;

decimal

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  blow-eprom

headerless                                                                

: setup-blow-prom       \ -- t/f ; setup the name of the prom programmer
  01 #help
  error-tone				\ this was a bad move	
  op-handle @		      		\ preserve current window #
  create-blow-window
  curr-handle to-window
  red .Warn dark .no-comm                                       
  cr .Enter				\ prompt                              
  pick-option on
  $blow-prom ed-$ dup >r		\ edit command          
  if     $blow-prom here>$                                      
  endif
  curr-handle from-window
  delete-curr-window
  op-handle !				\ restore last window
  reset-attribs
  r>					\ get flag back
;                                                   

: do-prom		\ -- ; make the dos call
  to-dos			\ use dos window
  cs> $blow-prom $dos		\ blow the prom     
  from-dos			\ back to mode
;

headers                                                                

: blow-prom             \ -- ; maybe blow a prom
  getxy			     		\ save screen pos
  $blow-prom 1+ c@ ascii - =		\ is the string set up ?        
  if
    setup-blow-prom			\ if not get it
    if
      do-prom				\ if set up by user
    endif
  else
    do-prom				\ or just do it
  endif                                                         
  gotoxy	 			\ restore screen pos
;                                                               

behead

\ -----End of Page-----
\ -- R.G.G -- 25/05/90 --  run cross compiler

headerless

: .not-set-up		\ -- ; say that compiler not set up
  error-tone				\ rasp to inform user
  op-handle @				\ preserve window
  create-compiler-window		\ create new window
  curr-handle to-window
  red .warn dark .no-comm 		\ warning 
  cr ." Please use the Keyboard configuration option."	\ message
  cr 15 spaces red .press dark 		\ press a key to continue
  (key) drop				\ wait for user
  spare-keys				\ remove extra key presses
  curr-handle from-window		\ close window
  delete-curr-window			\ remove from list
  op-handle !				\ back to old window
;

\ -----End of Page-----
\ -- R.G.G -- 26/06/90 --  .top-bar

headers

: .top-bar		\ -- ; print top bar of screen
  getxy op-handle @ 			\ preserve current window
  screen-handle @ op-handle !		\ go to whole screen window
  shell-mode @				\ according to which mode
  case
    1 of top-bar-target endof
    0 of top-bar-host   endof		\ print the right top bar
         top-bar-umb			\ if not an internal mode
  endcase
  op-handle !				\ back to old window
  gotoxy				\ and old location
; public

\ -----End of Page-----
\ -- R.G.G -- 08/06/90 --  redraw-bottom-bar

: redraw-bottom-bar	\ -- ; new bottom bar on screen
  save-win
  screen-handle @ op-handle !		\ use whole screen
  shell-mode @
  if
    bottom-bar-target			\ draw this bottom line
  else
    bottom-bar-host  			\ or that one	
  endif
  rest-win
; public


: (.new-banners)	\ -- ; patch for version needed earlier
  .top-bar
  redraw-bottom-bar
;  

assign (.new-banners) to-do .new-banners
  
\ -----End of Page-----
\ -- R.G.G -- 26/06/90 --  >compiler-module

create file-temp  64 allot

: preserve-fth-file		\ -- ;
  curr-text$ cs> file-temp curr-text$ c@l 1+ cmovel		\ get file$ to here
;

: get-curr-file			\ -- ; get the current file name from the epcb
  $14 op-handle @ ioctl drop 2+			\ get seg and off
  cs> file-temp 62 cmovel			\ copy pcb to file-temp
  file-temp asciiz>$				\ convert to $
  dup >r cs> swap curr-text$ r> c@ 1+ cmovel	\ move to services module
;

decimal

extern compiler-error

: ?restore-fth-file		\ -- ; set up either last file, or error file
  es> 2 mod-seg >es
  compiler-error e@
  if					\ if there was compiler error
    get-curr-file			\ get the current-name back from epcb
    where?				\ set page and line of error, file is same
  else					\ if no compiler error
    cs> file-temp curr-text$ file-temp c@ 1+ cmovel	\ move string back to slave
  endif
  redraw-bottom-bar			\ fix bottom bar to suit
  >es
;

extern compiler

: (compiler)		\ -- ; run compiler, and match source file names
  preserve-fth-file
  compiler				\ make call
  ?restore-fth-file
;

variable old-shell-mode

: >compiler-module	\ -- ; enter compiler module, and run compiler
  shell-mode @ old-shell-mode !  	\ preserve window
  2 shell-mode !			\ we are in compiler mode
  .top-bar				\ appropriate top bar
  redraw-bottom-bar			\ and bottom one
  api-handle to-window
\  op-handle @ set-op-handle		\ set handle for compiler messages: text loader
  (compiler)				\ make call
  /c @ 0=
  if
    cr red .press			\ tell user to press a key
    (key) drop				\ wait for user
    spare-keys				\ and tidy up keyboard buffer
    old-shell-mode @
    if   target-handle
    else host-handle
    endif
    @ op-handle !		  	\ restore window
  endif
  in-compiler off			\ internal compiler not active, compiler module turns it on
  mode-changed @
  if cls
  endif
  mode-changed off
;

\ -----End of Page-----
\ -- R.G.G -- 27/06/90 --  run-second

extern close-compiler

headerless

: run-second		\ -- ; run a second copy of compiler
  cls					\ pretend a new compiler
  close-compiler			\ close down last version of compiler
  3 del-mod# drop			\ delete old compiler
  2 del-mod# drop			\ delete old compiler
  $compiler 2 reload-mod# drop  	\ reload module
  $decompiler 3 reload-mod# drop
  cs> >es resolve-links			\ resolve links with compiler module
  2 mod-seg >es resolve-links
  3 mod-seg >es resolve-links
  2 shell-mode !			\ we are in compiler mode
  .top-bar				\ appropriate top bar
  (compiler)				\ make call again
;

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  (run-compiler)

: .no-compiler		\ -- ; say no compiler could be found
  error-tone					\ say so to user
  save-win
  create-error-window				\ create new window
  curr-handle to-window
  cr red ." Error "				\ say so
  dark ." Can't load (de)compiler: "		\ message
  $compiler count type				\ what it was
  cr red 15 spaces  .press	  		\ what to do
  (key) drop					\ wait for user
  spare-keys					\ rest of any keys left
  curr-handle from-window
  delete-curr-window				\ delete it
  rest-win
;

: set-nature		\ -- ; determine nature of compiler
  $compiler pad $move
  pad here 5 + here 5 + here 5 + here split-path	\ break compiler name up
  here count upper
  "" .XS3" here 3 s=		     			\ is compiler internal?
  if
    internal-compiler on	   		  	\ set flag to say so
  endif
;

: scan-\			\ addr -- addr' ; get add of backslash
  dup >r 1+		      	\ dummy address of `x' in Xnnnn.XS3
  r@ dup c@ +
  r> 1+ swap
  do				      	\ for last to first char...
    i c@ ascii \ =
    if drop i 1+ leave endif
  -1 +loop			      	\ -- addr of `x'/'d'
;

: make-decompiler-name		\ -- ; derive name of decompiler
  $compiler $decompiler $move		\ copy reference name
  $decompiler scan-\ 			\ get addr of char to change
  ascii D swap c!		      	\ fix with a `d' :: Dnnnn.XS3
;

: make-error-name		\ -- ; derive name of error file
\ ** for partial error file name - MF3.5
\  $decompiler scan-\			\ get addr of char to change
\  $decompiler c@ $decompiler + 1+	\ & -- addr of last char
\  over -				\ -- addr-d/e len-frag
\  dup here c!				\ set len at here
\  here 1+ swap cmove			\ move $ to here
\  ascii E here 1+ c!			\ make Exxx.XS3
\  here err-file$ $move			\ set name of error file
\ ** for complete error file name MF3.602
  $compiler err-file$ $move		\ copy reference name
  err-file$ scan-\			\ get addr of char to change
  ascii E swap c!		      	\ fix with a `e' :: Ennnn.XS3
;

headers

defer [bye-bye]

headerless

: run-internal		\ -- ; run an internal compiler
  make-decompiler-name			\ generate name of decomp mod.
  make-error-name			\ make name of error file
  2 del-mod# drop			\ remove last version of compiler
  3 del-mod# drop			\ remove last version of decompiler
  $compiler 2 reload-mod# 0= 	   	\ try to load module
  $decompiler 3 reload-mod# 0= and
  if 
    cs> >es resolve-links		\ resolve links with compiler module
    2 mod-seg >es resolve-links
    3 mod-seg >es resolve-links
    >compiler-module			\ run compiler module, if ok
    /c @
    if
      dark
      [bye-bye]
    endif
  else
    .no-compiler			\ say we couldn't load module
  endif
  2 del-mod# drop			\ remove last version of compiler
  3 del-mod# drop			\ remove last version of decompiler
;

: run-external		\ -- ; run an external compiler
  $compiler $>pad	      		\ command starts with compiler name
  space$ pad $+	      			\ add a separating space
  $comp-comm 1+ c@ ascii - <>		\ if command string set up....
  if 
    $comp-comm pad $+	      		\ end with compiler command
  endif
  screen-pcb handle close-path drop	\ close screen file         
  -1 screen-pcb !	      		\ set closed handle flag        
  to-compiler		      		\ pass into dos window
  2 shell-mode !			\ we are in compiler mode
  .top-bar			     	\ appropriate top bar
  api-handle to-window			\ go into new window, in case
  cs> pad $dos				\ execute compiler
  op-handle @ >r			\ preserve handle
  512 op-handle !  			\ set to dos handle
  getxy 				\ get the dos cursor position
  #rows @ 2- min			\ clip to the limits of the window
  r> op-handle !			\ back to this window
  gotoxy				\ move prompt to end of compiler display
  cr red .press				\ tell user to press a key
  dark
  (key) drop				\ wait for user
  spare-keys				\ and tidy up keyboard buffer
  from-compiler				\ and back
  screen-pcb open-path-pcb drop		\ try to re-open screen file    
;

headers

: (run-compiler)	\ -- ; run a compiler of some sort
  create-api-window		 	\ make window 
  api-handle to-window		 	\ go into new window
  set-nature			 	\ set appropriate flags
  internal-compiler @
  if
    run-internal		 	\ run an internal one
  else				 	\ if an external compiler
    from-api @			 	\ if external compiler already on
    if
      20 #help			 	\ appropriate help message
      .no-func			 	\ then say so
    else
      run-external		 	\ or run an external one
    endif
  endif
  delete-api-window		 	\ delete this window
;

headerless
                                                                
\ run-compiler   

decimal

: preserve-scr.file		\ -- ; save the name of the file on the go
  screen-pcb scr-buff 64 cmove		\ copy to here
;

: restore-scr.file		\ -- ; retore the name of the screen file on the go
  scr-buff screen-pcb 64 cmove 		\ copy back from here 
;

: run-first/external		\ -- ; run compiler first time round
  shell-mode @ 				\ preserve old-mode
  getxy
  $compiler 1+ c@ ascii - =  		\ is the command set up ?       
  if
    .not-set-up 			\ not set up: refer to ALT K
  else
    (run-compiler)			\ run compiler in some fashion
  endif
  gotoxy
  shell-mode !	   			\ restore previous mode
  .top-bar	   			\ new top bar
  redraw-bottom-bar			\ and lower one
;                                                            

headers

: run-compiler		\ -- ; run the compiler, somehow
  save-win
  preserve-scr.file			\ save screen file name
  del-fred				\ remove editor from memory
  in-compiler @				\ if internal compiler active
  if
    run-second				\ then re-run internal one
  else
    getxy				\ get location
    comp-xy ! comp-xy 2+ !		\ preserve
    run-first/external			\ run external, or first-time internal
    comp-xy 2+ @ comp-xy @		\ get last location
    gotoxy	
  endif
\  restore-scr.file			\ restore screen file name
  rest-win
  "" XS3-ERRS.XS3" err-file$ $move	\ name of errors file
;

behead

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  emulate-eprom

headerless                                                               

: setup-emu-prom	\ -- ; set up the emu on the fly
  01 #help
  error-tone				\ this was a bad move	
  op-handle @				\ preserve current window #
  create-emu-window
  curr-handle to-window
  red .Warn dark .no-comm                                       
  cr .Enter				\ prompt                              
  pick-option on
  $emu-prom ed-$ dup >r			\ edit command          
  if     $emu-prom here>$                                      
  endif
  curr-handle from-window
  delete-curr-window
  op-handle !				\ restore last window
  reset-attribs
  r> 					\ get status back
;                                                   

: do-emu		\ -- ; do the eprom emulator
  to-dos
  cs> $emu-prom $dos			\ use the emu
  from-dos
;

headers
                                                     
: emu-prom		\ -- ; run the emulator
  getxy			 		\ save screen pos
  $emu-prom 1+ c@ ascii - =		\ is the string set up ?        
  if
    setup-emu-prom			\ get the command
    if
      do-emu				\ doit it it was set up
    endif
  else					\ clear and goto top            
    do-emu				\ actually do it
  endif                                                         
  gotoxy	   			\ restore screen pos
; 

behead

\ -----End of Page-----
\ -- R.G.G -- 25/05/90 --  user 1 option

headerless

: setup-user#1		\ -- t/f ; get the user1 settings
  error-tone				\ this was a bad move	
  op-handle @				\ preserve current window #
  create-user1-window
  curr-handle to-window
  red .Warn dark .no-Comm                                       
  cr .Enter				\ prompt                               
  01 #help
  pick-option on
  $u1-comm ed-$	dup >r			\ edit command        
  if     $u1-comm here>$		\ set up command      
  endif                                                
  cr .Enter-menu			\ prompt              
  12 #help
  $u1-prompt ed-$-lower	dup >r		\ edit menu text      
  if      $u1-prompt here>$		\ set up text         
  endif                                                         
  curr-handle from-window
  delete-curr-window
  op-handle !		   		\ restore last window
  reset-attribs
  r> r> and				\ did we edit both
;                                                            

: do-user1		\ -- ; do the user1 option
  to-dos
  cs> $u1-comm $dos			\ run option        
  from-dos
;  

headers

: user#1		\ -- ; do user1 option
  getxy
  $u1-comm 1+ c@ ascii - =		\ is the command set up ?       
  if
    setup-user#1			\ set it up                     
    if
      do-user1				\ if the user did set it up
    endif
  else
    do-user1
  endif                                                         
  gotoxy
;                                                    

behead

\ -----End of Page-----
\ -- R.G.G -- 25/05/90 --  user 2 option

headerless

: setup-user#2          \ -- t/f ; set up this user option
  error-tone				\ this was a bad move	
  op-handle @				\ preserve current window #
  create-user2-window
  curr-handle to-window
  red .Warn dark .no-Comm                                       
  01 #help
  cr .Enter				\ prompt                               
  pick-option on
  $u2-comm ed-$	dup >r			\ edit command        
  if     $u2-comm here>$		\ set up command      
  endif                                                
  cr .Enter-menu	      		\ prompt              
  12 #help
  $u2-prompt ed-$-lower	 dup >r		\ edit menu text      
  if      $u2-prompt here>$   		\ set up text         
  endif                                                         
  curr-handle from-window
  delete-curr-window
  op-handle !		      		\ restore last window
  reset-attribs
  r> r> and				\ must mave set both
;                                                            

: do-user2		\ -- ; do the user2 option
  to-dos
  cs> $u2-comm $dos			\ run option        
  from-dos
;

headers

: user#2		\ -- ; do the user2 option
  getxy
  $u2-comm 1+ c@ ascii - =		\ is the command set up ?       
  if
    setup-user#2			\ set it up                     
    if
      do-user2				\ if the user did set it up
    endif
  else
    do-user2
  endif                                                         
  gotoxy
;

behead

\ -----End of Page-----
\ -- R.G.G -- 25/05/90 --  dump image option

headerless

: setup-dump		\ -- ; set up the dump option
  error-tone			\ this was a bad move	
  op-handle @			\ preserve current window #
  create-dump-window
  curr-handle to-window
  red .Warn dark .no-comm                                       
  cr .Enter			\ prompt                
  01 #help
  pick-option on
  $dump-comm ed-$ dup >r	\ edit command          
  if    $dump-comm here>$                                       
  endif                                                         
  curr-handle to-window
  delete-curr-window
  op-handle !			\ restore last window
  reset-attribs
  r>				\ get status of edit
;                                                               

: do-dump		\ -- ; do the dump option
  to-dos
  cs> $dump-comm $dos			\ either way, blow the prom  
  from-dos
;

headers
                                                                
: run-dump		\ -- ; maybe do the dump option
  getxy
  $dump-comm 1+ c@ ascii - =	\ is the command set up ?       
  if
    setup-dump			\ set it up                     
    if
      do-dump			\ now do it
    endif
  else
    do-dump			\ or just do it
  endif                                                         
  gotoxy
;                                                               

behead

\ -----End of Page-----
\ -- R.G.G -- 04/06/90 --  run-editor

decimal

: fix-pcb		\ pcb -- ; tidy up any spaces in file name
  p-name  62 bounds			\ for the chars of a pcb name
  do
    i c@ bl = 				\ if char is a space
    if 0 i c! endif			\ convert to nul
  loop
;  

headerless

: (run-external)	\ -- ; run another editor
  to-dos
  cls							\
  .top-bar
  cr							\ tidy up
  curr-edit$ cs> here curr-edit$ c@l 1+ cmovel		\ copy to this seg.
  here $>pad						\ start command
  edit-file @						\ only if file name wanted..
  if
    space$ pad $+					\ add a gap
    curr-text$ cs> here curr-text$ c@l 1+ cmovel 	\ copy to this seg.
    here text-name set-pathname				\ make as pcb
    text-name fix-pcb					\ clear out any extra spaces
    "" .FTH" text-name set-ext			  	\ set default ext
    text-name p-name asciiz>$				\ back to $addr
    pad $+						\ add file to edit
  endif
  cs> pad $dos		  			\ else just pass editor name
  from-dos
;

headers

: set-pick-attribs	\ -- ; set attribs of pick window
  window-attrib @ border-attrib @ header-attrib @
  help-body-attrib @ help-border-attrib @ dup dup pick-attribs
;

extern set-message$

headerless

: (run-ted)		\ -- ; run ted
  forth-buff $>pad				\ start with path to xshell
  "" TED.XS3" pad $+				\ add name of ted to it
  pad 4 reload-mod# 0=		 		\ try to load the module
  if
    es>
    4 mod-seg >es resolve-links			\ relink the editor
    cs> >es resolve-links
    >es
    page-no @ line-no @ col-no @ curr-text$	\ required params
    edit-file @	0=				\ if we dont want a file
    if 2drop 0 0 endif				\ specify dummy params for ted
    cs> "" XShell v3, " set-message$
    $ted
    drop					\ ignore status
    curr-text$ 2over c@l 1+ cmovel		\ copy new file name back
    col-no !  line-no !  page-no !		\ get the position in the file
    4 del-mod# drop				\ dump the module again
    set-pick-attribs
  else
    error-tone					\ beep if cant load editor
  endif
;

: (run-editor)		\ -- ; run the editor
  curr-edit$ cs> here 2over c@l 1+ cmovel
  here pad 5 + pad 5 + pad 5 + pad split-path	\ extract name of editor
  pad count upper
  "" .XS3" pad 3 s=			\ if ted required
  if
    (run-ted)				\ run the internal editor
  else
    (run-external)			\ else run an outside editor
  endif
;

: start-editor-window		\ -- ; open the window
  error-tone		  		\ this was a bad move	
  op-handle @				\ preserve current window #
  create-edit-window			\ make the window
  curr-handle to-window			\ use it
;

: end-editor-window		\ -- ; done with this box
  curr-handle from-window
  delete-curr-window
  op-handle !		    		\ restore last window
  reset-attribs
;

: setup-editor			\ -- t/f ; get the name of the editor
  start-editor-window
  red .Warn dark .no-comm                                       
  cr .Enter					\ prompt                
  01 #help
  curr-edit$ cs> pad curr-edit$ c@l 1+ cmovel	\ copy to this seg.
  pick-option on
  pad ed-$ dup >r									\ edit command          
  if
    cs> here curr-edit$ here c@ 1+ cmovel	\ copy to seg.	28
  endif                                                         
  end-editor-window
  r> 						\ was this a good edit
;

: get-filename		\ -- ; get the file to edit
  start-editor-window
  pick-option  on	      			\ we may use picklist
  02 #help
  cr ." Enter file to edit:  " 			\ prompt for filename
  curr-text$ cs> here curr-text$ c@l 1+ cmovel	\ copy to this seg.
  here text-name set-pathname		   	\ make dummy pcb
  text-name fix-pcb			   	\ clear out any extra spaces
  "" .FTH" text-name set-ext		   	\ fix extension
  text-name p-name asciiz>$  ed-$	   	\ edit counted string
  if 
    here text-name set-pathname			\ make dummy pcb again
    text-name fix-pcb				\ remove spaces from it
    text-name p-name asciiz>$			\ make into $ again
    >r cs> r@ curr-text$ r> c@ 1+ cmovel	\ copy to seg. 28
    end-editor-window
    (run-editor)				\ run the editor  
  else
    end-editor-window
  endif                                                         
;

: do-editor		\ -- ; maybe edit a file
  edit-file @			\ if we want to pass a filename
  if
    get-filename    		\ if needed, get a filename
  else
    (run-editor)		\ or just run the editor
  endif
;

headers

: run-editor		\ -- ; run some ascii editor or other
  del-fred				 	\ remove fred from memory
  getxy
  curr-edit$ cs> here curr-edit$ c@l 1+ cmovel	\ copy to this seg.
  here 1+ c@ ascii - =				\ is the command set up ?       
  if
    setup-editor				\ set it up
    if
      do-editor					\ do if set up
    endif
  else
    do-editor					\ just do anyway
  endif                                                         
  gotoxy
  redraw-bottom-bar				\ and refresh
;                                                               
behead

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  shell

"" {XShell v3}" dos-prompt$ $move		\ the new dos prompt

headerless

: (run-dos)		\ -- ; do dos command shell
  to-dos
  cls                                                            
  .top-bar
  cr cr
  $dos-func 1+ c@ bl =				\ if a shell required..
  if
    ." Type `EXIT' to return to " .prog		\ give a prompt for return
  endif
  cs> pad $dos					\ either way, run dos
  $dos-func 1+ c@ bl <>				\ if a command entered
  if
    red .press					\ prompt user to return to Xshell 3
    (key) drop					\ wait for user
    spare-keys					\ remove any extra keys				
  endif
  from-dos
;                                                               

: build-call		\ -- ; build a dos call command line
  root-buff $>pad			\ basis of command
  $dos-func c@ 0<>			\ if a command entered
  if
    ""  /c " pad $+			\ add `internal' flag to command
    $dos-func pad $+			\ add function to command
  endif
  (run-dos)				\ run dos function
;

headers

: run-dos		\ -- ; run dos shell or command
  save-win
  create-dosop-window				\ make dialogue box
  curr-handle to-window
  13 #help
  pick-option on
  cr ."  Press `Enter' for a command shell or type required DOS function:"	\ prompt
  cr space
  $dos-func ed-$	  			\ edit text string
  if
    $dos-func here>$				\ remake counted string
    build-call					\ make function call to do
  endif
  $dos-func off					\ reset function string
  curr-handle from-window
  delete-curr-window				\ delete it from list
  rest-win
  reset-attribs
  redraw-bottom-bar				\ and new bottom line
;                                                               

behead

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  ?close-file
                                                                
: ?close-file		\ -- ; close file if from xcomp
  from-api @				\ if from umbilical     
  if
    flush				\ flush any changes     
    screen-pcb handle close-path drop	\ close file in dos     
    -1 screen-pcb !			\ reset pcb              
  endif
;                                                               
                                                                
: ?open-file		\ -- ; open file if in umb
  from-api @	   			\ if called by compiler 
  if
    screen-pcb open-path-pcb drop     	\ try to open file      
  endif				      	\ else get new f. name  
;                                                               
 
\ -----End of Page-----
\ -- R.G.G -- 08/06/90 --  fred stuff

extern main-fred(xs3)			\ editor call

headerless

: (fred)		\ n -- ; call fred module
  >r				\ store scr#
  save-win
  create-fred-window		\ make new window
  fred-handle to-window
  r>				\ get scr#
  fred-loaded @
  if
    ?open-file
    main-fred(xs3)		\ call editor
    ?close-file
  endif
  scr !			    	\ reset screen number
  fred-handle from-window
  delete-fred-window		\ and remove it from list
  rest-win
  redraw-bottom-bar		\ and new bottom line
;

: get-file-name		\ -- t/f ; get the file to edit
  error-tone					\ this was a bad move	
  save-win
  create-file-window				\ make window
  curr-handle to-window
  red .Warn dark ."  No screen file open."
  cr ." Enter file name: "			\ prompt              
  02 #help
  pick-option on				\ enable pick-list
  screen-pcb ed-pcb			       	\ edit screen file    
  dup
  if cs> here $using	  		       	\ does it exist ?     
     cr ?make-scr			       	\ set up pcb          
  endif
  >r					       	\ preserve good/bad
  curr-handle from-window
  delete-curr-window			       	\ remove from list
  rest-win
  r>					       	\ restore flag
;

\ -----End of Page-----
\ -- R.G.G -- 11/07/90 --  fred edit

decimal

only forth also xs3 also config also forth definitions

headers

: fred			\ n -- ; fred word
  get-fred				\ reload editor
  set-fred				\ set configuration
  screen-pcb handle -1 =		\ if file is null
  if
    get-file-name			\ get a file to use
    if (fred) else drop endif	   	\ and run editor if file given
  else
    (fred)				\ else just run editor
  endif
  reset-attribs
  redraw-bottom-bar			\ and refresh
;

: edit			\ -- ; edit word
  scr @					\ use current scr#
  fred					\ and run editor
;

behead

only  forth also xs3 definitions

\ -----End of Page-----
\ -- R.G.G -- 06/06/90 --  list-files stuff

variable found-char

: -spaces		\ addr len -- addr' len' ; remove spaces from string
  found-char off		\ turn off char flag
  2dup				\ -- addr len addr len
  bounds
  swap 1+ swap 1+		\ -- addr len start end
  do				\ -- addr len
    i c@ bl <>		 	\ if not a space...
    if found-char on endif	\ .. then set flag
    i c@ bl = 			\ if a space
    if
      found-char @ 0=		\ if a leading space
      if
        1-		 	\ len-1
        dup i c!	 	\ len-1 in place of bl
        nip i swap	 	\ set new addr of string
      else		 	\ if a trailing space
        1-			\ decrement len
      endif
    endif
  loop
;

: list-files		\ -- ; list files in browse box
  save-win
  create-list-window
  curr-handle to-window
  ." Enter file spec.: "	     	\ prompt                
  07 #help
  $dir-spec ed-$			\ edit string           
  if
    here dup c@
    -spaces				\ tidy up user i/p
    dup 0>
    if
      2dup swap c!			\ reset count byte
      1+ $dir-spec swap cmove		\ copy to $dir-spec
      cs> $dir-spec 65 2 pick-window	\ use pick-list function
      drop 2drop			\ but dont care about results
    else
      2drop
    endif
  endif
  curr-handle from-window
  delete-curr-window
  rest-win
  reset-attribs
;                                 

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  info

headerless

: (.info)		\ -- ; show program details
  space .prog
  ."   Cross-Development Environment"
  cr
  cr ."  (c) " .year ."  MicroProcessor Engineering Ltd."       
  .latest									\ version# and date
  cr cr red .F10 dark                                     
;                                                               

headers

: .info			\ -- ; shoe program details
  save-win
  create-info-window
  curr-handle to-window
  04 #help
  (.info)		       		\ show blurb                    
  cursor-off spare-keys                                         
  begin stop-key until	       		\ wait for user, including help
  spare-keys                                                    
  cursor-on		       		\ back to old screen            
  curr-handle from-window
  delete-curr-window
  rest-win
;                                                               

behead

\ -----End of Page-----
\ -- R.G.G -- 10/10/90 --  PgUp code

headerless

variable up-load

: exit?			\ -- t/f ; quit from time-out ?
  1 3 gotoxy
  ." Target compiler has timed out. Continue? (y/n) "
  y/n?			   		\ get response
  if			   		\ if continue
    drop 50000		   		\ replace count
    0			   		\ return 0
  else			   		\ if abort
    -1			   		\ return -1
  endif
  1 3 gotoxy 50 spaces	   		\ clear prompt
  1 2 gotoxy
;

: absorb		\ -- ; ignore o/p from target
  begin
    ser-key?				\ if serial data          
   while
    ser-key output>log drop
  repeat				\ get, log and ignore     
;

: wait-target			\ -- t/f ; synch with romforth target
  -1						\ default true for continue
  romforth-flag @				\ if a romforth target
  if
    50000	      				\ start of time-out count
    begin
      1- dup 0=           			\ decrement till count=0
      if
        exit?	      				\ prompt user for action
        if	      				\ if to abort...
          2drop 0 exit 	 			\ tidy up and exit
        endif
      endif
      0 ser-key? 	   	 		\ dummy char and test serial
      if
        drop ser-key		 		\ if a char, replace dummy
      endif
      17 =	      				\ until an XON recieved
    until
    drop	      				\ drop time-out count
  endif
;

variable last-term			\ -- addr ; the previous terminator used

hex

: transmit-line		\ -- t/f ; send this line to target
  1 up-load +!    				\ increment counter
  1 2 gotoxy ." Line " up-load ?		\ redisplay
  #tib @ 0					\ string at tib for #tib cha    
  ?do
    tib i + c@					\ get char from tib             
    ser-emit					\ send it                       
  loop                                                          
  016 0100 ioctl drop				\ get line terminator
  0ff and					\ mask to first byte of same
  dup 0a <> over 0d <> and			\ if neither 0a or 0d
  if
    drop last-term @ ser-emit			\ send previous if this is no good
  else
    dup ser-emit				\ semd this terminator
    last-term !					\ and preserve for last record
  endif
\  0d ser-emit		\ ****			\ temporary CR char
  wait-target					\ maybe synch with target interpreter
;

decimal

: perform-upload	\ -- ; get stuff from file (file name at here)
  1 -1 cs> here					\ name of file
  op-handle @ >r
  "" NUL" $>asciiz open-path drop op-handle !
  get-stream next-file				\ open next file
  r> op-handle !
  if 
    exit					\ quit if cant open (shouldnt happen, trapped by caller)
  endif
  -1						\ dummy success flag
  begin
    next-line and				\ read line
  while
    transmit-line				\ send the line of text
  repeat
  prev-file drop				\ previous file
;

: (ascii-upload)	\ -- ; do an upload to target    
  here text-name set-pathname			\ reset file name
  text-name fix-pcb		   		\ clear out any gunk
  "" .FTH" text-name set-ext	   		\ set default extension
  text-name p-name here 62 move			\ copy name back to here
  here asciiz>$	drop				\ make counted string again
  text-name open-path-pcb 0=	   		\ if file exists
  if
     text-name handle close-path drop		\ close it again ready to load
     up-load off		   		\ reset line counter
     perform-upload		   		\ go do it
  else                                                          
    cr ."  Can't open file"	   		\ say error
    cr red .Press dark (key) drop  		\ tidy up
  endif                                                         
;

: say-which			\ -- ; say whether romforth or other target
  romforth-flag @				\ which is set
  if
    13 emit ."  ROM PowerForth - XON/OFF On           "
  else
    13 emit ."  Other - XON/XOFF Off                  "
  endif
;

: ?romforth		\ -- t/f ; true indicates to continue
  begin
    (key) upc						\ get the first key
    case
      27      of 0 exit endof				\ abort and false on escape
      ascii Y of romforth-flag on  -1 exit endof	\ set romforth and true
      ascii N of romforth-flag off -1 exit endof	\ set not-romforth
      0       of (key)
                 case
                   59 of more-help  endof		\ f1 for help
                   68 of 0 exit	    endof		\ f10 to quit
                 endcase
              endof
    endcase
  again
;

headers

: ascii-upload		\ -- ; upload code to target
  shell-mode @ 1 =				\ only in target mode
  if
    save-win					\ preserve old screen        
    create-upload-window			\ make new window
    curr-handle to-window			\ go into it
    32 #help					\ new help text
    ."  Is this a ROM PowerForth target? (Y/N)"	\ do we use handshake or not?
    ?romforth					\ set the type of target
    if
      say-which
      27 #help					\ new help message
      cr ."  File to upload to target: "    	\ user prompt                        
      curr-text$ cs> here curr-text$ c@l 1+ cmovel	\ copy to this seg.
      here text-name set-pathname	   	\ make dummy pcb
      "" .FTH" text-name set-ext	   	\ fix extension
      pick-option on
      text-name 2+ asciiz>$  ed-$	   	\ edit counted string
      if                         	        \ do upload             
        (ascii-upload)                                           
      endif                                                      
    endif
    curr-handle from-window			\ back out of new window
    delete-curr-window				\ delete new window		
    rest-win					\ back to old one
    reset-attribs
  else
    no-act					\ else beep to say no function
  endif
;

behead

\ -----End of Page-----
\ -- R.G.G -- 10/10/90 --  download

decimal

headerless

variable block#			\ block no so far

variable buff-seg		\ wherer the data is

variable in-pointer		\ where we have got to in buffer

512 constant buff-len		\ length of the buffer

: update-buffer		\ char -- ; store data in buffer, maybe write it
  buff-seg @ in-pointer @ c!l			\ store data in next location
  1 in-pointer +!				\ increment input pointer
  in-pointer @ buff-len = 			\ if at end of buffer
  if
    buff-seg @ 0 buff-len			\ long address and length
    text-name handle (write-path)		\ handle to write
    2drop					\ ignore dos errors for now
    in-pointer off				\ reset pointer into buffer
    1 block# +!
    1 3 gotoxy ." Block: " block# ?		\ say what so far
  endif
;

: write-last		\ -- ; write the last bit
  buff-seg @ 0 in-pointer @		\ address and length of whats left
  text-name handle (write-path)		\ handle to write
  2drop					\ ignore dos errors for now
;

: timeout		\ -- t/f ; true:timeout, false:more chars
  50000	 				\ starting timeout period
  begin
    1-	 				\ decrement
    dup 0=	       			\ test for zero
    if drop -1 exit endif		\ quit with true if timeout
    ser-key?		 		\ is there another char?
  until
  drop 0		 		\ tidy, and return 0
;

: log-chars		\ -- ; log characters coming up line
  block# off
  1 3 gotoxy ." Block: 0"
  begin
    (key?)			      		\ has user intervened?
    if
      (key) dup 27 =				\ if so, is it <Esc>
      if
        drop exit		      		\ if esc, then abort
      else
        ser-emit		      		\ otherwise transmit it
      endif			      		\ if so, then abort
    endif
    begin
      ser-key?			 		\ has the target sent anything
    while
      ser-key			      		\ if so, get it
      update-buffer				\ and buffer it
    repeat
    timeout			      		\ wait some 
  until
;

: make-buffer		\ -- t/f ; create the buffer for the download
  in-pointer off
  65 alloc-mem				\ grab 1k
  ?dup
  if
    drop 0				\ replace fail code with 0
  else
    buff-seg !				\ set buffer address
    -1					\ return true
  endif
;

: (do-download)		\ -- ; actually do the download
  make-buffer
  if
    text-name create-path-pcb 0=			\ create file
    if
      cr ."  Press <Esc> to stop, any other key is transmitted" 	\ prompt to start target
      (key)								\ read keyboard
      dup 27 =						\ if escape...
      if drop exit endif				\ then get out
      ser-emit						\ send key
      cr
      log-chars	  					\ log what the target sends
   endif
  endif
;

: finish-load		\ -- ; finish the download
  write-last				\ write the bits left over
  text-name close-path-pcb drop		\ and close the file
  buff-seg free-mem drop		\ free off buffer memory	
  13 ser-emit				\ send last CR to target
;

: do-download		\ -- ; try to do the download
  text-name open-path-pcb 0=			\ try to open it
  text-name close-path-pcb 0=			\ then try to close it
  and						\ if can do both...
  if
    error-tone
    cr ."  File already exists: overwrite? (y/n)" \ then so
    spare-keys
    assign (key?) to-do key?			\ 
    assign (key) to-do key			\ assign old key handler
    y/n?
    assign (alt-key?) to-do key?		\ 
    assign (alt-key) to-do key			\ assign new key handler
	0=									\ y:overwrite it
    if exit endif				\ n: abort
  endif
  (do-download)					\ go do it
  finish-load					\ clean up pc system
;

: (download)		\ -- ; get name and do download
  "" DOWNLOAD.LOG" text-name set-pathname	\ default filename
  ."  Filename to download from target: "	\ prompt for filename
  pick-option on
  text-name ed-pcb				\ get users name
  if
    here text-name set-pathname			\ set new filename
    do-download					\ and do it
  endif
;

headers

: download		\ -- ; do a download
  shell-mode @ 1 =			\ only in target mode
  if
    save-win				\ preserve old screen        
    create-download-window		\ make new window
    curr-handle to-window   		\ go into it
    28 #help				\ new help message
    (download)				\ go do it
    curr-handle from-window		\ back out of new window
    delete-curr-window			\ delete new window		
    rest-win				\ back to old one
    reset-attribs
  else
    no-act				\ else beep to say no function
  endif
;

\ -----End of Page-----
\ -- R.G.G -- 05/06/90 --  serial options window

headerless

decimal                                                                

: #data			\ n -- ; 
  5 ser-2drop			\ set no of data bits
;
                                                                
: #stop			\ n -- ;
  9 ser-2drop			\ set no of stop bits
;
                                                                
: par			\ n -- ;
  7 ser-2drop			\ set parity type
;

: hs			\ n -- ;
  3 ser-2drop			\ set hs type
;

: baud			\ n -- ;
  1 ser-2drop			\ set baud rate
;

: port 			\ n -- ;
  11 ser-2drop			\ set port number
  int/ext off			\ not using external comms channel
;

: set-external		\ -- ; specify external comms channel
  int/ext on			\ we are using external
;
                                                                
: clear-settings	\ -- ; clear the settings display
  0 0 gotoxy 62 spaces                                          
  0 1 gotoxy 62 spaces                                          
;                                                               
                                                                
: .parity		\ -- ; show current parity
  6 ser-drop				\ get parity type
  case   0 of ."  No"   endof                                   
         1 of ."  Odd"  endof                                   
         2 of ."  Even" endof                                   
  endcase                                                       
  ."  Parity, "                                                 
;                                                               
                                                             
: .stop			\ -- ; show current stop bits
  8 ser-drop dup			\ get no of stop bits
  1 .r ."  Stop bit"                                            
  2 = if ." s" endif
;                            

: .data			\ -- ; show current data bits
  4 ser-drop				\ get no of data bits
  1 .r ."  Data bits, "
;                                      

: .baud			\ -- ; show current rate
  0 ser-drop				\ get baud rate
  space u. ."  Baud, "		    	\ show baud rate
;

: .port			\ -- ; show current port number
  10 ser-drop				\ get port number
  ."  Port " 1 .r ." , "
;

: .hs			\ -- ; show current h/s mode
  ." Handshaking: "
  2 ser-drop				\ get shake type
  case
    1 of ." RTS/CTS" endof		\                      
    2 of ." DTR/DSR" endof		\                      
    3 of ." NONE" endof    		\                      
    4 of ." XON/XOFF" endof		\ show handshaking    
  endcase                                                       
;

: .format		\ -- ; show whether server or not
  dumb/files @
  if    ." , File server"
  else  ." , Dumb terminal"
  endif
;
                                                                
: .settings		\ -- ; show current settings
  base @ >r decimal		\ correct base
  clear-settings		\ redraw space
  0 0 gotoxy
  int/ext @			\ if using external
  if
    ."  External Communications driver"
  else
    .baud	     		\ show baud rate
    .parity
    .data 
    .stop
    cr
    .Port	     		\ show port number
    .hs				\ show handshake type
    .format
  endif
  r> base !			\ restore base        
;                                                            

: .options		\ -- ; list of options
  cr                                                          
  cr ."  (a)   38400 baud         (m)   No parity"            
  cr ."  (b)   19200              (n)   Even"                 
  cr ."  (c)    9600              (o)   Odd"                  
  cr ."  (d)    4800"                                         
  cr ."  (e)    2400              (p)   No handshaking"       
  cr ."  (f)    1200              (q)   RTS/CTS"              
  cr ."  (g)     300              (r)   DTR/DSR"              
  cr ."                           (s)   XON/XOFF"             
  cr ."  (h)   7 data bits"                                    
  cr ."  (i)   8                  (t)   Port 1" \      (x)  External"
  cr ."                           (u)   Port 2"
  cr ."  (j)   1 stop bit         (v)   Port 3"                             
  cr ."  (k)   2                  (w)   Port 4"    
  cr                                
  cr ."  (l)   Save configuration (y)   Terminal/Server"                
  cr
  cr ."  <F10> finish             Select option(s)"            
;                                                            

: get-options		\ -- ; get selections from user
  begin
    (key) upc                                             
    case
           00 of (key)
                 case
                   59 of more-help  endof
                   68 of exit endof
                      wrong-tone
                 endcase
              endof
      ascii A of 38400 baud endof   
      ascii B of 19200 baud endof  
      ascii C of 9600  baud endof
      ascii D of 4800 baud endof   
      ascii E of 2400  baud endof
      ascii F of 1200 baud endof   
      ascii G of  300  baud endof
      ascii H of 7 #data   endof   
      ascii I of 8 #data    endof
      ascii J of 1 #stop   endof   
      ascii K of 2 #stop    endof
      ascii L of write-cfg endof                        
      ascii M of 0 par endof   
      ascii N of 2 par endof
      ascii O of 1 par endof   
      ascii P of 3 hs  endof
      ascii Q of 1 hs  endof 
      ascii R of 2 hs  endof
      ascii S of 4 hs  endof
      ascii T of 1 port endof   
      ascii U of 2 port endof
      ascii V of 3 port endof
      ascii W of 4 port endof
\      ascii X of set-external  endof
      ascii Y of dumb/files dup @ not swap ! endof
           27 of exit  endof		      	\ quit on escape 
              wrong-tone	   		\ beep for wrong key
    endcase
    .settings
    42 19 gotoxy	  			\ best place for cursor
  again
;                

headers                                                                

: get-settings		\ -- ; get settings from user
  from-api @				\ not available inside api
  if
    curr-handle @
    22 #help
    .no-func
    curr-handle !
  else
    save-win
    create-set-window
    set-handle to-window
    ser-close				\ restore from last     
    09 #help
    .settings				\ show current          
    .options				\ show possibles        
    get-options				\ get them all          
    ser-open				\ open with new settings
    spare-keys
    redraw-bottom-bar			\ refresh the bottom of the screen
    set-handle from-window
    delete-set-window
    rest-win
  endif
;                                                               

behead 

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  bye-bye

headerless

: blank-bottom-line		\ -- ; erase the bottom line
  screen-handle @ op-handle !		\ back to default screen
  7 >attribs
  0 #rows @ gotoxy
  80 spaces
;

: confirm-key		\ -- t/f ; ask user yes or no
  0							\ dummy false
  begin
    (key) upc
    case
      ascii Y of drop -1 exit endof	\ quit flag
           00 of (key)
                 case
                    59 of 24 #help more-help endof
                       drop exit
                 endcase
              endof
              drop exit
    endcase
  again
;

: confirm		\ -- t/f ; true to quit
  save-win			 	\ preserve window
  create-quit-window			\ make new window
  curr-handle to-window			\ use new one
  cr
  ."     Quit " .prog	\ prompt
  cr
  cr ."      (Y)es    (N)o"		\ options
  cursor-off
  spare-keys			 	\ tdy up keyboard
  confirm-key			 	\ wait for user
  cursor-on
  spare-keys			 	\ and again
  >r					\ preserve flag
  curr-handle from-window		\ close new window
  delete-curr-window			\ delete new one
  rest-win				\ back to old one
  r>					\ restore flag
;

headers

: (bye-bye)		\ -- ;
  #rows @ 24 <>			\ if in 43 line mode...         
  if 25-line endif	 	\ then reset before quit        
  close-log		 	\ close log file if nec.        
  end			 	\ close down windows, if alt-C used
  /c @ 0= 			\ if no command line
  if
    cls	  			\ clear screen
  else				\ if run from command line
    blank-bottom-line		\ clear for dos
  endif
  flush				\ write changed blocks          
  cursor-on
  0 cooked  1 cooked		\ restore i/o                   
  f#04c				\ bye-bye function
;

assign (bye-bye) to-do [bye-bye]

: bye-bye		\ -- ; quit xshell3
  from-api @ 0=		  	\ if normal running...
  if
    loud @ 2 and 0=
    if
      confirm		  	\ do we really mean this?
    else
      -1
    endif
    if
      (bye-bye)		  	\ actually quit
    endif
  else
    19 #help		  	\ this help message
    .no-func		  	\ cant quit from api
  endif
;                                                               

behead

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  f1 help screen

headerless

: count-type		\ $addr -- ; print a message
  getxy				\ where are we                  
  23 spaces			\ blank rest of line            
  gotoxy			\ go back there                 
  count type			\ show command        
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  fn#>letter

: fn#>letter		\ fn# -- ascii                          
  letter-table + c@		\ get ascii code for fn#        
;                                                               
                                                                
\ NB. Expects ascii value in UPPER CASE                         

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  letter>help-string
                                                                
: letter>help-string	\ ascii -- ; print related message
  case                                                          
       ascii G of ." Generate Hex File      " endof
       ascii R of ." Real time clock        " endof                         
       ascii E of ." Emulate EPROM          " endof             
       ascii F of ." Forth Screen editor    " endof             
       ascii K of ." Keyboard configuration " endof             
       ascii L of ." List files             " endof             
       ascii P of ." Serial line settings   " endof             
       ascii Q of ." Quit                   " endof             
       ascii O of ." Output log             " endof             
       ascii Y of $u1-prompt count-type       endof             
       ascii Z of $u2-prompt count-type       endof             
       ascii T of ." Toggle modes           " endof             
       ascii D of ." DOS Functions          " endof             
       ascii C of ." Cross Compiler         " endof             
       ascii B of ." Blow EPROM             " endof             
       ascii A of ." Edit ASCII file        " endof             
       ascii I of ." Program Information    " endof             
       ascii V of ." View Image             " endof             
       ascii U of ." ASCII Values           " endof             
             0 of ." -                      " endof             
  endcase                                                       
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  menu messages 

: ."a			\ -- ; 
  ."  A    Edit ASCII file" cr 
;

: ."b			\ -- ; 
  ."  B    Blow EPROM" cr 
;                              

: ."c			\ -- ; 
  ."  C    Cross Compiler" cr 
;                          

: ."d			\ -- ; 
  ."  D    DOS Functions" cr 
;                               

: ."e			\ -- ; 
  ."  E    Emulate EPROM" cr 
;                           

: ."f			\ -- ; 
  ."  F    Forth Screen editor" cr 
;                     

: ."g			\ -- ; 
  ."  G    Generate Hex File" cr 
;

: ."i			\ -- ; 
  ."  I    Program Information" cr 
;                     

: ."k			\ -- ; 
  ."  K    Keyboard configuration" cr 
;                  

: ."l			\ -- ; 
  ."  L    List files" cr 
;                              

: ."m			\ -- ; 
  ."  M    Monitor mode" cr 
;                            

: ."o			\ -- ; 
  ."  O    Output log" cr 
;                              

: ."p			\ -- ; 
  ."  P    Serial line settings" cr 
;                    

: ."q			\ -- ; 
  ."  Q    Quit" cr 
;                                    

: ."r			\ -- ; 
  ."  R    Real time clock" cr 
;                         

: ."t			\ -- ; 
  ."  T    Toggle modes" cr 
;                            

: ."u			\ -- ; 
  ."  U    ASCII values" cr 
;                            

: ."v			\ -- ; 
  ."  V    View image" cr 
;                              

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  .help-alt

: .f1-help		\ x y -- ; print help message
  gotoxy ." F1    Help"		\ first one is fixed     
;                                                               

: .function-keys	\ x y -- ; function keys title
  gotoxy yellow ." Function Keys" dark                          
;                                                               

: .alt			\ x y -- ; alt keys title
  gotoxy yellow ." ALT Key functions" dark cr             
;                                                               
                                                                
: .help-alt		\ -- ; print all help text
  1 0 .ALT                                                      
  ."a  ."b  ."c  ."d  ."e  ."f                                  
  ."g  ."i  ."k  ."l  ."m  ."o  ."p                                  
  ."q  ."r  ."t  ."u  ."v                                  
  ."  Y    " $u1-prompt count-type cr                         
  ."  Z    " $u2-prompt count-type                              
  35 16 gotoxy yellow ." Further help:"
  35 17 gotoxy red ." F1    keyboard help"
  35 18 gotoxy     ." F2    screen help"
  35 19 gotoxy     ." F3    Forth help  (ALT-H)"
  35 20 gotoxy     ." F10   Finish"
  dark
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  .help-fn
                                                                
: .help-fn		\ -- ; print function key messages
  base @ >r decimal	       		\ preserve base         
  35 0 .Function-Keys                                           
  35 1 .F1-Help		       		\ first one is fixed     
  13 2			       		\ for other 11 keys      
  do                                                            
     35 0 i + gotoxy			\ goto right place       
     ." F" i 1 .r			\ show key number        
     i fn#>letter			\ get letter             
     41 0 i + gotoxy			\ line up for text       
     letter>help-string			\ show help string       
  loop                                                          
  r> base !				\ restore base           
  shell-mode @ 1 =
  if
    35 13 gotoxy ." PgUp  Upload to target"
    35 14 gotoxy ." PgDn  Download from target"
  endif
;                                                            

\ -----End of Page-----
\ -- R.G.G -- 24/1/91 -- .help 

headers

defer show-glos

headerless

: help-key		\ -- t/f ; get keys inside help window
  0			  				\ dummy quit flag		
  (key?)		  				\ if a key press
  if (key)		  				\ get first key
     case
       00 of (key)	  				\ if 00, get the second
             case   68 of drop -1 endof			\ set quit flag
                    59 of 00 #help more-help endof	\ do help
                    60 of 18 #help more-help endof
                    61 of show-glos endof
                          wrong-tone			\ wrong key
             endcase
          endof
       27 of drop -1 endof
             wrong-tone					\ wrong key
     endcase
  endif
;

headers                                                       

: .help			\ -- ; show first level help
  save-win
  create-help-window
  curr-handle to-window
  .help-fn			 	\ list fn keys          
  .help-alt			 	\ list ALT keys         
  dark cursor-off spare-keys                                    
  begin help-key until  	 	\ wait for user, incl. help
  spare-keys                                                    
  cursor-on			 	\ back to old screen    
  curr-handle from-window
  delete-curr-window
  rest-win
  reset-attribs
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  fn key configuration window

headerless

: .help-alt-config		\ -- ; show the messages
  1 0 .ALT                                                      
  ."a  ."b  ."c  ."d  ."e  ."f                                  
  ."g  ."i  ."l  ."m  ."o  ."p                                  
  ."q  ."r  ."t  ."u  ."v                                  
  ."  Y    " $u1-prompt count-type cr                         
  ."  Z    " $u2-prompt count-type                              
;                                                               
 
: .help-fn-config	\ -- ; show messages for configuration window
   base @ >r decimal		\ preserve base        
   38 0 .Function-Keys                                          
   38 1 .F1-Help		\ first one is fixed    
   13 2				\ for other 11 keys     
   do 38 0 i + gotoxy		\ goto right place      
      ." F" i 1 .r 4 spaces	\ show key number       
      i fn#>letter		\ get letter            
      44 0 i + gotoxy		\ line up for text      
      letter>help-string	\ show help string      
   loop                                                         
   38 14 gotoxy ." <Esc> finish"	\ how to stop           
   r> base !			\ restore base          
;                                                            

hex

: invert-attribs	\ -- ; use inverted attribs
  window-attrib @			\ get current colour
  dup 0000f and 010 *			\ mask lsn and shift to msn
  swap 000f0 and 010 /			\ mask msn and shift to lsn
  or					\ or them to make whole byte
  >attribs				\ and set attribs
;

decimal

: highlight-fn#		\ fn#(A-K) -- ; highlight the current function
  ascii ? -				\ back to 2-12                  
  dup >r				\ fn#                           
  38 swap gotoxy			\ to right place on screen      
  invert-attribs
  ." F" r@ 1 .r 4 spaces		\ show key number & pad out     
  r@ fn#>letter				\ get alt action letter         
  44 r@ gotoxy				\ line up for text              
  letter>help-string			\ show help string              
  dark					\ normal attribs                
  r> drop				\ tidy up                       
;                                                               
 
: letter>letter-table	\ alt -- alt ; store
  dup	       			\ keep a copy
  dup ascii - =			\ was it a backspace
  if 2drop 0 0 endif	 	\ if so, replace BS with '0'
  curr-fn# @		 	\ get fn# to configure
  letter-table +	 	\ offset into letter-table
  c!			 	\ store alt action
;                                                               

: reset			\ -- ; exchange flags           
  drop -1 
;

: valid-alt-action?	\ alt -- t/f ; test if valid
  0 swap			\ dummy flag                    
  case                                                          
    ascii R of reset endof   ascii M of reset endof             
    ascii T of reset endof   ascii O of reset endof 
    ascii P of reset endof   ascii G of reset endof          
    ascii B of reset endof   ascii A of reset endof             
    ascii E of reset endof   ascii C of reset endof             
    ascii F of reset endof   ascii D of reset endof            
    ascii Q of reset endof   ascii V of reset endof             
    ascii L of reset endof   ascii I of reset endof            
    ascii U of reset endof   ascii Y of reset endof             
    ascii Z of reset endof   ascii - of reset endof             
  endcase 
;

\ -----End of Page-----
\ -- R.G.G -- 25/05/90 --  letter>cfa

: letter>cfa		\ alt -- cfa ; get cfa of word associated with letter
  case                                                          
       ascii G of ['] bin2hex		endof
       ascii T of ['] mode-toggle     	endof                         
       ascii P of ['] get-settings	endof                        
       ascii B of ['] blow-prom		endof                         
       ascii E of ['] emu-prom		endof                           
       ascii O of ['] logger	      	endof                           
       ascii Y of ['] user#1	      	endof                           
       ascii Z of ['] user#2	      	endof                           
       ascii R of ['] time-window     	endof                       
       ascii M of ['] 25/43-mode      	endof                          
       ascii F of ['] edit	      	endof                           
       ascii A of ['] run-editor      	endof                          
       ascii C of ['] run-compiler	endof                        
       ascii D of ['] run-dos		endof                             
       ascii Q of ['] bye-bye		endof                            
       ascii L of ['] list-files      	endof                          
       ascii I of ['] .info	      	endof                           
       ascii V of ['] run-dump		endof                           
       ascii U of ['] ascii-table     	endof                         
             0 of ['] no-act	      	endof                    
  endcase                                                       
;                                                               

decimal

headers 

: (letter>action-table)		\ alt -- ; set up table
  letter>cfa				\ get cfa of required word      
  curr-fn# @				\ get fn# to set up             
  dup 11 12 within?                                             
  if					\ if it's 11 or 12              
    11 -				\ take 11 off fn#               
    133 + to-alt			\ set up in table               
  else                                                          
    2 -					\ 2 off fn#                     
    60 + to-alt				\ set up in table               
  endif                                                         
;                                                               

assign (letter>action-table) to-do letter>action-table

headerless

: get-alt-letter	\ -- ; get a key to configure to
  38 17 gotoxy ." Select Alt key to be "                        
  38 18 gotoxy ." action, or `-' to delete "
  begin                                                         
    spare-keys (key) upc		\ get upc key                   
    dup valid-alt-action?		\ is it valid ?                 
    if letter>letter-table		\ store in letter table         
       letter>action-table		\ get cfa of action             
       .help-fn-config			\ redraw right bit              
       exit				\ don't look for another one    
    else  27 =
      if  .help-fn-config exit		\ <ESC> to get back   
      else wrong-tone endif		\ bad action                   
    endif                                                       
  again  
;

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  set-fn#
                                                                
: set-fn#		\ (A-K) -- ; convert fn key to letter
  ascii ? -			\ back to 2-12                  
  curr-fn# !			\ save off                      
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  (fn-key)
                                                                
: (fn-key)		\ -- char ; get a function key to configure
  (key)						\ get a key             
  dup 0=					\ if 0                  
  if   drop					\ drop spare copy
       (key)					\ get another           
       case
                         59 of 16 #help more-help 0 endof	\ help key
         dup 60 68 within? ?of 60 - ascii A +	    endof	\ f2-f10
                         133 of      ascii J	    endof	\ f11
                         134 of      ascii K	    endof	\ f12
                            wrong-tone
       end-case
  endif                                                         
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  get-letters

: get-letters		\ -- ; configure function keys
  begin                                                         
    38 17 gotoxy ." Select Function key "                       
    38 18 gotoxy ." to configure (F2-12):     "                    
    spare-keys (fn-key) upc		\ get upc key                   
    dup ascii A ascii K within? 	\ valid ?                       
    if					\ if it is a fn#                
      dup highlight-fn#			\ highlight it                  
      set-fn#				\ set up the current fn#        
      get-alt-letter			\ get new letter                
    else				\ otherwise                     
      case
        27 of exit endof 		\ exit on ecape
        00 of      endof		\ nothing for null return of help
           wrong-tone			\ otherwise error note
      endcase
    endif                                                       
  again					\ round again                   
;                                                            

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  do-config-fn

headers                                                                

: do-config-fn		\ -- ; option to configure function keys
  save-win
  create-configa-window
  configa-handle to-window
  .help-alt-config			\ list ALT keys         
  .help-fn-config			\ list fn keys          
  get-letters				\ get the configs       
  spare-keys				\ any extra
  configa-handle from-window
  delete-configa-window
  rest-win
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 25/05/90 --  command configuration window

headerless

: .modes		\ -- ; show modes
  modes @ dup			\ get requirements
  01 and	    		\ test bit 0
  if   ." 43"			\ set: default is 43 line mode
  else ." 25"			\ not: default is 25 line mode
  endif
  ."  line      DOS: "		\ end of message, start of next
  02 and			\ test bit 1
  if   ." Full screen"		\ set: dos in whole screen
  else ." Window     " 		\ not: dos in window
  endif
;

: .loud		\ -- ; show flag states
  loud @ dup 			\ get requirements
  01 and     			\ test bit 0
  if   ." Quiet"      		\ set: no speaker
  else ." Loud "      		\ not: default is beeps and whistles
  endif
  ."         "			\ end of message, start of next
  02 and			\ test bit 1
  if   ." Terse  "		\ set: no messages
  else ." Verbose"	 	\ not: default is `quit yes/no'
  endif
;

: .edit-file		\ -- ; whether to pass name or not
  edit-file @
  if    ." Yes"
  else  ." No "
  endif
;

: .command-strings	\ -- ; show current commands
  0 0 gotoxy space "" Set up Commands" count type
  cr cr ."  (a)  Edit ASCII file:  "
  curr-edit$ cs> here curr-edit$ c@l 1+ cmovel
  here count-type  
  cr    ."  (b)  Pass filename?    " .edit-file
  cr    ."  (c)  Blow EPROM:       " $blow-prom count-type        
  cr    ."  (d)  Compiler name:    " $compiler count-type
  cr    ."  (e)  Compiler command: " $comp-comm count-type
  cr    ."  (f)  Emulate EPROM:    " $emu-prom count-type         
  cr    ."  (g)  View Image:       " $dump-comm count-type        
  cr    ."  (h)  User 1 prompt:    " $u1-prompt count-type        
  cr    ."  (i)  User 1 command:   " $u1-comm   count-type        
  cr    ."  (j)  User 2 prompt:    " $u2-prompt count-type        
  cr    ."  (k)  User 2 command:   " $u2-comm   count-type        
  cr    ."  (l)  Quiet/Verbose:    " .loud
  50 screen-drop
  dup 4 5 within? swap 7 8 within? or
  if
     cr ."  (m)  Screen modes:     "  .modes
  else
        cr
  endif
  cr cr ."  <F10> finish"                                   
  cr cr ."  Select command to set up (a-j): "          
;                                                            

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  set-string
                                                                
: set-string		\ addr t/f -- ; 
  if
     here swap $move			\ move to original address
  else
     drop				\ ignore if bad edit
  endif
;

: fix			\ -- ; reduce length of compiler name by one
  -1 $compiler c+!			\ decrement count by one
;

: set-string-comp	\ addr t/f -- ; set new compiler string
  if
     here swap $move
     fix
  else
     drop
  endif
;                                                                

: ed-set		\ addr - ; set new entry
  dup ed-$  set-string			\ edit $ and reset it   
;                                                               

: ed-set-comp		\ addr - ; set new compiler name 
  dup ed-$  set-string-comp            \ edit $ and reset it   
;

: toggle-edit-file	\ -- ; flip state of edit-file flag
  edit-file @
  if    edit-file  off
  else  edit-file  on
  endif
;

: toggle-scrn-modes	\ -- ; toggle screen mode flag
  modes @  1+ 				\ increment
  4 mod       				\ set range 0-3
  modes !
;

: toggle-loud-modes	\ -- ; toggle loud/lines modes flag
  loud @  1+	     			\ increment
  4 mod					\ set range 0-3
  loud !
;

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  edit-string

: edit-string		\ (A-K) -- ; edit the string associated
  ascii @ -			\ convert to 1-9 (subtract '@') 
  dup 1+ 24 swap gotoxy		\ goto right line               
  case                                                          
    1 of 33 #help
         curr-edit$ cs> pad curr-edit$ c@l 1+ cmovel 
         pick-option on pad ed-$
         if   cs> here curr-edit$ here c@ 1+ cmovel
         endif
      endof
    2 of         toggle-edit-file							endof
    3 of 01 #help $blow-prom  pick-option on	ed-set		endof
    4 of 14 #help $compiler   pick-option on  	ed-set		endof
    5 of 15 #help $comp-comm		     	ed-set		endof
    6 of 01 #help $emu-prom   pick-option on	ed-set		endof
    7 of 01 #help $dump-comm  pick-option on  	ed-set		endof
    8 of 12 #help $u1-prompt  dup ed-$-lower   set-string	endof
    9 of 01 #help $u1-comm    pick-option on	ed-set		endof
   10 of 12 #help $u2-prompt  dup ed-$-lower   set-string	endof
   11 of 01 #help $u2-comm    pick-option on	ed-set		endof
   12 of	  toggle-loud-modes		endof
   13 of          toggle-scrn-modes		endof
  endcase
  06 #help
;                                                  

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  get-command-letter

decimal
                                                                
: get-command-letter           \ -- ;                          
  begin                                                        
    spare-keys                        \ absorb spare keys     
    (key) upc                         \ get letter to setup   
    case
      dup ascii A ascii M within?
         ?of edit-string .command-strings endof
      27  of exit  endof
      00  of  (key)
            case   59 of more-help endof		\ help
                   68 of exit endof
                     wrong-tone				\ wrong key
            endcase
          endof
          wrong-tone				\ wrong key
    endcase
  again                 	               \ round again           
;

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  do-config-comm$

headers

: do-config-comm$	\ -- ; do configuration window
  save-win
  create-configb-window
  configb-handle to-window
  06 #help
  .command-strings                      \ show all configs.     
  get-command-letter                    \ get configs           
  make-compiler-path
  spare-keys		      		\ any extra
  configb-handle from-window
  delete-configb-window
  rest-win
;                                                               

behead

\ -- R.G.G -- 24/1/91 --  >glossary

headerless

: make-gloss-file	\ file$ -- file$ ; make the actual path of the file
  make-compiler-path			\ define where the compiler is
  (compiler-buff) pad $move		\ get the path to the compiler
  dup pad $+				\ add the name of the glossary file
  "" .HLP" pad $+			\ add the extension needed
  pad $>asciiz open-path 0<>		\ try to open the file
  if					\ if failed to open in compiler dir
    forth-buff pad $move		\ start with source drive/path
    pad $+				\ add filename needed
  else					\ if opened in compiler directory
    close-path drop			\ close it again
    (compiler-buff) pad $move
    pad $+
  endif
  pad					\ return address of source+filename
;

: (>glossary)  		\ title$ file$ -- ; show glossary
  make-gloss-file
  cs> swap set-help-file							\ use filename
  >r
  1 3 78 18										\ x y w h
  cs> r> 2line-border
  window-attrib @ border-attrib @ header-attrib @	\ attribs
  help-body-attrib @ help-border-attrib @  0		\ help attribs
  help-attribs									\ call extern
  cursor-on
  help
  cursor-off
;

: .glos-opts		\ -- ; show glossary options
  cr yellow ."  Glossary options:" dark
  cr ."  a)    Target"
  cr ."  b)    Umbilical"
  cr ."  c)    Compiler Directives"
  cr ."  <F10> Finish
  cr cr ."  Select glossary (a,b,c):
;

headers
: target-glossary	\ -- ;
  save-win
  "" Target Glossary"
  "" TARGET" (>glossary)
  rest-win
  cursor-on
;  
headerless

: glos-key		\ -- t/f ; get right glossary for user
  0		       					\ dummy quit flag		
  (key?)	       					\ if a key press
  if (key) upc						\ get first key
     case
       ascii A of "" ROM/RAM Glossary"
                  "" TARGET" (>glossary)
               endof
       ascii B of "" Umbilical Glossary"
                  "" UMBILIC" (>glossary)
               endof
       ascii C of "" Directives Glossary"
                  "" COMPILER" (>glossary)
               endof
       00 of (key)		     			\ if 00, get the second
             case   68 of drop -1 endof			\ set quit flag
                    59 of 29 #help more-help endof	\ do help
                          wrong-tone			\ wrong key
             endcase
          endof
       27 of drop -1 endof
             wrong-tone					\ wrong key
     endcase
  endif
;

headers

: >glossary		\ -- ; do glossary window
  save-win
  create-glos-window
  glos-handle to-window
  .glos-opts
  begin
    glos-key
  until
  spare-keys
  glos-handle from-window
  delete-glos-window			\ delete it
  rest-win
;

behead

assign >glossary to-do show-glos

\ -----End of Page-----
\ -- R.G.G -- 26/9/90 --  set-colours code

headerless

: .field-name		\ -- ; show what field we are editing
   1 1 gotoxy
   window-attrib @ >attribs
   ." Setting: "
   field# @
   case
     1 of ." Top banner     " endof
     2 of ." Help prompt    " endof
     3 of ." Main screen    " endof
     4 of ." Window border  " endof
     5 of ." Window title   " endof
     6 of ." Window contents" endof
     7 of ." Help border    " endof
     8 of ." Help contents  " endof
   endcase
;

: .frame		\ -- ; draw edit frame
  3 3 gotoxy ." "
  39 0  do   ." "  loop
  ." "
  11 0
  do
     3  4 i + gotoxy ." "
     43 4 i + gotoxy ." "
  loop
  3 14 gotoxy ." "
  40 0  do   ." "  loop
  43 14 gotoxy ." "  
;    

: .banner		\ -- ; draw sample banners
  temp-title-attrib @ >attribs
  4 4 gotoxy
  ."  XShell"  20 spaces            \ what program
  4 13 gotoxy
  ."  9600,N,8,1,None,1  C:\,NUL,FORTH.FTH  "
;

: .help-prompt		\ -- ; draw sample help prompt
  temp-help-prompt-attrib @ >attribs
  31 4 gotoxy
  ." F1 for Help "
;

: .abc...		\ -- ; print these chars
  ." abcdefghijklmnopqrstuvwxyz1234567890!$"
; 

: .body			\ -- ; draw sample screen body
  temp-body-attrib @ >attribs
  4 5 gotoxy 
  .abc...
  4 12 gotoxy
  .abc...
;

: .border		\ -- ; draw sample window border
  temp-border-attrib @ >attribs
  4 6 gotoxy ." ͵"
  12 6 gotoxy ." ͻ"
  4 11 gotoxy ." ͼ"
  4 0
  do
    4 7 i + gotoxy ." "
    28 7 i + gotoxy ." "
  loop
;				

: .help-border		\ -- ; draw sample help window
  temp-help-border-attrib @ >attribs
  29 6 gotoxy  ." ͵Helpͻ"
  29 11 gotoxy ." ͼ"
  4 0
  do
    29 7 i + gotoxy ." "
    42 7 i + gotoxy ." "
  loop
;				

: .help-screen		\ -- ; draw sample help text
  temp-help-body-attrib @ >attribs 
  4 0
  do
    30 7 i + gotoxy ." abcdefghijkl"
  loop
;


: .contents		\ -- ; draw sample window contents
  temp-window-attrib @ >attribs 
  4 0
  do
    5 7 i + gotoxy ." abcdefghijklmnopqrstuvw"
  loop
;

: .title		\ -- ; draw sample window header
  temp-header-attrib @ >attribs
  7 6 gotoxy ." Title"
;

: .screen		\ -- ; draw sample screen
  .field-name
  .frame
  .banner
  .help-prompt
  .body
  .border
  .title
  .contents
  .help-border
  .help-screen
;

: next-field		\ -- ; move on to next field
  field# @ 1+ dup
  9 =
  if
    drop 1
  endif
  field# !
;

: prev-field		\ -- ; move back to previous field
  field# @ 1- dup
  0 =
  if
    drop 8
  endif
  field# !
;

: +attrib		\ -- ; increment this attribute
  field# @
  case
    1 of  1 temp-title-attrib		+!  .banner		endof
    2 of  1 temp-help-prompt-attrib	+!  .help-prompt	endof
    3 of  1 temp-body-attrib	  	+!  .body   		endof
    4 of  1 temp-border-attrib		+!  .border		endof
    5 of  1 temp-header-attrib		+!  .title		endof
    6 of  1 temp-window-attrib		+!  .contents		endof
    7 of  1 temp-help-border-attrib	+!  .help-border	endof
    8 of  1 temp-help-body-attrib 	+!  .help-screen	endof
  endcase
  attribs-changed on
;

: -attrib		\ -- ; decrement this attribute
  field# @
  case
    1 of -1 temp-title-attrib		+!  .banner		endof
    2 of -1 temp-help-prompt-attrib	+!  .help-prompt	endof
    3 of -1 temp-body-attrib	      	+!  .body		endof
    4 of -1 temp-border-attrib		+!  .border		endof
    5 of -1 temp-header-attrib		+!  .title		endof
    6 of -1 temp-window-attrib		+!  .contents		endof
    7 of -1 temp-help-border-attrib   	+!  .help-border	endof
    8 of -1 temp-help-body-attrib 	+!  .help-screen	endof
  endcase
  attribs-changed on
;

: .keys			\ -- ; show what keys to use
  temp-window-attrib @ >attribs
  4 16 gotoxy
  ." <Tab> and <Sh><Tab> to change field"
  4 17 gotoxy
  ." <+> and <-> to change colour"
  4 18 gotoxy
  ." <F10> to abort, <Enter> to accept changes" 
  cursor-off
;

: set-temps    		\ -- ; set the temporary attributes
  title-attrib		@	temp-title-attrib		!
  help-prompt-attrib	@	temp-help-prompt-attrib		! 
  body-attrib	     	@	temp-body-attrib		!
  header-attrib		@	temp-header-attrib		!
  border-attrib		@	temp-border-attrib		!
  window-attrib		@	temp-window-attrib		!
  help-border-attrib	@	temp-help-border-attrib		!
  help-body-attrib 	@	temp-help-body-attrib		!
;

: set-actual	 	\ -- ; set the actual attributes
  temp-title-attrib		@	title-attrib		!
  temp-help-prompt-attrib	@	help-prompt-attrib	!
  temp-body-attrib   		@	body-attrib		!
  temp-header-attrib		@	header-attrib		!
  temp-border-attrib		@	border-attrib		!
  temp-window-attrib		@	window-attrib		!
  temp-help-border-attrib	@	help-border-attrib	!
  temp-help-body-attrib		@	help-body-attrib	!
  set-pick-attribs
;


: reset-windows	     	\ -- ; redraw with new attributes
  set-actual
  configc-handle @ close-window drop
  curr-handle @ close-window drop
  target-handle @ 
  dup close-window drop
  dup >r body-attrib @ dup dup r> attribs-window drop
      reopen-window drop
  host-handle @
  dup close-window drop
  dup >r body-attrib @ dup dup r> attribs-window drop
      reopen-window drop
  .top-bar
  redraw-bottom-bar
  curr-handle @ reopen-window drop
  configc-handle @ reopen-window drop
;

: (set-colours)		\ -- ; set new colours
  set-temps
  1 field# !
  done off
  .screen
  .keys
  begin
    .field-name
    (key)
    case
      00 of
            (key)
            case
              15 of prev-field  endof
              59 of more-help   endof
              68 of exit        endof
            endcase
         endof
      09 of next-field  endof
      13 of done on     endof
      27 of exit        endof
      43 of +attrib     endof
      45 of -attrib     endof
    endcase
    done @
  until
  attribs-changed @ 
  if
    reset-windows
  endif
;

headers

: set-colours		\ -- ; let user set new colours
  save-win				\ preserve state
  create-configc-window			\ make new window
  configc-handle to-window		\ enter new window
  26 #help				\ this help text
  (set-colours)				\ get settings
  cursor-on				\ restore cursor
  spare-keys				\ any extra
  configc-handle from-window		\ out of new window
  delete-configc-window			\ delete new window
  rest-win				\ restore old state
;                                                               

behead
 
\ -----End of Page-----
\ -- R.G.G -- 25/05/90 --  configuration main window                                                       

headerless

: .config-types		\ -- ; show the configuration options
  ."  Configuration options"                                    
  cr cr       ."  (a)  Set up function keys"                     
  cr          ."  (b)  Set up commands"                          
  cr          ."  (c)  Set screen colours"
  cr          ."  (d)  Set serial line configuration"
  cr cr       ."  (e)  Save configuration"                       
  cr cr       ."  <F10> finish"                                  
  cr cr ."  Select configuration option (a-e): "         
;                                                               

: get-config-type		\ -- ; select config option to use
  begin                                                         
    spare-keys
    (key) upc						\ get upc key           
    case
           00 of (key)
                 case   59 of more-help endof
                        68 of  exit endof
                           wrong-tone
                 endcase
              endof
      ascii A of do-config-fn  		endof                       
      ascii B of do-config-comm$	endof                    
      ascii C of set-colours		endof                       
      ascii D of get-settings   	endof
      ascii E of write-cfg	   	endof                       
           27 of exit endof 		               \ or finish             
              wrong-tone
    endcase                                                  
    05 #help
  again               			                  \ and round again       
;                                                            

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  do-config-all

headers

: do-config-all		\ -- ; get any user configuration option
  save-win
  create-config-window
  curr-handle to-window
  attribs-changed off
  05 #help
  .config-types			 	\ show options
  get-config-type		 	\ do one or the other           
  spare-keys			 	\ absorb any extra	
  curr-handle from-window
  delete-curr-window
  rest-win
  attribs-changed @
  if cls endif
  reset-attribs
;                                                               

behead

\ -----End of Page-----
\ -- R.G.G -- 16/10/91 --  target-abort

: (target-abort)	\ -- ; abort out of target system
  getxy >r >r					\ preserve cursor location
  31 #help					\ set the help message
  error-tone					\ this was a bad move	
  op-handle @					\ preserve current window #
  create-abort-window				\ make the message window
  curr-handle to-window				\ go into window
  1 abort-state !				\ error state of 1
  cr ." The host is now reset. Please reset target."		\ say what
  cr cr .press					\ tell user to press key
  begin (key?) while (key) drop repeat		\ absorb extra keys
  begin
    (key) 0=					\ is an alt key pressed
    if
      (key) 59 = if more-help endif 0		\ show more help if needed
    else
      -1					\ otherwise ready to quit
    endif
  until
  curr-handle from-window			\ back from window
  delete-curr-window				\ delete the message window
  op-handle !					\ restore last window
  reset-attribs					\ and the colours, etc
  r> r> gotoxy					\ restore curor location
;

assign (target-abort) to-do target-abort

\ -----End of Page-----
\ -- R.G.G -- 06/06/90 --  redefinitions

only forth also xs3 also forth definitions

: ed			\ -- ; takes into account the default or one typed
  bl word
  c@ 0<>
  if
    cs> here curr-text$ here c@ 1+ cmovel
  endif
  run-editor	     			\ run new version
;

: shell			\ -- ; makes this as pretty as ALT-D
  run-dos				\ run new version
;

: use			\ <filename> -- ; also does bottom bar
  use					\ do old version
  redraw-bottom-bar			\ and refresh
;

: using	 		\ <filename> -- ; also does bottom bar
  using					\ do old version
  redraw-bottom-bar			\ and refresh
;

: cd   			\ <pathname> -- ; also does bottom bar
  cd					\ do old version
  redraw-bottom-bar			\ and refresh
;

only forth also xs3 definitions

: (dir)			\ $addr -- ; uses browse box
  dup c@ 0<>						\ if length <> 0
  if
    dup dup c@ swap 1+ swap $dir-spec 1+ swap cmove	\ move given string
    c@ $dir-spec c!					\ and add count
  else
    drop						\ else tidy up
  endif
  list-files
; public

only forth also xs3 also forth definitions

: dir		\ <filespec> -- ; use browse box
  bl word   		\ get input	
  (dir)			\ do dir function
;

only forth also xs3 definitions

  
