\ input editor for XS3


\ -----End of Page-----
\ -- R.G.G -- 24/05/90 -- asciiz>$

: asciiz>$		\ addr1 -- addr2 ; convert asciiz to conted$
  dup dup dup                                                   
  255 00 scan drop		\ addr1 addr1'
  dup 32 swap c!		\ addr1 addr1'' & bl at what was
  1+ over - dup >r		\ addr1 len                     
  over 1+			\ addr1 len addr1+1             
  swap cmove>                               
  r> 1- swap c!			\ addr2
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --buffers
                                                                
create ed-buff  65 allot	\ editing buffer
44 constant max-size		\ the most characters to edit

headerless
                                                                
variable cur-x     0 cur-x !	\ cursor position in buffer     
variable cur-y			\ line number                   
variable base-x			\ begining of line              
                                                                
variable first/other		\ is this the first key press, or another
  0 first/other !			\ still the first

headers
variable good-edit		\ edited to completion ?        
variable pick-option		\ may the picklist be employed?
headerless
                                                                
: cur-x@		\ -- x ; get the x position
  cur-x @    
;                         

: ed-buff-c@		\ -- l ; position in string
  ed-buff c@ 
;                         

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  pcb>buff   
                                                                
: pcb>buff		\ pcb-addr -- ; copy pcb to edit buffer
  2+ dup			\ point at start of text
  62 bounds			\ assume 62 bytes of text
  do                                                            
    i c@ 32 =			\ if char is space
    if 0 i c! endif		\ convert to nul
  loop                                                          
  ed-buff 62 cmove		\ move to buffer
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  .buffer
                                                                
: .curs			\ -- ; goto position in string
  getxy nip cur-x@ base-x @ + swap gotoxy                       
;                                                               
                                                                
: .buffer		\ -- ; print the present contents of buffer
  base-x @ cur-y @ gotoxy			\ go to start
  ed-buff dup c@ swap 1+ swap type space	\ print text
  .curs						\ goto cursor positon
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  -> <-
                                                                
: ->			\ -- ; cursor right
  cur-x@ ed-buff-c@ <		\ was <=                                          
  if                                                            
    1 cur-x +! 			\ increment if not at end of buffer
  else                                                          
    no-act			\ beep if at end of line
  endif                                                         
;                                                               
                                                                
: <-			\ -- ; cursor left
  cur-x@ 0>
  if                                                            
    -1 cur-x +! 		\ increment if not at end of buffer
  else                                                          
    no-act			\ beep if at end of line
  endif                                                         
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  del>  del<
                                                                
: del>			\ -- ; delete forward
  cur-x@ ed-buff-c@ <		\ if not at end
  if                                                            
    ed-buff 1+ cur-x@ +		\ current char address          
    dup 1+ swap			\ -- next this                  
    ed-buff dup c@ + 1+		\ last char                     
    2dup swap -			\ no of chars                   
    nip cmove			\ copy down in buffer
    -1 ed-buff c+!		\ decrement postion to suit
  else                                                          
    no-act			\ beep if at end of line
  endif                                                         
;                                                               

: del<			\ -- ; delete backwards
  cur-x@ 0>			\ if not at end of line
  if                                                            
    ed-buff 1+ cur-x@ +		\ current char address          
    dup 1-			\ -- this prev                  
    ed-buff dup c@ + 1+		\ last char                     
    2dup swap -			\ no of chars                   
    nip cmove			\ move down in buffer
    -1 ed-buff c+!		\ new position in string
    -1 cur-x +!			\ and on screen
  else                                                          
    no-act			\ beep if at end of line
  endif                                                         
;

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  clean-up reset-buff
                                                               
: reset-buff		\ -- ; erase buffer if first keystroke
  first/other @				\ if this is the first `insert'
  if                                                            
    ed-buff-c@ >r ed-buff 62 erase	\ erase the buffer
    first/other off			\ set this flag
    base-x @ cur-y @ gotoxy		\ go to start of string
    r> spaces				\ erase place on screen
    getxy nip cur-x@ swap gotoxy	\ go to start of blank space
  endif                                                         
; 

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  insert
                                                                
: insert		\ key -- ; insert this key in buffer
  cur-x@ ed-buff-c@ <= ed-buff-c@ max-size < and
  if				\ if not at end of line
    reset-buff			\ maybe clear the buffer
    ed-buff 1+ cur-x@ +		\ current char address          
    dup dup >r 1+		\ -- this next                  
    ed-buff dup c@ + 1+		\ last char                     
    2dup swap - 1+		\ no of chars                   
    nip cmove>			\ move up in buffer
    1 ed-buff c+! r> c!		\ increment length of string
    1 cur-x +!			\ increment posotion in string
  else
    drop end-of-list-tone	\ `no room to insert'
  endif                                                         
;

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  >end >home
                                                                
: >end			\ -- ; go to end of line
  ed-buff-c@ cur-x !                                            
;                                                               
                                                                
: >home			\ -- ; go to start of line
  cur-x off                                                     
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 11/06/90 --  pick-file

: (pick-file) 		\ -- ; select a file, and insert that
  *.* 40 2 pick-window 0= 			\ raise pick window
  if
    ed-buff-c@ >r ed-buff 50 erase		\ clear the buffer
    base-x @ cur-y @ gotoxy  			\ start of entry
    r> spaces		     			\ clear the screen
    getxy nip cur-x@ swap gotoxy		\ start of entry again
    2dup c@l >r					\ get and preserve length
    1+						\ offset->start of string
    cs> ed-buff 1+ r@  cmovel 			\ move text to pad
    r> ed-buff c!	   			\ make counted string
    >home					\ cursor to start of name
    .buffer					\ reprint file name
  else
    2drop 					\ tidy up - result not wanted
  endif
;

: pick-file	     	\ -- ; maybe use a browse list
  pick-option @     	      	\ if this is permitted
  if
    getxy		      	\ preserve location
    op-handle @			\ preserve window
    (pick-file)			\ then show pick list
    op-handle !			\ restore window
    gotoxy			\ restore position
  else
    wrong-tone			\ else bleep to whinge
  endif
;

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  clean-up line-editor

: clean-up		\ -- ; move buffer back to here and tidy up
  ed-buff dup c@ 1+ here swap cmove                             
  pick-option off		\ turn off the flags
  dark				\ normal attributes
;                                                               

: reset-space		\ -- ; blank edit area on screen
  base-x @ cur-y @ gotoxy	\ go to start of string		
  ed-buff-c@ spaces		\ clear the space
  base-x @ cur-y @ gotoxy	\ go to start of string
;
                                                                
: line-editor		\ -- ; do the actual edit
  spare-keys			\ absorb any spurious keys
  begin                                              
    (key) dup			\ get a key
    case                                               
      0 of drop (key)		\ get the next bit of an alt-key
           case                                        
             59 of more-help  endof		\ F1
             72 of pick-file  endof		\ up or down
             80 of pick-file  endof		\ down or up
             77 of ->   .curs endof		\ right
             75 of <-   .curs endof           	\ left
             83 of del> .buffer endof		\ Del
             82 of noop endof                 	\ Ins
             79 of >end .curs endof		\ End
             71 of >home .curs endof          	\ Home
\              1 of drop clean-up exit endof		\ mouse only
\              4 of drop clean-up exit endof 		\ mouse only
\              2 of drop abort endof			\ mouse only
                   wrong-tone			\ no valid key
           endcase
        endof                                              
     13 of drop clean-up good-edit on exit  endof	\ Enter
     8  of drop del< .buffer   endof			\ BackSpace
     27 of drop reset-space
           good-edit off dark exit
        endof						\ Escape
           insert .buffer 			\ otherwise insert char
    endcase
    first/other off				\ we have had a key now
  again
;                         

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  do-ed  ed-pcb  init-ed

: init-ed		\ -- ; prepare to edit string
  good-edit on				\ set up
  yellow  cursor-on			\ use yellow text
  cur-x off				\ go to start of text
  first/other on			\ this will be the first key
  getxy cur-y ! base-x ! 		\ set postion to edit at
;

: do-ed			\ -- ; do the edit
  init-ed			\ set up
  .buffer			\ print the start buffer
  line-editor			\ do the edit
  good-edit @			\ say what result: aborted or accepted
;                                                

headers
                                                                
: ed-pcb		\ pcb -- ; edit the pcb named
  pcb>buff			\ copy to edit buffer
  ed-buff asciiz>$ drop		\ convert to counted string
  do-ed				\ do the edit
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  ed-$-lower  ed-$
                                                                
: ed-$-lower		\ $addr -- ; edit the string, and leave in users case
  dup count 1+ nip ed-buff swap cmove		\ move to buffer
  do-ed						\ edit it
;                                                               
                                                                
: ed-$			\ $addr -- ; edit and convert to upper case
  ed-$-lower				\ edit
  here count upper			\ make upper case
;                                                               

: here>$		\ addr -- ; move $ at HERE to addr
  here swap $move 
;                             

behead

