\ Modular Forth v3 by MicroProcessor Engineering     sfp 07/06/90 
 
(( 
Copyright (c) 1986..1991 to: 
 
MicroProcessor Engineering Limited 
133 Hill Lane 
Shirley 
Southampton SO1 5AF 
England 
 
tel: (+44) 703 631441 
fax: (+44) 703 339691 
 
This file contains useful tools. Unless otherwise noted 
the copyright belongs to MicroProcessor Engineering. 
)) 
\ Editor control words ............................sfp 19/09/90 
 
\ Added by the configuration system before release 
\ Supplied for information only. 
 
\ While developing a module, these words should be added to 
\ the module so that the editor can be called directly from it. 
 
( scr# -- ) 
: fred          flush (edit) scr !  ; 
( -- ) 
: edit          scr @ fred  ; 
 
;s 
 
\ Assembler control words .........................sfp 19/09/90 
 
\ Added by the configuration system before release 
\ Supplied for information only. 
 
\ While developing a module, these words should be added to 
\ the module so that the assembler can be called directly 
\ from it. 
\ 
\ The assembler is accessed as a sealed vocabulary in another 
\ module. Searching of the assembler vocabulary is enabled by 
\ temporarily replacing the interpreter loop with a modified 
\ one that searches the assembler words first. 
\ 
 
cr cr   .( load only into assembler target modules)  cr 
 
only forth definitions 
 
 
\ (a-loop) asm-on asm-off ........................ sfp 06/08/89 
 
: (a-loop)	\ ?? -- ?? ; may execute word in ASM-ACCESS 
    STATE OFF 
    BEGIN   ?stack 
            BL WORD ?done               \ while input lasts 
            cs> swap asm-exec? 0=       \   is it not in asm ? 
            IF  here find               \   y: in others ? 
                IF    execute           \      y: run it 
                ELSE  cs> over find/p   \      n: in public ? 
                      IF nip slave-call \         y: run that 
                      ELSE  number? 0=  \         n: not number? 
                            0 ?error    \            y: abort 
                      ENDIF             \ 
                ENDIF                   \ 
            ENDIF                       \ 
    AGAIN  ; 
 
: asm-on	\ -- ; turn assembler on 
  (asm)                                 \ load asm if not there 
  cs> dp asm-init                       \ initialise assembler 
  assign (a-loop) to-do i-loop  ;       \ switch on interpreter 
 
: asm-off	\ -- ; turn assembler off 
  assign (i-loop) to-do i-loop  ;       \ by reassigning interp 
\ assembler hooks from other modules ............  sfp 01/08/89 
 
decimal 
 
variable ecx-flg 
 
: LBL: 
  ?EXEC !CSP  CREATE SMUDGE   ecx-flg off 
  asm-on  r> drop  ['] (a-loop) >body >r  ;  immediate 
 
: CODE 
  ?EXEC !CSP  CREATE -3 allot  smudge  ecx-flg off 
  asm-on  r> drop  ['] (a-loop) >body >r  ;  immediate 
 
: ;CODE 
  ?COMP ?CSP  COMPILE (;CODE)  state off  ecx-flg on 
  !csp asm-on  r> drop  ['] (a-loop) >body >r  ;  immediate 
 
: end-code 
  asm-off unres-refs? 46 ?error   ?exec ?csp  smudge 
  ecx-flg @ if  r> drop  ecx-flg off endif  ;  immediate 
 
;p 
\ strings 1 .....................................   sfp july 86 
 
DECIMAL 
 
( addr -- #chars ; format a counted string at <addr> ) 
: $IN   0 
        BEGIN  DUP  KEY DUP 13 <>  ROT C/L 1- <  AND 
          WHILE  DUP 8  =                      ( Back space?) 
                     IF   DROP DUP IF 1- BS ENDIF 
                     ELSE  DUP 32 127 WITHIN? 
                         IF  DUP EMIT  >R 2DUP + 1+ R> 
                             SWAP C!  1+ 
                         ELSE  DROP  BELL 
                         ENDIF 
                     ENDIF 
        REPEAT 
        DROP  DUP ROT C!  ; 
 
: $variable	\ #chars -- ; 
  create  0 c,  allot  ;                \ n $variable <name> 
 
: $constant     \ -- 
  create  ",  ;                         \ $constant <name> text" 
 
(( 
\ $. ($+) $+ moved to nucleus 
: $.	\ $addr -- 
  count type  ;                         \ just print it 
 
: ($+)          \ addr len $dest -- 
  >r  2dup  r@ count + swap cmove       \ add source to end 
  r@ c@ + r> c!                         \ add length to count 
  drop  ;                               \ remove address 
 
: $+		\ $addr1 $addr2 -- 
  >r count r> ($+)  ;                   \ add $addr1 to $addr2 
)) 
 
: $left         \ $addr1 n $addr2 -- 
  rot 1+ -rot ($+)  ;                   \ add left n of $addr1 
 
: $mid          \ $addr1 s n $addr2 -- 
  >r >r  + 1+  r> r> ($+)  ;            \ add mid n from s 
 
: $right        \ $addr1 n $addr2 -- 
  >r >r  count r@ - +  r> r> ($+)  ;    \ add right n of $addr1 
\ strings 2 .....................................   sfp july 86 
 
: $val		\ $addr -- n1..nn n 
  number?  ;                            \ synonym 
 
: $len          \ $addr -- len 
  c@  ;                                 \ synonym 
 
: $clr          \ $addr -- ; clear it 
  0 swap c!  ;                          \ count:=0 
 
: $upc          \ $addr -- 
  count upper  ;                        \ make it upper case 
 
: $compare      \ $addr1 $addr2 -- -1/0/+1 
  count  rot count  rot			\ a2 a1 l1 l2 -- 
  2dup - >r				\ a2 a1 l1 l2 -- 
  min 0				\ a2 a1  l1/l2 0 
  ?do  swap 1+  swap 1+			\ step to next address 
       over 1- c@ over 1- c@ <>		\ a2 a1 a2<>a1 -- 
       ?leave				\ until different 
  loop				\ or until done 
  swap 1- c@  swap 1- c@  -		\ last two chars 
  ?dup				\ see if same 
  if  0<			\ not same, return indicator 
     if  +1  else  -1  endif 
     r> drop 
  else  r> dup				\ strings =, see if same length 
        if  0<				\ not, return indicator 
            if  -1  else  +1  endif 
        endif 
  endif  ; 
 
\ $1 $2 -- flag 
: $<    $compare 0<  ;                  \ true if $1 < $2 
: $=    $compare 0=  ;                  \ true if strings same 
: $>    $compare 0>  ;                  \ true if $1 > $2 
: $<>   $compare 0<>  ;                 \ true if strings differ 
 
: $instr	\ $1 $2 -- ff | n tf ; $1 in $2 ?, n=index from 0 
    0 -rot                      \ put false flag under arguments 
    >r  count dup  r> count     \ text-adrs & #s for strings 
    rot -                       \ difference (#2-#1) 
    -1 max 1+  0                \ if $2>=$1, compare #2-#1 times 
    ?DO dup i +  2over  s=      \ text1 in this part of text2 ? 
        IF  2drop               \ y: 4 items on stack - drop 2 
            i -1 2swap          \    put n & tf underneath 
            0                   \    dummy to drop after loop 
            LEAVE               \    exit loop 
        ENDIF 
    LOOP                        \ another compare 
    drop 2drop                  \ discard working values 
; 
 
;p\ interpretive control logic ........ Will Baden - EuroFORML 85 
\ This code adds control logic that works outside a colon 
\ definition. It is not fast, but it is a magic system for 
\ providing conditional compilation or execution. When used 
\ with immediate constants, control can be asserted within a 
\ colon definition. 
\ 
\ The word HAVE is used to to determine whether or not a word 
\ already exists. To see what is going on here, you should think 
\ about the uses of the return stack. 
\ 
\ Presented by Will Baden, of Costa Mesa, California, at the 
\ 1985 EuroFORML conference in Germany. 
 
only forth definitions 
 
vocabulary conditional  also conditional definitions 
 
: )else(        dup 1 = if  1-  endif  ; 
: if(           1+  ; 
: begin(        1+  ; 
: )then         1-  ; 
: )endif        1-  ; 
: )repeat       1-  ; 
: )until        1-  ; 
: )again        1-  ; 
: ."            ascii " word drop  ; 
: .(            [compile] (  ; 
: (             [compile] (  ; 
: \             [compile] \  ; 
 
 
\ passover ?enough .................. Will Baden - sfp 05/08/89 
 
only forth definitions  also conditional  also 
 
: passover      \ n -- ; levels to skip 
  begin  bl word  dup count ?dup 0=     \ check input exists 
         if  2drop 2drop  blk @         \ error if from disc 
             abort" unexpected end" exit 
         then 
         upper  ['] conditional v-find  \ look in cond. 
         if  execute ?dup  endif        \ execute if found 
  0= until  ;                           \ until level=0 
 
: ?enough                               \ n -- 
  depth 1- <                            \ error if less than n 
  abort" too few items on stack"  ;     \ so stop now! 
\ if( )else( )endif )then have ...... Will Baden - EuroFORML 85 
 
: if(           \ flag -- 
  1 ?enough  0=                         \ check stack, invert f 
  if  1 passover  endif  ;  immediate 
 
: )else(        \ -- 
  1 passover  ;  immediate              \ pass over text to )end 
 
: )endif	\ -- ; marker
  ;  immediate

: )then		\ -- ; marker
  ;  immediate
 
: have          \ -- flag 
  bl word find nip 0<>  ;  immediate    \ true if word exists 
 
 
\ begin( )repeat )until )while( ..... Will Baden - EuroFORML 85 
 
: begin(        \ -- 
  >in @ >r                              \ need >in to backtrack 
  begin  r@ >in !  interpret  again  ;  \ r-stack discarded 
                        immediate       \ by )while( or )until 
 
: )while(       \ flag -- 
  1 ?enough  0=                         \ check depth, invert f 
  if  r> r> r> 2drop drop               \ discard >in & exits 
      1 passover                        \ pass over text to )rep 
  endif  ;      immediate               \ 
 
: )repeat	\ -- ; exit interpret
  r> drop  ;  immediate
 
: )until        \ n -- 
  1 ?enough                             \ stack check 
  if  r> r> 2drop  endif                \ discard >in & exit 
  r> drop  ;  immediate                 \ exit interpret 
 
: )again	\ --
  0 [compile] )until ;  immediate 
 
;p 
\ Dick Pountain's profiler - adapted by SFP and PG       sfp 11/08/89 
 
( addr -- ; increment contents by one ) 
: 1+!   1 SWAP +!  ; 
 
( -- ; redefine : to insert a count field and skip over it ) 
: :     0 ,  [compile] :  ;  immediate  \ lay counter, do : 
 
( -- ; redefine ; to increment the count field ) 
: ;     LATEST n>link 2-                ( address of counter ) 
        [COMPILE] LITERAL               ( compiled as a literal) 
        COMPILE 1+!                     ( force increment ) 
        ?COMP ?CSP  COMPILE exit SMUDGE ( perform original ;  ) 
        STATE OFF R> DROP ; IMMEDIATE 
 
' 1+!                           \ cfa of 1+! 
  dup 1+ @                      \ fetch offset of branch 
  + 3 +                         \ cfa+offset+3 = branch target 
        CONSTANT DOCOL          \ address of runtime of : 
 
: colon?        \ cfa -- t/f ; true if word at CFA is colon def. 
  dup 1+ @  +  3 +                      \ pfa+offset=branch addr 
  docol =  ;                            \ is it colon point 
 
VARIABLE FINISH       ( holds addr. of last word in profiler) 

: max-nfa       \ -- addr nfa ; returns addr and top nfa
  0 0                                   \ clear result
  pad context @ >#threads @ 2* bounds   \ for all threads
  do  i @  over u>                      \ if greater
      if  2drop  i  i @   endif         \ replace current set
  2 +loop  ;                            \ step on

: profile	\ -- ; display list of words in CONTEXT dictionary
  cr                                    \ set up
  context @ >threads pad
  context @ >#threads @ 2* cmove        \ initialise threads
  Begin
    max-nfa dup                         \ while still one left
    halt? 0= and                        \ and no stop command
    over FINISH @ u> and		\ until we hit the profiler 
  While
    dup name> colon?			\ a colon definition?
    If
      dup n>link 2- @			\   get counter contents 
      tab  0 8 d.r			\   and print them 
      dup space .name cr		\   and the word's name 
      dup n>link 2- off			\   clear counter 
    Endif
    n>link @ swap !                     \ find next
  repeat
  2drop  ;

LATEST FINISH !                 \ profile is last word 
 
(( 
Notes by Dick Pountain about the profiler 
 
To use the profiler, just compile the previous page. Then 
compile the words to be profiled on top, and execute them. 
 
Typing PROFILE then prints an execution count for all the words 
compiled after PROFILE. Note that PROFILE resets the counters, 
so if you have more than a screenful, take a hard copy by 
typing PRINTER PROFILE CONSOLE. 
 
The code is very spartan; you can tart up the formatting etc. 
to taste. It is not too dificult to redefine VARIABLE and 
CONSTANT in a similar way, to profile variables and constants. 
CREATE ... DOES> definitions are more difficult to cope with. 
 
Modified by Stephen Pelc, thank you Dick. 
))\ >asm >forth     .......................          sfp 07/06/90 
 
(( 
This code allows an assembler definition, which might be a CODE word, 
a procedure started by LBL:, or an interrupt service routine, to call 
a high level word or group of words. Note that it is the responsibility 
of the code portions to perform all the initialisation and cleaning 
up of the 80x86 registers used by Forth. In practice this means: 
  SI - Forth Interpretive pointer 
  DI - Forth User area pointer 
  BP - Forth Return stack pointer 
  SP - Forth data stack pointer 
 
Alternatively it allows a high level definition to include a code fragment. 
This is particularly useful for recoding the inner portions of speed critical 
inner loops. 
)) 
 
hex 
 
: >asm          \ -- ; in-line code fragment follows 
  ?comp                                 \ must be compiling 
  here 2+ ,                             \ lay jump target 
  asm-on                                \ turn on assembler 
  [compile] [  ;  immediate             \ run interpreter 
 
: >forth        \ -- ; back to high level Forth 
  0BE C,  here 5 + ,                    \ SI, # $ 6 + MOV 
  0AD C,  0FF C,  0E0 C,                \ LODSW  AX JMP 
  asm-off                               \ turn off assembler 
  ]  ;                                  \ run compiler 
 
decimal 
 
\  eg,  : test  ." hi"  >asm  ax, # 123 mov  ax push  >forth 
\               .  ." hi again"  ; 
 
;p 
\ enlarge context array for more vocabularies      sfp 07/06/90 
 
hex 
 
: Enlarge-Context 
    context                             \ old address of context 
    050 ['] context >body !             \ set new USER offset 
    context  dup  020 erase             \ erase new region 
    0e cmove                            \ copy new to old 
    010 ['] c/l 8 + !                   \ #vocs 
    020 ['] c/l 0D + !                  \ vsize 
    ['] root >body  context  01e + !  ; 
 
Enlarge-Context 
forget Enlarge-Context 
decimal 
 
\ save modforth 
\ calling an external program                      sfp 07/06/90 
 
create long-address 0 , 0 , 
 
code long-call	\ seg offset -- 
  long-address bx mov                   \ get offset 
  long-address 2+ pop                   \ get segment 
  bp, sp xchg   si push   di push       \ save Forth registers 
  ds push   es push   bp, sp xchg       \ on return stack 
  long-address [] call/f                \ call routine 
  bp, sp xchg   es pop   ds pop         \ restore Forth register 
  di pop   si pop   bp, sp xchg         \ from return stack 
  bx pop                                \ put TOS back in BX 
  next,   end-code 
 
;p 
( shell dos" dir ............................. nms April 86 ) 
 
\ Provided as examples of how to use $DOS 
 
DECIMAL 
 
( -- ; use as DOS" <command> <parameters>" eg. DOS" FORTH.COM") 
: DOS"          ?EXEC  CS> ASCII " WORD  $DOS  ; 
 
( -- ) 
: SHELL         CLS CR CR 
                ." Type EXIT to return to Modular Forth" CR 
                CS> "" \COMMAND " $DOS  ; 
 
( -- ; use as DIR [path-name] eg. DIR   or DIR A:*.SCR etc.. ) 
: DIR           ASCII " WORD 
                COUNT DUP >R OVER 19 + SWAP CMOVE> 
                "" \COMMAND /C DIR /P " DUP C@ 1+ 
                HERE SWAP CMOVE R> HERE C+! 
                CS> HERE $DOS  ; 
 
;p\ show-vector dv ...............................   sfp 06/08/89 
 
hex 
 
only tasking also forth definitions 
 
\ n -- ; displays contents of 8086 interrupt vector n 
: show-vector 
  get-vector swap hex 4 u.r ascii : emit 4 u.r  ; 
 
\ -- ; displays all 8086 interrupt vectors 
: dv            0100 0 
                do  cr i hex 2 .r  space  i show-vector 
                    halt? ?leave 
                loop  ; 
 
;p 
\ multi-tasker example code - 1 - software scheduling ......... 
 
only forth also tasking definitions     \ set search order 
 
: INIT-MULTI	\ -- ; reset multi-tasker 
  INIT-MAIN                             \ reset main task 
  TASK-LIST MAKE-EMPTY                  \ clear out task list 
  MAIN TASK-LIST INSERT                 \ insert one task 
  TASK-LIST MAKE-CIRCULAR               \ make task-list circ. 
  MAIN CUR-TASK !  MAIN IDLE-TASK !     \ main is all tasks 
  MAIN TASK-LIST ACTION !  ;            \  to all men 
 
hex 
init-multi multi                        \ enable scheduler 
 
0200 0200 100 tcb test1                 \ make new task 
 
: act1	\ -- ; action of test1 
  begin  pause 7 emit  again  ;         \ wait a bit & ring bell 
 
assign act1 to-task test1               \ assign action 
01000 test1 every                       \ every 1000 ticks 
 
test1 activate                          \ now run it 
decimal 
 
;p\ interrupt example ............................    sfp july 86 
 
hex 
 
only tasking also forth definitions     \ select search order 
 
050 interrupt int050                    \ usually free in DOS 
 
code t050                               \ test int 050 
  050 int   next,   end-code            \ by calling it! 
 
int050 attach                           \ install interrupt 
 
cr ." calling int 050"                  \ tell user 
t050                                    \   created as noop 
cr ." got back ok!"                     \ made it 
 
assign words to-int int050              \ assign new action 
 
cr ." calling int 050 again"            \ tell user 
t050                                    \   now running words 
cr ." got back ok!"                     \ made it 
 
decimal 
 
;p 
\ timers - example 1 ...........................   sfp 15/05/90 
 
\ Get at timer by patching into interrupt 01c, the PC timer. 
\ Then make words that enable and disable timer action. 
 
only forth  also tasking definitions    \ set search order 
 
HEX 
01C PATCH-INTERRUPT INT-01C             \ patch handler to 01c 
 
: TIMERS-ON	\ -- ; enable timers 
  ASSIGN DO-TIMERS TO-INT INT-01C       \ turn timers on 
  INT-01C ATTACH  ;                     \ patch vector 
 
: TIMERS-OFF	\ -- ; disable timers 
  ASSIGN NOOP TO-INT INT-01C            \ set null action 
  INT-01C DETACH  ;                     \ un-patch vector 
 
: RUN-TIMER	\ timer -- 
  DUP TIMER-LIST MEMBER? 0=             \ if timer not in list 
  IF  TIMER-LIST INSERT                 \  add it to list 
  ELSE  DROP                            \  or already active 
  ENDIF  ; 
 
: STOP-TIMER	\ timer -- 
  DUP HALT  TIMER-LIST REMOVE  ;        \ halt it, & remove 
 
DECIMAL 
 
MAKE-TIMER BEEPER                       \ new timer 
 
VARIABLE TT                             \ -- addr ; used as counter 
 
: BEEP          \ -- ; ring bell 
  7 emit  1 tt +!  ;                    \ ring bell and count 
 
ASSIGN BEEP TO-TIMER BEEPER             \ set action of timer 
 
10  REP-MODE BEEPER SET-TIMER           \ add timer to list 
 
TIMERS-ON                               \ turn timers on 
 
;s 
\ multi-tasking - 1 - timer interrupt driven        sfp july 86 
 
HEX 
 
only forth also tasking definitions     \ search order 
 
01C PATCH-INTERRUPT INT-01C             \ timer on interrupt 01c 
 
: INIT-MULTI	\ -- ; initialise tasker 
  TASK-LIST MAKE-EMPTY                  \ ensure list is empty 
  MAIN CUR-TASK !                       \ Forth is current task 
  MAIN IDLE-TASK !                      \ which is idle task 
  INIT-MAIN  ;                          \ initialise tcb 
 
: MULTI		\ -- ; enable multi-tasking 
  multi                                 \ as for software sched. 
  ASSIGN DO-TASKS TO-INT INT-01C        \ install scheduler 
  INT-01C ATTACH  ;                     \ but attached to timer 
 
: SINGLE	\ -- ; disable multi-tasking 
  single                                \ as for software sched. 
  INT-01C DETACH  ;                     \ also detach interrupt 
 
decimal 
 
;p 
\ multi-tasking - 4 - timer interrupt driven       sfp 27/07/89 
 
only forth  also tasking definitions    \ search order 
 
init-multi  multi                       \ initialise data 
 
hex 
 
0100 0100 080 tcb task1                 \ make new task 
 
: act1          \ -- ; action of test1 
  begin  pause  7 emit  again  ;        \ wait a bit & ring bell 
assign act1 to-task task1               \ assign action 
 
0020 task1 every                        \ every 32 ticks 
direct-drivers                          \ DOS is not re-entrant! 
task1 activate                          \ now run it 
 
decimal 
 
;p 
\ Interrupt 010h screen drivers .............   nms may 86 
 
only forth definitions 
 
(( 
This code is already installed in the SERVICES module and is provided 
for information only. 
 
The following code performs screen handling 
through the video drivers provided for IBM PCs and many MSDOS 
machines through interrupt 010h. These routines are as 
bullet-proof as we can make them. In particular, the screen 
handling functions are much faster than the facilities in the 
ANSI.SYS driver. If the interrupt 010h driver is installed, the 
printer and file redirection provided by changing the handles 
is unavailable. 
)) 
 
hex 
 
LBL: @POS               \ get current position in DX 
        AH, # 03 MOV   BH, BH SUB 
        010 INT   RET   END-CODE 
 
LBL: !POS               \ store position in DX 
        AH, # 2 MOV   BH, BH SUB 
        010 INT   bx pop   next,   END-CODE 
 
LBL: SET-SCROLL-ATTR    \ 
        AH, # 0F MOV   010 INT   AL, # 7 CMP 
        NZ, IF,  AL, # 4 CMP 
                 GE, IF,  BH, BH SUB   RET   ENDIF, 
            ENDIF, 
        BH, # 7 MOV RET  END-CODE 
\ (int-emit) 
 
CODE (INT-EMIT) 
        al, bl mov                      \ copy TOS to SL 
        01A [DI] INC                    ( increment OUT ) 
        AL, # 08 CMP                    ( Back-space ? ) 
        Z, IF,  @POS CALL               ( get current position) 
                DL, # 0 CMP 
                Z, IF,  bx pop   next,  ( no bs at 0 ) 
                   ENDIF, 
                DL DEC                  ( dec X coord ) 
                !POS JMP                ( store new position ) 
           ENDIF, 
 
        AL, # 0A CMP                    ( Line feed ? ) 
        Z, IF,  @POS CALL               ( get current position) 
                DH, # 18 CMP            ( line 18 ? ) 
                Z, IF,  SET-SCROLL-ATTR CALL 
                        AX, # 0601 MOV  ( scroll func 1 line ) 
                        CX, CX SUB      ( top left pos) 
                        DX, # 184F MOV  ( lower right position) 
                        BP PUSH 010 INT BP POP 
                        bx pop   next,  \ TOS must be restored 
                ENDIF, 
                DH INC  !POS  JMP 
        ENDIF, 
 
        AL, # 0D CMP                    ( Carridge return ? ) 
        Z, IF,  @POS CALL               ( get current position) 
                DL, DL SUB              ( x coord = 0 ) 
                !POS JMP                ( store new position) 
        ENDIF, 
 
        BX, CURR-ATTRIBS MOV  BH, BH SUB ( get current attribs) 
        AL, # 020 CMP                   ( only if printable ) 
        AE, IF, DL, AL MOV              ( save char ) 
            AX, # 0920 MOV  CX, # 1 MOV ( write func, 1 char ) 
            010 INT                     ( 1 character) 
            AL, DL MOV                  ( restore char ) 
            ENDIF,                      ( now write teletype ) 
        AH, # 0E MOV  BP PUSH  010 INT  BP POP 
        bx pop   next,			\ TOS must be restored 
END-CODE 
 
\ Int10-type int-xy ....................           sfp 01/08/89 
 
hex 
 
: (int-type)            \ addr len -- 
  bounds ?do i c@ (int-emit) loop  ; 
 
lbl: xy-sub             \ x,y in dl,dh 
  AH, # 2 MOV   BH, BH SUB   010 INT   bx pop   next,  END-CODE 
 
code (int-xy)           \ x y -- 
  ax, bx mov   DX POP  DH, AL MOV  XY-SUB JMP  END-CODE 
 
code (int-cls)          \ -- 
  bx push 
  SET-SCROLL-ATTR CALL   AX, # 0600 MOV   CX, CX SUB 
  DX, # 194F MOV   BP PUSH   010 INT   BP POP 
  DX, DX SUB   XY-SUB JMP   END-CODE 
 
 
\ Int10 (curs-on) (curs-off) ?xy........           sfp 01/08/89 
 
hex 
 
code (curs-off)         \ -- 
  cx, # 02000 mov   ah, # 1 mov  010 int   next,   end-code 
 
code (curs-on)          \ -- 
  bx push   ah, # 0f mov  010 int  al, # 7 cmp  z, 
    if, cx, # 0C0D mov  else,  cx, # 0607 mov  endif, 
  ah, # 1 mov  010 int   bx pop   next,   end-code 
 
code ?xy		\ -- x y 
  bx push   ah, # 03 mov  bh, bh sub  010 int  bl, dh mov 
  dh, dh sub  dx push   bh, bh sub   next,  end-code 
 
decimal 
 
 
\ assign int10 handlers                            sfp 13/02/89 
 
: (int010-drvrs) 
  assign (int-emit) to-do emit 
  assign (int-type) to-do type 
  assign (int-xy) to-do gotoxy 
  assign (int-cls) to-do cls 
  assign (curs-off) to-do cursor-off 
  assign (curs-on) to-do cursor-on 
  assign ?xy to-do getxy  ; 
 
: int010-drivers 
  assign (int010-drvrs) to-do normal-drivers  normal-drivers ; 
 
\ int010-drivers 
 
;p 
\ emit/a                                           sfp 05/07/91 
 
\ Using the PC BIOS, display a character with a given attribute. 
 
hex 
 
code emit/a     \ char attr -- 
  ax pop                                \ get character 
  ah, # 09 mov                          \ set parameters 
  bh, # 0 mov                           \ attr already in BL 
  cx, # 1 mov                           \ 1 character 
  bp push   010 int   bp pop            \ call BIOS 
  bx pop   next,   end-code 
\ drive a: b: c: d: e: 
 
hex 
 
: drive         \ n -- ; -- [child]
  create  ,  ;code                      \ lay down drive # 
  bx push                               \ save TOS 
  bx, ax mov  dx, 3 [bx] mov            \ get drive code 
  ah, # 0e mov   021 int                \ call DOS 
  bx pop   next,   end-code             \ that's all 
decimal 
 
0 drive a:  public 
1 drive b:  public 
2 drive c:  public 
3 drive d:  public 
4 drive e:  public 
 
;p 
\ Reconfigure FRED Editor
 
ONLY FORTH DEFINITIONS DECIMAL 
 
CR CR .( Load only into Editor Module ) 
 
\ 
\ First change the relevant entries in the tables on the 
\ following screens. eg. -- 
\       to change the editor function to move the cursor up 
\       , currently  <CTRL U> , to  <ESCAPE><E> :- 
\         1:    change U to E in the table 
\         2:    and CONTROLS  to ESCAPES 
\         3:    and HELPS/C  to HELPS/E 
\ the line - CONTROL  U   DUP CONTROLS UP        HELPS/C $UP 
\ becomes  - CONTROL  E   DUP ESCAPES  UP        HELPS/E $UP 
\  Then Load this screen 
\       49 LOAD 
\       SAVE EDASM86 
 
 
\ control key assignation  
 
DECIMAL 
ALSO  EDITOR  RESET-KEYS		( clean out key tables ) 
 
( key value | type    | edit function   | help message     ) 
CONTROL U DUP CONTROLS UP               HELPS/C $UP 
CONTROL D DUP CONTROLS DOWN             HELPS/C $DOWN 
CONTROL L DUP CONTROLS LEFT             HELPS/C $LEFT 
CONTROL R DUP CONTROLS RIGHT            HELPS/C $RIGHT 
CONTROL T DUP CONTROLS HOME             HELPS/C $HOME 
CONTROL X DUP CONTROLS ERASE-LINE       HELPS/C $ERA-LIN 
CONTROL I DUP CONTROLS TAB-RIGHT        HELPS/C $TAB-R 
CONTROL O DUP CONTROLS TAB-LEFT         HELPS/C $TAB-L 
CONTROL K DUP CONTROLS DELETE-LINE      HELPS/C $DEL-LIN 
CONTROL N DUP CONTROLS NEXT-SCREEN      HELPS/C $NEXT 
CONTROL P DUP CONTROLS PREV-SCREEN      HELPS/C $PREV 
CONTROL S DUP CONTROLS INSERT-LINE      HELPS/C $INS-LIN 
CONTROL A DUP CONTROLS INS-SPACE        HELPS/C $INS-BL 
CONTROL Q DUP CONTROLS TOGGLE-INSERT    HELPS/C $INSERT 
CONTROL E DUP CONTROLS ERASE-SCREEN     HELPS/C $ERA-SCR

CONTROL G DUP CONTROLS DEL-UNDER        HELPS/C
$DEL-UNDER 
CONTROL H DUP CONTROLS DEL-LEFT         HELPS/C $DEL-LEFT 
CONTROL Y DUP CONTROLS DEL-EOL          HELPS/C $DEL-EOL 
CONTROL F DUP CONTROLS STEP-FORWARD     HELPS/C
$WORD-FOR 
CONTROL B DUP CONTROLS STEP-BACK        HELPS/C $WORD-BACK

CONTROL Z DUP CONTROLS LOAD-SCREEN      HELPS/C $RESTORE

13        DUP CONTROLS NEW-LINE         HELPS/C $NEW-LIN 
10        DUP CONTROLS DOWN             HELPS/C $DOWN 
27        DUP CONTROLS DO-ESCAPE        HELPS/C $ESC 
CONTROL V DUP CONTROLS TOGGLE-PUSH      HELPS/C $PUSH 
\ escape key assignation .................NMS 1sfp/nms 15/04/87 
 
( key value | type    | edit function   | help message     ) 
CONTROL M DUP ESCAPES  MCOPY            HELPS/E $MOVE-scr 
CONTROL N DUP ESCAPES  CHANGE-SCREEN    HELPS/E
$CHANGE-SCR 
CONTROL S DUP ESCAPES  SPLIT-LINE       HELPS/E $SPLIT-LIN 
CONTROL Y DUP ESCAPES  DEL-EOS          HELPS/E $DEL-EOS 
CONTROL F DUP ESCAPES  DEL/W-FORWARD    HELPS/E $DEL/W-F

CONTROL B DUP ESCAPES  DEL/W-BACK       HELPS/E $DEL/W-B 
CONTROL L DUP ESCAPES  SEARCH           HELPS/E $SEARCH 
CONTROL R DUP ESCAPES  REPLACE          HELPS/E $REPLACE 
CONTROL V DUP ESCAPES  SCR-INDEX        HELPS/E $INDEX 
CONTROL O DUP ESCAPES  JOIN-LINE        HELPS/E $JOIN 
CONTROL U DUP ESCAPES  ROLL-UP          HELPS/E $ROLL-UP 
CONTROL D DUP ESCAPES  ROLL-DOWN        HELPS/E $ROLL-DOWN

CONTROL I DUP ESCAPES  >SCRATCH         HELPS/E $>S 
CONTROL X DUP ESCAPES  S-DEL-LINE       HELPS/E $S-DEL-LIN 
CONTROL J DUP ESCAPES  SCRATCH>         HELPS/E $S> 
CONTROL E DUP ESCAPES  CLEAR-BARREL     HELPS/E $S-CLEAR 
CONTROL A DUP ESCAPES  INS-S>           HELPS/E $INS-S> 
CONTROL G DUP ESCAPES  >S-DEL           HELPS/E $>S-DEL 
0         DUP CONTROLS DO-ALT           HELPS/C $ALT 
CONTROL H DUP ESCAPES .HELP   DUP HELPS/E $HELP    
HELP-CHAR ! 
27        DUP ESCAPES  SET-LEAVING      HELPS/E $LEAVE 
\ alt key assignation 
 
( key value | type    | edit function   | help message     ) 
81  dup  alt-id" PgDn"  DUP ALT  NEXT-SCREEN  HELPS/A $NEXT 
73  dup  alt-id" PgUp"  DUP ALT  PREV-SCREEN  HELPS/A $PREV 
119 dup  alt-id" ^hom"  dup alt  ctl-home     helps/a $ctl-home 
117 dup  alt-id" ^end"  dup alt  ctl-end      helps/a $ctl-end 
132 dup  alt-id" ^PUp"  dup alt  roll-down  helps/a $roll-down 
118 dup  alt-id" ^PDn"  dup alt  roll-up    helps/a $roll-up 
82  dup  alt-id" Ins "  DUP ALT  TOGGLE-INSERT HELPS/A $INSERT 
83  dup  alt-id" Del "  DUP ALT  DEL-UNDER   HELPS/A $DEL-UNDER

72  dup  alt-id" ^|8 "  DUP ALT  UP           HELPS/A $UP 
80  dup  alt-id" v|2 "  DUP ALT  DOWN         HELPS/A $DOWN 
75  dup  alt-id" <|4 "  DUP ALT  LEFT         HELPS/A $LEFT 
77  dup  alt-id" >|6 "  DUP ALT  RIGHT        HELPS/A $RIGHT 
71  dup  alt-id" Home"  DUP ALT  HOME         HELPS/A $HOME 
79  dup  alt-id" End "  DUP ALT  SET-LEAVING  HELPS/A $LEAVE 
38  dup  alt-id" AltL"  DUP ALT REPEAT-SEARCH HELPS/A $RPT-SRCH

19  dup  alt-id" AltR" DUP ALT REPEAT-REPLACE HELPS/A $RPT-REPL

116 dup  alt-id" Ctl>"  DUP ALT  STEP-FORWARD HELPS/A $WORD-FOR

115 dup  alt-id" Ctl<"  DUP ALT  STEP-BACK   HELPS/A $WORD-BACK

66  dup  alt-id" Fn8 "  DUP ALT  dir          HELPS/A $dir 
84  dup  alt-id" ShF1"  DUP ALT  cd           HELPS/A $SWAPDIR 
15  dup  alt-id" ShTb"  DUP ALT  TAB-LEFT     HELPS/A $TAB-L 
59  dup  alt-id" Fn1 "  DUP ALT  change-file  HELPS/A $swapfile 
113 dup  alt-id" AF10"  DUP ALT  stamp-txt    HELPS/A $stmptxt 
68  dup  alt-id" Fn10"  DUP ALT  toggle-stamp HELPS/A $stamp 
85  dup  alt-id" ShF2"  DUP ALT  save-editor  HELPS/A $save-ed 
61  dup  alt-id" Fn3 "  DUP ALT  scr>scratch  HELPS/A $scr>src 
62  dup  alt-id" Fn4 "  DUP ALT  scratch>scr  HELPS/A $s>scr 
63  dup  alt-id" Fn5 "  DUP ALT  >s-line#     HELPS/A $>s-line 
64  dup  alt-id" Fn6 "  DUP ALT  tplat>scr    HELPS/A $tmplt>scr 
65  dup  alt-id" Fn7 "  DUP ALT set-tplat-scr HELPS/A $set-tmplt 
67  dup  alt-id" Fn9 "  DUP ALT  toggle-case  HELPS/A $u/l-srch 
94  dup  alt-id" CtF1"  DUP ALT  shell        HELPS/A $shell 
60  dup  alt-id" Fn2 "  DUP ALT  switch-file  HELPS/A $switch 
 
init-tab-set            \ initialise tab setting controls 
 
;p 
\ get- set-attribs get-mode mode for non ANSI      sfp 07/06/90 
 
(( 
These words illustrate how to use the IOCTL functions in 
the SERVICES module. 
)) 
 
hex 
 
: get-attribs   \ -- n ; return current video attributes 
  0 0100 ioctl drop  ;                  \ from services module 
 
: set-attribs   \ n -- ; set current video attributes 
  1 0100 ioctl 2drop  ; 
 
: get-mode      \ -- n ; return video mode 
  030 0100 ioctl drop  ; 
 
: mode          \ n -- ; set video mode 
  031 0100 ioctl 2drop  ; 
 
 
\ pen paper for non ANSI drivers                   sfp 07/06/90 
 
hex 
 
: pen		\ col -- 
  0f and  get-attribs  f0 and  or  set-attribs  ; 
 
: paper		\ col -- 
  07 and 010 *  get-attribs  08f and  or  set-attribs ; 
 
decimal 
 
;p 
\ pen paper mode  for ANSI-DRIVERS                 sfp 07/06/90 
 
decimal 
 
: esc-seq       \ -- 
  27 emit  ; 
 
: pen           \ col -- 
  esc-seq  ." [3"  48 + emit  ascii m emit  ; 
 
: paper         \ col -- 
  esc-seq  ." [4"  48 + emit  ascii m emit  ; 
 
: mode          \ n -- 
  esc-seq  ." [="   48 + emit  ascii h emit  ; 
 
;s 
\  screen colours                                  nms 27/10/86 
 
0 constant black                1 constant blue 
2 constant green                3 constant cyan 
4 constant red                  5 constant magenta 
6 constant brown                7 constant white 
8 constant grey                 9 constant light-blue 
10 constant light-green         11 constant light-cyan 
12 constant light-red           13 constant light-magenta 
14 constant yellow              15 constant bright-white 
\ 
\       use:  BLACK PEN    WHITE PAPER  ......etc. 
\ 
 
: 80*25col      3 mode ;        : 80*25b/w      2 mode ; 
: 40*25col      1 mode ;        : 40*25b/w      0 mode ; 
: 320*200col    4 mode ;        : 320*200b/w    5 mode ; 
: 640*200       6 mode ; 
\ constants h-chars v-chars -- box                 sfp 07/06/90 
 
\ How to draw a simple box using the IBM character graphics set 
 
decimal 
 
201 constant top-left           200 constant bot-left 
205 constant h-char             186 constant v-char 
187 constant top-right          188 constant bot-right 
 
variable x1           variable x2 
variable y1           variable y2 
 
: h-chars       \ n -- ; draw a horizontal line 
  0 do  h-char emit loop ; 
 
: v-chars       \ n -- ; draw a vertical line 
  0 do  v-char emit  10 emit 8 emit  loop ; 
 
: box           \ x1 y1 x2 y2 -- 
  y2 !  x2 !  y1 !  x1 ! 
  x1 @ y1 @ gotoxy  x2 @ x1 @ - h-chars 
  x2 @ y1 @ 1+ gotoxy  y2 @ y1 @ - 1- v-chars 
  x2 @ y1 @ gotoxy top-right emit 
  x1 @ y1 @ 1+ gotoxy  y2 @ y1 @ - 1- v-chars 
  x1 @ y1 @ gotoxy top-left emit 
  x1 @ y2 @ gotoxy  x2 @ x1 @ - h-chars 
  x1 @ y2 @ gotoxy bot-left emit 
  x2 @ y2 @ gotoxy bot-right emit  ; 
 
;p 
\ file compare utility ................. sfp 14/11/89 
 
(( 
This utility allows two files to be compared. Unlike the DOS tool 
FCOMP assumes the files to be binary files, and does not stop 
after only 10 mismatches. 
 
Use in the form: 
  FCOMP <file1> <file2> 

By bad example this code illustrates the benefits of factoring.
)) 
 
decimal 
 
variable stop-flag	\ set when stopping required 
 
1024 constant 1K	\ constant 
 
pcb file1               \ first file 
pcb file2               \ second file 
 
: set-files     \ -- ; get filenames from input stream 
  file1 pathname  file1 open-path-pcb 
  if  cr ." Can't open file" file1 .pcb cr quit  endif 
  file2 pathname  file2 open-path-pcb 
  if  cr ." Can't open file" file2 .pcb cr quit  endif  ; 
 
: close-files   \ -- 
  file1 handle close-path drop
  file2 handle close-path drop  ; 
 
 
\ file compare utility - .word .byte               sfp 08/09/90 
 
: .word         \ n -- 
  base @ swap  hex                      \ switch to hex 
  0 <# # # # # #> type                  \ 4 hex digits. 
  base !  ;                             \ 
 
: .byte         \ n -- 
  base @ swap  hex                      \ switch to hex 
  0 <# # # #> type                      \ 2 hex digits. 
  base !  ;                             \ 
 
 
\ file compare utility .................        sfp nms july 86 
 
: comp-some     ( offset1 len -- offset2 ) 
  0 
  ?do here 1K + i + c@  here  i + c@ 
      2dup <> 
      if  cr ." offset " 2 pick 
          .word space .byte ascii : emit  .byte 
      else  2drop 
      endif 
      1+ 
      halt? dup stop-flag ! ?leave 
  loop  ; 
 
\ file compare utility .................        sfp nms july 86 
 
: fcomp         ( -- ; use fcomp <file1> <file2> ) 
  base @ >r hex  stop-flag off 
  set-files 
  cr ." File 1: " file1 .pcb  ."  File 2: " file2 .pcb 
  cr  0 
  begin  here 1K file1 handle read-path drop dup 1K = 
         here 1K + 1K file2 handle read-path drop dup 1K = 
         rot and  stop-flag @ 0= and 
    while   min comp-some 
  repeat 
  2dup <> 
     if min comp-some cr ." files have unequal lengths  " 
     else  2drop  endif 
  drop close-files  r> base !  cr cr  ; 
 
;p 
\ FILE-COMPRESS begin compilation ...............  nms 29/08/86 
 
(( 
This tool converts screen files to text files removing trailing spaces. 
 
Although not as comprehensive as the SCR2FTH utility, it is provided as 
as an example. 

Do not use as an example of good code
)) 
 
CR CR ." Wait ... compiling FILE-COMPRESS utility " CR CR 
 
: task ; 
 
SCREEN-pcb CONSTANT SOURCE-pcb		\ synonym 
 
pcb DEST-pcb  1 ALLOT			\ to hold character count 
 
create cr/lf    13 c, 10 c,		\ holds CR/LF pair 
 
: WHICH-FILE?	\ -- ; asks until user ready 
  BEGIN 
    CR CR ." Specify compressed file:  " 
    DEST-pcb QUERY pathname  "" .TXT" dest-pcb SET-EXT 
    CR CR 
    ." Ready to compress " SOURCE-pcb .pcb ."   to " 
    DEST-pcb .pcb  ."   ok? (y/n)  " Y/N? 
  UNTIL  ; 
 
: OPEN-DEST	\ -- ; delete o/p file, and create a new one 
  DEST-pcb p-name DELETE-path DROP	\ delete old o/p file if there
  DEST-pcb create-path-pcb		\ create new one 
  abort" Can't create output file "  ;	\ error if no create 
 
: write-path?	\ addr len handle --  
  write-path				\ write to file 
  abort" Write error on output file"	\ report error 
  drop ;				\ discard length written 
\ file compress 
 
: FILE-COMPRESS	\ -- ; compress current screen file 
  CR CR CR 
  ." Screen File Compress Utility"	\ sign on 
  CR CR ." using "  SCREEN-pcb .pcb	\ check source file is ok 
  ."  as source - OK? (Y/N) " Y/N? 0= 
  IF  EXIT  ENDIF			\ just get out if not 
  WHICH-FILE? OPEN-DEST 
  cr cr ." Compressing " SOURCE-pcb .pcb 
  ."  into "  DEST-pcb .pcb		\ check ALL ok 
  ."   OK? (Y/N) " Y/N? 0= 
  IF  EXIT  ENDIF			\ just get out if not 
  CR CR ." To cancel compression press <Esc>" cr cr 
  DISK-ERROR OFF			\ no error at start 
  0					\ starting block number 
  BEGIN  DISK-ERROR @ 0=		\ check for previous disk error 
         key?				\ if key pressed 
         if  key 27 <> and  endif	\ check for ESC key 
    WHILE  DUP BLOCK			\ read block 
           ." Screen " over .  13 emit	\ display number 
           16 0				\ for each line 
           DO  DUP 64 -TRAILING		\ strip trailing spaces 
               DEST-pcb handle write-path?		\ write out line 
               cr/lf 2 dest-pcb handle write-path?	\ add CR/LF 
               64 +					\ step address 
           LOOP 
           DROP				\ discard address 
           1+				\ increment block number 
  REPEAT 
  DROP					\ discard block number 
  dest-pcb close-path DROP		\ close output file 
  CR CR ." Compression complete."	\ all done, tell user 
  CR  ;	 
 
CR CR ." FILE-COMPRESS has been compiled." CR 
CR .free CR 
 
;p 
\ FILE-EXPAND ....................  nms 31/08/86 
 
(( 
FILE-EXPAND reverses the process performed by FILE-COMPRESS. 
Each line of the text file is expanded to 64 characters, and is 
then placed in the line of the file. 
 
Characters are read from DOS one at a time, which is slow. For 
performance a buffered read system should be used. In practice a 
512 byte buffer is adequate for floppy discs, but using at least 
the cluster size gives benefits. Using a buffer that is as big as 
a disc track can also give improvements. 
 
A hard disc track is usually 17 sectors, 17 * 512 bytes = 8704 bytes. 
)) 
 
: TASK ; 
 
CR CR ." Wait ... compiling FILE-EXPAND utility " CR CR 
 
VARIABLE CHAR-IN	\ -- addr ; character buffer 
PCB COMP-PCB		\ -- addr ; file PCB 
 
0 CONSTANT FALSE 
-1 CONSTANT TRUE 
 
: COMP-READ-BYTE	\ -- char status ; read one byte from file 
  CHAR-IN 1 COMP-PCB HANDLE READ-PATH           \ read 1 char 
  SWAP 1 <> OR  CHAR-IN C@ SWAP ; 
 
: SOURCE-FILE?		\ -- ; ask for source file 
  BEGIN 
    CR CR ." Specify Compressed file to expand " 
    comp-pcb QUERY pathname 
    "" .TXT"  comp-pcb SET-EXT 
    13 EMIT 
    ." Source file      = " comp-pcb .pcb 
    ."   - OK? (Y/N) : " Y/N? 
  UNTIL  ; 
 
: OPEN-SCREEN 		\ -- status ; false on error 
  TRUE 
  SCREEN-PCB OPEN-PATH-PCB 
  IF  CR CR ." Can't find " .SCR 
      ."  create it?  " Y/N? CR 
      IF  SCREEN-PCB CREATE-PATH-PCB 
          IF  CR  ." Can't create it" CR 
              DROP  1+ 
          ENDIF 
      ELSE  1+ 
      ENDIF 
  ENDIF  ; 
 
\ FILE-EXPAND open-comp .........................  nms 31/08/86 
 
: OPEN-COMP	\ -- status
  TRUE 
  comp-pcb open-path-pcb 
  IF  CR ." Can't find "  COMP-PCB .PCB 
      CR  DROP FALSE 
  ENDIF ; 
 
DECIMAL 
 
: LINEIN 	\ addr --- status ; true if error 
  FALSE  SWAP 
  65 0 
  DO  COMP-READ-BYTE			\ 0 addr b f -- 
      IF  DROP  NIP TRUE SWAP LEAVE 
      ELSE  DUP 13 <> 
            IF  32 MAX 127 MIN OVER I + C! 
            ELSE  DROP			\ read line feed 
                  COMP-READ-BYTE NIP 
                  IF  NIP TRUE SWAP  ENDIF 
                  LEAVE 
            ENDIF 
      ENDIF 
  LOOP 
  DROP  ; 
 
: SCREEN-FILE?	\ -- 
  FLUSH  SCR-handle CLOSE-PATH DROP 
  SCREEN-PCB PREV-PCB 64 CMOVE 
  BEGIN 
    CR CR ." Specify Screen file " 
    SCREEN-PCB QUERY PATHNAME  SCREXT 13 EMIT 
    ." Screen file      = " SCREEN-PCB .PCB 
    ."  - OK? (Y/N) : " Y/N? 
  UNTIL  ; 

: BLOCKIN 	\ block# -- status 
  TRUE  SWAP DUP ." Screen " . 13 EMIT 
  BLOCK DUP 1024 BLANK 
  16 0 
  DO  DUP LINEIN 
      IF  NIP FALSE SWAP LEAVE 
      ELSE  64 + 
      ENDIF 
  LOOP 
  DROP UPDATE  ; 
\ FILE-EXPAND main control ......................  nms 31/08/86 

: FILE-EXPAND	\ -- 
  CR CR CR 
  ." Text file expansion to Screen File"  CR 
  SOURCE-FILE?  SCREEN-FILE? 
  OPEN-COMP 
  IF  OPEN-SCREEN 
      IF  CR CR  ." Expanding " 
          COMP-PCB .PCB  SPACE ." into " .SCR 
          ."   OK (Y/N) " Y/N? 0= 
          IF  RE-OPEN 
              COMP-PCB HANDLE CLOSE-PATH DROP 
              EXIT 
          ENDIF 
          CR CR ." To cancel expansion press <Esc>" cr cr 
          0 
          BEGIN  DUP BLOCKIN 
                 key? 
                 if  key 27 <> and  endif 
            WHILE  1+ 
          REPEAT 
          DROP CR CR 
          FLUSH  SCR-HANDLE CLOSE-PATH DROP 
      ENDIF 
      RE-OPEN  COMP-PCB HANDLE CLOSE-PATH DROP 
  ELSE RE-OPEN DROP 
  ENDIF  ; 
 
CR CR ." FILE-EXPAND has been compiled." CR 
CR .free CR 
 
;p 
\ remvdu using serial i/o functions                sfp 15/05/90 

((
REMVDU implements a simple terminal emulator that displays
all characters received on the serial line, and transmits all
keystrokes to the serial line. Type ^B to leave the terminal
emulator.
))
 
: REMVDU        \ -- ; terminal emulator 
  cr cr ." Type ^B to leave terminal emulator" cr 
  ser-open                              \ public word
  BEGIN  ser-key? 
         if  ser-key emit  endif 
         key? 
         IF  KEY dup 2 = 
             if  ser-close  1 abort" REMVDU terminated"  endif 
             ser-emit 
         ENDIF 
         pause 
  AGAIN  ; 
 
;p 
\ screen file transfer utility ..................  sfp 15/05/90 
 
CR  .( Loading screen file transfer utility.) CR 

((
Implements SEND-FILE and RECV-FILE, a simple pair
of words that transmits screen files between computers
using the serial line.

Groups of blocks may be transferred using
SEND-BLKS and RECV-BLKS.
))
 
HEX 
 
: SEND-BLOCK    ( block# --- ) 
  ." ." 
  BEGIN  SER-KEY 0D =  UNTIL 
  BLOCK  0400 0 
  DO  DUP I + C@ SER-EMIT  LOOP 
  DROP ; 
 
: FETCH-BLOCK   ( block# --- ) 
  BLOCK  0D SER-EMIT  0400 0 
  DO  SER-KEY OVER I + C!  LOOP 
  DROP  UPDATE FLUSH  ." ."  ; 
 
: SEND-FILE     \ #blocks -- 
  CR  SER-OPEN  1+ 0 
  DO  I SEND-BLOCK  LOOP CR  ; 
 
: RECV-FILE     \ #blocks -- 
  CR  SER-OPEN  1+ 0 
  DO  I FETCH-BLOCK  LOOP 
  SER-CLOSE  CR  ; 
 
: SEND-BLKS     \ start-block# #blocks -- 
  CR  SER-OPEN  BOUNDS 
  ?DO  I SEND-BLOCK  LOOP 
  SER-CLOSE  CR  ; 
 
: RECV-BLKS     \ start-block #blocks -- 
  CR  SER-OPEN  BOUNDS 
  ?DO  I FETCH-BLOCK  LOOP 
  SER-CLOSE  CR  ; 
 
: SEND-ALL      \ -- 
  SER-OPEN  0 
  BEGIN  DISK-ERROR @ 0= 
    WHILE  DUP SEND-BLOCK  1+ 
  REPEAT 
  DROP  SER-CLOSE  ; 
 
DECIMAL 
 
;p 
\ remove duff characters from a screen             sfp 07/06/90 

((
Sometimes screen files have been corrupted by control files.
In this case it is desirable to have a filter that will remove
these characters and convert them to a space.

CLEAN-SCREEN and CLEAN-FILE implement this function.
))

hex 
 
: clean-screen  \ n -- ; clean block n 
  dup 
  cr ." Screen " .                      \ display screen # 
  block 0400 bounds                     \ for all chars 
  do  i c@ 020 <                        \ control character ? 
      if  bl i c!  update               \ replace with space 
          i .                           \ show which characters 
      endif                             \ 
  loop                                  \ 
  flush  ;                              \ write block back 
 
decimal 
 
: clean-file    \ clean up current text file 
  32767 0                               \ for all screens 
  do  i block drop                      \ test block 
      disk-error @ ?leave               \ read ok? 
      i clean-screen                    \ clean this screen 
  loop  ; 
 
;p 
\ select: ( like ON GOTO or Vector tables )......  nms 27/08/86 
 
\  n -- 
: select: 
  create  smudge , c-loop 
  does>  2dup @ u< not  abort" select out of range " 
         over + + 2+ @  execute ; 
 
\ select: example:- 
\ 
\    : CAT ." Cat " ;   : DOG ." Dog " ;   : RAT  ." Rat " ; 
\ 
\               3 SELECT: PET   CAT  DOG  RAT  ; 
\               0 PET   will execute  CAT 
\               1 PET   will execute  DOG 
\               9 PET   will print " select out of range" 
\ Random number generator, J. E. Rickenbacker 
\ FORTH DIMENSIONS II/2 PAGE 34 
decimal 
 
VARIABLE SEED  0 SEED ! 
 
: (RAND)  ( -- n ) 
    SEED @  259 *  3 +  32767 AND 
    DUP SEED ! 
; 
: RANDOM  ( n -- random# )   \ psudo-random number within range 
    (RAND) 32767 */ 
; 
 
\ Multi-dimensional array definition, by Joel Shprentz 
 
: *ARRAY                \ n1..nn #nn -- 
  dup 1 255 within?  not   ( must be at least 1 dimension ) 
  abort" wrong dimensions" ( but less than 255 of them ) 
  CREATE 
    DUP C,              ( save # of dimensions ) 
    1 SWAP              ( initialize total size ) 
    0 ?DO               ( loop on # of dimensions ) 
      OVER ,            ( save dimension ) 
      *                 ( increase total size ) 
      LOOP 
    1 ,                 ( save dummy dimension ) 
    2* ALLOT            ( allocate space for words ) 
 
  DOES> 
    COUNT               ( get # of dimensions ) 
    0 SWAP              ( initialize offset ) 
    0 ?DO               ( loop on # of dimensions ) 
      >R                ( save offset ) 
      2DUP @ U< NOT     ( error if negative index ) 
      ABORT" wrong index value" ( error if index too large ) 
      2+ DUP @          ( advance to next dimension ) 
      ROT R> + *        ( calculate offset so far ) 
      LOOP 
    2*                  ( double offset for words ) 
    + 2+ ;              ( calculate element address ) 
 
(( 
Multi-dimensional arrays, examples 
 
To define an array, the vector size for each dimension 
must be on the stack followed by the total # of dimensions. 
Example:  to define a 3 dimensional array named MATRIX with 
a vector length of 5 in each dimension (i.e. x, y, z = 0...4) 
you would execute: 
        5  5  5  3  *ARRAY  MATRIX 
 
To get an indexed address into the array, put the coordinates 
on the stack followed by the name of the array. 
Example:  to retrieve the value stored in (x,y,x) = (1,2,3) 
for the array above, you would execute: 
        1  2  3  MATRIX  @ 
)) 
\ Trig lookup routines with Sine * 10000 table 
 
\ Based on article by J S JAMES in FORTH DIMENSIONS IV 1 
 
: TABLE		\ values n ... ; create data table 
  CREATE  0 ?DO , LOOP  \ compile data elements 
  DOES> SWAP 2* + @ ;   \ return a value 
 
\ Create a table of sine of 0-90 degrees 
10000 9998 9994 9986 9976 9962 9945 9925 9903 9877 
 9848 9816 9781 9744 9703 9659 9613 9563 9511 9455 
 9397 9336 9272 9205 9135 9063 8988 8910 8829 8746 
 8660 8572 8480 8387 8290 8192 8090 7986 7880 7771 
 7660 7547 7431 7314 7193 7071 6947 6820 6691 6561 
 6428 6293 6157 6018 5878 5736 5592 5446 5299 5150 
 5000 4848 4695 4540 4384 4226 4067 3907 3746 3584 
 3420 3256 3090 2924 2756 2588 2419 2250 2079 1908 
 1736 1564 1391 1219 1045 0872 0698 0523 0349 0175 
 0000 ( 91 data elements on stack ) 91 TABLE SINTABLE 
 
 
\ degrees -- sine*10000 ; sine of 0-180 degrees 
: S180          DUP 90 >                   ( 91-180 degrees ? ) 
                IF  180  SWAP - ENDIF      ( Subtract from 180 ) 
                SINTABLE  ; 
 
\ degrees -- sine*10000 
: SIN           360 MOD                    ( +360<n>-360 ) 
                DUP 0< IF 360 + ENDIF      ( if -ve add 360 ) 
                DUP 180 > 
                IF  180 - S180 NEGATE      ( 180<n>360 ) 
                ELSE  S180 
                ENDIF ; 
 
\ degrees -- cosine*10000 
: COS           360 MOD  90 + SIN  ; 
 
\ n -- ; plot a line of n stars 
: plot		cr  0 
		do  ascii * emit  loop  ; 
 
\ -- ; plot a wave 
: wave		360 0 
		do  i sin 300 / 40 + plot  5 +loop 
		cr  ; 
 
;p 
\ break-on break-off break? .......................sfp 15/05/90 
 
hex 
 
code break-on   \ -- 
  ax, # 03301 mov  dl, # 01 mov  021 int  \ enable ^C check 
  ax, # 02523 mov  dx, # 104 mov  021 int \ install ^C restart 
  next,   end-code                        \ done 
 
code break-off  \ -- 
  ax, # 03301 mov  dl, # 0 mov  021 int   \ disable ^C check 
  next,   end-code 
 
code break?     \ -- flag 
  ax, # 03300 mov   021 int               \ ask DOS if enabled 
  dh, dh xor   dx push                    \ return flag 
  next,   end-code                        \   0=disabled 
 
;p 
\ US date format .............................  nms  feb  86 
 
decimal 
 
: US-DATE       \ -- addr len  ; US date format   MM/DD/YY 
  (DATE) 1900 - 
  0 <# # #   2DROP   ASCII / HOLD  SWAP 
  0 # #      2DROP   ASCII / HOLD 
  0 # # #> 
  ROT  DROP  ; 
 
: mm/dd/yy 
  ASSIGN US-DATE TO-DO  FMT-DATE  ; 
 
mm/dd/yy 
 
;p 
\ beep                                  sfp 15/05/90 
 
hex 
 
code beep	\ frequency 1/100-sec -- 
  al, # 0b6 mov  043 al out     \ write timer mode register 
  dx, # 012 mov ax, # 03280 mov \ timer divisor = 533h*896/freq 
  cx pop  cx, # 14 cmp a,       \ feequency must be > 13h 
  if,  cx div                   \ divide by 533h*896 
     042 al out                 \ write timer 2 count low byte 
     al, ah mov  042 al out     \ write timer 2 count high byte 
     al, 061 in  ah, al mov     \ get current port B save in AH 
     al, # 03 or 061 al out     \ turn speaker on 
l$1: 1000 times, loop, 
     bx dec  l$1 jnz		\ delay 
     al, ah mov  061 al out     \ turn speaker off 
  endif, 
  bx pop   next,   end-code 
decimal 
 
 
\ test-beeper                                      sfp 15/05/90 
 
decimal 
 
: test-beeper   \ -- ; produces sliding tone 
  4000 0 
  do  i 40 beep 
      1000 0 do loop 
  100 +loop ; 
\ various tones                           nms 20:18:41 13/12/86 
 
decimal 
 
: EXIT-TONE	 \ -- ; de da de 
  880 5 beep  440 10 beep  880 5 beep  ; 
 
: PAUSE-TONE    \ -- ; growl 
  41 40 beep  ; 
 
: IG-TONE       \ -- ; eep 
  783 8 beep  ; 
 
: DONE-TONE	\ -- ; de del eet de del eet charge! 
  2 0 
  DO  220 10 BEEP  440 10 BEEP  880 30 BEEP  LOOP  ; 
 
: POOP-TONE	\ -- ; falling 
  1680 0 
  DO  2000 I - 1 BEEP  60 +LOOP  ; 
 
: ERR-TONE	\ -- ; oh no! 
  1046 5 BEEP  523 15 BEEP  ; 
 
: DROP-TONE     \ -- ; pip 
  1760 8 BEEP  ; 
 
: WARN-TONE     \ -- ; what? 
  1680 41 
  DO  I 1 BEEP  I 2/  +LOOP ; 
 
: NOTE-TONE	\ -- ; droop 
  1680 0 
  DO  2000 I - 1 BEEP  150 +LOOP  ; 
 
;p 
\ vars - usage 
 
(( 
A VAR is a word that acts like a variable in other languages. 
If used by without a modifier, the value will be returned. When 
a VAR is created, its initial value is zero. 
 
Modifiers must be used before the VAR, and are '->' to store a 
value, and 'at' to return the address. The example below shows 
how VARS are used. 
 
VAR Q1                          \ initial value will be 0 
VAR Q2 
VAR Q3 
5 -> Q1  3 -> Q2                \ set up initial values 
Q1 Q2 * -> Q3  Q3 .  at Q3 ?    \ process them 
)) 
 
 
\ modifier                                         sfp 15/05/90 
 
\ ACTION holds the DEMANDED-ACTION of a VAR 
variable action 
 
: modifier      \ -- ; builds an action descriptor 
  create  ?exec !csp smudge             \ checks 
          immediate                     \ result is immediate 
          asm-on                        \ turn assembler on 
          r> drop ['] (a-loop) >body >r \ switch loops 
  does> action !  ;                     \ stash action address 
 
(( 
Use in the form: 
modifier <name> 
  <code definition ......>  end-code 
)) 
 
modifier v@     \ addr -- n ; returns contents data structure 
  bx, 0 [bx] mov   next,   end-code     \ fetch contents 
v@                                      \ initialise 
 
modifier ->     \ addr n -- ; stores into a var 
  0 [bx] pop   bx pop   next,   end-code 
 
modifier at     \ addr -- addr ; return address 
  next,   end-code                      \ all done 
 
modifier +=     \ n addr -- ; add n to addr 
  ax pop   0 [bx], ax add   bx pop 
  next,   end-code 
\ var-sub                                          sfp 18/05/90 
 
hex 
 
lbl: var-jmp    \ -- addr 
  bx push   ax, # 3 add   bx, ax mov 
  next,   end-code 
 
: lay-jmp       \ addr -- ; compile JMP to given address 
  0E9 c,  here 2+ - ,  ; 
 
 
\ the VAR-RUN array holds the DEMANDED-ACTION, the 
\ ADDRESS and EXIT. It is used for execution of a VAR. 
create var-run  ] noop var-run exit [ 
 
: var           \ -- ; builds a var 
  create  immediate                     \ result is immediate 
          var-jmp lay-jmp  0 ,          \ action & allocation 
  does>  state @ 
         if  ,  action @ ,              \ lay structure & action 
         else  var-run !                \ set structure CFA 
               action @ var-run 2+ !    \ store address 
               var-run >r               \ will jump there! 
         endif 
         [compile] v@  ;                \ reset action 
\ user-vars - use and structure                    sfp 15/05/90 
 
(( 
USER-VARS are used in the same ways as VARS, except that the 
parameter specifies the offset into the user table. 
 
The modifiers '->' and 'at' are used as before: 
 
6 user-var trial-s0             \ offset 6 in table 
 
5 -> trial  trial .             \ set value and check it 
 
As with VARS, the implementation is by multiple code field 
words, which allows fetches and stores to be faster than 
in a conventional system. 
)) 
 
hex 
 
lbl: uservar-jmp        \ -- addr 
  bx push                               \ save TOS 
  bx, ax mov   bx, 3 [bx] mov           \ get offset 
  bx, di add                            \ add user base address 
  next,   end-code 
 
: user-var      \ n -- ; builds a USER var 
  create  immediate                     \ result is immediate 
          uservar-jmp lay-jmp  ,        \ action & allocation 
  does>  state @ 
         if  ,  action @ ,              \ lay structure & action 
         else  var-run !                \ set structure CFA 
               action @ var-run 2+ !    \ store address 
               var-run >r               \ will jump there! 
         endif 
         [compile] v@  ;                \ reset action 
 
\ local variables as vars in a local frame 
 
(( 
The following code implement local variables. 
A local variables frame is used for the variables, allowing 
them to be used interactively. The frame is reclaimed when the 
word that allocated the frame exits. 
 
Request 4 local variables: 
 
: t     4 locals  5 -> lv$0  3 -> lv$1  lv$0 lv$1 * .  ; 
 
Ten words that refer to local variables are predefined. 
Additional ones are allocated by the word LOCAL-VAR e.g: 
 
11 local-var lv$11 
)) 
 
decimal 
 
create local-buffer  200 allot 
create local-base  local-buffer ,  0 ,  \ pointer and size 
 
lbl: localvar-jmp       \ -- addr 
  bx push                               \ save TOS 
  bx, ax mov   bx, 3 [bx] mov           \ get offset 
  bx, local-base add                    \ add user base addre 
  next,   end-code 
 
: local-var     \ n -- ; builds a USER var 
  create  immediate                     \ result is immediate 
          localvar-jmp lay-jmp  2* ,    \ action & allocation 
  does>  state @ 
         if  ,  action @ ,              \ lay structure & action 
         else  var-run !                \ set structure CFA 
               action @ var-run 2+ !    \ store address 
               var-run >r               \ will jump there! 
         endif 
         [compile] v@  ;                \ reset action 
\ local variables with automatic clean up 
 
: locals                                \ n -- ; ask for n vars 
  local-base 2@                         \ save current value 
  local-base 2+ @  local-base +!        \ step by old size 
  local-base @ 2!                       \ save old value 
  4 local-base +!                       \ step over return frame 
  2* local-base 2+ !                    \ update frame size 
  r>  ['] -locals >body >r  r>  ;       \ insert -locals 
 
: -locals                               \ tidy up ; real dirty 
  local-base @ 4 - 2@ local-base 2!  ;  \ restore old frame 
 
 
\ predefined local variables .................................. 
 
0 local-var lv$0                1 local-var lv$1 
2 local-var lv$2                3 local-var lv$3 
4 local-var lv$4                5 local-var lv$5 
6 local-var lv$6                7 local-var lv$7 
8 local-var lv$8                9 local-var lv$9 
 
(( 
\ local variable examples 
: t     5 locals  4 -> lv$0  lv$0 . ; 
 
: t2    10 locals  10 -> lv$0  lv$0 . t  ; 
 
: t3    4 locals  5 -> lv$0  3 -> lv$1  lv$0 lv$1 * .  ; 
)) 
 
;p 
\ set file size                           nms 11:38:33 17/02/87 
 
(( 
This word truncates a file to the given size by seeking to the 
required position, and then writing 0 bytes to the file. A quirk 
of DOS is that writing 0 bytes to a file truncates it to that 
position. Because of that quirk, the Modular Forth WRITE-PATH 
word detects this condirion and does nothing if zero length 
is required. 
)) 
 
hex 
 
code (set-file-size)    \ size(32b) handle --  status 
  ax, # 04200 mov               \ dos function 42, seek offset 0 
  ( bx pop )  cx pop  dx pop    \ get parameters 
  021 int                       \ call dos to move file pointer 
  ncy,                          \ error? 
  if,                           \ if no error 
     ax, # 04000 mov            \    dos function 40, write 
     cx, cx sub                 \    length of zero 
     021 int                    \    call dos, write 0 len 
     ncy, if, ax, ax sub endif, \    if no error, clear AX 
  endif,                        \ 
  ( ax push ) bx, ax mov        \ return status 
  next,   end-code              \ finish 
decimal 
\ #words in - counts words in vocabulary           sfp 14/11/90 
 
: #words        \ voc-cfa -- n 
  0 swap                                \ start count at 0 
  dup >threads                          \ 0 voc-cfa threads 
  swap >#threads @ 2*                   \ 0 threads #threads*2 
  bounds				\ for each thread 
  ?do  i                                \ n addr 
       begin  @ ?dup			\ if word exists 
         while  n>link			\ get next one 
                swap 1+ swap		\ and count 
       repeat 
  2 +loop  ;				\ until all threads done 
 
: in            \ -- ; in <voc> 
  ' #words ." there are " . ." words"  ; 
\ open-sys-file - from any module                  sfp 04/03/91 
 
decimal 
 
create forth-dir  128 allot 
 
: open-sys-file \ addr -- handle 0 | status 
  dup $>asciiz open-path                \ in default dir? 
  IF  forth$  cs> forth-dir             \  copy MF3 dir name 
      2over c@l 1+ cmovel               \ 
      forth-dir $+                      \ add file name 
      forth-dir $>asciiz open-path      \ try forth dir? 
  ELSE  nip  0                          \ drop $addr 
  ENDIF  ; 

\ measure system speed

\ This measurement is based on detecting transitions of the 32-bit timer
\ count at address 040:06C in the BIOS data area.

hex

: tick		\ -- n ; only interested in transitions
  040 06C c@l  ;

: speed		\ -- speed ; return measure of system speed
  0					\ initial speed value
\
\ wait for first transition
  tick					\ first reading
  begin  tick				\ next reading
	 2dup =				\ if same
    while  drop				\ discard 2nd
  repeat
  nip					\ at end use final reading
\
\ count until next transition
  begin  tick over =			\ while still the same
    while  swap 1+ swap			\ increment count
  repeat
  drop  ;				\ discard counter value

;p 

