\ help system for xshell 3

Notes:
  page 2 is for master module
  pages 3 ... are slave module

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  help system calls for master module

headers

extern where/help-sys

variable help# public

: #help			\ n -- ; set the number of the message to use in future
  help# !			\ set message number
; public

headers

: more-help    		\ -- ; do the help system
  save-win			    	\ preserve location
  create-helpsys-window		    	\ create new window
  helpsys-handle to-window	    	\ go into it
  1 where/help-sys			\ help is fn#1
  helpsys-handle  from-window	    	\ quit window
  delete-helpsys-window		    	\ remove new from list
  rest-win			    	\ into old window
; public

: where?		\ -- ; set editor to error position
  2 where/help-sys		\ get the parameters
  page-no !			\ set page number to that of error
  line-no !			\ set line number to that of error
  1 col-no !			\ dont know column, use 1
;

behead

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  help system for services module

\ -----End of Page-----
\ -- R.G.G -- 25/4/91 --  set-op-handle

: spare-keys		\ -- ; consume extra keys in this module
  begin
    key?			\ while there are keys
  while
    key drop			\ ignore them
  repeat                                                        
;                                                               

: set-op-handle		\ handle -- ; set the handle for this module
  op-handle !
; public

\ -----End of Page-----
\ -- R.G.G -- 13/06/90 --  externs and variables

extern help#	  		\ the message number

extern shell-mode		\ which mode the master is in

extern  helpsys-handle		\ the window number


variable this-handle		\ temporary handle number
variable help-handle		\ the handle for the window to use
variable nul-handle		\ the handle of the nul file
variable first-call		\ is this the first call to the system?
  first-call off			\ default `yes'
variable found			\ says the file is found

pcb help-file			\ the name of the help file

\ -----End of Page-----
\ -- R.G.G -- 13/07/90 --  more

: more			\ -- ; pause for the user to read text, then scroll
  bl tib c!			\ overwrite the /p word which was found
  bl tib 1+ c!
  cr
  cr ."    More...."		\ say there is more to come
  spare-keys			\ avoid sillies
  key drop			\ and waitr for user
  spare-keys			\ avoid sillies
;
 
\ -----End of Page-----
\ -- R.G.G -- 4/10/90 --  ?pause

: ?pause		\ -- t/f ; should we pause on this line?
  tib c@ ascii / =		\ is there a /
  tib 1+ c@ ascii p =		\ and a lower-case p
  and
;

\ -----End of Page-----
\ -- R.G.G -- 4/10/90 --  .line

: .help-line 		\ -- ; maybe print this line of the file
  ?pause			\ is this line a /p ?
  if
    more			\ do more
  else
    tib #tib @ type cr		\ else print line
  endif
;

\ -----End of Page-----
\ -- R.G.G -- 5/10/90 --  redirect

: redirect			\ -- ; send o/p to nul for a while
  "" nul" $>asciiz open-path
  drop 
  dup op-handle !			\ redirct to nul
  nul-handle !
;

\ -----End of Page-----
\ -- R.G.G -- 5/10/90 --  close-nul

: close-nul			\ -- ; finished with nul file now
  nul-handle @ close-path drop
;

\ -----End of Page-----
\ -- R.G.G -- 4/10/90 --  .help

only forth also from-voc also forth definitions

: .help			\ page# -- ; show this page of help
  blk @ >r  >in @ >r #tib @ >r			\ save for screen files
  dup cs> pad  get-stream next-file		\ get file
  dup ?error     								\ open next file
  close-nul
  help-handle @ op-handle !			\ back to window
  begin
    next-line            			\ read line
  while 
    .help-line	 				\ act on line
  repeat                               		\
  prev-file dup ?error        			\ previous file
  r> #tib !  r> >in !  r> dup blk !        	\ restore saved data
  0=                                    	\ keyboard?
  if  #tib off  >in off  endif         		\ yes; clear tib
;

only forth definitions

\ -----End of Page-----
\ -- R.G.G -- 13/06/90 --  (help-sys)

: (help-sys)		\ n -- ; display this help text
  case
    00 of 01 .help	endof		\ depending which is required
    01 of 02 .help	endof
    02 of 03 .help	endof
    03 of 04 .help	endof
    04 of 05 .help	endof
    05 of 06 .help	endof
    06 of 07 .help	endof
    07 of 08 .help	endof
    08 of 09 .help	endof
    09 of 10 .help	endof
    10 of 11 .help	endof
    11 of 12 .help	endof
    12 of 13 .help	endof
    13 of 14 .help	endof
    14 of 15 .help	endof
    15 of 16 .help	endof
    16 of 17 .help	endof
    17 of 18 .help	endof
    18 of 					\ for this one
         0 mod-seg >es shell-mode e@		\ also test the mode
         case
           0 of 19 .help endof			\ host
           1 of 20 .help endof			\ target
           2 of 21 .help endof			\ compiler
           3 of 22 .help endof			\ umbilical
         endcase
       endof
    19 of 23 .help	endof
    20 of 24 .help	endof
    21 of 25 .help	endof
    22 of 26 .help	endof
    23 of 27 .help	endof
    24 of 28 .help	endof
    25 of 29 .help	endof
    26 of 30 .help	endof
    27 of 31 .help endof
    28 of 32 .help endof
    29 of 33 .help endof
    30 of 34 .help endof
    31 of 35 .help endof
    32 of 36 .help endof
    33 of 37 .help endof
  endcase
  spare-keys
  key drop	      		\ wait for user
  spare-keys
;

\ -----End of Page-----
\ -- R.G.G -- 4/10/90 --  open-help-file

: open-help-file		\ -- t/f ; true:- can find file
  0 mod-seg forth-buff				\ source seg/off
  cs> pad					\ dest seg/off
  0 mod-seg forth-buff c@l 1+ cmovel 		\ length and long move
  "" HELPTXT.XS3" pad $+			\ add the name of the help file
  first-call @ 0=				\ if this is the first call
  if
    pad help-file set-pathname			\ then set the name
    help-file open-path-pcb 0=			\ try to open it
    help-file close-path-pcb 0=			\ and try to close it
    and						\ combine results
    dup found !					\ and say we either can or cant
    first-call on				\ now we have done this
  else
    found @					\ just return the previous result
  endif
;

\ -----End of Page-----
\ -- R.G.G -- 13/06/90 --  help-sys

hex

: help-sys     		\ -- ; show more help
  op-handle @	this-handle !		\ preserve o/p channel
  es>
  0 mod-seg >es				\ preserve es				
  helpsys-handle e@ dup op-handle !	\ use help window
  help-handle !				\ spare copy for later
  help# e@				\ get message number
  swap >es				\ restore es
  redirect				\ go to nul to open the file
  open-help-file			\ can find help file?
  if
    (help-sys)	       			\ do help system
  else
    drop									\ tidy up
    this-handle @ op-handle !
    cr cr ." Error: Can't open help file HELPTXT.XS3" 	\ say so
    cr cr ." Press any key to continue." 		\ what to do next
    key drop					     	\ wait for user
  endif
  this-handle @ op-handle !	  	\ restore channel
;

only forth also from-voc also forth definitions

: where			\ -- line# page# ; return position from `from'
  ip-page-line# @			\ get line in page
  ip-page# @				\ get page number
;

only forth definitions

: where/help-sys	\ fn# -- ??? ; either context-help or .where
  case
    1 of help-sys  endof		\ fn#1 is help system
    2 of where	   endof		\ fn#2 is .where parameters
  endcase
; public
