\ hex converter code for xshell3


\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  code for master module

: del-fred		\ -- ; delete the fred module
  fred-loaded off		\ say it is deleted
  1 del-mod# drop		\ and delete it
;

: get-fred		\ -- ; load the fred module
  forth-buff $>pad	    		\ make forth path
  "" FRED.XS3" pad $+	   		\ and add module name
  pad 1 reload-mod# 	   		\ get module
  0= fred-loaded !	    		\ set flag to say so
  es>
  cs> >es resolve-links	   		\ resolve for master module
  1 mod-seg >es resolve-links		\ resolve for fred.xs3
  >es
;

extern (bin2hex)

extern set-fred-handle

: .press		\ -- ; message to press any key
  ."  Press any key to continue"    
;

: bin2hex		\ -- ; convert by making call to fred module
  save-win		    		\ preserve window
  create-bin-window	    		\ new window
  curr-handle to-window	    		\ use new window
  base @ >r hex		    		\ required base
  get-fred		    		\ load the module
  op-handle @ set-fred-handle		\ set window handle for fred
  (bin2hex)		    		\ get prompts, etc and do it
  del-fred				\ delete the module again
  r> base !		    		\ back to previous base
  spare-keys		    		\ any keys the user may have pressed
  curr-handle from-window   		\ exit this window
  delete-curr-window	    		\ remove it
  rest-win		    		\ back to old one
  reset-attribs
;

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  intel hex converter for xs3 slave module

: set-fred-handle	\ handle -- ; set the  window handle passed by master
  op-handle !
; public

extern loud			\ whether to be noisy or not

all from-file tones		\ get the noise code required

: no-act		\ -- ; beep for wrong key
  wrong-tone
;

extern yellow			\ words to go to certain colours
extern red
extern dark

extern #help			\ the help message number
extern window#			\ the window to use
extern ser-emit			\ how to send to the serial port
extern more-help		\ the help code

: spare-keys		\ -- ; consume any spare keys
  begin
    (key?)			\ while there are keys
  while
    (key) drop			\ get them and ignore them
  repeat
;

all from-file editor		\ get the text entry editor

\ -----End of Page-----
\ -- R.G.G -- 13/06/90 --  .press

: .press		\ -- ; message for user
  ."  Press any key to continue"
;

\ -----End of Page-----
\ -- R.G.G -- 13/06/90 --  data structures

\ headerless

HEX                                                             

010  constant line-length		\ no of bytes in a line
0200 constant buffer-length		\ length of the file buffer

pcb bin-source    			\ the source file name
pcb hex-dest				\ the destination file name

variable port#				\ -- addr ; which port to write to

create load-buffer  buffer-length allot	\ the file buffer

create $bin-name			\ string for name of bin file
  40 allot  $bin-name off			\ default
create $hex-name			\ string for name of hex file
  40 allot  "" TARGET.HEX" $hex-name $move	\ default
create addr$
  20 allot     "" 0000" addr$ $move		\ default

variable checksum			\ checksum so far
variable length
variable record                                               
variable target-address       
variable host-address         

variable record#

\ -----End of Page-----
\ Intel hex down loader  ....................       rg 25/10/87 
                                                                
: bin-ascii		\ 8b -- char ; convert nibble to ascii char
  0f and  dup 9 >		\ if 0..9
  if
    037 +
  else
    030 +			\ if a..f
  endif  
;                
                                                                
: byte-ascii		\ byte -- lsc msc ; convert byte to ascii
  dup bin-ascii
  swap 010 /  bin-ascii  
;         
                                                                
: sum			\ data -- ; advance checksum
  checksum +!  
;                                  

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  intel hex down loader

: byte-target		\ byte -- ; send one byte
  0ff and dup sum                                 
  byte-ascii emit emit  
;           
                                                                
: send-header       	\ -- ; send line header
  ascii : emit
  checksum off  
;                
                                                                
: record-length		\ -- ; send record length
  length @ byte-target  
;                         
                                                                
: start-address		\ -- ; send start address
  target-address @ 0 0100 um/mod                  
  byte-target  byte-target  
;                     
                                                                
: type-of-record	\ -- ; send type (line/end)
  record @ byte-target  
;                        

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  intel hex down loader
                                                                
: data			\ -- ; send data
  host-address @ length @ +   host-address @      
  do
    i c@ byte-target			\ send each byte in turn
  loop  
;                 
                                                                
: send-check  	 	\ -- ; send checksum
  checksum @ negate byte-target                   
  checksum off  
;                                 
                                                                
: send-record		\ -- ; send one record
  send-header			\ the header
  record-length 		\ the length
  start-address              	\ the address
  type-of-record		\ the type
  data				\ the data
  send-check			\ the checksum
  cr  				\ ready for next line
;        
                                                                
: send-last-record	\ --; send final record
  length off  target-address off  1 record !      
  send-header
  record-length
  start-address              
  type-of-record
  send-check
  cr
  record off  
; 

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  intel hex down loader

: .record#	    	\ -- ; screen progress record
  op-handle @		    		\ preserve file handle
  base @ >r decimal	    		\ print in decimal
  es> 0 mod-seg >es
  window# e@ op-handle !    		\ use window
  >es
  1 5 gotoxy		    		\ nice place in window
  ." record: " record# ?    		\ get record#
  r> base !		    		\ reset base
  op-handle !
;
                                                                
: send-blocks		\ -- ; send the data
  record# off				\ start at record 0
  begin
    load-buffer buffer-length bin-source handle read-path   \ read some  binary
    0= swap  0<>  and			\ see if we read ok
   while 
    load-buffer host-address !		\ while there is source file
    line-length length !		\ set the line length
    buffer-length line-length / 0	\ divide into lines per buffer
    do					\ for each record in a buffer
      1 record# +!			\ increment count
      .record#				\ show progress
      send-record			\ send the record
      line-length host-address +!	\ increment the address
      line-length target-address +!	\ and this address
    loop                                                  
  repeat  				\ next buffer
;                                                     

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  Intel hex down loader

: open-source		\ -- t/f ; source opened
  $bin-name bin-source set-pathname	\ set filename
  bin-source open-path-pcb dup		\ try to open file
  if
    cr ."  Can't open source file"	\ say so
  endif
  0=
;

: create-dest		\ -- t/f ; file created
  hex-dest create-path-pcb		\ try to create
  0=			  		\ true for success
;

: ?comm-port		\ -- ; was a comms port specified
  $hex-name "" AUX" 4 s=	\ if destination file name is this
  if port# on endif		\ then set the port on
;

: open-dest		\ -- t/f ; true:- create the file
  $hex-name hex-dest set-pathname		\ set filename
  hex-dest open-path-pcb			\ try to open file      
  0=				     		\ if it exists          
  hex-dest handle close-path			\ try to close file  
  0= and			     		\ if can do both
  if
     error-tone					\ say so
     cr ."  Hex file " hex-dest .pcb ."  already exists."     
     cr ."  Overwrite it (y/n)?"		\ should we overwrite  
     y/n?			     		\ yes to create file
  else
     -1				     		\ may create the file         
  endif                                                         
;

hex

: down-load	    \ -- ; download the file
  open-source	     		\ open source file
  if
    port# @ 0=			\ if we want a file
    if
      open-dest	     		\ test destination file
    else
      -1	     		\ pretend have opened it, if COMn
    endif
    if
      port# @ 0=		\ create file if one needed
      if
        create-dest  		\ create it
      else
        assign ser-emit to-do emit 	\ else use serial driver
        -1
      endif
      if
        es> 0 mod-seg >es
        op-handle @ window# e!			\ preserve window
        >es
        hex-dest handle op-handle !		\ o/p to file
        send-blocks		   		\ actually send data
        bin-source handle close-path drop	\ close source file
        send-last-record		 	\ send last record
        hex-dest handle close-path drop		\ close hex file
        es> 0 mod-seg >es
        window# e@ op-handle !    	 	\ return to window
        >es
      endif
    endif
  endif
;                                      

: addr$>number		\ -- t/f ; make address number
  00						\ dummy fail flag
\  -1 addr$ c+!					\ decrement count to just number
  base @ >r hex
  addr$ number?					\ try to convert
  r> base !
  case
    00 of cr ."  Invalid number"  	endof	\ bad number
    01 of      target-address ! drop -1	endof	\ ok - single
    02 of drop target-address ! drop -1	endof	\ ok - double
  endcase
;

decimal

\ headers

: (bin2hex)		\ -- ; do the whole thing
  action-of emit				\ preserve the current emit acton
  port# off					\ writing to a file
  17 #help pick-option on
  ."  Enter source binary file:   "  		\ prompt
  $bin-name ed-$				\ get file name
  if
    $bin-name here>$				\ reset string
    02 #help  pick-option on
    cr ."  Enter destination hex file: "  	\ next prompt
    $hex-name ed-$				\ get string
    if
      $hex-name here>$				\ reset string
      ?comm-port				\ test if a comms port specified
      03 #help
      cr ."  Enter destination address:  "	\ next prompt
      addr$ ed-$				\ get address as string
      if
        addr$ here>$				\ reset string
        addr$>number				\ convert to number
        if					\ if valid number
          down-load				\ then finally download file
        endif
        cr red 10 spaces .press dark		\ wait for user
        (key) drop				\ 
      endif
	endif
  endif
  to-do emit					\ reset the emit action
; public

\ behead


