\ initialisation code for xs3

\ -----End of Page-----
\ -- R.G.G -- 26/9/90 --  standard-attribs

: w-attribs		\ -- body border header ; return the window attribs
  window-attrib @		\ body colour
  border-attrib @		\ border colour
  header-attrib @		\ header colour
;
  
\ -----End of Page-----
\ -- R.G.G -- 12/06/90 --  del-window

headerless

: del-window   		\ addr -- ; delete the named window
  @ delete-window drop		\ get handle and delete window	
;

: cr-window		\ a1 a2 a3 x y w h $addr h-addr -- ; create one
  dup  create-window 0=	     	\ try to create window
  if
    swap !		     	\ store handle 
  else
    drop		     	\ or tidy up
  endif
  >r			     	\ preserve addr of handle
  >r 2line-border cs> r> r@ @	\ x y w h $addr handle -- 
  define-window drop	     	\ define the window
  r> @ attribs-window drop   	\ assign colours
;

headers

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  delete-curr-window

: delete-curr-window	\ -- ; delete this window
  curr-handle del-window
;

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  create-time-window

: create-time-window	\ -- ;
  w-attribs 6 6 33 6 "" Time" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  create-host-window

: create-host-window	\ -- ;
  create-window  0=		\ try to create window
  if
    host-handle !	      	\ stash handle
  else
    drop		      	\ or drop
  endif
  0 1 80 #rows @ 1- 0 0  
  0 0 host-handle @ define-window drop	\ define the window
;

: delete-host-window	\ -- ;
  host-handle del-window
;

\ -----End of Page-----
\ -- R.G.G -- 25/06/90 --  create-api-window

: create-api-window	\ -- ;
  create-window  0=	  	\ try to create window
  if
    api-handle !	  	\ stash handle
  else
    drop		  	\ or drop
  endif
  0 1 80 #rows @ 1- 0 0  
  0 0 api-handle @ define-window drop	\ define the window
  body-attrib @ dup dup api-handle @ attribs-window drop
;

: delete-api-window	\ -- ;
  api-handle del-window
;

\ -----End of Page-----
\ -- R.G.G -- 04/06/90 --  create-target-window

: create-target-window	\ -- ;
  create-window  0=	      	\ try to create window
  if
    target-handle !	      	\ stash handle
  else
    drop		      	\ or drop
  endif
  0 1 80 #rows @ 1- 0 0  
  0 0 target-handle @ define-window drop	\ define the window
;

: delete-target-window	\ -- ;
  target-handle del-window
;

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  create-dos-window

: create-dos-window	\ -- ;
  create-window  0=	 	\ try to create window
  if
    dos-handle !	 	\ stash handle
  else
    drop		 	\ or drop
  endif
  modes @ 2 and
  if
    0 0 80 #rows @ 1+ 0 0  
  else
    0 0 80 25 0 0
  endif
  0 0 dos-handle @ define-window drop	\ define the window
;

: delete-dos-window	\ -- ;
  dos-handle del-window		\ remove from list
;

\ -----End of Page-----
\ -- R.G.G -- 26/06/90 --  create-dos-comp-window

: create-dos-comp-window	\ -- ;
  create-window  0=			\ try to create window
  if
    dos-comp-handle !			\ stash handle
  else
    drop				\ or drop
  endif
  modes @ 2 and
  if
    0 0 80 #rows @ 1+ 0 0  
  else
    0 0 80 25 0 0
  endif
  0 0 dos-comp-handle @ define-window drop	\ define the window
;

: delete-dos-comp-window  	\ -- ;
  dos-comp-handle del-window		\ remove from list
;

\ -----End of Page-----
\ -- R.G.G -- 08/06/90 --  create-fred-window

: create-fred-window		\ -- ;
  create-window  0=	 		\ try to create window
  if
    fred-handle !	 		\ stash handle
  else
    drop		 		\ or drop
  endif
  0 0 80 25 0 0  
  0 0 fred-handle @ define-window drop	\ define the window
;

: delete-fred-window		\ -- ;
  fred-handle del-window			\ remove from list
;

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  create-blow-window

: create-blow-window	\ -- ;
  w-attribs 5 5 70 5 "" Blow EPROM" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 10/10/90 --  create-upload-window

: create-upload-window	\ -- ;
  w-attribs 5 10 75 6   "" ASCII File Upload" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 10/10/90 --  create-download-window

: create-download-window	\ -- ;
  w-attribs 5 10 75 7   "" File Download" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  create-quit-window

: create-quit-window	\ -- ;
  w-attribs 20 8 30 7   "" Quit" curr-handle cr-window
;

\ -----End of Page-----

\ -- R.G.G -- 08/06/90 --  create-file-window

: create-file-window	\ -- ;
  w-attribs 5 5 70 5 "" Forth Screen Editor" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 06/06/90 --  create-list-window

: create-list-window	\ -- ;
  w-attribs 5 5 70 5 "" List Files" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  create-emu-window

: create-emu-window	\ -- ;
  w-attribs 5 5 70 5 "" Emulate EPROM" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  create-info-window

: create-info-window	\ -- ;
  w-attribs 5 8 52 10 "" Program Information" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  create-help-window

: create-help-window	\ -- ;
  w-attribs 5 1 70 23 "" Keyboard Assignments" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 25/05/90 --  create-configa-window

: create-configa-window	\ -- ;
  w-attribs 5 2 71 22 "" Configure function keys" configa-handle cr-window
;

: delete-configa-window	\ -- ;
  configa-handle del-window
;

\ -----End of Page-----
\ -- R.G.G -- 25/05/90 --  create-config-window

: create-config-window	\ -- ;
  w-attribs 4 1 51 14 "" Keyboard set-up" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 25/05/90 --  create-configb-window

: create-configb-window	\ -- ;
  w-attribs 5 2 72 21 "" Configure Commands" configb-handle cr-window
;

: delete-configb-window	\ -- ;
  configb-handle del-window
;

\ -----End of Page-----
\ -- R.G.G -- 26/9/90 --  create-configc-window

: create-configc-window	\ -- ;
  w-attribs 5 2 49 22 "" Configure Screen Colours" configc-handle cr-window
;

: delete-configc-window	\ -- ;
  configc-handle del-window
;

\ -----End of Page-----
\ -- R.G.G -- 13/06/90 --  create-helpsys-window

: create-helpsys-window			\ -- ;
  help-body-attrib @ help-border-attrib @ dup  
  7 7 55 16 "" Help" helpsys-handle cr-window
;

: delete-helpsys-window			\ -- ;
  helpsys-handle del-window
;

\ -----End of Page-----
\ -- R.G.G -- 24/1/91 --  create-glos-window

: create-glos-window		\ -- ;
  w-attribs 39 12 40 11 "" Forth Glossary" glos-handle cr-window
;

: delete-glos-window		\ -- ;
  glos-handle del-window
;

\ -----End of Page-----
\ -- R.G.G -- 13/06/90 --  create-bin-window

: create-bin-window		\ -- ;
  w-attribs 5 5 70 10 "" Generate Hex File" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 25/05/90 --  create-compiler-window

: create-compiler-window	\ -- ;
  w-attribs 5 5 70 5 "" Cross Compiler" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 12/06/90 --  create-abort-window

: create-abort-window	\ -- ;
  w-attribs 5 5 70 5 "" Target Error" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 12/06/90 --  create-error-window

: create-error-window	\ -- ;
  w-attribs 5 5 70 5 "" System Error" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 25/05/90 --  create-user1-window

: create-user1-window	\ -- ;
  w-attribs 5 5 70 5 "" User option 1" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 25/05/90 --  create-user2-window

: create-user2-window	\ -- ;
  w-attribs 5 5 70 5 "" User option 2" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 25/05/90 --  create-dump-window

: create-dump-window	\ -- ;
  w-attribs 5 5 70 5 "" View image" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 25/05/90 --  create-ascii-window

: create-ascii-windows	\ -- ;
  w-attribs a/t-tlx @  a/t-tly @ 28 14 "" ASCII Table" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 05/06/90 --  create-set-window

: create-set-window	\ -- ;
  w-attribs 3 2 67 22 "" Line Settings" set-handle cr-window
;

: delete-set-window	\ -- ;
  set-handle del-window
;

\ -----End of Page-----
\ -- R.G.G -- 05/06/90 --  create-log-window

: create-log-window	\ -- ;
  w-attribs 5 5 70 14 "" Output log" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 05/06/90 --  create-mode-window

: create-mode-window	\ -- ;
  w-attribs 5 5 55 5 "" Video Mode"  curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 06/06/90 --  create-edit-window

: create-edit-window	\ -- ;
  w-attribs 5 5 70 5 "" Text Editor" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 12/06/90 --  create-dosop-window

: create-dosop-window	\ -- ;
  w-attribs 5 5 70 6 "" DOS Functions" curr-handle cr-window
;

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  init-windows

: init				\ -- ;
  start-windows					\ start window system
  create-target-window
;

\ -----End of Page-----
\ -- R.G.G -- 12/06/90 --  to-window   from-window

: to-window			\ addr -- ;
  @ dup open-window drop		\ open right window
  op-handle !				\ and use it
;

: from-window			\ addr -- ;
  @ close-window drop
;

\ -----End of Page-----
\ -- R.G.G -- 12/06/90 --  save-win  rest-win

: save-win 		\ -- x y handle ; stash the current position
  getxy		 		\ preserve position
  op-handle @	 		\ preserve window number
;

: rest-win    		\ x y handle -- ; restore to saved position
  op-handle !			 \ restore window number
  gotoxy			 \ restore loacation
;

behead
