\ keyboard handler -- XS3

headerless

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  alt-key structure

decimal

create alt-table        \ -- addr ; alt key vector table        
       270 allot               \ space for 135 keys              
                                                                
: to-alt                \ cfa number -- ;
  2*                            \ offset into table             
  alt-table +                   \ plus base address             
  !                             \ store CFA                     
;                                                               
                                                                
: no-act		\ -- ; dummy action
  wrong-tone			\ just beep
;

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  alt-key handler

hex                                                             

: do-alt-key		\ n --  ; perform the action of this alt-key
  0FF and                                             
  dup 87 <				\ mask flag and bounds          
  if
    2* alt-table + @ execute		\ get action & execute 
  else
    drop no-act                 	\ beep if not in range 
  endif                                                     
;

variable key-found		\ flag to say a key was found
variable key-val  		\ store for found key values

: (alt-key?)		\ -- t/f ; like (key?), but performs actions of alt keys
  key-found @			\ see first if a key was available from last time
  if
    -1 exit			\ if so, return true and dont get another key
  endif
  (key?)  	       		\ is a key available
  if
    (key)	       		\ if so, get it
    dup 0=	       		\ and test with 0
    if
      drop	       		\ if zero, drop spare copy
      (key)	       		\ get next key in pair
      do-alt-key       		\ do the required action
      0		       		\ zero flag for no key avalailable now
    else
      key-found on
      key-val !	       		\ if not zero, stash value
      -1	       		\ true flag for key available now
    endif
  else
    0		       		\ if no key, then false flag
  endif
;  public

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  alt key definitions 

hex                                                             

: (alt-key)  		\ -- char ; like (key), but does alt-key actions
  begin
    (alt-key?)			\ wait till key pressed,
    key-found @ or		\ or the key which is already waiting
  until
  key-found off			\ set that this key is consumed
  key-val @			\ and say which key
;  public

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  spare-keys

: spare-keys		\ -- ; consume any spare keys lurking in buffer
  begin
    (key?)			\ while there are keys
  while
    (key) drop			\ ignore them
  repeat                                                        
;                                                               
 
\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  key assignments

decimal

'  no-act           0    2* alt-table + !       \              
'  no-act           1    2* alt-table + !       \              
'  no-act           2    2* alt-table + !       \              
'  no-act           3    2* alt-table + !       \              
'  no-act           4    2* alt-table + !       \              
'  no-act           5    2* alt-table + !       \              
'  no-act           6    2* alt-table + !       \              
'  no-act           7    2* alt-table + !       \              
'  no-act           8    2* alt-table + !       \              
'  no-act           9    2* alt-table + !       \              
'  no-act           10   2* alt-table + !       \              
'  no-act           11   2* alt-table + !       \              
'  no-act           12   2* alt-table + !       \              
'  no-act           13   2* alt-table + !       \              
'  no-act           14   2* alt-table + !       \              
'  no-act           15   2* alt-table + !       \              
' bye-bye           16   2* alt-table + !       \ Q             
'  no-act           17   2* alt-table + !       \              
' emu-prom          18   2* alt-table + !       \ E             
' time-window       19   2* alt-table + !       \ R             
' mode-toggle       20   2* alt-table + !       \ T             
' user#1            21   2* alt-table + !       \ Y             
' ascii-table       22   2* alt-table + !       \ U             
' .info             23   2* alt-table + !       \ I             
' logger            24   2* alt-table + !       \ O             
' get-settings      25   2* alt-table + !       \ P             
'  no-act           26   2* alt-table + !       \              
'  no-act           27   2* alt-table + !       \              
'  no-act           28   2* alt-table + !       \              
'  no-act           29   2* alt-table + !       \              
' run-editor        30   2* alt-table + !       \ A             
' no-act            31   2* alt-table + !       \ S             
' run-dos           32   2* alt-table + !       \ D             
' edit              33   2* alt-table + !       \ F             
' bin2hex           34   2* alt-table + !       \ G
\ '  no-act           35   2* alt-table + !       \              
'  target-glossary  35   2* alt-table + !       \              
'  no-act           36   2* alt-table + !       \              
' do-config-all     37   2* alt-table + !       \ K             
' list-files        38   2* alt-table + !       \ L             
'  no-act           39   2* alt-table + !       \              
'  no-act           40   2* alt-table + !       \              
'  no-act           41   2* alt-table + !       \              
'  no-act           42   2* alt-table + !       \              
'  no-act           43   2* alt-table + !       \              
' user#2            44   2* alt-table + !       \ Z             
'  no-act           45   2* alt-table + !       \              
' run-compiler      46   2* alt-table + !       \ C             
' run-dump          47   2* alt-table + !       \ V             
'  blow-prom        48   2* alt-table + !       \ B             
'  no-act           49   2* alt-table + !       \              
' 25/43-mode        50   2* alt-table + !       \ M             
'  no-act           51   2* alt-table + !       \              
'  no-act           52   2* alt-table + !       \              
'  no-act           53   2* alt-table + !       \              
'  no-act           54   2* alt-table + !       \              
'  no-act           55   2* alt-table + !       \              
'  no-act           56   2* alt-table + !       \              
'  no-act           57   2* alt-table + !       \              
'  no-act           58   2* alt-table + !       \              
' .help             59   2* alt-table + !       \ F1            
'  no-act           60   2* alt-table + !       \              
'  no-act           61   2* alt-table + !       \              
'  no-act           62   2* alt-table + !       \              
'  no-act           63   2* alt-table + !       \              
'  no-act           64   2* alt-table + !       \              
'  no-act           65   2* alt-table + !       \              
'  no-act           66   2* alt-table + !       \              
'  no-act           67   2* alt-table + !       \              
'  no-act           68   2* alt-table + !       \              
'  no-act           69   2* alt-table + !       \              
'  no-act           70   2* alt-table + !       \              
' no-act            71   2* alt-table + !       \ <Home>  send-home
' no-act            72   2* alt-table + !       \ <Up>    send-up 
' ascii-upload      73   2* alt-table + !       \ PgUp          
'  no-act           74   2* alt-table + !       \              
' no-act            75   2* alt-table + !       \ <Left>  send-left
'  no-act           76   2* alt-table + !       \              
' no-act            77   2* alt-table + !       \ <Right> send-right
'  no-act           78   2* alt-table + !       \              
' no-act            79   2* alt-table + !       \ <End>   send-end
' no-act            80   2* alt-table + !       \ <Down>  send-down
' download          81   2* alt-table + !       \ PgDn
'  no-act           82   2* alt-table + !       \              
' no-act            83   2* alt-table + !       \ <Del>   send-del
'  no-act           84   2* alt-table + !       \              
'  no-act           85   2* alt-table + !       \              
'  no-act           86   2* alt-table + !       \              
'  no-act           87   2* alt-table + !       \              
'  no-act           88   2* alt-table + !       \              
'  no-act           89   2* alt-table + !       \              
'  no-act           90   2* alt-table + !       \              
'  no-act           91   2* alt-table + !       \              
'  no-act           92   2* alt-table + !       \              
'  no-act           93   2* alt-table + !       \              
'  no-act           94   2* alt-table + !       \              
'  no-act           95   2* alt-table + !       \              
'  no-act           96   2* alt-table + !       \              
'  no-act           97   2* alt-table + !       \              
'  no-act           98   2* alt-table + !       \              
'  no-act           99   2* alt-table + !       \              
'  no-act          100   2* alt-table + !       \              
'  no-act          101   2* alt-table + !       \              
'  no-act          102   2* alt-table + !       \              
'  no-act          103   2* alt-table + !       \              
'  no-act          104   2* alt-table + !       \              
'  no-act          105   2* alt-table + !       \              
'  no-act          106   2* alt-table + !       \              
'  no-act          107   2* alt-table + !       \              
'  no-act          108   2* alt-table + !       \              
'  no-act          109   2* alt-table + !       \              
'  no-act          110   2* alt-table + !       \              
'  no-act          111   2* alt-table + !       \              
'  no-act          112   2* alt-table + !       \              
'  no-act          113   2* alt-table + !       \              
'  no-act          114   2* alt-table + !       \              
'  no-act          115   2* alt-table + !       \              
'  no-act          116   2* alt-table + !       \              
'  no-act          117   2* alt-table + !       \              
'  no-act          118   2* alt-table + !       \              
'  no-act          119   2* alt-table + !       \              
'  no-act          120   2* alt-table + !       \              
'  no-act          121   2* alt-table + !       \              
'  no-act          122   2* alt-table + !       \              
'  no-act          123   2* alt-table + !       \              
'  no-act          124   2* alt-table + !       \              
'  no-act          125   2* alt-table + !       \              
'  no-act          126   2* alt-table + !       \              
'  no-act          127   2* alt-table + !       \              
'  no-act          128   2* alt-table + !       \              
'  no-act          129   2* alt-table + !       \              
'  no-act          130   2* alt-table + !       \              
'  no-act          131   2* alt-table + !       \              
'  no-act          132   2* alt-table + !       \              
'  no-act          133   2* alt-table + !       \              
'  no-act          134   2* alt-table + !       \              

behead
