\ Output logger for XS3                                           


\ -----End of Page-----
\ -- R.G.G -- 5/9/90 --  variables and pcbs

headerless
                                                                
variable output-flag            \ tar. output is being logged   
variable input-flag             \ tar. input is being logged    
                                                                
variable char-buff              \ log file buffer               
                                                                
variable prev-log-state         \ state of log at start of op.  
variable file-state             \ state of log file (o/c)       
                                                                
pcb log-file                    \ output log file-spec          

"" TARGET.LOG" log-file set-pathname		\ default name for log file

\ -----End of Page-----
\ -- R.G.G -- 05/06/90 --  defered words


assign noop to-do output>log   		\ default action
assign noop to-do umb-o/p>log		\ default action

assign noop to-do input>log		\ default action
assign noop to-do umb-i/p>log		\ default action

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --log-file-error (open-log)
                                                                
: log-file-error	\ code -- ; say error writing to log
  if						\ if an error   
    ." Log: Error in writing log file."		\ say so              
    log-file .pcb				\ say file name 
    abort					\ abort         
  endif                                                         
;                                                               
                                                                
: (open-log)		\ -- ; open the log file
  log-file create-path-pcb log-file-error	\ open & error  
  file-state on					\ set flag      
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  close-log

headers
                                                                
: close-log		\ -- ; close the log file
  file-state @                                                  
  if				\ if file is open               
    log-file handle		\ file to use                   
    close-path			\ close it                      
    log-file-error		\ any error ?                   
    file-state off		\ flag off                      
  endif                                                         
;                                                               

headerless

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  get-log-name
                                                                
: get-log-name		\ -- ; get name from user
  29 2 gotoxy			\ right place in window
  02 #help			\ right help message
  pick-option on		\ may use pick list
  log-file ed-pcb		\ get the name
  if here log-file set-pathname	\ set the name
  endif                                                         
  08 #help			\ back to normal help
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  char>log

headers                                                                

: char>log		\ char -- char ; log a character to the log file
  dup
  char-buff c!			\ store char in buffer
  char-buff 1 log-file handle	\ params
  write-path			\ write one char to file
  0<> swap 1 <> or		\ failed at all ?
  log-file-error		\ display error message
;                                                               

headerless

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  .state
                                                                
: .state		\ -- ; say what state the log is in
  ."  Log: "				\ basic message
  input-flag @ output-flag @ and	\ if i/p and o/p
  if      ." Target input & output"	\ say so
  else					\ if one or the other
    input-flag @			\ if i/p
    if    ." Input to target      "
    else				\ if o/p or none 
      output-flag @			\ if o/p
      if  ." Output from target   "                                  
      else				\ if none
          ." None                 "                                  
      endif
    endif
  endif
  cr
;

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  .log-options
                                                                
: .log-options		\ -- ; show the options here
  0 0 gotoxy					  \ correct place on screen       
  .state					  \ show current state of log     
  cr ."  (a)  Log file name:         " log-file .pcb          
  cr cr ."  (b)  "
  output-flag @                           
  if    ." Disable log of target output"                        
  else  ." Enable log of target output "
  endif                  
  cr ."  (c)  "
  input-flag @                                 
  if    ." Disable log of input to target"                      
  else  ." Enable log of input to target "
  endif
  cr cr ."  <F10> finish"                                   
  cr cr ."  Select option: "                                
;

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  enable-output disable-output
                                                                
: enable-output		\ -- ; set log to log o/p by target
  output-flag on	      			\ flag on
  assign char>log to-do output>log		\ correct action
  assign char>log to-do umb-o/p>log		\ correct action
;                                                               
                                                                
: disable-output	\ -- ; set log to not log o/p by target
  output-flag off	   			\ flag off
  assign noop to-do output>log			\ correct action
  assign noop to-do umb-o/p>log			\ correct version
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  enable-input disable-input
                                                                
: enable-input		\ -- ; set log to log i/p to target
  input-flag on				 	\ flag on
  assign char>log to-do input>log	 	\ correct action
  assign char>log to-do umb-i/p>log		\ correct action
;                                                               
                                                                
: disable-input		\ -- ; set log to not log i/p to target
  input-flag off			    	\ flag off
  assign noop to-do input>log			\ correct action
  assign noop to-do umb-i/p>log			\ correct version
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  control-input control-output
                                                                
: control-input		\ -- ; toggle i/p log
  input-flag @				\ get state of flag     
  if   disable-input			\ disable               
  else enable-input			\ enable the right one  
  endif                                                         
;                                                               
                                                                
: control-output	\ -- ; toggle o/p log
  output-flag @				\ get state of flag     
  if   disable-output			\ disable               
  else enable-output			\ enable the right one  
  endif                                                         
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  reset-log
                                                                
: reset-log		\ -- ; default log state
  log-file handle close-path drop	\ close it up           
  disable-output			\ no output log         
  disable-input				\ no input log          
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  open-log
                                                                
: open-log		\ -- ; open the log file
  log-file open-path-pcb			\ try to open file      
  0=			      			\ if it exists          
  log-file handle close-path			\ try to close file  
  0= and		      			\ if can do both
  if
     error-tone					\ say so
     cr ."  Log file " log-file .pcb ."  already exists."     
     cr ."  Overwrite it (y/n)?"		\ should we overwrite  
     assign (key?) to-do key? 			\ 
     assign (key) to-do key   			\ assign old key handler
     y/n?
     assign (alt-key?) to-do key?  		\ 
     assign (alt-key) to-do key	   		\ assign new key handler
     if    (open-log)				\ open the file         
     else  reset-log				\ back to 'off'         
     endif
  else
    (open-log)					\ open the file         
  endif                                                         
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  control-log-file
                                                                
: control-log-file	\ -- ; open or close log as deemed necessary
  input-flag @  output-flag @
  or
  if				\ if logging of some sort
    prev-log-state @ 0=		\
    if				\ if previously not logging
      open-log			\ open file
    endif
  else				\ if no logging required
    close-log			\ close file
  endif                                                         
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  get-log-options
                                                                
: get-log-options	\ -- ; get choices from user
  begin                                                         
    (key) upc				\ upc key                       
    case                                                        
           00 of (key)
                 case
                   59 of more-help endof
                   68 of exit endof
                      wrong-tone
                 endcase
              endof
      ascii A of get-log-name   endof	\ get file name         
      ascii B of control-output endof	\ output on or off      
      ascii C of control-input  endof	\ input on or off       
           27 of exit           endof	\ quit                  
                 wrong-tone		\ wrong key
    endcase                                                     
    .log-options                        \ show new options      
  again                                                         
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  set-state
                                                                
: set-state		\ -- ; indicate old state before taking new choices
  output-flag @			\ get one flag                  
  input-flag @			\ get the other                 
  or				\ or them                       
  prev-log-state !		\ set flag to say so            
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  (logger)

headers

: reset-attribs		\ -- ; restore attributes to required ones
  body-attrib @ dup dup host-handle @ attribs-window drop
  body-attrib @ dup dup target-handle @ attribs-window drop
;                                                                

: logger		\ -- ; the whole logger window
  save-win				\ save current screen status
  create-log-window			\ make the new window
  curr-handle to-window			\ enter it
  set-state	    			\ get current state of logger   
  08 #help				\ new help message number
  .log-options			   	\ show current options          
  get-log-options		   	\ get the new ones              
  control-log-file		   	\ switch on/off or leave        
  spare-keys				\ use any remaining keys
  curr-handle from-window		\ exit this window
  delete-curr-window			\ and delete it
  rest-win				\ back where we were
  reset-attribs				\ and in the right colours
;

behead
