\ path qualification and splitting code

\ -----End of Page-----
\ -- P.G. 16/10/91 -- quailify-name

headerless

((
 Undocumented DOS call
 this call is supposed to return a qualified path name, given
 any old path descriptor, which should mean that it will convert
 
 xxx\yy\..\*.*  to  xxx\*.*

 it works! DOS 3 upwards only please
))

hex

code qualify-path	\ source dest -- ; qualify a pathway
  bp, sp xchg   si push   di push   bp, sp xchg	\ save Forth
  si pop   di, bx mov				\ set parameters
  bx, es mov   ax, ds mov   es, ax mov		\ reset segments
  bp push   ah, # 060 mov   021 int   bp pop	\ call DOS
  es, bx mov					\ restore segment
  bp, sp xchg   di pop   si pop   bp, sp xchg	\ restore Forth
  bx pop					\ new TOS
  next,
end-code

decimal

: upper?		\ char -- t/f ; returns true if char is upper
  ascii A ascii Z within?
;

: lower			\ addr n -- ; converts string to lower case
  bounds
  ?do
    i c@ upper?				\ in upper case
    if i c@ 32 + i c! endif		\ change to lower
  loop
;

decimal

: qualify-name		\ addr$ -- ; qualify this string
  dup >r				\ 
  $>asciiz pad qualify-path 		\ qualify asciiz version
  pad r@ 64 cmove 			\ copy from pad
  r@ asciiz>$ drop			\ make counted
  r> count lower			\ make lower case
;

\ -----End of Page-----
\ -- R.G.G -- 6/12/91 --  split-path

: parse-ext		\ source$ dest$ -- ; parse ext from source
  0 0				\ dummy addr and length
  3 pick c@ 4 min  0		\ loop limits
  ?do
    3 pick dup c@ +		\ make address of last character
    i -				\ make address of this character
    c@  ascii . =		\ is it a dot?
    if
      2drop			\ drop dummy addr and length
      over dup c@ + i -		\ make address of the .
      i 1+			\ make length of text, including dot
      leave			\ quit loop
    endif
  loop
  2dup 0= swap 0= and		\ if addr and length are both zero
  if
    2drop 2drop			\ tidy up
  else
    dup >r			\ spare copy of length
    2 pick 1+ swap cmove	\ copy to destination addr
    r@ swap c!			\ make dest into counted string
    r> negate swap c+!		\ decrement source string to suit
  endif
;

: parse-name		\ source$ dest$ -- ; parse name from source
  0 0				\ dummy addr and length
  3 pick c@ 9 min  0		\ loop limits
  ?do
    3 pick dup c@ +		\ make address of last character
    i -				\ make address of this character
    c@  ascii \ =		\ is it a dot?
    if
      2drop			\ drop dummy addr and length
      over dup c@ + i -	1+	\ make address of the \
      i 			\ make length of text, including \
      leave			\ quit loop
    endif
    3 pick dup c@ +		\ make address of last character
    i -				\ make address of this character
    c@  ascii : =		\ is it a dot?
    if
      2drop			\ drop dummy addr and length
      over dup c@ + i -	1+	\ make address of the \
      i 			\ make length of text, including \
      leave			\ quit loop
    endif
  loop
  2dup 0= swap 0= and		\ if addr and length is zero
  if
    2drop			\ tidy up
    over >r			\ copy of source
    $move			\ make dest=source
    r> 0 swap c!		\ turn of source string
  else
    dup >r			\ spare copy of length
    2 pick 1+ swap cmove	\ copy to destination addr
    r@ swap c!			\ make dest into counted string
    r> negate swap c+!		\ decrement source string to suit
  endif
;

: parse-path		\ source$ dest$	-- ; parse path from source
  0 0				\ dummy addr and length
  3 pick c@ 1+ 0		\ loop limits
  ?do
    3 pick dup c@ +		\ make address of last character
    i -				\ make address of this character
    c@  ascii : =		\ is it a dot?
    if
      2drop			\ drop dummy addr and length
      over dup c@ + i -	1+	\ make address of the :
      i 			\ make length of text, including :
      leave			\ quit loop
    endif
  loop
  2dup 0= swap 0 = and		\ if addr and length is zero
  if
    2drop			\ tidy up
    over >r			\ copy of source
    $move			\ make dest=source
    r> 0 swap c!		\ turn of source string
  else
    dup >r			\ spare copy of length
    2 pick 1+ swap cmove	\ copy to destination addr
    r@ swap c!			\ make dest into counted string
    r> negate swap c+!		\ decrement source string to suit
  endif
;

: parse-drive		\ source$ dest$ -- ; parse drive from source
  $move				\ copy remaining bit to drive$
;

: (split-path)		\ source$ d$ p$ n$ e$ -- ; split name into bits
  4 pick swap parse-ext		\ get extension, and reduce string
  3 pick swap parse-name	\ get name, and reduce string
  2 pick swap parse-path	\ get path, and reduce string
  parse-drive			\ get drive
;

headers

: split-path		\ source$ d$ p$ n$ e$ -- ; perhaps split name into bits
  dup 0 swap c!			\ turn off the extension string
  over 0 swap c!		\ turn off the name string
  2 pick 0 swap c!		\ turn off the path string
  3 pick 0 swap c!		\ turn off the drive string
  4 pick c@ 0<>			\ get the length of the source
  if				\ if there is a string
    (split-path)		\ break down the text
  else
    2drop 2drop drop		\ tidy up, if zero-length source
  endif
;

headerless

\ -----End of Page-----
\ -- R.G.G -- 9/12/91 --  get-cwd

hex

: get-cwd		\ -- addr ; get the current drive and dir.
  0 pad 3 + ?current-dir        \ drive# addr -- status         
  ?drive ascii A + pad c!       \ form current drive letter     
  ascii : pad 1+ c!             \                               
  ascii \ pad 2+ c!             \ now have d:\                  
  pad asciiz>$ drop             \ make into string             
  "" \" pad $+			\ finish with a \ character
  pad here $move		\ copy string to here
  here				\ return addr
;

\ -----End of Page-----
\ -- R.G.G -- 9/12/91 --  make-compiler-dir

create drive1  3 allot			\ space for a drive name
create drive2  3 allot			\ and another
create path1   64 allot			\ space for a path
create path2   64 allot			\ and another

headers

: make-compiler-path		\ -- ; make name of compiler directory
  get-cwd				\ where are we now
  drive1 path1 pad pad split-path	\ split it up
  $compiler here $move			\ where the compiler is
  here drive2 path2 pad pad split-path	\ split it up
  drive2 c@ 0=				\ test for a drive in the comp name
  if					\ if there is not a drive
    drive1 pad $move			\ get this drive name
    path2 1+ c@ ascii \ <>		\ test first char of compiler path
    if					\ if not absolute path
      path1 pad $+			\ add the current directory
    endif
    $compiler 1+ c@ ascii - <>		\ check user has configured it
    if
      path2 pad $+			\ if configured, add the relative path
    else				\ if not configured
      forth-buff pad $move		\ make the xshell directory
    endif
    pad qualify-name			\ make into sensible path
  else					\ if there is a drive
    drive2 pad $move			\ get drive name
    path2  pad $+			\ add path name
  endif
  pad (compiler-buff) $move		\ make this it
;

: compiler-path			\ -- seg off ; path and drive of compiler
  cs> (compiler-buff)			\ make address
; public				\ ... so that jon can get it

behead
