\ start up code for XS3

\ headerless

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  start-key-assigns

: start-key-assigns	\ -- ; set up default function keys
  letter-table 14 erase				\ zero fn keys           
  "" FCBTV" count letter-table 2+ swap cmove	\ set up F2,3,4,5
  "" DQ"    count letter-table 9 + swap cmove	\ set up F9,10
;

\ -----End of Page-----
\ -- R.G.G -- 05/06/90 --  start-comms

decimal

: start-comms		\ -- ; start serial comms (defaults)
\ val  fn ch.  
  9600  1 ser-2drop			\ 2400 baud
  0     7 ser-2drop			\ no parity
  8     5 ser-2drop			\ 8 data bits
  1     9 ser-2drop			\ 1 stop bit
  3     3 ser-2drop			\ no handshaking
  1    11 ser-2drop			\ port 1
  ser-open	      			\ start comms going
  dumb/files on				\ default to file server
;

\ -----End of Page-----
\ -- R.G.G -- 06/06/90 --  >host-window

\ headers

: >host-window	   	\ -- ; brings us into host window
  host-handle @ op-handle !		\ reset to host handle
;

\ headerless

decimal

\ -----End of Page-----
\ -- R.G.G -- 11/07/90 --  relink-io-sys

decimal

: relink-io-sys		\ -- ; link the extras in services
  es>			      		\ preserve es
  cs> >es resolve-links	      		\ resolve for master
  28 mod-seg >es resolve-links		\ resolve io-sys
  >es			      		\ restore es
;

\ -----End of Page-----
\ -- R.G.G -- 2/10/90 --  reset-colours

: reset-colours		\ -- ; set colours to required ones
  set-pick-attribs

  host-handle @
  dup close-window drop
  dup >r body-attrib @ dup dup r> attribs-window drop
      reopen-window drop

  target-handle @ 
  dup close-window drop
  dup >r body-attrib @ dup dup r> attribs-window drop
      reopen-window drop
  target-handle init-window

  .top-bar
  redraw-bottom-bar
;

\ -----End of Page-----
\ -- R.G.G -- 12/07/90 --  set-default-mode

: set-default-mode	 \ -- ; set configured screen mode
  modes @		 	\ get toggle value
  01 and		 	\ is it for setting?
  /e @ or		 	\ or was command line used?
  if
    25/43-mode
  else
    reset-colours	 	\ set colours from cfg file
    cls
  endif
;

\ -----End of Page-----
\ -- R.G.G -- 13/07/90 --  parse-command-line

: get-command-line	\ -- ; read the command line
  tib ed-buff 1+		\ old and new buffers
  #tib @ cmove			\ transfer command-line
  #tib @ ed-buff c!		\ make into counted string
;

: get-scr		\ addr len -- addr len ; get the scr file name
  over 2+ c@				\ get /S:
  ascii : =				\ if correct
  if
    swap 3 + swap 3 -			\ move to start of filename
    2dup 2dup				\ preserve for end of definition
    bl scan drop nip			\ -- addr1 addr2 
    over - dup >r			\ -- addr len
    here 1+ swap cmove			\ move to here
    r> here c!				\ make counted string
    cs> here $using drop 		\ try to use filename
    redraw-bottom-bar  			\ match on bottom line
  endif
;

: get-fth	 	\ addr len -- addr len ; get fth file name
  over 2+ c@				\ get /F:
  ascii : = 				\ if correct
  if
    swap 3 + swap 3 -			\ move to start of filename
    2dup 2dup				\ preserve for end of definition
    bl scan drop nip			\ -- addr1 addr2 
    over - 				\ -- addr len
    >r cs> swap curr-text$ 1+ r@ cmovel \ move to slave mod.
    r> curr-text$ c!l			\ move length to slave mod
    redraw-bottom-bar  			\ match on bottom line
  endif
;

: get-com		\ addr len -- addr len ; get commane line compiler
  over 2+ c@		  	\ get /F:
  ascii " =		  	\ if correct
  if
    /c on
    swap 3 + swap 3 -		\ move to start of filename
    2dup	2dup		\ preserve for end of definition
    ascii " scan drop nip	\ -- addr1 addr2 
    over - dup >r		\ -- addr len
    $comp-comm 1+ swap cmove	\ move to file name
    r> $comp-comm c!		\ make counted string
  endif
;

: test-next		\ addr len -- addr len ;
  over 1+ c@ upc       			\ get next char. ie, /n
  case
    ascii A of #tib off >in off
               ted
               bye-bye
            endof  			\ run ted only
    ascii T of /t on   endof		\ switch terminal mode
    ascii S of get-scr endof		\ set screen file name
    ascii F of get-fth endof		\ set text file name
    ascii M of /e on   endof		\ set 43 line mode
    ascii C of get-com endof		\ run compiler only
  endcase
;

: get-switches		\ -- ;
  ed-buff 1+ ed-buff c@ 	\ start addr and length
  begin
    bl skip			\ skip to first non-space
    dup				\ while there is a non-space	
  while
    ascii / scan dup 0<>	\ find a `/'
    if 
      test-next			\ get rest of switch
      bl scan			\ get to next white space
    endif
  repeat		   	\ round for next switch
  2drop			   	\ tidy stack
;

\ -----End of Page-----
\ -- R.G.G -- 13/07/90 --  ?set-terminal-mode

: ?set-terminal-mode	\ -- ; default to terminal mode
  /t @				\ if command line says so..
  if  mode-toggle		\ go into target mode
  endif
;

\ -----End of Page-----
\ -- R.G.G -- 17/07/90 --  cold

hex

only forth definitions

\ headers

: cold			\ -- ; new version of cold
  cls				\ tidy up
  op-handle @			\ preserve window
  0134 @ execute  		\ magic number: '(init)
  [ also xs3 definitions ]
  assign >host-window to-do normal-drivers
  [ previous ]
  op-handle !			\ restore window
  ."  ok"			\ say so
  abort				\ and start again
;

\ headerless

only forth also xs3 definitions

decimal

\ -----End of Page-----
\ -- R.G.G -- 24/07/90 --  ?compiler

: ?compiler		\ -- ; should we run the compiler
  /c @ 				\ if switch specified
  if
    (run-compiler)		\ run compiler as default
    dark
    (bye-bye)	   		\ and quit immediately
  endif
;

\ -----End of Page-----
\ -- R.G.G -- 12/2/91 --  default-colours

decimal
: default-colours	\ -- ; sets colour attribs if appropriate
  50 screen-drop dup			\ -- type type
  2 mod 0=				\ -- type t/f-even
  swap
  [ hex ] 082 [ decimal ] =		\ -- InColor c/e/vga-colour
  or			    		\ -- colour?
  if			    		\ if a colour adaptor...
    113 title-attrib !
    116 help-prompt-attrib !
    23  body-attrib !
    12  header-attrib !
    14  border-attrib !
    7   window-attrib !
    112 help-border-attrib !
    113 help-body-attrib !
    reset-colours
    cls
  endif			       		\ else leave as hard-coded
;

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  start

\ headers

: start			\ -- ; the cold start word
  blk off state off s0 @ sp!  r0 @ rp!		\ default states
  cls
  decimal
  cs> "" -                             "
  curr-edit$ 31 cmovel				\ make default editor name
  get-command-line		     		\ get command line parameters
  relink-io-sys					\ resolve links in io-sys module
  48 screen-drop old-mode !			\ save screen mode on entry
  shell-mode off		     		\ host mode selected
  start-key-assigns				\ initialise key table
  init-api-int					\ initialise api
  start-fn#s					\ initialise function keys
  start-comms					\ initialise comms link
  init						\ start windows
  op-handle @ screen-handle !
  assign >host-window to-do normal-drivers
  assign noop to-do loader			\ now we have booted
  host			      			\ host screen bars, etc
  default-colours	      			\ set default colours (for colour)
  read-cfg		      			\ load configuration file
  target-handle init-window			\ initialise target window
  get-switches					\ process command line
  assign (alt-key?) to-do key?			\ use alt key handler
  assign (alt-key) to-do key			\ assign new key handler
  set-default-mode				\ set default screen mode
  ?set-terminal-mode				\ should we default to terminal mode?
  ."   ok"					\ first prompt
  ?compiler					\ should we run compiler first time
  op-handle @ set-op-handle			\ set op-handle in services module
  abort			  			\ kick into forth system
;

\ behead
