\ target mode code for xshell v3

\ -- R.G.G -- 16/10/91 --  output words to be defined later

defer output>log       	   	  	\ target logger word			
defer umb-o/p>log public	  	\   and for umbilical mode

defer input>log			  	\ target logger word
defer umb-i/p>log public	  	\   and for umbilical mode

\ -----End of Page-----
\ -- R.G.G -- 30/1/92 --  tar-xxx

: tar-key		\ -- char ; get a char from target
  int/ext @
  if
    noop
  else
    ser-key
  endif
;

: tar-key?		\ -- t/f ; is a key available from target
  int/ext @
  if
    noop
  else
    ser-key?
  endif
;

: tar-emit		\ char -- ; send char to target
  int/ext @
  if
    noop
  else
    ser-emit
  endif
;

\ -----End of Page-----
\ -- R.G.G -- 04/06/90 --  top-bar-target

: top-bar-target	\ -- ; draw top bar in target mode
  0 0 gotoxy			\ top of screen                 
  attrib>112			\ inverse attribs               
  80 spaces
  0 0 gotoxy			\ top of screen                 
  .XSHELL			\ what program                  
  target-banner c@ 2/ 40 swap - 0 gotoxy
  target-banner count type
  68 0 gotoxy
  .F1				\ the help key                  
  attrib>7			\ normal attribs                
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 04/06/90 --  bottom-bar-target

hex

headerless

: .baud(bar)		\ -- ; print baud rate
  0 ser-drop	       		\ get baud rate
  u.		       		\ print number
  8 emit ascii , emit  		\ tidy up        
;

: .bits(bar)   		\ -- ; print #bits
  4 ser-drop		   	\ get #data bits
  1 .r ascii , emit	   	\ print and add a a comma
  8 ser-drop		   	\ get #stop bits
  1 .r ascii , emit            	\ print and add a comma                  
;

: .parity(bar)		\ -- ; print parity type
  6 ser-drop			\ get parity number
  case				\ print appropriate letter	
    0 of ." N" endof
    1 of ." O" endof            
    2 of ." E" endof    
  endcase     
  ascii , emit			\ add a comma
;                                                               

: .hs(bar)		\ -- ; print handshake type
  2 ser-drop			\ get handshake type
  case                                            
    1 of ." RTS" endof		\ print appropriate message
    2 of ." DTR" endof                    
    4 of ." XON" endof
         ." NONE" 
  endcase                                                       
  ascii , emit			\ add a comma
;

: .port(bar)		\ -- ; print port number in use
  0a ser-drop			\ get port number
  1 .r				\ print it
;

: .format(bar)		\ -- ; print whether file server or not
  dumb/files @
  if  ." ,F"
  endif
;

: .external		\ -- ; say external channel in use
  ." External"
;

decimal

headers
: bottom-bar-target	\ -- ; print the whole bottom bar
  base @ >r decimal                                             
  0 #rows @ gotoxy attrib>112		\ bottom & inverse      
  1 5 screen-2drop
  80 spaces				\ blank row
  0 5 screen-2drop
  0 #rows @ gotoxy			\ blank it & start      
  int/ext @
  if
    .external
  else
    .baud(bar)				\ show baud rate
    .parity(bar)       			\ show line settings    
    .bits(bar)				\ data bits and stop bits
    .hs(bar)				\ hand shake type
    .port(bar)				\ show port number      
    .format(bar)       			\ show server/dumb
  endif
  .files				\ current files, etc    
  attrib>7 r> base !			\ normal attribs        
;                                                            


\ -----End of Page-----
\ -- R.G.G -- 04/06/90 --  target

defer .new-banners

headerless

: open-target		\ -- ; start target mode
  getxy					\ get location
  targ-xy ! targ-xy 2+ !		\ and preserve
  screen-handle @ op-handle !		\ use whole screen
  top-bar-target			\ top line of screen
  bottom-bar-target			\ bottom line of screen
  target-handle @ reopen-window drop	\ open window
  target-handle @ op-handle !		\ redirect i/o
  attribs-changed @			\ if user has changed colours lately
  if cls endif				\ then clear the screen
  attribs-changed off			\ and cancel the `changed' flag
;

: close-target		\ -- ; close target mode
  target-handle @ close-window drop	\ close the window for now
  screen-handle @ op-handle !		\ use whole screen
  .new-banners			      	\ print new top and bottom lines
  previous-mode @ 0=		      	\ what mode were we in ?
  if   host-handle 			\ go back to either host
  else api-handle 			\ or compiler/umbilical window
  endif
  @ op-handle !			      	\ back to old window
  targ-xy 2+ @ targ-xy @	      	\ get position
  gotoxy	       			\ restore position
  attribs-changed @			\ if user has changed colours lately
  if cls endif				\ then clear to show them
  attribs-changed off			\ cancel flag
;

headers

: init-window		\ addr -- ; start the target window itself
  op-handle @				\ save current window
  swap
  @ dup open-window drop	    	\ open target window
  dup >r  body-attrib @ dup dup r> attribs-window drop
  dup clear-window drop			\ clear it
  close-window drop			\ and close it again
  op-handle !				\ back to old window
;

\ -----End of Page-----
\ -- R.G.G -- 9/10/90 --  protocol words

variable abort-state			\ the error state when abort out of target comms
defer target-abort			\ how to get out of target mode

decimal                                                         

headerless

\ -- n                                                          
1  constant start			\ transmission special chars
6  constant ack                                                 
21 constant nack                                                

hex                                                             

012 constant ^r         001 constant ^a		\ control chars to look for
017 constant ^w         006 constant ^f                         
003 constant ^c         005 constant ^e                         
015 constant ^u         01b constant esc                        

variable rep-count			\ how many tries have we had so far
variable rep-rate			\ the number of tries to take
  4000 rep-rate !                           
variable old-hs				\ default handshaking mode
variable line-counter			\ how many lines sent so far
decimal

13 constant ACR				\ protocol special chars
17 constant XON                                                 
19 constant XOFF                                                

: ser-key		\ -- char ; testing version of ser-key
  begin
    key?				\ is there a kb key
    if  key-val @ 2 =			\ if so was it a ^b
        if -1 throw  endif		\ quit if yes
    endif
    ser-key?				\ roll till a serial key
  until
  ser-key				\ and get the serial key
;
                                                                
: ?send-start		\ -- ; send start n times
  rep-count @ rep-rate @ =	\ count = rate ?
  if
    0 rep-count !		\ if, reset count
    start ser-emit		\     send start code
  endif				\
  1 rep-count +!		\ increment count
;

: get-blk-addrs		\ -- end-addr+1 start-addr ; get block addresses
  2 ser-drop >r				\ preserve h/s type
  3 3 ser-2drop				\ set no handshake
  ser-key  ser-key 256 um* drop +	\ receive block number          
  screen-pcb @ -1 <>			\ if there is a block file open
  if
    block 1024			     	\ formulate buffer addresses
  else
    drop first 2+ 1024 2dup bl fill	\ fill with spaces
  endif
  bounds				\ make address of block
  ack ser-emit				\ send ack
  r> 3 ser-2drop			\ restore h/s type
;                      
                                                                
: send-ack/nack		\ -- ; send disk status back
  disk-error @			\ test status
  if  NACK  else  ACK  endif	\ send NACK on error
  ser-emit
;

: synch-to-target	\ -- ; synchronise host and target for rest of transfer
  rep-rate @ rep-count !		\
  begin					\ sync.
    ?send-start				\   send start code
    ser-key ack = 
\    key?
\    if
\      key-val @ 2 =
\      if
\        target-abort exit
\      endif
\    endif
\    ser-key?
\    if
\      ser-key ack =			\   test receive;  ack code?
\    else
\      0					\   else  delay, wait for ack
\    endif				\
  until					\
;

: get#			\ -- n ; get number from serial line
  ser-key  ser-key 256 *  +		\ receive number
  ack ser-emit				\ acknowledge it
;

: reset-hs		\ -- ; restore old handshaking type
  old-hs @  3 ser-2drop		\ get old and restore it
;                                                               
                                                                
: set-xon/xoff		\ -- ; use manual xon/xoff instead of whatever
  2 ser-drop			\ get current type
  old-hs !			\ save h.shake type
  3 3 ser-2drop	       		\ set new type (none)
;                                                               
 
: get$			\ -- ;  gets $ to pad
  set-xon/xoff			\ use no handshaking here
  synch-to-target		\ synchronise to target
  get#  dup pad c!		\ store length at pad
  0				\ length - 0
  ?do
\    key?
\    if  key-val @ 2 =
\        if  -1 throw  endif
\    endif
    ser-key pad i + 1+ c!	\ get char & store at pad+i     
  loop
  begin
\    key?			\ if there is a key
\    if
\      key-val @ 2 =		\ test it with 2
\      if
\        target-abort exit	\ get out if user has aborted
\      endif
\    endif			\ abort if failed
\    ser-key?			\ if there is a serial char
\    if
      ser-key ack =		\ test for acknowledge
\    else
\      0
\    endif
  until				 \ wait for ack                  
  send-ack/nack			\ send status                   
  reset-hs			\ back to previous hs mode
; 

: tar-$use		\ -- ; get text file name from taget
  get$		       			\ get string from target        
  pad count upper      			\ convert to upper case         
  cs> pad curr-text$ pad c@ 1+ cmovel	\ copy to buffer             
  save-win	       			\ preserve current window
  screen-handle @ op-handle !		\ use whole screen
  bottom-bar-target    			\ normal bottom line           
  rest-win	       			\ back to old window
;
 
: tar-$using		\ -- ; get screen file name from target
  get$		   			\ get string from target        
  cs> pad $using   			\ do a using                    
  ?make-scr	   			\ make it if we have to         
  save-win	   			\ preserve current window
  screen-handle @ op-handle !		\ use whole screen
  bottom-bar-target 			\ normal bottom line           
  rest-win	    			\ back to old window
; 

: rem-blk-send		\ -- ; send a block to target
  synch-to-target			\ synchronise                     
  get-blk-addrs				\ get blk# & form buffer addresses
  do
    i c@ ( dup emit ) ser-emit		\ send 8 bits from buffer     
  loop
  begin
\    key?				\ if there has been a key
\    if
\      key-val @ 2 =			\ is it a ^B
\      if
\        target-abort exit		\ then get out cos user is fed up
\      endif
\    endif
\    ser-key?				\ get a serial char
\    if
      ser-key ack =			\ get out when ack
\    else
\      0
\    endif
  until					\ wait for ack
  send-ack/nack  			\ send disk status
;

variable leaving		\ used to detect abort failure

: rem-blk-receive	\ -- ; get block from target
  leaving off
  synch-to-target		\ synchronise                     
  get-blk-addrs			\ get blk# & form buffer addresses
  do
    begin
      key?
      if
        key-val @ 2 =		\ has user presses ^B ?
        if
          target-abort leaving on leave		\ if so then quit
        endif
      endif
      ser-key?			\ have we a serial char
      if
        ser-key i c! -1		\ store it, and reduce count, ready for next
      else
        0
      endif
    until			\ loop until a char received, or user aborts
  loop				\ and get next char
  leaving @			\ abort now if user intervened
  if exit endif
  update flush			\                                 
  send-ack/nack			\ send ack/nack to complete trans 
;

\ -----End of Page-----
\ -- R.G.G -- 9/10/90 --  tar-$from

: wait-ack		\ -- ; wait for target ACK, and acknowledge it
  begin					\ loop waiting for an ack
\    key?				\ has user pressed a key
\    if
\      key-val @ 2 =			\ and is it a ^B
\      if
\        target-abort -1 throw		\ then get out
\      endif
\    endif
\    ser-key?				\ is there a serial key
\    if
      ser-key dup ack <>		\ is it an ack
      if
        emit 0				\ emit if not
      else
        drop -1				\ ignore and prepare to quit
      endif
\    else
\      0
\    endif
  until
  ack ser-emit				\ send an ack to finish
;

headers

defer send-file

headerless

: tar-nested		\ -- ; get next file name
  tar-$use			\ get file name and select it
  get#				\ receive last-p#
  get#				\ receive first-p#
  swap curr-text$		\ setup for host's $from
  synch-to-target		\ re-synch
  send-file			\ and send the file
;                                                               

: load-feedback		\ -- ; see what the target is telling us
  begin                               
    ser-key?	   			\ is there a serial key         
  while		   			\ while there is                
    case
      ser-key	   			\ get it                        
      ^f of  tar-nested  endof		\ nest another file
      ^e of  -1 throw  endof	 	\ an error on target
         dup emit		 	\ else just emit it         
    endcase
  repeat			 	\ round again                   
;                                                               

decimal                                                         

: start-line		\ -- ; wait at start of line
  begin
\    begin
\      key?				\ has user pressed ^B ?
\      if
\        key-val @ 2 =
\        if
\          target-abort -1 throw		\ if so then quit
\        endif
\      endif
\      ser-key?				\ if there is a serial key
\      if
        ser-key \ -1			\ then get it
\      else
\        0
\      endif
\    until
    dup ^f =				\ ^f = load file cmd.   
    if  tar-nested  endif 		\ nest file
    dup ^e =				\ ^e = error            
    if  -1 throw  endif                      
    dup xon <>				\ if not XON            
    if  dup emit  endif			\  display character    
    xon =                                                  
  until					\ wait for XON
;         
                                                                
decimal                                                         
                                                                
: end-line		\ -- ; wait at end of line
  ACR ser-emit  1 line-counter +!	\ send CR               
  begin
\    begin
\      key?			 	\ has user pressed a key
\      if
\        key-val @ 2 =		 	\ if it was a ^B
\        if
\          target-abort -1 throw	 	\ then abort
\        endif
\      endif
\      ser-key?			 	\ have we a serial char
\      if
        ser-key \ -1		 	\ then get it
\      else
\        0
\      endif
\    until			 	\ wait till serial char got
    dup xoff <>				\ wait for XOFF         
   while
    emit	    			\  display all else     
  repeat
  drop		    			\ discard XOFF          
  ascii . emit	    			\ show line finished    
  100 0					\ settling time         
  do loop  
;
                                                                
decimal                                                         
                                                                
: send-line		\ -- ; send a line of text
  start-line			\ wait for XON                  
  #tib @ 0			\ string at tib for #tib cha    
  ?do
    load-feedback		\ is the target saying anything 
    tib i + c@			\ get char from tib             
    ser-emit			\ send it                       
  loop                                                          
  end-line			\ send CR, wait for XOFF        
;

headers

: (send-file)	   	\ first last seg off -- ; send file (like $from)
  get-stream next-file			\ open next file
  if 
    cr ." Can't open required file. Press a key." (key) drop
    target-abort -1 throw endif
  begin
    next-line				\ read line
  while
    send-line				\ send the line of text
  repeat
  prev-file				\ previous file
  if target-abort -1 throw endif
;

assign (send-file) to-do send-file

headerless

decimal
                                                               
: reset-tar-xon/xoff	\ -- ; send end command to target, and reset
  start-line			\ simulate a line from the file
  "" end-load " count bounds	\ the string to send
  do
    load-feedback		\ check for i/p
    i c@ ser-emit		\ send chars in string
  loop
  end-line			\ wait for the final     
;

headers                                                                

: (tar-$from)		\ -- ; downloads a file, collecting name from target
  tar-$use			\ get file name and select it   
  get#				\ receive last-p#               
  get#				\ receive first-p#              
  swap curr-text$		\ setup for host's $from        
  set-xon/xoff			\ no handshaking                
  synch-to-target		\ re-synch                      
  send-file			\ send text from file
  reset-tar-xon/xoff		\ send 'XON/XOFF OFF' to target 
  reset-hs			\ original hs reset
;

: tar-$from		\ -- ; as (TAR-$FROM), but protected
  ['] (tar-$from) catch		\ execute guarded (TAR-$FROM)
  if
    release-files		\ shut down file system
    abort-state @ 1 <>		\ if not manual abort
    if
      wait-ack			\ acknowledge host
    endif
    reset-hs			\ reset host handshake
    cr				\ make display pretty
  endif
; 

headerless

\ -----End of Page-----
\ -- R.G.G -- 04/06/90 --  terminal-mode

headerless

: terminal-key		\ -- char ; get a key to send to target
  key-found off
  key-val @			\ get the key from the buffer
  input>log	   		\ a defered word
;

: terminal-emit	    	\ char -- ; emit a character from the target
  output>log   			\ a defered word
  emit				\ and print it
;

: ?special	  	\ char -- ; maybe act on control key from target
  dumb/files @				\ if we are a file server
  if
    dup
    case
      ^a of drop abort-state off tar-$use		endof	\ special cases
      ^c of drop abort-state off cls	 		endof
      ^f of drop abort-state off tar-$from 		endof
      ^r of drop abort-state off rem-blk-send		endof
      ^u of drop abort-state off tar-$using		endof
      ^w of drop abort-state off rem-blk-receive	endof
            terminal-emit					\ any other key
    endcase
  else
    terminal-emit			\ or just emit it
  endif
;

: (terminal-emulator)	\ -- ; be a terminal emulator
  begin
    tar-key?	       		\ if theres a serial char
    if
      tar-key	       		\ get it
      ?special	       		\ protocol key ?
    endif	
    key?	       		\ if a keyboard char
    if
      terminal-key     		\ get it
      tar-emit	       		\ send it
    endif
    terminal-quit @    		\ stop when finished
  until
  previous-mode @ shell-mode !	\ restore old mode
  close-target		      	\ shut window
;

: terminal-emulator	\ -- ; protected version of above
  ['] (terminal-emulator) catch		\ execute guarded version
  if  target-abort			\ raise error window if and when
      key-val off			\ reset kb
      ser-close  ser-open		\ reinit serial port on PC
      recurse				\ run again for continuity
  endif
;

\ -----End of Page-----
\ -- R.G.G -- 04/06/90 --  mode-toggle

headers

defer .no-func

: mode-toggle		\ -- ; switch in or out of terminal mode
  from-api @				\ if calling from external xcomp
  if
    21 #help	    			\ right help message
    .no-func	    			\ say not available
  else
    shell-mode @  1 =			\ if running terminal mode
    if
      terminal-quit on	   		\ reset exit flag
      key-found off			\ and reset kb
    else
      terminal-quit off	   		\ set exit flag
      shell-mode @ previous-mode !    	\ preserve shell mode
      1 shell-mode !	   	    	\ reset mode: terminal mode
      open-target	   		\ open window
      terminal-emulator	   		\ run terminal emulator
    endif
  endif
;

behead
