\ Time and date window for xshell3

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  master code

extern (time-window)		\ the actual code in the fred module

: time-window		\ -- ; show the time and date
  save-win			\ preserve the position in the window
  create-time-window		\ create the new window
  curr-handle to-window		\ go to it
  get-fred			\ get the fred module with the code in
  op-handle @ set-fred-handle	\ pass the handle through
  (time-window)			\ do it
  del-fred			\ delete the module
  curr-handle from-window	\ back to this window
  delete-curr-window		\ delete the time window
  rest-win			\ back where we were
;

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  slave code
\  am/pm .2                                     R. G.  14/07/89 

headerless

variable last-second		\ the second last time we redrew
variable am/pm			\ am or pm
                                                                
0 am/pm !			\ default to something
                                                                
: .2			\ n -- ; print a number with no trailing space
  0 <# # # #> type
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  show-time
                                                                
: show-time		\ -- ; maybe show the time
  (time)				\ get time from dos             
  drop					\ drop 1/100ths                 
  dup last-second @ <>
  if
    rot					\ hour to top of stack          
    dup 12 >= if  am/pm on endif	\ if 12...., set pm flag        
    dup 12 >  if  12 -  endif		\ subtract 12 if 13....         
    space . 8 emit ascii : emit		\ show hour                     
    swap .2 ascii : emit		\ show minute                   
    dup last-second !			\ stash current second to not print next time
    .2					\ show second                   
    am/pm @
    if ."  pm    " else ."  am    " endif                 
  else
    2drop drop				\ ignore if still same second
  endif
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  .day
                                                                
: .day			\ day# -- ; print the name of the day
  space                                                         
  case                                                          
    0 of ." Sunday"    endof                                      
    1 of ." Monday"    endof                                      
    2 of ." Tuesday"   endof                                      
    3 of ." Wednesday" endof                                      
    4 of ." Thursday"  endof                                      
    5 of ." Friday"    endof                                      
    6 of ." Saturday"  endof                                      
  endcase                                                       
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  .month
                                                                
: .month		\ month# -- ; print name of month
  case
    1 of ." January"   endof                                    
    2 of ." February"  endof                                    
    3 of ." March"     endof                                    
    4 of ." April"     endof                                    
    5 of ." May"       endof                                    
    6 of ." June"      endof                                    
    7 of ." July"      endof                                    
    8 of ." August"    endof                                    
    9 of ." September" endof                                    
   10 of ." October"   endof                                    
   11 of ." November"  endof                                    
   12 of ." December"  endof                                    
  endcase 
; 

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  show-date
                                                                
: show-date		\ -- ; print date
  (date)			\ get date from dos             
  3 roll			\ get day# to top of stack      
  .day				\ show day                      
  rot				\ get day to top of stack       
  space .			\ show day                      
  swap				\ get month to top of stack     
  .month space			\ show month                    
  .				\ show year                     
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  time-loop

decimal

headers

: stop-key		\ -- t/f ; wait for a key to stop, or help
  0		   		      		\ dummy quit flag		
  (key?)	   		      		\ if a key press
  if (key)	   			      	\ get first key
     case
       00 of (key)				\ if 00, get the second
             case   68 of drop -1 endof		\ set quit flag
                    59 of more-help endof	\ do help
                          wrong-tone		\ wrong key
             endcase
          endof
       27 of drop -1 endof
             wrong-tone				\ wrong key
     endcase
  endif
;

headerless

: time-loop		\ -- ; wait for user, and update time
  begin                                                         
    0 1 gotoxy			\ begining of window
    show-time			\ print the time                    
    stop-key			\ wait for user	
  until                                                         
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 9/1/92 --  time-window

headers

: (time-window)		\ -- ; do the whole thing
  11 #help
  cr				\ space                 
  show-time			\ show time first       
  cr cr				\ more space            
  show-date			\ show date             
  cursor-off			\ turn off cursor for neatness
  time-loop			\ loop                  
  spare-keys			\ get rid of spares     
  cursor-on			\ and cursor back on again
; public

behead
