\ variables for XS3 master module


\ -----End of Page-----
\ -- R.G.G -- 15/06/90 --  vocabulary

vocabulary xs3

extern set-op-handle			\ to pass handle to other modules

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  window handles

only forth also xs3 definitions		\ hide the xs3 code

variable curr-handle			\ used for all single-level window
variable host-handle			\ the host mode window
variable target-handle			\ the target mode window
variable dos-handle			\ the dos shell window
variable configa-handle			\ the config option a window
variable configb-handle			\ the config option b window
variable configc-handle			\ the config option c window
variable screen-handle			\ the handle of the full-scren window
variable set-handle			\ the handle for serial comms settings window
variable fred-handle		public	\ the window to run fred in
variable helpsys-handle		public	\ the window for the context-help system
variable api-handle		public	\ the window to run the compiler in
variable dos-comp-handle		\ the window to run external compiler in
variable glos-handle			\ the window for the glossary options

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  buffers

create letter-table 15 allot 		\ -- addr ; fn#>letter map      

create line-buff 80 allot		\ -- addr ; to build up bot.bar 

create alt-file 64 allot public		\ buffer for second file name in FRED
alt-file 64 erase      				\ clear out ready for first use
alt-file on					\ simulate -1 (closed) handle

create scr-buff 64 allot		\ name of screen, while compiler runs

create $blow-prom  64 allot  		"" -" $blow-prom 3 cmove
create $emu-prom   64 allot		"" -" $emu-prom 3 cmove
create $u1-prompt  64 allot		"" -" $u1-prompt 3 cmove    
create $u2-prompt  64 allot		"" -" $u2-prompt 3 cmove
create $u1-comm    64 allot		"" -" $u1-comm 3 cmove
create $u2-comm    64 allot		"" -" $u2-comm 3 cmove
create $compiler   64 allot		"" -" $compiler 3 cmove
create $decompiler 64 allot		"" -" $decompiler 3 cmove
create $comp-comm  64 allot  public 	"" -" $comp-comm 3 cmove
create $dir-spec   64 allot  public 	"" *.*" $dir-spec 5 cmove
create $dump-comm  64 allot		"" -" $dump-comm 3 cmove
create $dos-func   64 allot  $dos-func off

create (compiler-buff)		\ -- addr ; the name of the compiler path
  64 allot				\ space for the drive&path

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  screen variables

variable #rows		24 #rows !	\ last line# of screen
variable curr-fn#		    	\ fn# being configured

variable a/t-tlx        \ -- addr ; t.l.x co-ord of ascii window      
variable a/t-tly        \ -- addr ; t.l.y co-ord of ascii window      
36  a/t-tlx !           \ initial t.l.x                         
3   a/t-tly !           \ initial t.l.y                         

variable max-rows

variable comp-xy 2 allot  		\ 2-var for x,y around compiler
variable targ-xy 2 allot  		\ 2-var for x,y around target

\ -----End of Page-----
\ -- R.G.G -- 04/06/90 --  system variables

variable shell-mode	public  \ 0=host,1=target,2=compiler,3=umbilical
variable previous-mode		\ the mode in before compiler mode
variable terminal-quit		\ flag to enable to quit from terminal mode
variable old-mode		\ the dos screen mode at start up

pcb text-name			\ buffer for name of text-file (scratch only)

variable fred-loaded		\ says that fred module is loaded or not

variable internal-compiler	\ says that we are using v5 or v0-4 compiler

create space$  01 c, bl c,	\ a string with a space in

variable  edit-file		\ say whether to pass a name to the editor

variable from-api		\ says we have been called by umbilical

variable in-compiler public	\ we are currently running the compiler

variable entry-r0  public	\ the value of r0 first time
variable entry-s0  public	\ the value of s0 first time

variable modes			\ default screen modes (25/43)
variable loud public 		\ default loud/quiet,verbose/terse modes

variable /t			\ command-line /t switch
variable /e			\ command-line /m switch
variable /c 			\ command-line /c switch

variable mode-changed		\ says the screen mode (25/43/50) changed

variable alt-scr# public	\ current-scr in alt file for FRED

variable dumb/files		\ says whether file server or not
variable int/ext		\ internal or external comms

create prog-name 20 allot		\ the product name
"" XShell v3  " prog-name $move		\ our product (or others')

create target-banner  25 allot		\ the Target-Mode banner
"" TARGET MODE" target-banner $move	\ our mode (or others')

variable romforth-flag		\ -- addr ; indicates romforth target

\ -----End of Page-----
\ -- R.G.G -- 26/9/90 --  colour settings stuff

variable done			\ says we are done setting the colour
variable field#			\ which colour selection are we editing
variable attribs-changed	\ says we have changed something

\ -----End of Page-----
\ -- R.G.G -- 29/11/91 --  editor control stuff

extern $ted			\ the editor word to call

variable page-no		\ the page number to enter TED with
variable line-no		\ the line number to enter TED with
variable col-no			\ the column number to enter TED with

1 page-no !			\ preset to defaults
1 line-no !			\ ditto
1 col-no !			\ ditto

\ -----End of Page-----
\ -- R.G.G -- 25/1/91 --  ioctl function

decimal
: screen-drop			\ fn# -- result ; get a value from services
  op-handle @ ioctl drop
;

: screen-2drop			\ n fn# -- ; set a value in services
  screen-drop drop
;

: ser-drop			\ fn# -- result ; get a value from serial system
  1024 ioctl drop
;

: ser-2drop			\ n fn# -- ; set a value in serial system
  ser-drop drop
;

