((

	VOCABS.FTH

	J Lee :- 28/6/90

	MicroProcessor Engineering Ltd
	133/133a Hill Lane
	Southampton
	SO1 5AF

	tele:	(0703) 631441
	inter:	+44 703 631441


	This code maintains vocabularies.

))



only forth also c-c definitions
decimal



\ Create-Voc-Chunk Link-Voc-Chunk Build-Voc .. J Lee -- 28/06/90
\


decimal

: Create-Voc-Chunk		( -- chunk )
	get-chunk  ;


: Link-Voc-Chunk	( chunk seg offset -- ; link new chunk )
	>r over dup latest-chunk !(p)l r>	\ set latest chunk for new voc
	Voc-Chunk+ !(s)l  ;


: $Build-Voc	( seg $addr -- )
	$make-voc
	latest-chunk @(v) last'(s)@	\ return seg offset of symbol
	create-voc-chunk			\ create a new voc chunk
	-rot link-voc-chunk  ;		\ set pointer in voc symbol


: Build-Voc	( -- ; <name> )
	cs> bl word  dup count upper		\ build the voc symbol
	$build-voc  ;
	



\ Also(s) Only(s) .. Jon 04/08/88
\


: Also(s)	( -- )
	curr-page-chunk Context(s)  dup dcell(s)+
	Vsize(s) 2 dcell(s)* -					\ shift context
	cmove>(s)l  ;							\ search order


: Only(s)	( -- )
	curr-page@ 0<>				\ not page 0?
	If
		Page-Voc(s) 2@(p)		\ use paged-voc for search order
	Else
		'Root(s) 2@(g)			\ Root symbol voc only in search order
	Endif
	curr-page-chunk Context(s)  Vsize(s) dcell(s)-
	3dup Erase(s)l
	+  2!(p)l  ;


\ Previous(s) Definitions(s) Order(s) Vocs(s) .. Jon 04/08/88
\


: Previous(s)	( -- )
	Context(s)  curr-page-chunk over dcell(s)+  rot	\ -- source destination
	Vsize(s) 2 dcell(s)* -				\ length to shift
	cmove(s)l							\ shift context
	Context(s)  Vsize(s) 2 dcell(s)* -  +	\ get last but one context addr
	0 0 rot 2!(p)  ;					\ delete entry


: Set-Definitions(s)	(( seg offset -- ; sets voc seg and current(s) ))
	2dup current(s) 2!(p)
	voc-chunk+ @(s)l voc-seg!  ;


: Definitions(s)	( -- )
  Context(s) 2@(p) set-definitions(s)  ;  \  Current(s) 2!(p)  ;


: .Context(s)	( -- ; display search order for symbols )
	cr ." Context(s): "
	Context(s)			\ address of first voc in context
	[ VSize(s) dcell(s) / ] literal  0	\ number of possible vocs in context
	?Do
		dup  2@(p)		\ fetch from context
		2dup or 0<>		\ if there is a voc  i.e. non-zero
		If
			>name(s) .name(s)	\ display name (uses voc-seg)
			space			\ tidy display
		Else
			2drop			\ no voc so clear up
		Endif
	    	dcell(s)+			\ step on through context
	Loop
	drop  ;


: .Current(s)	( -- ; display definitons vocabulary )
	cr ." Current(s): "
	current(s) 2@(p)		\ get current vocabulary
	2dup or 0<>			\ vocabulary present? ( 0 = not present )
	If
		>name(s) .name(s)	\	y: display name
	Else
		2drop			\ 	n: tidy stack
	Endif  ;


: Order(s)	( -- ; display search order and definitions vocabulary )
	.context(s)
	.current(s)
	cr  ;


: Vocs(s)	( -- ; display all vocabularies in a page )
	cr
	<voc-link(s) 2@(p)		\ backward voc link  i.e. last voc created
	Begin
		2dup or 0<>
	While
		2dup <voc-link(s)-		\ get symbol address
		2 spaces
		>name(s) .name(s)		\ display symbol name
		2@(p)l				\ get next voc in chain
	Repeat
	2drop  ;




\ Evoc EVocs .. J Lee -- 04/07/90
\


\ : Evoc	(( seg >voc-link(s) -- ; enumerate a single vocabulary ))
\	>voc-link(s)-  2dup >name(s) cr .name(s)
\	voc-chunk+ @(p)l				\ get vocs first chunk
\	Begin
\		cr dup .hex				\ display chunk segment
\		>chunk-link				\ get >chunk-link addr
\		@(p)l					\ get next chunk
\		dup 0=					\ continue until end of chunk chain
\	Until
\	drop  ;


\ : EVocs	( page# -- ; enumerate all chunks of all vocs in page page# )
\	page-chunk@			\ get page chunk
\	>voc-link(s) 2@(p)l		\ get first voc
\	Begin
\		2dup cr evoc		\ enumerate single voc
\		2@(p)l			\ get next voc
\		2dup or 0=		\ continue if current voc not last in chain
\	Until
\	2drop  ;




\ Free-Voc Free-Forth-Vocs -Labels -Equates .. J Lee -- 20/07/90
\


: Free-Voc	(( seg >voc-link(s) -- ; free a single vocabulary ))
	>voc-link(s)-
\	2dup >name(s) cr .name(s)
	voc-chunk+ @(p)l				\ get vocs first chunk
	Begin
\		cr dup .hex				\ display chunk segment
		dup release-chunk			\ release it
		>chunk-link				\ get >chunk-link addr
		@(p)l					\ get next chunk
		dup 0=					\ continue until end of chunk chain
	Until
	drop  ;


: Free-Forth-Vocs	( page# -- ; enumerate all chunks of all vocs in page page# )
	page-chunk@			\ get page chunk
	>voc-link(s) 2@(p)l		\ get first voc
	Begin
		2dup free-voc           \ enumerate single voc
		2@(p)l			\ get next voc
		2dup or 0=		\ continue if current voc not last in chain
	Until
	2drop  ;


: Free-Labels	( -- ; free labels chunks )
	'labels(s) 2@(g) >voc-link(s)+ free-voc  ;


: Free-Equates	( -- ; free equates chunks )
	'equates(s) 2@(g) >voc-link(s)+ free-voc  ;


: Free-Page0	( -- ; free all page 0 )
	free-labels
	free-equates
	0 free-forth-vocs  ;


: (Free-All-Pages)	( -- ; free all pages )
	free-page0
	#pages 1		\ page 0 released first
	?Do
		i page-chunk@ 
		If
			i free-forth-vocs
		Endif
	Loop  ;


defer FREE-ALL-PAGES    assign (FREE-ALL-PAGES) to-do FREE-ALL-PAGES


: Free-Symbol-Space	( -- ; free symbol space if needed )
	symbols-allocated @(g)			\ if symbol memory in use
	If
		free-all-pages				\   then free memory
		symbols-allocated off(g)		\ and flag symbol space as free
	Endif  ;
	
	

		



