\ MPE 80x96 family assembler                         sfp 25/03/90
((
Written by Stephen Pelc
version 1.0  December 1988
conversion to v4.16 cross compiler  March 1990

Copyright (c) 1987-1988
MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: (+44) 703 631441
))


cr cr   .( Loading 8096/80196 cross assembler ... )

only forth  also c-c  also assembler definitions

\ MPE 8096 Cross assembler                         sfp 25/03/90

hex

: ?Uncons	( -- )
  Ref1 @(g) ?dup
  If
    cr cell+ @ 6u.r  02e error  Ref1 off(g)
  Endif
  Ref2 @(g) ?dup
  If
    cr  cell+ @ 6u.r  02e error  Ref2 off(g)
  Endif  ;

\ variables                                        sfp 25/03/90

variable <prefix>               \ prefix/postfix mode
        <prefix> on             \
create aprior  0 , 0 ,          \ see ?prefix
create last-pos 0 , 0 ,         \ holds BLK & >IN

VARIABLE ADDR-MODE              \ indicates address mode
variable <3operands>            \ true if three operands needed
variable last-bit               \ holds index/indirect bit

\ save-pos restore-pos                             sfp 18/12/88

: save-pos      \ -- ; preserves opcode position in text
  blk @  >in @  last-pos 2!  ;

: restore-pos   \ -- ; restore text position
  last-pos 2@  >in !  blk !  ;

\ a-error ?a-error                                 sfp 09/12/88

: prefix?       \ -- t/f ; true if in prefix mode
  <prefix> @  ;

: a-error       \ n -- ; error exit
  prefix?
  if  restore-pos  endif
  error  ;

: ?a-error      \ t/f n -- ; error n if t/f true
  swap
  if  a-error  else  drop  endif  ;

\ ?even ?long-int short? ?short                    sfp 10/12/88
hex

: ?even         \ n -- ; error if not even
  1 and 021 ?a-error  ;

: ?long-int     \ n -- ; error if not long aligned
  3 and 026 ?a-error  ;

: short?        \ n -- t/f ; true if in range -128..+127
  -080 07F within?  ;

: ?short        \ n -- ; error if not in range -128..+127
  short? 0= 022 ?a-error  ;

\ forward-set absolute                             sfp 25/03/90

: forward-set	( addr mode -- addr )
  >r							\ preserve mode
  sc/c(s)						\ preserve order
  here(t) over dcell(s)+ ref-seg @(g) swap !(s)l	\ put addr in packet
  r> over 3 cells(s)+ ref-seg @(g) swap !(s)l		\ put mode in packet
  rc/c(s)  ;					\ restore order

: Absolute	( addr -- )
  dup
  If
    dup Ref1 @(g) =
    If
      Ref1-Seg @(g) ref-seg !(g)
      Ref1 off(g)  1 forward-set
    Endif
    dup Ref2 @(g) =
    If
      Ref2-Seg @(g) ref-seg !(g)
      Ref2 off(g)  1 forward-set
    Endif
  Endif
  w,(t) ;

\ rel8                                             sfp 18/12/88


: Rel8	( addr/n -- )
  dup
  If
    dup Ref1 @(g) = 
    If
      Ref1-Seg @(g) Ref-Seg !(g)
      Ref1 off(g)  3 forward-set
      drop  0 c,(t)  exit
    Endif
    dup Ref2 @(g) =
    If
      Ref2-Seg @(g) Ref-Seg !(g)
      Ref2 off(g)  3 forward-set
      drop  0 c,(t)  exit
    Endif
  Endif
  here(t) 1+ - dup ?short
  c,(t)  ;

\ rel16                                            sfp 25/03/90

: Rel16	( addr -- )
  dup
  If
    dup Ref1 @(g) =
    If
      Ref1-Seg @(g) Ref-Seg !(g)
      Ref1 off(g)  2 forward-set	
    Endif
    dup Ref2 @(g) =
    If
      Ref2-Seg @(g) Ref-Seg !(g)
      Ref2 off(g)  2 forward-set
    Endif
  Endif
  here(t) 2+ - 
  ,(t)  ;

\ res1k                                            sfp 10/12/88
hex

: res1k         \ label-addr reference-addr --
  >r  r@ 1+ -                           \ form offset
  dup -0400 03FF within? 0= 029 ?a-error  \ check it
  dup  r@ c!(t)                         \ store low part
  flip 07 and  r@ 1- c@(t) 0F8 and  or  \ merge op & high part
  r> 1- c!(t)  ;                        \ and save it

\ off1k                                            sfp 07/01/89
hex

: off1k         \ label-addr --
  DUP
  IF
    DUP REF1 @ =
    IF
      Ref1-Seg @(g) Ref-Seg !(g)
      REF1 off(g)  4 forward-set
      drop  0 c,(t)  exit
    ENDIF
    DUP REF2 @ =
    IF
      Ref2-Seg @(g) Ref-Seg !(g)
      REF2 off(g)  4 forward-set
      drop  0 c,(t)  exit
    ENDIF
  ENDIF
  here(t)  0 c,(t)  res1k  ;

\ ?prefix                                          sfp 18/12/88
\
\ The basis of this code was presented by Bob Smith at the
\ November 1987 FORML Conference - thanks
\
: ?prefix       \ n -- n' ; executes previous opcode
  prefix?
  if  r>
      aprior 2@  2swap  aprior 2!
      >r
  endif  ;

\ prefix postfix                                   sfp 07/01/89

also interpreter definitions

: prefix        cc/i  <prefix> on  ;

: postfix       cc/i  <prefix> off  ;

previous definitions

\ mode                                             sfp 18/12/88

: mode  \ type last-bit -- ; --
  create  , ,  does>
  dup @ last-bit !  2+ @ addr-mode !  ;

also asm-access definitions
0 0 mode R                              \ shared with abs [0]
1 0 mode #                              \ immediate
2 0 mode []                             \ indirect
2 1 mode []+                            \ indirect+autoinc
3 0 mode ,[]                            \ indexed (default byte)
3 1 mode W,[]                           \ word indexed
previous definitions

\ ?reg#                                            sfp 18/12/88
hex
: 0..255?          \ reg -- t/f
  0 0FF within?  ;

: ?reg#         \ reg -- ; range check it
  0..255? 0= 023 ?a-error  ;

: reg.b,        \ reg --
  dup ?reg# c,(t)  ;

: reg.w,        \ reg --
  dup ?reg#  dup ?even  c,(t)  ;

: reg.l,        \ reg --
  dup ?reg#  dup ?long-int  c,(t)  ;    
\ op, reg,                                         sfp 18/12/88

: op,           \ opcode --
  <3operands> @                         \ three operands ?
  if  020 xor  endif                    \ yes, modify opcode
  c,(t)  ;                              \ lay opcode

: reg,          \ reg# size --
  case
    0 of  reg.b,  endof
    1 of  reg.w,  endof
    2 of  reg.l,  endof
      cr ." REG, " 024 a-error
  endcase  ;

\ register.b                                       sfp 18/12/88

: register.b    \ reg opcode --
  over 0..255?                          \ register ?
  if  op,  reg.b,                       \ yes, aa=0
  else  3 or op,  1 c,(t)  absolute     \ no, aa=3, long indexed
  endif  ;

: register.w    \ reg opcode --
  over 0..255?                          \ register ?
  if  op,  reg.w,                       \ yes, aa=0
  else  3 or op,  1 c,(t)               \ no, aa=3, long indexed
        dup ?even absolute              \ with word offset
  endif  ;

\ #.b #.w                                          sfp 18/12/88

: #.b           \ n/b opcode --
  1 or op,                              \ lay opcode
  dup 0..255? 0= 02C ?a-error  c,(t)  ; \ check operand

: #.w           \ n opcode --
  1 or op,  absolute  ;                 \ lay opcode & data

\ indirect                                         sfp 18/12/88

: indirect      \ reg opcode --
  over ?reg#  over ?even                \ check register
  2 or op,  last-bit @ or c,(t)  ;      \ lay opcode and re

: indexed       \ n reg opcode --
  over ?reg#  over ?even                \ check register
  3 or op,                              \ lay opcode
  over 0..255?                          \ check offset
  if  c,(t)  c,(t)                      \ lay register & index
  else  1 or c,(t)  absolute            \  "
  endif  ;

\ baop                                             sfp 18/12/88

: baop
  case  addr-mode @
    0 of  register.b  endof
    1 of  #.b         endof
    2 of  indirect    endof
    3 of  indexed     endof
      cr ." BAOP "  024 a-error
  endcase  ;

\ waop                                             sfp 18/12/88

: waop
  case  addr-mode @
    0 of  register.w  endof
    1 of  #.w         endof
    2 of  indirect    endof
    3 of  indexed     endof
      cr ." WAOP "  024 a-error
  endcase  ;

\ & ?3ops.b ?3ops.w                                sfp 09/12/88

also asm-access definitions
: &             \ -- ; sets 3 operands flag
  <3operands> on  ;
previous definitions

: ?3ops.b       \ [breg#] --
  <3operands> @
  if  reg.b,  endif  ;

: ?3ops.w       \ [wreg#] --
  <3operands> @
  if  reg.w,  endif  ;

\ a-reset                                          sfp 18/12/88

also c-c definitions

: a-reset       \ -- reset assembler variables
  addr-mode off  last-bit off           \ addressing mode flags
  <3operands> off                       \
  save-pos  ;

previous definitions

: null-op       \ run dummy for labels etc
  0 ?prefix  drop  a-reset  ;

\ asm_start asm_end                                sfp 09/12/88

: kickoff       \ -- ; dummy operator
  drop  a-reset ;

: set-null      \ -- ; initialise APRIOR
  0 ['] kickoff >body aprior 2!  ;

also c-c definitions

: ASM_START     \ -- ; initialise assembler
  set-null  a-reset  ;

: ASM_END       \ -- reset assembler
  null-op  ;

: initfwd ;

previous definitions

\ end-code                                         sfp 25/03/90

also asm-access definitions


: End-Code	( -- )
  asm_end  ?uncons
  sp@ cell+ <> 02f ?error
\ 'latest: 2@(v) smudge(s)
  State(t) off(g)  ;

: FORTH
  END-CODE
\  'FORTH(s) @(m) is-voc(s)
;
previous definitions

\ 0op                                              sfp 08/01/89

: 0op           \ n -- ; -- child
  create  ,  does>  ?prefix
  @ c,(t)  a-reset  ;

: 1op.waop      \ opcode -- ; waop --
  create  ,  does>  ?prefix
  @ waop  a-reset  ;

: pop.op        \ opcode -- ; waop -- ; as 1op.waop not #
  create  ,  does>  ?prefix
  addr-mode @ 1 = 02B ?a-error          \ immediate not allowed
  @ waop  a-reset  ;

\ must-be-reg ?bit-no not-3ops                     sfp 18/12/88
hex

: must-be-reg   \ -- ; error if not register addressing
  addr-mode @ 0<> 02B ?a-error  ;       \ check addressing mode

: ?bit-no       \ n -- ; error if n not in range 0..7
  0 7 within? 0= 027 ?a-error  ;

: not-3ops
  <3operands> @ 028 ?a-error  ;

\ 1op 2ops.wb 2ops.lb                              sfp 11/12/88

: 1op           \ opcode b/w/l -- ; [sys] --
  create  , ,  does>  ?prefix           \
  must-be-reg                           \ check
  dup 2+ @ c,(t)                        \ lay opcode
  @ reg,  a-reset  ;                    \ lay register

: 2ops.wb       \ opcode -- ; wreg# baop --
  create  ,  does>  ?prefix
  not-3ops  @ baop  reg.w,  a-reset  ;

: 2ops.lb       \ opcode -- ; wreg# baop --
  create  ,  does>  ?prefix
  not-3ops  @ baop  reg.l,  a-reset  ;

\ 2ops                                             sfp 11/12/88

: 2ops          \ opcode size -- ; sys -- [child]
  create  , ,  does>  ?prefix           \
  not-3ops
  dup 2+ @  swap @                      \ get opcode & size
  case                                  \ reg, operand, size
    0 of  baop  reg.b,  endof           \ byte
    1 of  waop  reg.w,  endof           \ word
    2 of  waop  reg.l,  endof           \ long
      cr ." 2OPS"  024 a-error          \ error
  endcase
  a-reset  ;

\ 2/3ops                                           sfp 11/12/88

: 2/3ops        \ opcode size -- ; sys -- [child]
  create  , ,  does>  ?prefix
  dup 2+ @  swap @                      \ get opcode & size
  case
    0 of  baop  ?3ops.b  reg.b,  endof  \ reg [reg] operand
    1 of  waop  ?3ops.w  reg.w,  endof  \ reg [reg] operand
    cr ." 2/3ops"  024 a-error
  endcase
  a-reset  ;                            \ clean up

\ jump.bit                                  sfp 09/sfp 18/12/88

: jump.bit      \ n -- ; reg# bit# addr --
  create  ,  does>  ?prefix             \
  @  rot dup ?bit-no  or c,(t)          \ lay opcode + bit#
  swap reg.b,  rel8  a-reset  ;         \ lay reg & offset

: jump.ins      \ n -- ; addr -- [child]
  create  ,  does>  ?prefix             \ previous
  @ c,(t)  rel8  a-reset  ;             \ lay opcode & offset

\ mul,                                             sfp 11/12/88
hex

: mul,          \ [sys] opcode size --
  case
    0 of  baop  ?3ops.b  reg.w,  endof
    1 of  waop  ?3ops.w  reg.l,  endof
      cr ." MUL, "  024 a-error
  endcase  ;

\ 2/3muls 2/3mulu                                  sfp 11/12/88
hex

: 2/3muls       \ opcode size -- ; lreg# [reg#] waop --
  create  , ,  does>  ?prefix
  0FE c,(t)  dup 2+ @  swap @
  mul,  a-reset  ;

: 2/3mulu       \ opcode size -- ; lreg# [reg#] waop --
  create  , ,  does>  ?prefix
  dup 2+ @  swap @
  mul,  a-reset  ;

\ div-s div-u                                      sfp 11/12/88
hex

: div-s         \ opcode size -- ; lreg# waop --
  create  , ,  does>  ?prefix
  not-3ops  0FE c,(t)  dup 2+ @  swap @
  mul,  a-reset  ;

: div-u         \ opcode size -- ; lreg# waop --
  create  , ,  does>  ?prefix
  not-3ops  dup 2+ @  swap @
  mul,  a-reset  ;

\ sjmp/call ljmp/call                              sfp 07/01/89

: sjmp/cal      \ opcode -- ; addr --
  create  ,  does>  ?prefix
  @ c,(t)  off1k  a-reset  ;

: ljmp/cal      \ opcode -- ; addr --
  create  ,  does>  ?prefix
  @ c,(t)  rel16  a-reset  ;

\ shift                                            sfp 12/12/88
hex

: shift         \ opcode size -- ; breg# count/breg#
  create  , ,  does>  ?prefix           \
  dup 2+ @ c,(t)  @ >r                  \ get opcode & size
  case  addr-mode @                     \ check # or reg/abs
    0 of  reg.b,  endof                 \ reg/abs
    1 of  dup 0 0F within? 0= 02A ?a-error
          c,(t)
      endof
      02B a-error
  endcase
  r> reg,  a-reset  ;                   \ lay reg

\ opcodes                                          sfp 11/12/88
also asm-access definitions     hex

064 1 2/3ops ADD        074 0 2/3ops ADDB
0A4 1 2ops   ADDC       0B4 0 2ops   ADDCB
060 1 2/3ops AND        070 0 2/3ops ANDB
001 1 1op    CLR        011 0 1op    CLRB
0F8 0op      CLRC       0FC 0op      CLRVT
088 1 2ops   CMP        098 0 2ops   CMPB
005 1 1op    DEC        015 0 1op    DECB
0FA 0op      DI
08C 1 div-s  DIV        09C 0 div-s  DIVB
08C 1 div-u  DIVU       09C 0 div-u  DIVUB
0FB 0op      EI

\ opcodes 2                                        sfp 18/12/88
hex
006 2 1op    EXT        016 1 1op    EXTB
007 1 1op    INC        017 0 1op    INCB
030 jump.bit JBC        038 jump.bit JBS
0DB jump.ins JC         0DF jump.ins JE
0D6 jump.ins JGE        0D2 jump.ins JGT
0D9 jump.ins JH         0DA jump.ins JLE
0DE jump.ins JLT        0D3 jump.ins JNC
0D7 jump.ins JNE        0D1 jump.ins JNH
0D0 jump.ins JNST       0D5 jump.ins JNV
0D4 jump.ins JNVT       0D8 jump.ins JST
0DD jump.ins JV         0DC jump.ins JVT
0EF ljmp/cal LCALL

\ opcodes 3                                        sfp 08/01/89
hex
0A0 1 2ops   LD         0B0 0 2ops     LDB
0BC 2ops.wb  LDBSE      0AC 2ops.wb  LDBZE
0E7 ljmp/cal LJMP
06C 1 2/3muls MUL       07C 0 2/3muls MULB
06C 1 2/3mulu MULU      07C 0 2/3mulu MULUB
003 1 1op    NEG        013 0 1op    NEGB
0FD 0op      NOP        00F 2ops.lb  NORML
002 1 1op    NOT        012 0 1op    NOTB
080 1 2ops   OR         090 0 2ops   ORB
0CC pop.op   POP        0F3 0op      POPF
0C8 1op.waop PUSH       0F2 0op      PUSHF
0F0 0op      RET        0FF 0op      RST

\ opcodes 4                                        sfp 18/12/88
hex
028 sjmp/cal SCALL      0F9 0op      SETC
009 1 shift  SHL        019 0 shift  SHLB
00D 2 shift  SHLL       008 1 shift  SHR
00A 1 shift  SHRA       01A 0 shift  SHRAB
00E 2 shift  SHRAL      018 0 shift  SHRB
00C 2 shift  SHRL
020 sjmp/cal SJMP       000 0 1op    SKIP
0C0 1 2ops   ST         0C4 0 2ops   STB
068 1 2/3ops SUB        078 0 2/3ops SUBB
0A8 1 2ops   SUBC       0B8 0 2ops   SUBCB
0F7 0op      TRAP
084 1 2ops   XOR        094 0 2ops   XORB

\ opcodes 5 (196 instructions)                     sfp 18/12/88
hex

0F4 0op      PUSHA      0F5 0op      POPA

0EC 0op      DPTS       0ED 0op      EPTS       \ KC version

\ br djnz                                          sfp 18/12/88
hex

: br            \ wreg#
  0E3  ?prefix
  addr-mode @ 2 <> 02B ?a-error
  last-bit @ 02B ?a-error
  c,(t)  reg.w,  a-reset  ;

: djnz          \ reg# addr --
  0E0  ?prefix                          \ opcode & previous
  must-be-reg                           \ check addressing mode
  c,(t)  swap reg.b,  rel8  a-reset  ;  \ lay data

\ djnzw cmpl                                       sfp 18/12/88
hex

: djnzw         \ wreg# addr --
  0E1  ?prefix
  must-be-reg
  c,(t)  swap reg.w,  rel8  a-reset  ;

: cmpl          \ lreg# lreg# --
  0C5  ?prefix
  must-be-reg
  c,(t)  reg.l,  reg.l,  a-reset  ;

\ bmov bmovi                                       sfp 02/02/92

hex

: bmov          \ lreg# wreg# --
  0C1  ?prefix
  must-be-reg
  c,(t)  reg.w,  reg.l,  a-reset  ;

: bmovi         \ lreg# wreg# --
  0CD ?prefix
  must-be-reg
  c,(t)  reg.w,  reg.l,  a-reset  ;

\ idlpd                                            sfp 02/02/92

hex

: idlpd         \ n --
  0F6  ?prefix
  addr-mode @ 1 <> 02B ?a-error         \ must be immediate
  c,(t)                                 \ lay opcode
  dup 0..255? 0= 02C ?a-error  c,(t)    \ check operand
  a-reset  ;

\ tijmp                                            sfp 02/02/92

hex

: tijmp         \ tbase index mask --
  0E2 ?prefix c,(t)                     \ previous opcode
  swap  reg.w,                          \ lay index
  dup 0..255? 0= 02C ?a-error  c,(t)    \ lay mask 0..255
  reg.w,                                \ lay base pointer
  a-reset  ;

\ xch                                              sfp 02/02/92

hex

: xch
  0 ?prefix drop   not-3ops
  case  addr-mode @
    0 of  004 c,(t)  reg.w,  endof
    3 of  008 indexed        endof
          02B a-error
  endcase
  reg.w,  a-reset  ;

\ xchb                                             sfp 02/02/92

hex

: xchb
  0 ?prefix drop   not-3ops
  case  addr-mode @
    0 of  014 c,(t)  reg.b,  endof
    3 of  018 indexed        endof
          02B a-error
  endcase
  reg.b,  a-reset  ;

previous definitions

\ condition codes for structured conditionals      sfp 07/01/89
hex

variable <c-code>                       \ condition code set

: c-code        \ opcode -- ; -- opcode
  create  ,  does> @ <c-code> !  ;

: get-cond      \ -- condition-code
  <c-code> @   <c-code> off             \ get code, reset var.
  dup 0= 02D ?error  ;                  \ check it was set

\ condition codes for structured conditionals      sfp 07/01/89
hex

also asm-access definitions
0DB c-code nc,          0DB c-code ncy,
0DF c-code ne,          0D6 c-code lt,
0D2 c-code le,          0D9 c-code nh,
0DA c-code gt,          0DE c-code ge,
0D3 c-code cy,          0D7 c-code e,           0D7 c-code eq,
0D1 c-code h,           0D0 c-code st,
0D5 c-code v,           0D4 c-code vt,
0D8 c-code nst,         0DD c-code nv,
0DC c-code nvt,
previous definitions

\ Assembler conditional structures cont.           sfp 18/12/88
hex

: a-mrk>        \ opcode -- addr ; lay forward branch
  c,(t)  here(t)  0 c,(t)  ;

: a-res>        \ addr type --
  if  here(t) swap res1k                \ sjmp
  else  dup 1+  here(t) swap -          \ -- addr offset
        dup ?short  swap c!(t)          \ check and set
  endif  ;

\ Assembler conditional structures cont.           sfp 18/12/88
hex

: a-mrk<        \ -- addr
  here(t)  ;

: a-res<        \ addr opcode type --
  swap c,(t)                            \ lay opcode
  if  here(t)  0 c,(t)  res1k           \ resolve sjmp
  else  here(t) 1+ -  dup ?short c,(t)  \ resolve jxx
  endif  ;

\ Assembler conditional structures                 sfp 07/01/89

also asm-access definitions
: IF,           \  -- addr type
  null-op  get-cond a-mrk> 0  a-reset  ;

: ELSE,         \ addr1 type1 -- addr2 type2
  null-op  020 a-mrk> 1  2swap a-res>  a-reset ;

: ENDIF,        \ addr type
  null-op  a-res>  a-reset  ;

previous definitions

\ Assembler conditional structures                 sfp 07/01/89

also asm-access definitions
: BEGIN,        \ -- addr
  null-op  a-mrk<  a-reset  ;
: WHILE,        \ addr1 -- addr1 addr2 type
  null-op  get-cond a-mrk> 0  a-reset  ;
: REPEAT,       \ addr1 addr2 type --
  null-op  rot 020 1 a-res<  a-res>  a-reset  ;
: UNTIL,        \ addr opcode --
  null-op  get-cond 0 a-res<  a-reset  ;
: AGAIN,        \ addr --
  null-op  020 1 a-res<  a-reset  ;
previous definitions

\ macros                                           sfp 07/01/89
hex

: .lo           \ n -- n'
  0FF and  ;

: .hi           \ n -- n'
  flip .lo  ;

also asm-access definitions
: .lo   .lo  ;
: .hi   .hi  ;
previous definitions

\ Vocabulary switching                             sfp 07/11/88

: C-C   [COMPILE] C-C  ;        IMMEDIATE
: CC/A  [COMPILE] CC/A  ;       IMMEDIATE

\ target branch words                              sfp 07/11/88

only forth also c-c definitions hex

        CR CR   ." Loading target branches ....."  CR

: MRK>          HERE(T)  0 W,(T)  ;
: MRK<          HERE(T)  ;

( absolute branches )
: >RES          HERE(T) SWAP W!(T)  ;
: <RES          W,(T)  ;
((
( relative branches )
: >RES          HERE(T) OVER - SWAP W!(T)  ;
: <RES          HERE(T) - W,(T)  ;
))
\ (Resolve) .............................          sfp 25/03/90
cr cr .( loading resolve ...) cr cr
: (Resolve)	(( n fwd-ref(d) symbol(d) -- ))
\ debug @(g) If  cr ." RESOLVING: " 2dup >name(s) .name(s) cr  Endif
  status+ mark-resolved	\ mark symbol as resolved
  3dup !(s)l			\ set target addr in symbol
  cell(s)+ 2dup 2@(s)l	\ fetch next forward reference packet
  0 0 2rot 2!(s)l		\ set ^forward reference as resolved
  rot >r				\ stach symbol value
  Begin
    2dup or 0<>
  While
    2dup dcell(s)+  2dup @(s)l
    r@ swap 2swap cell(s)+ @(s)l
    Case                		\ label-addr reference-location mode
      assembl?  state_flag @(g) 2 =   or
      If				\ fix for labels page
	save-env-page @(g) curr-page!
      Endif
      0 Of !(t) Endof                       \ CFA
      1 Of !(t) Endof                       \ absolute address
      2 Of swap over 2+ - swap !(t) Endof   \ 16 bit offset
      3 Of swap over 1+ - dup [ also assembler ] ?short
           [ previous ] swap c!(t) Endof    \ 8 bit offset
      4 Of [ also assembler ] res1k [ previous ] Endof
           025 Error
    Endcase
    assembl?  state_flag @(g) 2 =   or
    If				\ fix for labels page
      0 curr-page!
    Endif
    2@(s)l
  Repeat
  2drop r> drop  ;

\ Resolve Resolve-Def-Word (Host-Create)           sfp 27/02/89
                                      \
: Resolve                             \ n addr -- n addr val-fld
  2dup (resolve)                      \ go resolve symbol
;                                     \
                                      \
: Resolve-Def-Word	(( n addr(d) -- ))
  2dup status+ mark-run-time           \ mark run time defined
  2dup 3 cells(s)+ 2swap               \ target addr field
  (resolve)  ;                         \ go resolve symbol

\ dodoes, docreate,                                sfp 18/12/88
: asm-run-ref
  state(t) @(g) >r  2 state(t) !(g)  run-time-ref
  r> state(t) !(g)  ;

hex
: compile-call
  asm-run-ref
  [ also assembler ] 0EF c,(t) rel16 [previous]  ;

: compile-jmp
  asm-run-ref
  [ also assembler ] 0E7 c,(t) rel16 [previous]  ;

: compile-run
  3 cells+ compile-call ;

\ asm-ref dodoes, docreate,                        sfp 10/01/89

: asm-ref
  state(t) @(g) >r
  2 state(t) !(g)  ref
  r> state(t) !(g)  ;

: ?align-pfa    \ -- ; insert NOP to put PFA on even boundary
  here(t) 1 and 0= if  0FD c,(t)  endif  ;

: DODOES,
  ?align-pfa  the-label DODOES asm-ref
  [ also assembler ] 0EF c,(t) rel16 [previous]  ;

: DOCREATE,
  ?align-pfa  the-label DOCREATE asm-ref
  [ also assembler ] 0EF c,(t) rel16 [previous]  ;


