((

	XDTC50-1

	MPE Forth Cross Compiler v5.00

	J Lee - 9/7/90


	Copyright (C) 1983-1990

	MicroProcessor Engineering
	133 Hill Lane
	Southampton
	SO1 5AF
	England

	tel: (+44) 703 631441   (international)
	tel: 0703-631441        (domestic)

))




\ Disk Interface - DOS 2 interface .. Jon 30/01/89
\


also Forth definitions

decimal

	cr cr	.( Loading output file handler.. )
	cr		.( HOST dependent words ........ )
	cr




\ File control block .. sfp 12/01/90
\


decimal

variable Out-Handle	\ Image file handle
variable Blk.Cur		\ current block # in memory
variable Flg.Upd		\ true if current block has changed
variable I$Opn		\ true if file open

1024 constant B/Img	\ # bytes in buffer
  -1 Out-Handle !		\ Starts not open


pcb Img.Pcb	Img.Pcb pathname IMAGE.COM

create image-buffer	b/img allot	image-buffer b/img erase


: .img	( -- )
	img.pcb .pcb  ;




\ Image disk file management .. Jon 20/09/88
\


decimal

: ?I$Opn	( -- ; check that image file is open )
	I$Opn @ 0= abort" Image file not open"  ;


: I.Seek	( -- ; seek in image file )
	blk.cur @ b/img um* out-handle @ seek-path
	abort" Image file seek error"  ;


: I.Read	( -- ; read image file block from disk )
	?I$OPN  i.seek
	image-buffer b/img out-handle @ read-path
	abort" Image file read error"
	image-buffer b/img rot /string erase  ;


: I.Write	( -- ; write to image file )
	?I$OPN  i.seek
	image-buffer b/img out-handle @ write-path
	swap b/img <> or
	abort" Image file write error"  ;


: I.Upd	( -- ;set flag to force block write )
	Flg.Upd on  ;


: I.Kill	( pcb -- ; delete old image file if it exists )
	p-name delete-path drop  ;



: I.Create	( pcb -- ;create a new image file )
	dup dup I.Kill  create-path-pcb  dup 0= I$Opn !
	abort" Can't create image file"
	handle Out-Handle !  ;


: I.Open	( pcb -- t/f ; open a image file )
	dup open-path-pcb dup 0= i$Opn !
	swap handle Out-handle !  ;


: I.Close	( -- ; close image file )
        out-handle @ close-path drop  i$opn off  ;


: I.Blk	( n --- buffer-address )
	dup Blk.Cur @ <>
	If
		Flg.Upd @
		If
			i.write
			Flg.Upd off
		Endif
		Blk.Cur !  i.read
	Else
		drop
	Endif
	image-buffer  ;




\ Close-Disk Output-File .. Jon 15/02/89
\


: Close-Disk	( -- )
        i$opn @                 \ image file open?
        If                      \ y:  flush and close file
	  i.write i.close
        Endif  ;


: Output-File	( -- ; <filename> )
	img.pcb pathname			\ get filename
	"" .IMG" img.pcb set-ext  ;	\ add default ext. if req.




\ Fill-Buffer #Blocks Write-Blocks .. J Lee -- 20/09/90
\


: Fill-Buffer	( b -- ; fill image buffer with 'b' )
	image-buffer b/img rot fill  ;


: #Blocks	( start end -- #blocks ; returns number of blocks needed )
	swap -  0 b/img um/mod nip  1+  ;


: Write-Blocks	( start end pcb -- ; write out file of known bytes )
	i.create					\ open file
	fill-byte @(g) fill-buffer	\ set buffer with characters
	Blk.Cur off				\ set first block
	#blocks 0					\ for number of blocks:
	?Do
		i.write				\	write block
		1 Blk.Cur +!			\	and move to next
	Loop
	i.close					\ close file
	Blk.Cur off  ;				\ and reset block



previous definitions


