((

	XDTC50-3

	MPE Forth Cross Compiler v5.00

	J Lee - 9/7/90


	Copyright (C) 1983-1990

	MicroProcessor Engineering
	133 Hill Lane
	Southampton
	SO1 5AF
	England

	tel: (+44) 703 631441   (international)
	tel: 0703-631441        (domestic)

))




\ .symbol-space .. sfp 12/01/90
\


: .Curr-File	( -- )
	." Using " .scr  ;


: NccAbort	( -- )
	ncclogo  interpret
	.curr-file cr
	only Forth definitions  ;




\ latest(t) is-voc(s) .. sfp 15/08/88
\


only forth also c-c definitions


: Latest(t)	(( -- addr(t) ))
	last(t) @(g)  ;


: Is-Voc(s)	( voc-addr -- )
	Context(s) 2!(p)  ;




\ Sc/c(s) Rc/c(s) .. Jon 05/01/89
\

global-var save-env-page		\ temporary old page holder


: Sc/c(s)-Page	( -- ; save current page )
	curr-page@ save-env-page !(g)  ;


: Sc/c(s)	( -- )
	Context(s) 2@(p) Cont(s) 2!(g)	\ save symbol vocabulary
	Current(s) 2@(p) Curr(s) 2!(g)  ;	\ environment


: Rc/c(s)	( -- )
	Cont(s) 2@(g) Context(s) 2!(p)		\ restore symbol
	Curr(s) 2@(g) set-definitions(s)   	\ vocabulary environment
	save-env-page @(g) curr-page!			\ restore current page
	current(s) 2@(p) voc-chunk+ @(s)l voc-seg!  ;	\ reset page voc-seg




\ Compil? Interp? .. sfp 21/09/89
\


: Compil?	( -- t/f )
	State(t) @(g) 1 =  ;


: Interp?	( -- t/f )
	State(t) @(g) 0=  ;


: Assembl?	( -- t/f )
	State(t) @(g) 2 =  ;




\ Printing  .. sfp 21/02/90
\


hex

	cr cr	.( Loading Form Handlers ....... )
	cr


: Eject	( -- )
	0c emit  ;


: Title	( -- )
	cr 3 spaces .version
	cr 3 spaces .target
	cr 3 spaces .symbol-space
	cr cr 5 #Lines !(g)  ;


: New-Page	( -- )
	eject title
	#Logged off(g)  ;


: Page	( -- )
	#Lines @(g)
	If
		#Lines @(g) L/P 1- >
		If
			new-page
		Else
			1 #Lines +!(g)
		Endif
	Else
		new-page
	Endif  ;


: Pcr	( -- )
	cr page
	#Logged off(g)  ;


: 6U.r	( n -- )
	Base @  hex
	swap 0 6 d.r	\ force to positive 32-bit number
	Base !  ;




\ Save/Restore Context .. Jon 09/08/88
\


hex

	cr cr	.( Loading Error redefinitions ... )
	cr



: SC/C	( -- ; save CURRENT and CONTEXT, and go to the root FORTH )
	Current @ Curr !(g)
	Context @ Cont !(g)
	Forth definitions  ;


: RC/C	( -- ;restore saved environment )
	Curr @(g) Current !
	Cont @(g) Context !  ;




\ Error redefinitions ..  sfp 09/12/89
\


hex


: ?Exec	( -- ; conditionally print error message )
	interp? not  012 ?error  ;


: ?Comp	( -- )
	Compil? not  011 ?error  ;


: Min-1	( -- ; error if stack depth less than one item )
	depth 1 <   1 ?error  ;		\ stack depth check


: ?In-Root	( -- ; error if string at HERE is not defined in host FORTH )
\	here [ ' forth >body ] literal  v-find	\ ModForth2 version
	here [ ' forth ] literal  v-find	\ ModForth3 version
	?dup 0= 01C ?error  ;


: ?Undef	( -- )
	0= 0 ?error  ;




\ Pseudo operations ..  Jon 30/01/89
\


hex

	cr cr	.( Loading Pseudo ops .......... )
	cr


: Target-Width	( width -- )
	the-equate HEADS? @(s)l
	If
		Width(t) !(g)
	Else
		drop
	Endif  ;


: Internal	 ( -- )
	0 target-width  ;


: External	 ( -- )
	01F target-width  ;


: No-Heads	( -- )
	0 target-width
	0 the-equate HEADS? !(s)l  ;



: Bounding	( prom-size mask min-space leading-offset -- )
	Prom-Offset !(g)  min-space !(g)
	swap  Prom-Size !(g)
	Dp(T) @(p) and  Prom-Size @(g) +  Next-Prom !(g)
	?bounding on(g)  ;


: ?Rom-End	( -- ; check for end of ROM )
	Dp(t) @(p)
	curr-page@ >page-table dup page.start @(g)  swap page.end @(g) uwithin? not
	If
		cr	cr ." ***********************************************"
			cr ."  WARNING: Dictionary extended beyond ROM / Page"
			cr ." ***********************************************"
		cr
	Endif  ;




\ Pseudo operations .. sfp 20/01/90
\


hex

((
: Initialised-Ram	( #bytes -- )
	dup Ram-Size !(g)
	here zero, Ram-Area !(g)
	here over allot swap erase  ;
))

: Initialised-Ram  ( #bytes -- )
  dup #bytes>#paras alloc-mem                   \ grab memory fro RAM table
  abort" Can't grab RAM table memory"           \ abort on error
  2dup 0 rot 0 fill(s)l                          \ zero RAM table memory
  Ram-Area !(g)                                 \ set RAM table pointer
  Ram-Size !(g)                                 \ set max size (#bytes)
  Curr-Ram-Size off(g)  ;                       \ set curr-size of RAN table


: Free-Init-Ram  ( -- ; free RAM table )
  kernel-ram-page @(g)
  If
    Ram-Area @(g) free-mem
    If  ." Can't free RAM table"  bye  Endif
  Endif  ;


: Mem-End	( addr -- )
	the-equate EM !(s)l  ;


: Ram-End	( addr -- )
	mem-end  ;

: Rom?	( -- t/f ; ROM/RAM system check )
	?Rom @(g)  ;




\ Pseudo operations .. sfp 27/02/89
\


hex

: Org	( addr -- )
	Dp(t) !(p)  ;


: Mem-Base	( addr -- )
	dup Dp(t) !(p)  dup O-I !(p)
	the-label ORIGIN 2dup status+ mark-resolved !(s)l
	Emulator-Out @(g) 0=
	If
		img.pcb i.open abort" Can't open KERNEL file"
	Endif  ;


: Rom/Ram	( addr -- )
	?Rom on(g)  ;




\ Pseudo-ops -- Aligning .. sfp 27/02/89
\


: Align	( -- ; align CFAs to even boundaries )
	2 ?Aligning !(g)  ;


: Align-Even	( -- ; align CFAs to even boundaries )
	2 ?aligning !(g)  ;


: Align-Odd	( -- ; align CFAs to odd boundaries )
	1 ?aligning !(g)  ;


: No-Align	( -- ; turn alignment off )
	0 ?aligning !(g)  ;




\ Memory reference .. J Lee -- 19/2/91
\


hex

	cr cr	.( Loading Memory referencing .. )
	cr


: Here(t)	( -- addr )
	Dp(t) @(p)  ;


: There(t)	( -- addr )
        with-data
	curr-page@ >page-table page.rp @(g)
        with-code  ;


((
: Allot-Ram	( n -- )
        with-data
	dup curr-page@ >page-table page.rp +!(g)
	Ram-Area @(g) +!
        with-code  ;
))

: Allot-Ram  ( n -- ; allot n bytes in RAM table )
  with-data
  dup curr-page@ >page-table page.rp +!(g)      \ force Page table pointer
  Curr-Ram-Size +!(g)                           \ update RAM table pointer
  with-code
  Curr-Ram-Size @(g)  Ram-Size @(g)  u>  $1a ?error  ;  \ check for overflow


: ?Inram	( addr1 -- addr2 t/f )
  ?Rom @(g)
  If
    dup the-label RAM-START @(s)l  u< not
    If
      dup the-label RAM-START @(s)l Ram-Size @(g) + u<
      If
	the-label RAM-START @(s)l - 1
      Else
	0
      Endif
    Else
      0
    Endif
  Else
    0
  Endif  ;




\ Memory reference .. sfp 21/02/90
\



: D-Addr	( address -- offset block# ; converts target address to file )
	O-I @(p) - 0 B/IMG um/mod
	SB# @(g) +  ;


